package routines;

import java.io.UnsupportedEncodingException;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;

/*
 * user specification: the function's comment should contain keys as follows: 1. write about the function's comment.but
 * it must be before the "{talendTypes}" key.
 * 
 * 2. {talendTypes} 's value must be talend Type, it is required . its value should be one of: String, char | Character,
 * long | Long, int | Integer, boolean | Boolean, byte | Byte, Date, double | Double, float | Float, Object, short |
 * Short
 * 
 * 3. {Category} define a category for the Function. it is required. its value is user-defined .
 * 
 * 4. {param} 's format is: {param} <type>[(<default value or closed list values>)] <name>[ : <comment>]
 * 
 * <type> 's value should be one of: string, int, list, double, object, boolean, long, char, date. <name>'s value is the
 * Function's parameter name. the {param} is optional. so if you the Function without the parameters. the {param} don't
 * added. you can have many parameters for the Function.
 * 
 * 5. {example} gives a example for the Function. it is optional.
 */
public class UNIMES {

	/**
	 * pwdToUnicode: return the pwd to unicode value.
	 * 
	 * 
	 * {talendTypes} String
	 * 
	 * {Category} User Defined
	 * 
	 * {param} string("password") input: The string need to be encode.
	 * 
	 * {example} pwdToUnicode("world") # .
	 */
	public static byte[] pwdToUnicode(String password) {
		try {
			String quotedPassword = password; 
			char unicodePwd[] = quotedPassword.toCharArray(); 
			byte pwdArray[] = new byte[unicodePwd.length * 2]; 
			for (int i=0; i<unicodePwd.length; i++) { 
				pwdArray[i*2 + 1] = (byte) (unicodePwd[i] >>> 8); 
				pwdArray[i*2 + 0] = (byte) (unicodePwd[i] & 0xff); 
			} 
			return pwdArray;
			// sun.misc.BASE64Encoder enc = new sun.misc.BASE64Encoder(); 
			// return  enc.encode(password.getBytes("UTF-16LE"));
		} catch (Exception e) {
			return null;
		}
	}

	public static String getHost(int num) {
		return "context.ad_Host_" + num;
	}

	public static String getAdminDN(int num) {
		return "context.ad_BindPrincipal_" + num;
	}

	public static String getBaseDN(int num) {
		return "context.ad_BaseDN_" + num;
	}

	public static String shaPassword(String password)
	{
		String sha1 = "";
		try
		{
			MessageDigest crypt = MessageDigest.getInstance("SHA-1");
			crypt.reset();
			System.out.println(password);
			crypt.update(password.getBytes("UTF-8"));
			sha1 = new String(java.util.Base64.getEncoder().encode(crypt.digest()));
		}
		catch(NoSuchAlgorithmException e)
		{
			e.printStackTrace();
		}
		catch(UnsupportedEncodingException e)
		{
			e.printStackTrace();
		}
		return sha1;
	}

	public static String ntPassword(String password)
	{
		if (password.length() > 128)
		{
			password = password.substring(0, 128);
		}

		char c_ary[] = password.toCharArray();

		// we need to simulate NT's little endian Unicode
		// representation before we pass this to md4

		byte wpwd[] = new byte[c_ary.length * 2];

		for (int i = 0; i < c_ary.length; i++)
		{
			char c = c_ary[i];

			wpwd[2*i] = (byte) (c & 0x00ff);
			wpwd[2*i+1] = (byte) (c & 0xff00);
		}

		routines.MD4 m = new routines.MD4(wpwd);
		m.calc();

		return m.toString().toUpperCase();
	}

}
