// ============================================================================
//
// Copyright (c) 2006-2015, Talend Inc.
//
// This source code has been automatically generated by_Talend Open Studio for Data Integration
// / Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
// http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.


package ldap.sgbm_export_1_6;

import routines.DataOperation;
import routines.LazyTrustManager;
import routines.TalendDataGenerator;
import routines.Base64;
import routines.Relational;
import routines.Mathematical;
import routines.Numeric;
import routines.ADConnection;
import routines.UNIMES;
import routines.TalendStringUtil;
import routines.TalendString;
import routines.StringHandling;
import routines.TalendDate;
import routines.MD4;
import routines.LazySSLSocketFactory;
import routines.system.*;
import routines.system.api.*;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;
import java.math.BigDecimal;
import java.io.ByteArrayOutputStream;
import java.io.ByteArrayInputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.ObjectOutputStream;
import java.io.ObjectInputStream;
import java.io.IOException;
import java.util.Comparator;
 




	//the import part of tJavaFlex_1
	//import java.util.List;


@SuppressWarnings("unused")

/**
 * Job: sgbm_export Purpose: <br>
 * Description:  <br>
 * @author user@talend.com
 * @version 6.5.1.20180116_1512
 * @status 
 */
public class sgbm_export implements TalendJob {



	public final Object obj = new Object();

	// for transmiting parameters purpose
	private Object valueObject = null;

	public Object getValueObject() {
		return this.valueObject;
	}

	public void setValueObject(Object valueObject) {
		this.valueObject = valueObject;
	}
	
	private final static String defaultCharset = java.nio.charset.Charset.defaultCharset().name();

	
	private final static String utf8Charset = "UTF-8";
	//contains type for every context property
	public class PropertiesWithType extends java.util.Properties {
		private static final long serialVersionUID = 1L;
		private java.util.Map<String,String> propertyTypes = new java.util.HashMap<>();
		
		public PropertiesWithType(java.util.Properties properties){
			super(properties);
		}
		public PropertiesWithType(){
			super();
		}
		
		public void setContextType(String key, String type) {
			propertyTypes.put(key,type);
		}
	
		public String getContextType(String key) {
			return propertyTypes.get(key);
		}
	}
	
	// create and load default properties
	private java.util.Properties defaultProps = new java.util.Properties();
	// create application properties with default
	public class ContextProperties extends PropertiesWithType {

		private static final long serialVersionUID = 1L;

		public ContextProperties(java.util.Properties properties){
			super(properties);
		}
		public ContextProperties(){
			super();
		}

		public void synchronizeContext(){
			
			if(oracle_login != null){
				
					this.setProperty("oracle_login", oracle_login.toString());
				
			}
			
			if(oracle_password != null){
				
					this.setProperty("oracle_password", oracle_password.toString());
				
			}
			
			if(oracle_port != null){
				
					this.setProperty("oracle_port", oracle_port.toString());
				
			}
			
			if(oracle_schema != null){
				
					this.setProperty("oracle_schema", oracle_schema.toString());
				
			}
			
			if(oracle_server != null){
				
					this.setProperty("oracle_server", oracle_server.toString());
				
			}
			
			if(oracle_sid != null){
				
					this.setProperty("oracle_sid", oracle_sid.toString());
				
			}
			
			if(sigb_active != null){
				
					this.setProperty("sigb_active", sigb_active.toString());
				
			}
			
			if(sigb_biu_cle_publique != null){
				
					this.setProperty("sigb_biu_cle_publique", sigb_biu_cle_publique.toString());
				
			}
			
			if(sigb_biu_dir != null){
				
					this.setProperty("sigb_biu_dir", sigb_biu_dir.toString());
				
			}
			
			if(sigb_biu_host != null){
				
					this.setProperty("sigb_biu_host", sigb_biu_host.toString());
				
			}
			
			if(sigb_biu_password != null){
				
					this.setProperty("sigb_biu_password", sigb_biu_password.toString());
				
			}
			
			if(sigb_biu_port != null){
				
					this.setProperty("sigb_biu_port", sigb_biu_port.toString());
				
			}
			
			if(sigb_biu_username != null){
				
					this.setProperty("sigb_biu_username", sigb_biu_username.toString());
				
			}
			
			if(sigb_cataloger_level != null){
				
					this.setProperty("sigb_cataloger_level", sigb_cataloger_level.toString());
				
			}
			
			if(sigb_cataloger_level_desc != null){
				
					this.setProperty("sigb_cataloger_level_desc", sigb_cataloger_level_desc.toString());
				
			}
			
			if(sigb_external != null){
				
					this.setProperty("sigb_external", sigb_external.toString());
				
			}
			
			if(sigb_external_desc != null){
				
					this.setProperty("sigb_external_desc", sigb_external_desc.toString());
				
			}
			
			if(sigb_external_id != null){
				
					this.setProperty("sigb_external_id", sigb_external_id.toString());
				
			}
			
			if(sigb_file_name != null){
				
					this.setProperty("sigb_file_name", sigb_file_name.toString());
				
			}
			
			if(sigb_files_dir != null){
				
					this.setProperty("sigb_files_dir", sigb_files_dir.toString());
				
			}
			
			if(sigb_id_type_eppn != null){
				
					this.setProperty("sigb_id_type_eppn", sigb_id_type_eppn.toString());
				
			}
			
			if(sigb_param_file != null){
				
					this.setProperty("sigb_param_file", sigb_param_file.toString());
				
			}
			
			if(sigb_record_type != null){
				
					this.setProperty("sigb_record_type", sigb_record_type.toString());
				
			}
			
			if(sigb_user_group != null){
				
					this.setProperty("sigb_user_group", sigb_user_group.toString());
				
			}
			
			if(sigb_user_group_desc != null){
				
					this.setProperty("sigb_user_group_desc", sigb_user_group_desc.toString());
				
			}
			
		}

public String oracle_login;
public String getOracle_login(){
	return this.oracle_login;
}
public String oracle_password;
public String getOracle_password(){
	return this.oracle_password;
}
public String oracle_port;
public String getOracle_port(){
	return this.oracle_port;
}
public String oracle_schema;
public String getOracle_schema(){
	return this.oracle_schema;
}
public String oracle_server;
public String getOracle_server(){
	return this.oracle_server;
}
public String oracle_sid;
public String getOracle_sid(){
	return this.oracle_sid;
}
public String sigb_active;
public String getSigb_active(){
	return this.sigb_active;
}
public String sigb_biu_cle_publique;
public String getSigb_biu_cle_publique(){
	return this.sigb_biu_cle_publique;
}
public String sigb_biu_dir;
public String getSigb_biu_dir(){
	return this.sigb_biu_dir;
}
public String sigb_biu_host;
public String getSigb_biu_host(){
	return this.sigb_biu_host;
}
public String sigb_biu_password;
public String getSigb_biu_password(){
	return this.sigb_biu_password;
}
public Integer sigb_biu_port;
public Integer getSigb_biu_port(){
	return this.sigb_biu_port;
}
public String sigb_biu_username;
public String getSigb_biu_username(){
	return this.sigb_biu_username;
}
public String sigb_cataloger_level;
public String getSigb_cataloger_level(){
	return this.sigb_cataloger_level;
}
public String sigb_cataloger_level_desc;
public String getSigb_cataloger_level_desc(){
	return this.sigb_cataloger_level_desc;
}
public String sigb_external;
public String getSigb_external(){
	return this.sigb_external;
}
public String sigb_external_desc;
public String getSigb_external_desc(){
	return this.sigb_external_desc;
}
public String sigb_external_id;
public String getSigb_external_id(){
	return this.sigb_external_id;
}
public String sigb_file_name;
public String getSigb_file_name(){
	return this.sigb_file_name;
}
public String sigb_files_dir;
public String getSigb_files_dir(){
	return this.sigb_files_dir;
}
public String sigb_id_type_eppn;
public String getSigb_id_type_eppn(){
	return this.sigb_id_type_eppn;
}
public String sigb_param_file;
public String getSigb_param_file(){
	return this.sigb_param_file;
}
public String sigb_record_type;
public String getSigb_record_type(){
	return this.sigb_record_type;
}
public String sigb_user_group;
public String getSigb_user_group(){
	return this.sigb_user_group;
}
public String sigb_user_group_desc;
public String getSigb_user_group_desc(){
	return this.sigb_user_group_desc;
}
	}
	private ContextProperties context = new ContextProperties();
	public ContextProperties getContext() {
		return this.context;
	}
	private final String jobVersion = "1.6";
	private final String jobName = "sgbm_export";
	private final String projectName = "LDAP";
	public Integer errorCode = null;
	private String currentComponent = "";
	
		private final java.util.Map<String, Object> globalMap = new java.util.HashMap<String, Object>();
        private final static java.util.Map<String, Object> junitGlobalMap = new java.util.HashMap<String, Object>();
	
		private final java.util.Map<String, Long> start_Hash = new java.util.HashMap<String, Long>();
		private final java.util.Map<String, Long> end_Hash = new java.util.HashMap<String, Long>();
		private final java.util.Map<String, Boolean> ok_Hash = new java.util.HashMap<String, Boolean>();
		public  final java.util.List<String[]> globalBuffer = new java.util.ArrayList<String[]>();
	

private RunStat runStat = new RunStat();

	// OSGi DataSource
	private final static String KEY_DB_DATASOURCES = "KEY_DB_DATASOURCES";

	public void setDataSources(java.util.Map<String, javax.sql.DataSource> dataSources) {
		java.util.Map<String, routines.system.TalendDataSource> talendDataSources = new java.util.HashMap<String, routines.system.TalendDataSource>();
		for (java.util.Map.Entry<String, javax.sql.DataSource> dataSourceEntry : dataSources.entrySet()) {
			talendDataSources.put(dataSourceEntry.getKey(), new routines.system.TalendDataSource(dataSourceEntry.getValue()));
		}
		globalMap.put(KEY_DB_DATASOURCES, talendDataSources);
	}


private final java.io.ByteArrayOutputStream baos = new java.io.ByteArrayOutputStream();
private final java.io.PrintStream errorMessagePS = new java.io.PrintStream(new java.io.BufferedOutputStream(baos));

public String getExceptionStackTrace() {
	if ("failure".equals(this.getStatus())) {
		errorMessagePS.flush();
		return baos.toString();
	}
	return null;
}

private Exception exception;

public Exception getException() {
	if ("failure".equals(this.getStatus())) {
		return this.exception;
	}
	return null;
}

private class TalendException extends Exception {

	private static final long serialVersionUID = 1L;

	private java.util.Map<String, Object> globalMap = null;
	private Exception e = null;
	private String currentComponent = null;
	private String virtualComponentName = null;
	
	public void setVirtualComponentName (String virtualComponentName){
		this.virtualComponentName = virtualComponentName;
	}

	private TalendException(Exception e, String errorComponent, final java.util.Map<String, Object> globalMap) {
		this.currentComponent= errorComponent;
		this.globalMap = globalMap;
		this.e = e;
	}

	public Exception getException() {
		return this.e;
	}

	public String getCurrentComponent() {
		return this.currentComponent;
	}

	
    public String getExceptionCauseMessage(Exception e){
        Throwable cause = e;
        String message = null;
        int i = 10;
        while (null != cause && 0 < i--) {
            message = cause.getMessage();
            if (null == message) {
                cause = cause.getCause();
            } else {
                break;          
            }
        }
        if (null == message) {
            message = e.getClass().getName();
        }   
        return message;
    }

	@Override
	public void printStackTrace() {
		if (!(e instanceof TalendException || e instanceof TDieException)) {
			if(virtualComponentName!=null && currentComponent.indexOf(virtualComponentName+"_")==0){
				globalMap.put(virtualComponentName+"_ERROR_MESSAGE",getExceptionCauseMessage(e));
			}
			globalMap.put(currentComponent+"_ERROR_MESSAGE",getExceptionCauseMessage(e));
			System.err.println("Exception in component " + currentComponent + " (" + jobName + ")");
		}
		if (!(e instanceof TDieException)) {
			if(e instanceof TalendException){
				e.printStackTrace();
			} else {
				e.printStackTrace();
				e.printStackTrace(errorMessagePS);
				sgbm_export.this.exception = e;
			}
		}
		if (!(e instanceof TalendException)) {
		try {
			for (java.lang.reflect.Method m : this.getClass().getEnclosingClass().getMethods()) {
				if (m.getName().compareTo(currentComponent + "_error") == 0) {
					m.invoke(sgbm_export.this, new Object[] { e , currentComponent, globalMap});
					break;
				}
			}

			if(!(e instanceof TDieException)){
			}
		} catch (Exception e) {
			this.e.printStackTrace();
		}
		}
	}
}

			public void tPrejob_1_error(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {
				
				end_Hash.put(errorComponent, System.currentTimeMillis());
				
				status = "failure";
				
					tPrejob_1_onSubJobError(exception, errorComponent, globalMap);
			}
			
			public void tFileInputProperties_1_error(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {
				
				end_Hash.put(errorComponent, System.currentTimeMillis());
				
				status = "failure";
				
					tFileInputProperties_1_onSubJobError(exception, errorComponent, globalMap);
			}
			
			public void tContextLoad_1_error(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {
				
				end_Hash.put(errorComponent, System.currentTimeMillis());
				
				status = "failure";
				
					tFileInputProperties_1_onSubJobError(exception, errorComponent, globalMap);
			}
			
			public void tOracleConnection_1_error(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {
				
				end_Hash.put(errorComponent, System.currentTimeMillis());
				
				status = "failure";
				
					tOracleConnection_1_onSubJobError(exception, errorComponent, globalMap);
			}
			
			public void tSCPConnection_1_error(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {
				
				end_Hash.put(errorComponent, System.currentTimeMillis());
				
				status = "failure";
				
					tSCPConnection_1_onSubJobError(exception, errorComponent, globalMap);
			}
			
			public void tOracleInput_5_error(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {
				
				end_Hash.put(errorComponent, System.currentTimeMillis());
				
				status = "failure";
				
					tOracleInput_5_onSubJobError(exception, errorComponent, globalMap);
			}
			
			public void tXMLMap_1_error(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {
				
				end_Hash.put(errorComponent, System.currentTimeMillis());
				
				status = "failure";
				
					tOracleInput_5_onSubJobError(exception, errorComponent, globalMap);
			}
			
			public void tExtractXMLField_1_error(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {
				
				end_Hash.put(errorComponent, System.currentTimeMillis());
				
				status = "failure";
				
					tOracleInput_5_onSubJobError(exception, errorComponent, globalMap);
			}
			
			public void tMap_1_error(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {
				
				end_Hash.put(errorComponent, System.currentTimeMillis());
				
				status = "failure";
				
					tOracleInput_5_onSubJobError(exception, errorComponent, globalMap);
			}
			
			public void tJavaFlex_1_error(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {
				
				end_Hash.put(errorComponent, System.currentTimeMillis());
				
				status = "failure";
				
					tOracleInput_5_onSubJobError(exception, errorComponent, globalMap);
			}
			
			public void tFileArchive_1_error(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {
				
				end_Hash.put(errorComponent, System.currentTimeMillis());
				
				status = "failure";
				
					tFileArchive_1_onSubJobError(exception, errorComponent, globalMap);
			}
			
			public void tSCPPut_1_error(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {
				
				end_Hash.put(errorComponent, System.currentTimeMillis());
				
				status = "failure";
				
					tFileArchive_1_onSubJobError(exception, errorComponent, globalMap);
			}
			
			public void tOracleInput_1_error(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {
				
				end_Hash.put(errorComponent, System.currentTimeMillis());
				
				status = "failure";
				
					tOracleInput_1_onSubJobError(exception, errorComponent, globalMap);
			}
			
			public void tExtractXMLField_2_error(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {
				
				end_Hash.put(errorComponent, System.currentTimeMillis());
				
				status = "failure";
				
					tOracleInput_1_onSubJobError(exception, errorComponent, globalMap);
			}
			
			public void tOracleInput_2_error(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {
				
				end_Hash.put(errorComponent, System.currentTimeMillis());
				
				status = "failure";
				
					tOracleInput_2_onSubJobError(exception, errorComponent, globalMap);
			}
			
			public void tOracleInput_3_error(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {
				
				end_Hash.put(errorComponent, System.currentTimeMillis());
				
				status = "failure";
				
					tOracleInput_3_onSubJobError(exception, errorComponent, globalMap);
			}
			
			public void tExtractXMLField_3_error(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {
				
				end_Hash.put(errorComponent, System.currentTimeMillis());
				
				status = "failure";
				
					tOracleInput_3_onSubJobError(exception, errorComponent, globalMap);
			}
			
			public void tOracleInput_4_error(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {
				
				end_Hash.put(errorComponent, System.currentTimeMillis());
				
				status = "failure";
				
					tOracleInput_4_onSubJobError(exception, errorComponent, globalMap);
			}
			
			public void tOracleInput_6_error(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {
				
				end_Hash.put(errorComponent, System.currentTimeMillis());
				
				status = "failure";
				
					tOracleInput_6_onSubJobError(exception, errorComponent, globalMap);
			}
			
			public void tExtractXMLField_4_error(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {
				
				end_Hash.put(errorComponent, System.currentTimeMillis());
				
				status = "failure";
				
					tOracleInput_6_onSubJobError(exception, errorComponent, globalMap);
			}
			
			public void tOracleInput_7_error(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {
				
				end_Hash.put(errorComponent, System.currentTimeMillis());
				
				status = "failure";
				
					tOracleInput_7_onSubJobError(exception, errorComponent, globalMap);
			}
			
			public void tOracleInput_8_error(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {
				
				end_Hash.put(errorComponent, System.currentTimeMillis());
				
				status = "failure";
				
					tOracleInput_8_onSubJobError(exception, errorComponent, globalMap);
			}
			
			public void tExtractXMLField_5_error(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {
				
				end_Hash.put(errorComponent, System.currentTimeMillis());
				
				status = "failure";
				
					tOracleInput_8_onSubJobError(exception, errorComponent, globalMap);
			}
			
			public void tOracleInput_9_error(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {
				
				end_Hash.put(errorComponent, System.currentTimeMillis());
				
				status = "failure";
				
					tOracleInput_9_onSubJobError(exception, errorComponent, globalMap);
			}
			
			public void tPostjob_1_error(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {
				
				end_Hash.put(errorComponent, System.currentTimeMillis());
				
				status = "failure";
				
					tPostjob_1_onSubJobError(exception, errorComponent, globalMap);
			}
			
			public void tSCPClose_1_error(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {
				
				end_Hash.put(errorComponent, System.currentTimeMillis());
				
				status = "failure";
				
					tSCPClose_1_onSubJobError(exception, errorComponent, globalMap);
			}
			
			public void tOracleClose_1_error(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {
				
				end_Hash.put(errorComponent, System.currentTimeMillis());
				
				status = "failure";
				
					tOracleClose_1_onSubJobError(exception, errorComponent, globalMap);
			}
			
			public void tAdvancedHash_adress_error(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {
				
				end_Hash.put(errorComponent, System.currentTimeMillis());
				
				status = "failure";
				
					tOracleInput_1_onSubJobError(exception, errorComponent, globalMap);
			}
			
			public void tAdvancedXMLMapHash_adresse_error(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {
				
				end_Hash.put(errorComponent, System.currentTimeMillis());
				
				status = "failure";
				
					tOracleInput_2_onSubJobError(exception, errorComponent, globalMap);
			}
			
			public void tAdvancedHash_email_error(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {
				
				end_Hash.put(errorComponent, System.currentTimeMillis());
				
				status = "failure";
				
					tOracleInput_3_onSubJobError(exception, errorComponent, globalMap);
			}
			
			public void tAdvancedXMLMapHash_mail_error(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {
				
				end_Hash.put(errorComponent, System.currentTimeMillis());
				
				status = "failure";
				
					tOracleInput_4_onSubJobError(exception, errorComponent, globalMap);
			}
			
			public void tAdvancedHash_phone_error(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {
				
				end_Hash.put(errorComponent, System.currentTimeMillis());
				
				status = "failure";
				
					tOracleInput_6_onSubJobError(exception, errorComponent, globalMap);
			}
			
			public void tAdvancedXMLMapHash_telephone_error(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {
				
				end_Hash.put(errorComponent, System.currentTimeMillis());
				
				status = "failure";
				
					tOracleInput_7_onSubJobError(exception, errorComponent, globalMap);
			}
			
			public void tAdvancedHash_statistique_error(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {
				
				end_Hash.put(errorComponent, System.currentTimeMillis());
				
				status = "failure";
				
					tOracleInput_8_onSubJobError(exception, errorComponent, globalMap);
			}
			
			public void tAdvancedXMLMapHash_stat_error(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {
				
				end_Hash.put(errorComponent, System.currentTimeMillis());
				
				status = "failure";
				
					tOracleInput_9_onSubJobError(exception, errorComponent, globalMap);
			}
			
			public void tXMLMap_2_TXMLMAP_OUT_error(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {
				
							tXMLMap_2_TXMLMAP_IN_error(exception, errorComponent, globalMap);
						
						}
					
			public void tXMLMap_2_TXMLMAP_IN_error(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {
				
				end_Hash.put(errorComponent, System.currentTimeMillis());
				
				status = "failure";
				
					tOracleInput_1_onSubJobError(exception, errorComponent, globalMap);
			}
			
			public void tXMLMap_3_TXMLMAP_OUT_error(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {
				
							tXMLMap_3_TXMLMAP_IN_error(exception, errorComponent, globalMap);
						
						}
					
			public void tXMLMap_3_TXMLMAP_IN_error(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {
				
				end_Hash.put(errorComponent, System.currentTimeMillis());
				
				status = "failure";
				
					tOracleInput_3_onSubJobError(exception, errorComponent, globalMap);
			}
			
			public void tXMLMap_4_TXMLMAP_OUT_error(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {
				
							tXMLMap_4_TXMLMAP_IN_error(exception, errorComponent, globalMap);
						
						}
					
			public void tXMLMap_4_TXMLMAP_IN_error(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {
				
				end_Hash.put(errorComponent, System.currentTimeMillis());
				
				status = "failure";
				
					tOracleInput_6_onSubJobError(exception, errorComponent, globalMap);
			}
			
			public void tXMLMap_5_TXMLMAP_OUT_error(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {
				
							tXMLMap_5_TXMLMAP_IN_error(exception, errorComponent, globalMap);
						
						}
					
			public void tXMLMap_5_TXMLMAP_IN_error(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {
				
				end_Hash.put(errorComponent, System.currentTimeMillis());
				
				status = "failure";
				
					tOracleInput_8_onSubJobError(exception, errorComponent, globalMap);
			}
			
			public void tPrejob_1_onSubJobError(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {

resumeUtil.addLog("SYSTEM_LOG", "NODE:"+ errorComponent, "", Thread.currentThread().getId()+ "", "FATAL", "", exception.getMessage(), ResumeUtil.getExceptionStackTrace(exception),"");

			}
			public void tFileInputProperties_1_onSubJobError(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {

resumeUtil.addLog("SYSTEM_LOG", "NODE:"+ errorComponent, "", Thread.currentThread().getId()+ "", "FATAL", "", exception.getMessage(), ResumeUtil.getExceptionStackTrace(exception),"");

			}
			public void tOracleConnection_1_onSubJobError(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {

resumeUtil.addLog("SYSTEM_LOG", "NODE:"+ errorComponent, "", Thread.currentThread().getId()+ "", "FATAL", "", exception.getMessage(), ResumeUtil.getExceptionStackTrace(exception),"");

			}
			public void tSCPConnection_1_onSubJobError(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {

resumeUtil.addLog("SYSTEM_LOG", "NODE:"+ errorComponent, "", Thread.currentThread().getId()+ "", "FATAL", "", exception.getMessage(), ResumeUtil.getExceptionStackTrace(exception),"");

			}
			public void tOracleInput_5_onSubJobError(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {

resumeUtil.addLog("SYSTEM_LOG", "NODE:"+ errorComponent, "", Thread.currentThread().getId()+ "", "FATAL", "", exception.getMessage(), ResumeUtil.getExceptionStackTrace(exception),"");

			}
			public void tFileArchive_1_onSubJobError(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {

resumeUtil.addLog("SYSTEM_LOG", "NODE:"+ errorComponent, "", Thread.currentThread().getId()+ "", "FATAL", "", exception.getMessage(), ResumeUtil.getExceptionStackTrace(exception),"");

			}
			public void tOracleInput_1_onSubJobError(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {

resumeUtil.addLog("SYSTEM_LOG", "NODE:"+ errorComponent, "", Thread.currentThread().getId()+ "", "FATAL", "", exception.getMessage(), ResumeUtil.getExceptionStackTrace(exception),"");

			}
			public void tOracleInput_2_onSubJobError(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {

resumeUtil.addLog("SYSTEM_LOG", "NODE:"+ errorComponent, "", Thread.currentThread().getId()+ "", "FATAL", "", exception.getMessage(), ResumeUtil.getExceptionStackTrace(exception),"");

			}
			public void tOracleInput_3_onSubJobError(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {

resumeUtil.addLog("SYSTEM_LOG", "NODE:"+ errorComponent, "", Thread.currentThread().getId()+ "", "FATAL", "", exception.getMessage(), ResumeUtil.getExceptionStackTrace(exception),"");

			}
			public void tOracleInput_4_onSubJobError(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {

resumeUtil.addLog("SYSTEM_LOG", "NODE:"+ errorComponent, "", Thread.currentThread().getId()+ "", "FATAL", "", exception.getMessage(), ResumeUtil.getExceptionStackTrace(exception),"");

			}
			public void tOracleInput_6_onSubJobError(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {

resumeUtil.addLog("SYSTEM_LOG", "NODE:"+ errorComponent, "", Thread.currentThread().getId()+ "", "FATAL", "", exception.getMessage(), ResumeUtil.getExceptionStackTrace(exception),"");

			}
			public void tOracleInput_7_onSubJobError(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {

resumeUtil.addLog("SYSTEM_LOG", "NODE:"+ errorComponent, "", Thread.currentThread().getId()+ "", "FATAL", "", exception.getMessage(), ResumeUtil.getExceptionStackTrace(exception),"");

			}
			public void tOracleInput_8_onSubJobError(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {

resumeUtil.addLog("SYSTEM_LOG", "NODE:"+ errorComponent, "", Thread.currentThread().getId()+ "", "FATAL", "", exception.getMessage(), ResumeUtil.getExceptionStackTrace(exception),"");

			}
			public void tOracleInput_9_onSubJobError(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {

resumeUtil.addLog("SYSTEM_LOG", "NODE:"+ errorComponent, "", Thread.currentThread().getId()+ "", "FATAL", "", exception.getMessage(), ResumeUtil.getExceptionStackTrace(exception),"");

			}
			public void tPostjob_1_onSubJobError(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {

resumeUtil.addLog("SYSTEM_LOG", "NODE:"+ errorComponent, "", Thread.currentThread().getId()+ "", "FATAL", "", exception.getMessage(), ResumeUtil.getExceptionStackTrace(exception),"");

			}
			public void tSCPClose_1_onSubJobError(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {

resumeUtil.addLog("SYSTEM_LOG", "NODE:"+ errorComponent, "", Thread.currentThread().getId()+ "", "FATAL", "", exception.getMessage(), ResumeUtil.getExceptionStackTrace(exception),"");

			}
			public void tOracleClose_1_onSubJobError(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {

resumeUtil.addLog("SYSTEM_LOG", "NODE:"+ errorComponent, "", Thread.currentThread().getId()+ "", "FATAL", "", exception.getMessage(), ResumeUtil.getExceptionStackTrace(exception),"");

			}
		





public void tPrejob_1Process(final java.util.Map<String, Object> globalMap) throws TalendException {
	globalMap.put("tPrejob_1_SUBPROCESS_STATE", 0);

 final boolean execStat = this.execStat;
	
		String iterateId = "";
	
	
	String currentComponent = "";
	java.util.Map<String, Object> resourceMap = new java.util.HashMap<String, Object>();

	try {

			String currentMethodName = new java.lang.Exception().getStackTrace()[0].getMethodName();
			boolean resumeIt = currentMethodName.equals(resumeEntryMethodName);
			if( resumeEntryMethodName == null || resumeIt || globalResumeTicket){//start the resume
				globalResumeTicket = true;



		


	
	/**
	 * [tPrejob_1 begin ] start
	 */

	

	
		
		ok_Hash.put("tPrejob_1", false);
		start_Hash.put("tPrejob_1", System.currentTimeMillis());
		
	
	currentComponent="tPrejob_1";

	
		int tos_count_tPrejob_1 = 0;
		
    	class BytesLimit65535_tPrejob_1{
    		public void limitLog4jByte() throws Exception{
    			
    		}
    	}
    	
        new BytesLimit65535_tPrejob_1().limitLog4jByte();

 



/**
 * [tPrejob_1 begin ] stop
 */
	
	/**
	 * [tPrejob_1 main ] start
	 */

	

	
	
	currentComponent="tPrejob_1";

	

 


	tos_count_tPrejob_1++;

/**
 * [tPrejob_1 main ] stop
 */
	
	/**
	 * [tPrejob_1 end ] start
	 */

	

	
	
	currentComponent="tPrejob_1";

	

 

ok_Hash.put("tPrejob_1", true);
end_Hash.put("tPrejob_1", System.currentTimeMillis());

				if(execStat){   
   	 				runStat.updateStatOnConnection("OnComponentOk1", 0, "ok");
				}
				tFileInputProperties_1Process(globalMap);



/**
 * [tPrejob_1 end ] stop
 */
				}//end the resume

				



	
			}catch(java.lang.Exception e){	
				
				TalendException te = new TalendException(e, currentComponent, globalMap);
				
				throw te;
			}catch(java.lang.Error error){	
				
					runStat.stopThreadStat();
				
				throw error;
			}finally{
				
				try{
					
	
	/**
	 * [tPrejob_1 finally ] start
	 */

	

	
	
	currentComponent="tPrejob_1";

	

 



/**
 * [tPrejob_1 finally ] stop
 */
				}catch(java.lang.Exception e){	
					//ignore
				}catch(java.lang.Error error){
					//ignore
				}
				resourceMap = null;
			}
		

		globalMap.put("tPrejob_1_SUBPROCESS_STATE", 1);
	}
	


public static class row5Struct implements routines.system.IPersistableRow<row5Struct> {
    final static byte[] commonByteArrayLock_LDAP_sgbm_export = new byte[0];
    static byte[] commonByteArray_LDAP_sgbm_export = new byte[0];

	
			    public String key;

				public String getKey () {
					return this.key;
				}
				
			    public String value;

				public String getValue () {
					return this.value;
				}
				



	private String readString(ObjectInputStream dis) throws IOException{
		String strReturn = null;
		int length = 0;
        length = dis.readInt();
		if (length == -1) {
			strReturn = null;
		} else {
			if(length > commonByteArray_LDAP_sgbm_export.length) {
				if(length < 1024 && commonByteArray_LDAP_sgbm_export.length == 0) {
   					commonByteArray_LDAP_sgbm_export = new byte[1024];
				} else {
   					commonByteArray_LDAP_sgbm_export = new byte[2 * length];
   				}
			}
			dis.readFully(commonByteArray_LDAP_sgbm_export, 0, length);
			strReturn = new String(commonByteArray_LDAP_sgbm_export, 0, length, utf8Charset);
		}
		return strReturn;
	}

    private void writeString(String str, ObjectOutputStream dos) throws IOException{
		if(str == null) {
            dos.writeInt(-1);
		} else {
            byte[] byteArray = str.getBytes(utf8Charset);
	    	dos.writeInt(byteArray.length);
			dos.write(byteArray);
    	}
    }

    public void readData(ObjectInputStream dis) {

		synchronized(commonByteArrayLock_LDAP_sgbm_export) {

        	try {

        		int length = 0;
		
					this.key = readString(dis);
					
					this.value = readString(dis);
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);

		

        }

		

      }


    }

    public void writeData(ObjectOutputStream dos) {
        try {

		
					// String
				
						writeString(this.key,dos);
					
					// String
				
						writeString(this.value,dos);
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);
        }


    }


    public String toString() {

		StringBuilder sb = new StringBuilder();
		sb.append(super.toString());
		sb.append("[");
		sb.append("key="+key);
		sb.append(",value="+value);
	    sb.append("]");

	    return sb.toString();
    }

    /**
     * Compare keys
     */
    public int compareTo(row5Struct other) {

		int returnValue = -1;
		
	    return returnValue;
    }


    private int checkNullsAndCompare(Object object1, Object object2) {
        int returnValue = 0;
		if (object1 instanceof Comparable && object2 instanceof Comparable) {
            returnValue = ((Comparable) object1).compareTo(object2);
        } else if (object1 != null && object2 != null) {
            returnValue = compareStrings(object1.toString(), object2.toString());
        } else if (object1 == null && object2 != null) {
            returnValue = 1;
        } else if (object1 != null && object2 == null) {
            returnValue = -1;
        } else {
            returnValue = 0;
        }

        return returnValue;
    }

    private int compareStrings(String string1, String string2) {
        return string1.compareTo(string2);
    }


}
public void tFileInputProperties_1Process(final java.util.Map<String, Object> globalMap) throws TalendException {
	globalMap.put("tFileInputProperties_1_SUBPROCESS_STATE", 0);

 final boolean execStat = this.execStat;
	
		String iterateId = "";
	
	
	String currentComponent = "";
	java.util.Map<String, Object> resourceMap = new java.util.HashMap<String, Object>();

	try {

			String currentMethodName = new java.lang.Exception().getStackTrace()[0].getMethodName();
			boolean resumeIt = currentMethodName.equals(resumeEntryMethodName);
			if( resumeEntryMethodName == null || resumeIt || globalResumeTicket){//start the resume
				globalResumeTicket = true;



		row5Struct row5 = new row5Struct();




	
	/**
	 * [tContextLoad_1 begin ] start
	 */

	

	
		
		ok_Hash.put("tContextLoad_1", false);
		start_Hash.put("tContextLoad_1", System.currentTimeMillis());
		
	
	currentComponent="tContextLoad_1";

	
			if (execStat) {
				if(resourceMap.get("inIterateVComp") == null){
					
						runStat.updateStatOnConnection("row5" + iterateId, 0, 0);
					
				}
			} 

		
		int tos_count_tContextLoad_1 = 0;
		
    	class BytesLimit65535_tContextLoad_1{
    		public void limitLog4jByte() throws Exception{
    			
    		}
    	}
    	
        new BytesLimit65535_tContextLoad_1().limitLog4jByte();
	java.util.List<String> assignList_tContextLoad_1 = new java.util.ArrayList<String>();
	java.util.List<String> newPropertyList_tContextLoad_1 = new java.util.ArrayList<String>();
	java.util.List<String> noAssignList_tContextLoad_1 = new java.util.ArrayList<String>();
	int nb_line_tContextLoad_1 = 0;

 



/**
 * [tContextLoad_1 begin ] stop
 */



	
	/**
	 * [tFileInputProperties_1 begin ] start
	 */

	

	
		
		ok_Hash.put("tFileInputProperties_1", false);
		start_Hash.put("tFileInputProperties_1", System.currentTimeMillis());
		
	
	currentComponent="tFileInputProperties_1";

	
		int tos_count_tFileInputProperties_1 = 0;
		
    	class BytesLimit65535_tFileInputProperties_1{
    		public void limitLog4jByte() throws Exception{
    			
    		}
    	}
    	
        new BytesLimit65535_tFileInputProperties_1().limitLog4jByte();

	java.io.File file_tFileInputProperties_1 = new java.io.File(context.sigb_param_file);
	int nb_line_tFileInputProperties_1 = 0;
	java.util.Properties properties_tFileInputProperties_1 = new java.util.Properties();
	java.io.FileInputStream fis_tFileInputProperties_1=new java.io.FileInputStream(file_tFileInputProperties_1);
   	try{
		properties_tFileInputProperties_1.load(fis_tFileInputProperties_1);
		java.util.Enumeration enumeration_tFileInputProperties_1 = properties_tFileInputProperties_1.propertyNames();
		while (enumeration_tFileInputProperties_1.hasMoreElements()) {
			nb_line_tFileInputProperties_1++;
			row5.key = (String)enumeration_tFileInputProperties_1.nextElement();
			row5.value = (String)properties_tFileInputProperties_1.getProperty(row5.key);

 



/**
 * [tFileInputProperties_1 begin ] stop
 */
	
	/**
	 * [tFileInputProperties_1 main ] start
	 */

	

	
	
	currentComponent="tFileInputProperties_1";

	

 


	tos_count_tFileInputProperties_1++;

/**
 * [tFileInputProperties_1 main ] stop
 */

	
	/**
	 * [tContextLoad_1 main ] start
	 */

	

	
	
	currentComponent="tContextLoad_1";

	

			//row5
			//row5


			
				if(execStat){
					runStat.updateStatOnConnection("row5"+iterateId,1, 1);
				} 
			

		
        //////////////////////////
        String tmp_key_tContextLoad_1 = null;
                    String key_tContextLoad_1 = null;
                      if (row5.key != null){
                          tmp_key_tContextLoad_1 = row5.key.trim();
                        if ((tmp_key_tContextLoad_1.startsWith("#") || tmp_key_tContextLoad_1.startsWith("!") )){
                          tmp_key_tContextLoad_1 = null;
                        } else {
                          row5.key = tmp_key_tContextLoad_1;
                        }
                      }
                        if(row5.key != null) {
                    key_tContextLoad_1 =
                        row5.key;
                        }
                    String value_tContextLoad_1 = null;
                        if(row5.value != null) {
                    value_tContextLoad_1 =
                        row5.value;
                        }
				
				String currentValue_tContextLoad_1 = value_tContextLoad_1;
				

  if (tmp_key_tContextLoad_1 != null){
  try{
        if(key_tContextLoad_1!=null && "oracle_login".equals(key_tContextLoad_1))
        {
           context.oracle_login=value_tContextLoad_1;
        }

        if(key_tContextLoad_1!=null && "oracle_password".equals(key_tContextLoad_1))
        {
           context.oracle_password=value_tContextLoad_1;
        }

        if(key_tContextLoad_1!=null && "oracle_port".equals(key_tContextLoad_1))
        {
           context.oracle_port=value_tContextLoad_1;
        }

        if(key_tContextLoad_1!=null && "oracle_schema".equals(key_tContextLoad_1))
        {
           context.oracle_schema=value_tContextLoad_1;
        }

        if(key_tContextLoad_1!=null && "oracle_server".equals(key_tContextLoad_1))
        {
           context.oracle_server=value_tContextLoad_1;
        }

        if(key_tContextLoad_1!=null && "oracle_sid".equals(key_tContextLoad_1))
        {
           context.oracle_sid=value_tContextLoad_1;
        }

        if(key_tContextLoad_1!=null && "sigb_active".equals(key_tContextLoad_1))
        {
           context.sigb_active=value_tContextLoad_1;
        }

        if(key_tContextLoad_1!=null && "sigb_biu_cle_publique".equals(key_tContextLoad_1))
        {
           context.sigb_biu_cle_publique=value_tContextLoad_1;
        }

        if(key_tContextLoad_1!=null && "sigb_biu_dir".equals(key_tContextLoad_1))
        {
           context.sigb_biu_dir=value_tContextLoad_1;
        }

        if(key_tContextLoad_1!=null && "sigb_biu_host".equals(key_tContextLoad_1))
        {
           context.sigb_biu_host=value_tContextLoad_1;
        }

        if(key_tContextLoad_1!=null && "sigb_biu_password".equals(key_tContextLoad_1))
        {
           context.sigb_biu_password=value_tContextLoad_1;
        }

        if(key_tContextLoad_1!=null && "sigb_biu_port".equals(key_tContextLoad_1))
        {

                context.sigb_biu_port=Integer.parseInt(value_tContextLoad_1);

        }

        if(key_tContextLoad_1!=null && "sigb_biu_username".equals(key_tContextLoad_1))
        {
           context.sigb_biu_username=value_tContextLoad_1;
        }

        if(key_tContextLoad_1!=null && "sigb_cataloger_level".equals(key_tContextLoad_1))
        {
           context.sigb_cataloger_level=value_tContextLoad_1;
        }

        if(key_tContextLoad_1!=null && "sigb_cataloger_level_desc".equals(key_tContextLoad_1))
        {
           context.sigb_cataloger_level_desc=value_tContextLoad_1;
        }

        if(key_tContextLoad_1!=null && "sigb_external".equals(key_tContextLoad_1))
        {
           context.sigb_external=value_tContextLoad_1;
        }

        if(key_tContextLoad_1!=null && "sigb_external_desc".equals(key_tContextLoad_1))
        {
           context.sigb_external_desc=value_tContextLoad_1;
        }

        if(key_tContextLoad_1!=null && "sigb_external_id".equals(key_tContextLoad_1))
        {
           context.sigb_external_id=value_tContextLoad_1;
        }

        if(key_tContextLoad_1!=null && "sigb_file_name".equals(key_tContextLoad_1))
        {
           context.sigb_file_name=value_tContextLoad_1;
        }

        if(key_tContextLoad_1!=null && "sigb_files_dir".equals(key_tContextLoad_1))
        {
           context.sigb_files_dir=value_tContextLoad_1;
        }

        if(key_tContextLoad_1!=null && "sigb_id_type_eppn".equals(key_tContextLoad_1))
        {
           context.sigb_id_type_eppn=value_tContextLoad_1;
        }

        if(key_tContextLoad_1!=null && "sigb_param_file".equals(key_tContextLoad_1))
        {
           context.sigb_param_file=value_tContextLoad_1;
        }

        if(key_tContextLoad_1!=null && "sigb_record_type".equals(key_tContextLoad_1))
        {
           context.sigb_record_type=value_tContextLoad_1;
        }

        if(key_tContextLoad_1!=null && "sigb_user_group".equals(key_tContextLoad_1))
        {
           context.sigb_user_group=value_tContextLoad_1;
        }

        if(key_tContextLoad_1!=null && "sigb_user_group_desc".equals(key_tContextLoad_1))
        {
           context.sigb_user_group_desc=value_tContextLoad_1;
        }


        if (context.getProperty(key_tContextLoad_1)!=null)
        {
            assignList_tContextLoad_1.add(key_tContextLoad_1);
        }else  {
            newPropertyList_tContextLoad_1.add(key_tContextLoad_1);
        }
        if(value_tContextLoad_1 == null){
            context.setProperty(key_tContextLoad_1, "");
        }else{
            context.setProperty(key_tContextLoad_1,value_tContextLoad_1);
        }
    }catch(java.lang.Exception e){
        System.err.println("Setting a value for the key \"" + key_tContextLoad_1 + "\" has failed. Error message: " + e.getMessage());
    }
        nb_line_tContextLoad_1++;
    }
        //////////////////////////

 


	tos_count_tContextLoad_1++;

/**
 * [tContextLoad_1 main ] stop
 */



	
	/**
	 * [tFileInputProperties_1 end ] start
	 */

	

	
	
	currentComponent="tFileInputProperties_1";

	

		}
	}finally{
		if(fis_tFileInputProperties_1!=null){
			fis_tFileInputProperties_1.close();
		}
	}
globalMap.put("tFileInputProperties_1_NB_LINE", nb_line_tFileInputProperties_1);
 

ok_Hash.put("tFileInputProperties_1", true);
end_Hash.put("tFileInputProperties_1", System.currentTimeMillis());




/**
 * [tFileInputProperties_1 end ] stop
 */

	
	/**
	 * [tContextLoad_1 end ] start
	 */

	

	
	
	currentComponent="tContextLoad_1";

	
	
	java.util.Enumeration<?> enu_tContextLoad_1 = context.propertyNames();
    while(enu_tContextLoad_1.hasMoreElements())
    {           
    	String key_tContextLoad_1 = (String)enu_tContextLoad_1.nextElement();
        if(!assignList_tContextLoad_1.contains(key_tContextLoad_1) && !newPropertyList_tContextLoad_1.contains(key_tContextLoad_1))
        {
            noAssignList_tContextLoad_1.add(key_tContextLoad_1);
        }          
    } 

    String newPropertyStr_tContextLoad_1 = newPropertyList_tContextLoad_1.toString();
    String newProperty_tContextLoad_1 = newPropertyStr_tContextLoad_1.substring(1, newPropertyStr_tContextLoad_1.length() - 1);
    
    String noAssignStr_tContextLoad_1 = noAssignList_tContextLoad_1.toString();
    String noAssign_tContextLoad_1 = noAssignStr_tContextLoad_1.substring(1, noAssignStr_tContextLoad_1.length() - 1);
    
    globalMap.put("tContextLoad_1_KEY_NOT_INCONTEXT", newProperty_tContextLoad_1);
    globalMap.put("tContextLoad_1_KEY_NOT_LOADED", noAssign_tContextLoad_1);

    globalMap.put("tContextLoad_1_NB_LINE",nb_line_tContextLoad_1);

	List<String> parametersToEncrypt_tContextLoad_1 = new java.util.ArrayList<String>();
	
	
	resumeUtil.addLog("NODE", "NODE:tContextLoad_1", "", Thread.currentThread().getId() + "", "","","","",resumeUtil.convertToJsonText(context,parametersToEncrypt_tContextLoad_1));    
    
			if(execStat){
				if(resourceMap.get("inIterateVComp") == null || !((Boolean)resourceMap.get("inIterateVComp"))){
			 		runStat.updateStatOnConnection("row5"+iterateId,2, 0); 
			 	}
			}
		
 

ok_Hash.put("tContextLoad_1", true);
end_Hash.put("tContextLoad_1", System.currentTimeMillis());

				if(execStat){   
   	 				runStat.updateStatOnConnection("OnComponentOk2", 0, "ok");
				}
				tOracleConnection_1Process(globalMap);



/**
 * [tContextLoad_1 end ] stop
 */



				}//end the resume

				



	
			}catch(java.lang.Exception e){	
				
				TalendException te = new TalendException(e, currentComponent, globalMap);
				
				throw te;
			}catch(java.lang.Error error){	
				
					runStat.stopThreadStat();
				
				throw error;
			}finally{
				
				try{
					
	
	/**
	 * [tFileInputProperties_1 finally ] start
	 */

	

	
	
	currentComponent="tFileInputProperties_1";

	

 



/**
 * [tFileInputProperties_1 finally ] stop
 */

	
	/**
	 * [tContextLoad_1 finally ] start
	 */

	

	
	
	currentComponent="tContextLoad_1";

	

 



/**
 * [tContextLoad_1 finally ] stop
 */



				}catch(java.lang.Exception e){	
					//ignore
				}catch(java.lang.Error error){
					//ignore
				}
				resourceMap = null;
			}
		

		globalMap.put("tFileInputProperties_1_SUBPROCESS_STATE", 1);
	}
	

public void tOracleConnection_1Process(final java.util.Map<String, Object> globalMap) throws TalendException {
	globalMap.put("tOracleConnection_1_SUBPROCESS_STATE", 0);

 final boolean execStat = this.execStat;
	
		String iterateId = "";
	
	
	String currentComponent = "";
	java.util.Map<String, Object> resourceMap = new java.util.HashMap<String, Object>();

	try {

			String currentMethodName = new java.lang.Exception().getStackTrace()[0].getMethodName();
			boolean resumeIt = currentMethodName.equals(resumeEntryMethodName);
			if( resumeEntryMethodName == null || resumeIt || globalResumeTicket){//start the resume
				globalResumeTicket = true;



		


	
	/**
	 * [tOracleConnection_1 begin ] start
	 */

	

	
		
		ok_Hash.put("tOracleConnection_1", false);
		start_Hash.put("tOracleConnection_1", System.currentTimeMillis());
		
	
	currentComponent="tOracleConnection_1";

	
		int tos_count_tOracleConnection_1 = 0;
		
    	class BytesLimit65535_tOracleConnection_1{
    		public void limitLog4jByte() throws Exception{
    			
    		}
    	}
    	
        new BytesLimit65535_tOracleConnection_1().limitLog4jByte();
	

	
        String url_tOracleConnection_1 = "jdbc:oracle:thin:@" + context.oracle_server + ":" + context.oracle_port + ":" + context.oracle_sid;
    	globalMap.put("connectionType_" + "tOracleConnection_1", "ORACLE_SID");

	String dbUser_tOracleConnection_1 = context.oracle_login;
	
	
		
	final String decryptedPassword_tOracleConnection_1 = context.oracle_password; 
		String dbPwd_tOracleConnection_1 = decryptedPassword_tOracleConnection_1;
	

	java.sql.Connection conn_tOracleConnection_1 = null;
	
		
			String driverClass_tOracleConnection_1 = "oracle.jdbc.OracleDriver";
			java.lang.Class.forName(driverClass_tOracleConnection_1);
		
			conn_tOracleConnection_1 = java.sql.DriverManager.getConnection(url_tOracleConnection_1,dbUser_tOracleConnection_1,dbPwd_tOracleConnection_1);

		globalMap.put("conn_tOracleConnection_1", conn_tOracleConnection_1);
	if (null != conn_tOracleConnection_1) {
		
			conn_tOracleConnection_1.setAutoCommit(false);
	}
        globalMap.put("host_" + "tOracleConnection_1",context.oracle_server);
        globalMap.put("port_" + "tOracleConnection_1",context.oracle_port);
        globalMap.put("dbname_" + "tOracleConnection_1",context.oracle_sid);

	globalMap.put("conn_" + "tOracleConnection_1",conn_tOracleConnection_1);
	globalMap.put("dbschema_" + "tOracleConnection_1", context.oracle_schema);
	globalMap.put("username_" + "tOracleConnection_1",context.oracle_login);
	globalMap.put("password_" + "tOracleConnection_1",dbPwd_tOracleConnection_1);

 



/**
 * [tOracleConnection_1 begin ] stop
 */
	
	/**
	 * [tOracleConnection_1 main ] start
	 */

	

	
	
	currentComponent="tOracleConnection_1";

	

 


	tos_count_tOracleConnection_1++;

/**
 * [tOracleConnection_1 main ] stop
 */
	
	/**
	 * [tOracleConnection_1 end ] start
	 */

	

	
	
	currentComponent="tOracleConnection_1";

	

 

ok_Hash.put("tOracleConnection_1", true);
end_Hash.put("tOracleConnection_1", System.currentTimeMillis());

				if(execStat){   
   	 				runStat.updateStatOnConnection("OnComponentOk3", 0, "ok");
				}
				tSCPConnection_1Process(globalMap);



/**
 * [tOracleConnection_1 end ] stop
 */
				}//end the resume

				



	
			}catch(java.lang.Exception e){	
				
				TalendException te = new TalendException(e, currentComponent, globalMap);
				
				throw te;
			}catch(java.lang.Error error){	
				
					runStat.stopThreadStat();
				
				throw error;
			}finally{
				
				try{
					
	
	/**
	 * [tOracleConnection_1 finally ] start
	 */

	

	
	
	currentComponent="tOracleConnection_1";

	

 



/**
 * [tOracleConnection_1 finally ] stop
 */
				}catch(java.lang.Exception e){	
					//ignore
				}catch(java.lang.Error error){
					//ignore
				}
				resourceMap = null;
			}
		

		globalMap.put("tOracleConnection_1_SUBPROCESS_STATE", 1);
	}
	

public void tSCPConnection_1Process(final java.util.Map<String, Object> globalMap) throws TalendException {
	globalMap.put("tSCPConnection_1_SUBPROCESS_STATE", 0);

 final boolean execStat = this.execStat;
	
		String iterateId = "";
	
	
	String currentComponent = "";
	java.util.Map<String, Object> resourceMap = new java.util.HashMap<String, Object>();

	try {

			String currentMethodName = new java.lang.Exception().getStackTrace()[0].getMethodName();
			boolean resumeIt = currentMethodName.equals(resumeEntryMethodName);
			if( resumeEntryMethodName == null || resumeIt || globalResumeTicket){//start the resume
				globalResumeTicket = true;



		


	
	/**
	 * [tSCPConnection_1 begin ] start
	 */

	

	
		
		ok_Hash.put("tSCPConnection_1", false);
		start_Hash.put("tSCPConnection_1", System.currentTimeMillis());
		
	
	currentComponent="tSCPConnection_1";

	
		int tos_count_tSCPConnection_1 = 0;
		
    	class BytesLimit65535_tSCPConnection_1{
    		public void limitLog4jByte() throws Exception{
    			
    		}
    	}
    	
        new BytesLimit65535_tSCPConnection_1().limitLog4jByte();

 	
	String hostname_tSCPConnection_1 = context.sigb_biu_host;
    String username_tSCPConnection_1 = context.sigb_biu_username;
    /* Create a connection instance */
			ch.ethz.ssh2.Connection conn_tSCPConnection_1 = new ch.ethz.ssh2.Connection(hostname_tSCPConnection_1,context.sigb_biu_port);
              /* Now connect */
		
        conn_tSCPConnection_1.connect();
		
			
        	java.io.File keyfile_tSCPConnection_1 = new java.io.File(context.sigb_biu_cle_publique); 
        	
            
	final String decryptedPassword_tSCPConnection_1 = context.sigb_biu_password; 
        	
            boolean isAuthenticated_tSCPConnection_1 = conn_tSCPConnection_1.authenticateWithPublicKey(username_tSCPConnection_1, keyfile_tSCPConnection_1, decryptedPassword_tSCPConnection_1);
			if (isAuthenticated_tSCPConnection_1 == false){
                throw new RuntimeException("Authentication failed.");
			}
			
		globalMap.put("conn_tSCPConnection_1",conn_tSCPConnection_1);

 



/**
 * [tSCPConnection_1 begin ] stop
 */
	
	/**
	 * [tSCPConnection_1 main ] start
	 */

	

	
	
	currentComponent="tSCPConnection_1";

	

 


	tos_count_tSCPConnection_1++;

/**
 * [tSCPConnection_1 main ] stop
 */
	
	/**
	 * [tSCPConnection_1 end ] start
	 */

	

	
	
	currentComponent="tSCPConnection_1";

	

 

ok_Hash.put("tSCPConnection_1", true);
end_Hash.put("tSCPConnection_1", System.currentTimeMillis());




/**
 * [tSCPConnection_1 end ] stop
 */
				}//end the resume

				
				    			if(resumeEntryMethodName == null || globalResumeTicket){
				    				resumeUtil.addLog("CHECKPOINT", "CONNECTION:SUBJOB_OK:tSCPConnection_1:OnSubjobOk", "", Thread.currentThread().getId() + "", "", "", "", "", "");
								}	    				    			
					    	
								if(execStat){    	
									runStat.updateStatOnConnection("OnSubjobOk1", 0, "ok");
								} 
							
							tOracleInput_5Process(globalMap); 
						



	
			}catch(java.lang.Exception e){	
				
				TalendException te = new TalendException(e, currentComponent, globalMap);
				
				throw te;
			}catch(java.lang.Error error){	
				
					runStat.stopThreadStat();
				
				throw error;
			}finally{
				
				try{
					
	
	/**
	 * [tSCPConnection_1 finally ] start
	 */

	

	
	
	currentComponent="tSCPConnection_1";

	

 



/**
 * [tSCPConnection_1 finally ] stop
 */
				}catch(java.lang.Exception e){	
					//ignore
				}catch(java.lang.Error error){
					//ignore
				}
				resourceMap = null;
			}
		

		globalMap.put("tSCPConnection_1_SUBPROCESS_STATE", 1);
	}
	


public static class out1Struct implements routines.system.IPersistableRow<out1Struct> {
    final static byte[] commonByteArrayLock_LDAP_sgbm_export = new byte[0];
    static byte[] commonByteArray_LDAP_sgbm_export = new byte[0];

	
			    public String user;

				public String getUser () {
					return this.user;
				}
				
			    public String CODE_BARRE;

				public String getCODE_BARRE () {
					return this.CODE_BARRE;
				}
				



	private String readString(ObjectInputStream dis) throws IOException{
		String strReturn = null;
		int length = 0;
        length = dis.readInt();
		if (length == -1) {
			strReturn = null;
		} else {
			if(length > commonByteArray_LDAP_sgbm_export.length) {
				if(length < 1024 && commonByteArray_LDAP_sgbm_export.length == 0) {
   					commonByteArray_LDAP_sgbm_export = new byte[1024];
				} else {
   					commonByteArray_LDAP_sgbm_export = new byte[2 * length];
   				}
			}
			dis.readFully(commonByteArray_LDAP_sgbm_export, 0, length);
			strReturn = new String(commonByteArray_LDAP_sgbm_export, 0, length, utf8Charset);
		}
		return strReturn;
	}

    private void writeString(String str, ObjectOutputStream dos) throws IOException{
		if(str == null) {
            dos.writeInt(-1);
		} else {
            byte[] byteArray = str.getBytes(utf8Charset);
	    	dos.writeInt(byteArray.length);
			dos.write(byteArray);
    	}
    }

    public void readData(ObjectInputStream dis) {

		synchronized(commonByteArrayLock_LDAP_sgbm_export) {

        	try {

        		int length = 0;
		
					this.user = readString(dis);
					
					this.CODE_BARRE = readString(dis);
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);

		

        }

		

      }


    }

    public void writeData(ObjectOutputStream dos) {
        try {

		
					// String
				
						writeString(this.user,dos);
					
					// String
				
						writeString(this.CODE_BARRE,dos);
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);
        }


    }


    public String toString() {

		StringBuilder sb = new StringBuilder();
		sb.append(super.toString());
		sb.append("[");
		sb.append("user="+user);
		sb.append(",CODE_BARRE="+CODE_BARRE);
	    sb.append("]");

	    return sb.toString();
    }

    /**
     * Compare keys
     */
    public int compareTo(out1Struct other) {

		int returnValue = -1;
		
	    return returnValue;
    }


    private int checkNullsAndCompare(Object object1, Object object2) {
        int returnValue = 0;
		if (object1 instanceof Comparable && object2 instanceof Comparable) {
            returnValue = ((Comparable) object1).compareTo(object2);
        } else if (object1 != null && object2 != null) {
            returnValue = compareStrings(object1.toString(), object2.toString());
        } else if (object1 == null && object2 != null) {
            returnValue = 1;
        } else if (object1 != null && object2 == null) {
            returnValue = -1;
        } else {
            returnValue = 0;
        }

        return returnValue;
    }

    private int compareStrings(String string1, String string2) {
        return string1.compareTo(string2);
    }


}

public static class infosStruct implements routines.system.IPersistableRow<infosStruct> {
    final static byte[] commonByteArrayLock_LDAP_sgbm_export = new byte[0];
    static byte[] commonByteArray_LDAP_sgbm_export = new byte[0];

	
			    public routines.system.Document document;

				public routines.system.Document getDocument () {
					return this.document;
				}
				
			    public String CODE_BARRE;

				public String getCODE_BARRE () {
					return this.CODE_BARRE;
				}
				



	private String readString(ObjectInputStream dis) throws IOException{
		String strReturn = null;
		int length = 0;
        length = dis.readInt();
		if (length == -1) {
			strReturn = null;
		} else {
			if(length > commonByteArray_LDAP_sgbm_export.length) {
				if(length < 1024 && commonByteArray_LDAP_sgbm_export.length == 0) {
   					commonByteArray_LDAP_sgbm_export = new byte[1024];
				} else {
   					commonByteArray_LDAP_sgbm_export = new byte[2 * length];
   				}
			}
			dis.readFully(commonByteArray_LDAP_sgbm_export, 0, length);
			strReturn = new String(commonByteArray_LDAP_sgbm_export, 0, length, utf8Charset);
		}
		return strReturn;
	}

    private void writeString(String str, ObjectOutputStream dos) throws IOException{
		if(str == null) {
            dos.writeInt(-1);
		} else {
            byte[] byteArray = str.getBytes(utf8Charset);
	    	dos.writeInt(byteArray.length);
			dos.write(byteArray);
    	}
    }

    public void readData(ObjectInputStream dis) {

		synchronized(commonByteArrayLock_LDAP_sgbm_export) {

        	try {

        		int length = 0;
		
						this.document = (routines.system.Document) dis.readObject();
					
					this.CODE_BARRE = readString(dis);
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);

		
			} catch(ClassNotFoundException eCNFE) {
				 throw new RuntimeException(eCNFE);
		

        }

		

      }


    }

    public void writeData(ObjectOutputStream dos) {
        try {

		
					// Document
				
       			    	dos.writeObject(this.document);
					
					// String
				
						writeString(this.CODE_BARRE,dos);
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);
        }


    }


    public String toString() {

		StringBuilder sb = new StringBuilder();
		sb.append(super.toString());
		sb.append("[");
		sb.append("document="+String.valueOf(document));
		sb.append(",CODE_BARRE="+CODE_BARRE);
	    sb.append("]");

	    return sb.toString();
    }

    /**
     * Compare keys
     */
    public int compareTo(infosStruct other) {

		int returnValue = -1;
		
	    return returnValue;
    }


    private int checkNullsAndCompare(Object object1, Object object2) {
        int returnValue = 0;
		if (object1 instanceof Comparable && object2 instanceof Comparable) {
            returnValue = ((Comparable) object1).compareTo(object2);
        } else if (object1 != null && object2 != null) {
            returnValue = compareStrings(object1.toString(), object2.toString());
        } else if (object1 == null && object2 != null) {
            returnValue = 1;
        } else if (object1 != null && object2 == null) {
            returnValue = -1;
        } else {
            returnValue = 0;
        }

        return returnValue;
    }

    private int compareStrings(String string1, String string2) {
        return string1.compareTo(string2);
    }


}

public static class xmlStruct implements routines.system.IPersistableRow<xmlStruct> {
    final static byte[] commonByteArrayLock_LDAP_sgbm_export = new byte[0];
    static byte[] commonByteArray_LDAP_sgbm_export = new byte[0];

	
			    public routines.system.Document document;

				public routines.system.Document getDocument () {
					return this.document;
				}
				
			    public String CODE_BARRE;

				public String getCODE_BARRE () {
					return this.CODE_BARRE;
				}
				



	private String readString(ObjectInputStream dis) throws IOException{
		String strReturn = null;
		int length = 0;
        length = dis.readInt();
		if (length == -1) {
			strReturn = null;
		} else {
			if(length > commonByteArray_LDAP_sgbm_export.length) {
				if(length < 1024 && commonByteArray_LDAP_sgbm_export.length == 0) {
   					commonByteArray_LDAP_sgbm_export = new byte[1024];
				} else {
   					commonByteArray_LDAP_sgbm_export = new byte[2 * length];
   				}
			}
			dis.readFully(commonByteArray_LDAP_sgbm_export, 0, length);
			strReturn = new String(commonByteArray_LDAP_sgbm_export, 0, length, utf8Charset);
		}
		return strReturn;
	}

    private void writeString(String str, ObjectOutputStream dos) throws IOException{
		if(str == null) {
            dos.writeInt(-1);
		} else {
            byte[] byteArray = str.getBytes(utf8Charset);
	    	dos.writeInt(byteArray.length);
			dos.write(byteArray);
    	}
    }

    public void readData(ObjectInputStream dis) {

		synchronized(commonByteArrayLock_LDAP_sgbm_export) {

        	try {

        		int length = 0;
		
						this.document = (routines.system.Document) dis.readObject();
					
					this.CODE_BARRE = readString(dis);
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);

		
			} catch(ClassNotFoundException eCNFE) {
				 throw new RuntimeException(eCNFE);
		

        }

		

      }


    }

    public void writeData(ObjectOutputStream dos) {
        try {

		
					// Document
				
       			    	dos.writeObject(this.document);
					
					// String
				
						writeString(this.CODE_BARRE,dos);
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);
        }


    }


    public String toString() {

		StringBuilder sb = new StringBuilder();
		sb.append(super.toString());
		sb.append("[");
		sb.append("document="+String.valueOf(document));
		sb.append(",CODE_BARRE="+CODE_BARRE);
	    sb.append("]");

	    return sb.toString();
    }

    /**
     * Compare keys
     */
    public int compareTo(xmlStruct other) {

		int returnValue = -1;
		
	    return returnValue;
    }


    private int checkNullsAndCompare(Object object1, Object object2) {
        int returnValue = 0;
		if (object1 instanceof Comparable && object2 instanceof Comparable) {
            returnValue = ((Comparable) object1).compareTo(object2);
        } else if (object1 != null && object2 != null) {
            returnValue = compareStrings(object1.toString(), object2.toString());
        } else if (object1 == null && object2 != null) {
            returnValue = 1;
        } else if (object1 != null && object2 == null) {
            returnValue = -1;
        } else {
            returnValue = 0;
        }

        return returnValue;
    }

    private int compareStrings(String string1, String string2) {
        return string1.compareTo(string2);
    }


}

public static class infogeneStruct implements routines.system.IPersistableRow<infogeneStruct> {
    final static byte[] commonByteArrayLock_LDAP_sgbm_export = new byte[0];
    static byte[] commonByteArray_LDAP_sgbm_export = new byte[0];

	
			    public String CODE_BARRE;

				public String getCODE_BARRE () {
					return this.CODE_BARRE;
				}
				
			    public String NOM;

				public String getNOM () {
					return this.NOM;
				}
				
			    public String PRENOM;

				public String getPRENOM () {
					return this.PRENOM;
				}
				
			    public String GROUPE;

				public String getGROUPE () {
					return this.GROUPE;
				}
				
			    public String CAMPUS;

				public String getCAMPUS () {
					return this.CAMPUS;
				}
				
			    public String LANGUE;

				public String getLANGUE () {
					return this.LANGUE;
				}
				
			    public String STATUT;

				public String getSTATUT () {
					return this.STATUT;
				}
				
			    public java.util.Date DATE_NAISSANCE;

				public java.util.Date getDATE_NAISSANCE () {
					return this.DATE_NAISSANCE;
				}
				
			    public java.util.Date DATE_MODIF;

				public java.util.Date getDATE_MODIF () {
					return this.DATE_MODIF;
				}
				
			    public java.util.Date DATE_EXPIRATION;

				public java.util.Date getDATE_EXPIRATION () {
					return this.DATE_EXPIRATION;
				}
				
			    public java.util.Date DATE_ELIMINATION;

				public java.util.Date getDATE_ELIMINATION () {
					return this.DATE_ELIMINATION;
				}
				
			    public String EPPN;

				public String getEPPN () {
					return this.EPPN;
				}
				



	private String readString(ObjectInputStream dis) throws IOException{
		String strReturn = null;
		int length = 0;
        length = dis.readInt();
		if (length == -1) {
			strReturn = null;
		} else {
			if(length > commonByteArray_LDAP_sgbm_export.length) {
				if(length < 1024 && commonByteArray_LDAP_sgbm_export.length == 0) {
   					commonByteArray_LDAP_sgbm_export = new byte[1024];
				} else {
   					commonByteArray_LDAP_sgbm_export = new byte[2 * length];
   				}
			}
			dis.readFully(commonByteArray_LDAP_sgbm_export, 0, length);
			strReturn = new String(commonByteArray_LDAP_sgbm_export, 0, length, utf8Charset);
		}
		return strReturn;
	}

    private void writeString(String str, ObjectOutputStream dos) throws IOException{
		if(str == null) {
            dos.writeInt(-1);
		} else {
            byte[] byteArray = str.getBytes(utf8Charset);
	    	dos.writeInt(byteArray.length);
			dos.write(byteArray);
    	}
    }

	private java.util.Date readDate(ObjectInputStream dis) throws IOException{
		java.util.Date dateReturn = null;
        int length = 0;
        length = dis.readByte();
		if (length == -1) {
			dateReturn = null;
		} else {
	    	dateReturn = new Date(dis.readLong());
		}
		return dateReturn;
	}

    private void writeDate(java.util.Date date1, ObjectOutputStream dos) throws IOException{
		if(date1 == null) {
            dos.writeByte(-1);
		} else {
			dos.writeByte(0);
	    	dos.writeLong(date1.getTime());
    	}
    }

    public void readData(ObjectInputStream dis) {

		synchronized(commonByteArrayLock_LDAP_sgbm_export) {

        	try {

        		int length = 0;
		
					this.CODE_BARRE = readString(dis);
					
					this.NOM = readString(dis);
					
					this.PRENOM = readString(dis);
					
					this.GROUPE = readString(dis);
					
					this.CAMPUS = readString(dis);
					
					this.LANGUE = readString(dis);
					
					this.STATUT = readString(dis);
					
					this.DATE_NAISSANCE = readDate(dis);
					
					this.DATE_MODIF = readDate(dis);
					
					this.DATE_EXPIRATION = readDate(dis);
					
					this.DATE_ELIMINATION = readDate(dis);
					
					this.EPPN = readString(dis);
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);

		

        }

		

      }


    }

    public void writeData(ObjectOutputStream dos) {
        try {

		
					// String
				
						writeString(this.CODE_BARRE,dos);
					
					// String
				
						writeString(this.NOM,dos);
					
					// String
				
						writeString(this.PRENOM,dos);
					
					// String
				
						writeString(this.GROUPE,dos);
					
					// String
				
						writeString(this.CAMPUS,dos);
					
					// String
				
						writeString(this.LANGUE,dos);
					
					// String
				
						writeString(this.STATUT,dos);
					
					// java.util.Date
				
						writeDate(this.DATE_NAISSANCE,dos);
					
					// java.util.Date
				
						writeDate(this.DATE_MODIF,dos);
					
					// java.util.Date
				
						writeDate(this.DATE_EXPIRATION,dos);
					
					// java.util.Date
				
						writeDate(this.DATE_ELIMINATION,dos);
					
					// String
				
						writeString(this.EPPN,dos);
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);
        }


    }


    public String toString() {

		StringBuilder sb = new StringBuilder();
		sb.append(super.toString());
		sb.append("[");
		sb.append("CODE_BARRE="+CODE_BARRE);
		sb.append(",NOM="+NOM);
		sb.append(",PRENOM="+PRENOM);
		sb.append(",GROUPE="+GROUPE);
		sb.append(",CAMPUS="+CAMPUS);
		sb.append(",LANGUE="+LANGUE);
		sb.append(",STATUT="+STATUT);
		sb.append(",DATE_NAISSANCE="+String.valueOf(DATE_NAISSANCE));
		sb.append(",DATE_MODIF="+String.valueOf(DATE_MODIF));
		sb.append(",DATE_EXPIRATION="+String.valueOf(DATE_EXPIRATION));
		sb.append(",DATE_ELIMINATION="+String.valueOf(DATE_ELIMINATION));
		sb.append(",EPPN="+EPPN);
	    sb.append("]");

	    return sb.toString();
    }

    /**
     * Compare keys
     */
    public int compareTo(infogeneStruct other) {

		int returnValue = -1;
		
	    return returnValue;
    }


    private int checkNullsAndCompare(Object object1, Object object2) {
        int returnValue = 0;
		if (object1 instanceof Comparable && object2 instanceof Comparable) {
            returnValue = ((Comparable) object1).compareTo(object2);
        } else if (object1 != null && object2 != null) {
            returnValue = compareStrings(object1.toString(), object2.toString());
        } else if (object1 == null && object2 != null) {
            returnValue = 1;
        } else if (object1 != null && object2 == null) {
            returnValue = -1;
        } else {
            returnValue = 0;
        }

        return returnValue;
    }

    private int compareStrings(String string1, String string2) {
        return string1.compareTo(string2);
    }


}

public static class after_tOracleInput_5Struct implements routines.system.IPersistableRow<after_tOracleInput_5Struct> {
    final static byte[] commonByteArrayLock_LDAP_sgbm_export = new byte[0];
    static byte[] commonByteArray_LDAP_sgbm_export = new byte[0];

	
			    public String CODE_BARRE;

				public String getCODE_BARRE () {
					return this.CODE_BARRE;
				}
				
			    public String NOM;

				public String getNOM () {
					return this.NOM;
				}
				
			    public String PRENOM;

				public String getPRENOM () {
					return this.PRENOM;
				}
				
			    public String GROUPE;

				public String getGROUPE () {
					return this.GROUPE;
				}
				
			    public String CAMPUS;

				public String getCAMPUS () {
					return this.CAMPUS;
				}
				
			    public String LANGUE;

				public String getLANGUE () {
					return this.LANGUE;
				}
				
			    public String STATUT;

				public String getSTATUT () {
					return this.STATUT;
				}
				
			    public java.util.Date DATE_NAISSANCE;

				public java.util.Date getDATE_NAISSANCE () {
					return this.DATE_NAISSANCE;
				}
				
			    public java.util.Date DATE_MODIF;

				public java.util.Date getDATE_MODIF () {
					return this.DATE_MODIF;
				}
				
			    public java.util.Date DATE_EXPIRATION;

				public java.util.Date getDATE_EXPIRATION () {
					return this.DATE_EXPIRATION;
				}
				
			    public java.util.Date DATE_ELIMINATION;

				public java.util.Date getDATE_ELIMINATION () {
					return this.DATE_ELIMINATION;
				}
				
			    public String EPPN;

				public String getEPPN () {
					return this.EPPN;
				}
				



	private String readString(ObjectInputStream dis) throws IOException{
		String strReturn = null;
		int length = 0;
        length = dis.readInt();
		if (length == -1) {
			strReturn = null;
		} else {
			if(length > commonByteArray_LDAP_sgbm_export.length) {
				if(length < 1024 && commonByteArray_LDAP_sgbm_export.length == 0) {
   					commonByteArray_LDAP_sgbm_export = new byte[1024];
				} else {
   					commonByteArray_LDAP_sgbm_export = new byte[2 * length];
   				}
			}
			dis.readFully(commonByteArray_LDAP_sgbm_export, 0, length);
			strReturn = new String(commonByteArray_LDAP_sgbm_export, 0, length, utf8Charset);
		}
		return strReturn;
	}

    private void writeString(String str, ObjectOutputStream dos) throws IOException{
		if(str == null) {
            dos.writeInt(-1);
		} else {
            byte[] byteArray = str.getBytes(utf8Charset);
	    	dos.writeInt(byteArray.length);
			dos.write(byteArray);
    	}
    }

	private java.util.Date readDate(ObjectInputStream dis) throws IOException{
		java.util.Date dateReturn = null;
        int length = 0;
        length = dis.readByte();
		if (length == -1) {
			dateReturn = null;
		} else {
	    	dateReturn = new Date(dis.readLong());
		}
		return dateReturn;
	}

    private void writeDate(java.util.Date date1, ObjectOutputStream dos) throws IOException{
		if(date1 == null) {
            dos.writeByte(-1);
		} else {
			dos.writeByte(0);
	    	dos.writeLong(date1.getTime());
    	}
    }

    public void readData(ObjectInputStream dis) {

		synchronized(commonByteArrayLock_LDAP_sgbm_export) {

        	try {

        		int length = 0;
		
					this.CODE_BARRE = readString(dis);
					
					this.NOM = readString(dis);
					
					this.PRENOM = readString(dis);
					
					this.GROUPE = readString(dis);
					
					this.CAMPUS = readString(dis);
					
					this.LANGUE = readString(dis);
					
					this.STATUT = readString(dis);
					
					this.DATE_NAISSANCE = readDate(dis);
					
					this.DATE_MODIF = readDate(dis);
					
					this.DATE_EXPIRATION = readDate(dis);
					
					this.DATE_ELIMINATION = readDate(dis);
					
					this.EPPN = readString(dis);
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);

		

        }

		

      }


    }

    public void writeData(ObjectOutputStream dos) {
        try {

		
					// String
				
						writeString(this.CODE_BARRE,dos);
					
					// String
				
						writeString(this.NOM,dos);
					
					// String
				
						writeString(this.PRENOM,dos);
					
					// String
				
						writeString(this.GROUPE,dos);
					
					// String
				
						writeString(this.CAMPUS,dos);
					
					// String
				
						writeString(this.LANGUE,dos);
					
					// String
				
						writeString(this.STATUT,dos);
					
					// java.util.Date
				
						writeDate(this.DATE_NAISSANCE,dos);
					
					// java.util.Date
				
						writeDate(this.DATE_MODIF,dos);
					
					// java.util.Date
				
						writeDate(this.DATE_EXPIRATION,dos);
					
					// java.util.Date
				
						writeDate(this.DATE_ELIMINATION,dos);
					
					// String
				
						writeString(this.EPPN,dos);
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);
        }


    }


    public String toString() {

		StringBuilder sb = new StringBuilder();
		sb.append(super.toString());
		sb.append("[");
		sb.append("CODE_BARRE="+CODE_BARRE);
		sb.append(",NOM="+NOM);
		sb.append(",PRENOM="+PRENOM);
		sb.append(",GROUPE="+GROUPE);
		sb.append(",CAMPUS="+CAMPUS);
		sb.append(",LANGUE="+LANGUE);
		sb.append(",STATUT="+STATUT);
		sb.append(",DATE_NAISSANCE="+String.valueOf(DATE_NAISSANCE));
		sb.append(",DATE_MODIF="+String.valueOf(DATE_MODIF));
		sb.append(",DATE_EXPIRATION="+String.valueOf(DATE_EXPIRATION));
		sb.append(",DATE_ELIMINATION="+String.valueOf(DATE_ELIMINATION));
		sb.append(",EPPN="+EPPN);
	    sb.append("]");

	    return sb.toString();
    }

    /**
     * Compare keys
     */
    public int compareTo(after_tOracleInput_5Struct other) {

		int returnValue = -1;
		
	    return returnValue;
    }


    private int checkNullsAndCompare(Object object1, Object object2) {
        int returnValue = 0;
		if (object1 instanceof Comparable && object2 instanceof Comparable) {
            returnValue = ((Comparable) object1).compareTo(object2);
        } else if (object1 != null && object2 != null) {
            returnValue = compareStrings(object1.toString(), object2.toString());
        } else if (object1 == null && object2 != null) {
            returnValue = 1;
        } else if (object1 != null && object2 == null) {
            returnValue = -1;
        } else {
            returnValue = 0;
        }

        return returnValue;
    }

    private int compareStrings(String string1, String string2) {
        return string1.compareTo(string2);
    }


}
public void tOracleInput_5Process(final java.util.Map<String, Object> globalMap) throws TalendException {
	globalMap.put("tOracleInput_5_SUBPROCESS_STATE", 0);

 final boolean execStat = this.execStat;
	
		String iterateId = "";
	
	
	String currentComponent = "";
	java.util.Map<String, Object> resourceMap = new java.util.HashMap<String, Object>();

	try {

			String currentMethodName = new java.lang.Exception().getStackTrace()[0].getMethodName();
			boolean resumeIt = currentMethodName.equals(resumeEntryMethodName);
			if( resumeEntryMethodName == null || resumeIt || globalResumeTicket){//start the resume
				globalResumeTicket = true;


		tOracleInput_1Process(globalMap);
		tOracleInput_3Process(globalMap);
		tOracleInput_6Process(globalMap);
		tOracleInput_8Process(globalMap);

		infogeneStruct infogene = new infogeneStruct();
xmlStruct xml = new xmlStruct();
infosStruct infos = new infosStruct();
out1Struct out1 = new out1Struct();







	
	/**
	 * [tJavaFlex_1 begin ] start
	 */

	

	
		
		ok_Hash.put("tJavaFlex_1", false);
		start_Hash.put("tJavaFlex_1", System.currentTimeMillis());
		
	
	currentComponent="tJavaFlex_1";

	
			if (execStat) {
				if(resourceMap.get("inIterateVComp") == null){
					
						runStat.updateStatOnConnection("out1" + iterateId, 0, 0);
					
				}
			} 

		
		int tos_count_tJavaFlex_1 = 0;
		
    	class BytesLimit65535_tJavaFlex_1{
    		public void limitLog4jByte() throws Exception{
    			
    		}
    	}
    	
        new BytesLimit65535_tJavaFlex_1().limitLog4jByte();


String filename = context.sigb_files_dir+context.sigb_file_name+".xml";
java.io.PrintWriter writer = new java.io.PrintWriter(filename,"UTF-8");

writer.println("<?xml version=\"1.0\" encoding=\"UTF-8\"?>");
writer.println("<users>");



 



/**
 * [tJavaFlex_1 begin ] stop
 */



	
	/**
	 * [tMap_1 begin ] start
	 */

	

	
		
		ok_Hash.put("tMap_1", false);
		start_Hash.put("tMap_1", System.currentTimeMillis());
		
	
	currentComponent="tMap_1";

	
			if (execStat) {
				if(resourceMap.get("inIterateVComp") == null){
					
						runStat.updateStatOnConnection("infos" + iterateId, 0, 0);
					
				}
			} 

		
		int tos_count_tMap_1 = 0;
		
    	class BytesLimit65535_tMap_1{
    		public void limitLog4jByte() throws Exception{
    			
    		}
    	}
    	
        new BytesLimit65535_tMap_1().limitLog4jByte();




// ###############################
// # Lookup's keys initialization
	
		org.talend.designer.components.lookup.memory.AdvancedMemoryLookup<emailStruct> tHash_Lookup_email = (org.talend.designer.components.lookup.memory.AdvancedMemoryLookup<emailStruct>) 
				((org.talend.designer.components.lookup.memory.AdvancedMemoryLookup<emailStruct>) 
					globalMap.get( "tHash_Lookup_email" ))
					;					
					
	

emailStruct emailHashKey = new emailStruct();
emailStruct emailDefault = new emailStruct();
	
		org.talend.designer.components.lookup.memory.AdvancedMemoryLookup<adressStruct> tHash_Lookup_adress = (org.talend.designer.components.lookup.memory.AdvancedMemoryLookup<adressStruct>) 
				((org.talend.designer.components.lookup.memory.AdvancedMemoryLookup<adressStruct>) 
					globalMap.get( "tHash_Lookup_adress" ))
					;					
					
	

adressStruct adressHashKey = new adressStruct();
adressStruct adressDefault = new adressStruct();
	
		org.talend.designer.components.lookup.memory.AdvancedMemoryLookup<phoneStruct> tHash_Lookup_phone = (org.talend.designer.components.lookup.memory.AdvancedMemoryLookup<phoneStruct>) 
				((org.talend.designer.components.lookup.memory.AdvancedMemoryLookup<phoneStruct>) 
					globalMap.get( "tHash_Lookup_phone" ))
					;					
					
	

phoneStruct phoneHashKey = new phoneStruct();
phoneStruct phoneDefault = new phoneStruct();
	
		org.talend.designer.components.lookup.memory.AdvancedMemoryLookup<statistiqueStruct> tHash_Lookup_statistique = (org.talend.designer.components.lookup.memory.AdvancedMemoryLookup<statistiqueStruct>) 
				((org.talend.designer.components.lookup.memory.AdvancedMemoryLookup<statistiqueStruct>) 
					globalMap.get( "tHash_Lookup_statistique" ))
					;					
					
	

statistiqueStruct statistiqueHashKey = new statistiqueStruct();
statistiqueStruct statistiqueDefault = new statistiqueStruct();
// ###############################        

// ###############################
// # Vars initialization
class  Var__tMap_1__Struct  {
	String mails;
	String telephones;
	String adresses;
	String statistiques;
}
Var__tMap_1__Struct Var__tMap_1 = new Var__tMap_1__Struct();
// ###############################

// ###############################
// # Outputs initialization
out1Struct out1_tmp = new out1Struct();
// ###############################

        
        



        









 



/**
 * [tMap_1 begin ] stop
 */



	
	/**
	 * [tExtractXMLField_1 begin ] start
	 */

	

	
		
		ok_Hash.put("tExtractXMLField_1", false);
		start_Hash.put("tExtractXMLField_1", System.currentTimeMillis());
		
	
	currentComponent="tExtractXMLField_1";

	
			if (execStat) {
				if(resourceMap.get("inIterateVComp") == null){
					
						runStat.updateStatOnConnection("xml" + iterateId, 0, 0);
					
				}
			} 

		
		int tos_count_tExtractXMLField_1 = 0;
		
    	class BytesLimit65535_tExtractXMLField_1{
    		public void limitLog4jByte() throws Exception{
    			
    		}
    	}
    	
        new BytesLimit65535_tExtractXMLField_1().limitLog4jByte();

int nb_line_tExtractXMLField_1 = 0;

class NameSpaceTool_tExtractXMLField_1 {

    public java.util.HashMap<String, String> xmlNameSpaceMap = new java.util.HashMap<String, String>();
    
	private java.util.List<String> defualtNSPath = new java.util.ArrayList<String>();

    public void countNSMap(org.dom4j.Element el) {
        for (org.dom4j.Namespace ns : (java.util.List<org.dom4j.Namespace>) el.declaredNamespaces()) {
            if (ns.getPrefix().trim().length() == 0) {
                xmlNameSpaceMap.put("pre"+defualtNSPath.size(), ns.getURI());
                String path = "";
                org.dom4j.Element elTmp = el;
                while (elTmp != null) {
                   	if (elTmp.getNamespacePrefix() != null && elTmp.getNamespacePrefix().length() > 0) {
                        path = "/" + elTmp.getNamespacePrefix() + ":" + elTmp.getName() + path;
                    } else {
                        path = "/" + elTmp.getName() + path;
                    }
                    elTmp = elTmp.getParent();
                }
                defualtNSPath.add(path);
            } else {
                xmlNameSpaceMap.put(ns.getPrefix(), ns.getURI());
            }

        }
        for (org.dom4j.Element e : (java.util.List<org.dom4j.Element>) el.elements()) {
            countNSMap(e);
        }
    }
    
    /**
	 *	the regex for the xpath like that : 
	 *	case 1 : functionA(locationXPathExpression) 
	 *	case 2 : fn:functionA(locationXPathExpression) 
	 *	case 3 : functionA(functionB(locationXPathExpression))
	 *	case 4 : fn:functionA(fn:functionB(locationXPathExpression))
	 *	and like that.
	*/
	private java.util.regex.Pattern simpleFunctionPattern;
	private StringBuffer stringBuffer;
	private java.util.Map<String,String> resultCache;
	
	public String addDefaultNSPrefix(final String xpathExpression, String loopPath) {
	    if (defualtNSPath.size() < 1) {
        	return xpathExpression;
    	}
    	
    	if(resultCache == null) {
    		resultCache = new java.util.HashMap<String,String>();
    	}
    	
    	String resultXpathExpression = resultCache.get(xpathExpression);
		if(resultXpathExpression!=null) {
    		return resultXpathExpression;
    	}
    	
    	String locationPathExpression = xpathExpression;
    	
    	if(simpleFunctionPattern == null) {
    		simpleFunctionPattern = java.util.regex.Pattern.compile("([a-zA-z0-9]+:)?[a-zA-Z]+-?[A-Za-z]+\\(.*\\)");
    	}
    	
    	boolean isSimpleFunctionXPath = simpleFunctionPattern.matcher(xpathExpression).matches();
    	String tail = null;
    	if(isSimpleFunctionXPath) {
			int start = xpathExpression.lastIndexOf('(');
			int end = xpathExpression.indexOf(')');
			if(start < end) {
			    if(stringBuffer == null) {
    				stringBuffer = new StringBuffer();
    			}
				locationPathExpression = xpathExpression.substring(start+1,end);
				stringBuffer.append(xpathExpression.substring(0,start+1));
				tail = xpathExpression.substring(end);
			} else {
				isSimpleFunctionXPath = false;
			}
    	}
    	
    	locationPathExpression = addDefaultNSPrefixForLocationXPathExpression(locationPathExpression,loopPath);
    	
    	resultXpathExpression = locationPathExpression;
    	
    	if(isSimpleFunctionXPath) {
        	stringBuffer.append(locationPathExpression);
    		stringBuffer.append(tail);
    		resultXpathExpression = stringBuffer.toString();
    		stringBuffer.setLength(0);
        }
    	
    	resultCache.put(xpathExpression,resultXpathExpression);
    	return resultXpathExpression;
	}
	
    private String addDefaultNSPrefixForLocationXPathExpression(String path, String loopPath) {
    	String fullPath = loopPath;
    	if(!path.equals(fullPath)){
        	for (String tmp : path.split("/")) {
        		if (("..").equals(tmp)) {
                    fullPath = fullPath.substring(0, fullPath.lastIndexOf("/"));
                } else {
                    fullPath += "/" + tmp;
                }
        	}
        }
    	int[] indexs = new int[fullPath.split("/").length - 1];
        java.util.Arrays.fill(indexs, -1);
        int length = 0;
        for (int i = 0; i < defualtNSPath.size(); i++) {
            if (defualtNSPath.get(i).length() > length && fullPath.startsWith(defualtNSPath.get(i))) {
                java.util.Arrays.fill(indexs, defualtNSPath.get(i).split("/").length - 2, indexs.length, i);
                length = defualtNSPath.get(i).length();
            }
        }
    
        StringBuilder newPath = new StringBuilder();
        String[] pathStrs = path.split("/");
        for (int i = 0; i < pathStrs.length; i++) {
            String tmp = pathStrs[i];
            if (newPath.length() > 0) {
                newPath.append("/");
            }
            if (tmp.length() > 0 && tmp.indexOf(":") == -1 && tmp.indexOf(".") == -1 /*&& tmp.indexOf("@") == -1*/) {
                int index = indexs[i + indexs.length - pathStrs.length];
                if (index >= 0) {
                	//==== add by wliu to support both filter and functions==
    				if(tmp.indexOf("[")>0 && tmp.indexOf("]")>tmp.indexOf("[")){//include filter
    					String tmpStr=replaceElementWithNS(tmp,"pre"+index+":");
    					newPath.append(tmpStr);
    				}else{
    					if(tmp.indexOf("@") != -1 || tmp.indexOf("(")<tmp.indexOf(")")){  // include attribute
    						newPath.append(tmp);
    					}else{
    				//==add end=======	
                    		newPath.append("pre").append(index).append(":").append(tmp);
                    	}
                    }                    
                } else {
                    newPath.append(tmp);
                }
            } else {
                newPath.append(tmp);
            }
        }
        return newPath.toString();
    }
    
	private String matches = "@*\\b[a-z|A-Z|_]+[[-]*\\w]*\\b[^'|^\\(]";
    private java.util.regex.Pattern pattern = java.util.regex.Pattern.compile(matches);
    
	private String replaceElementWithNS(String global, String pre){

        java.util.regex.Matcher match = pattern.matcher(global);
        StringBuffer sb = new StringBuffer();
        match.reset();
        while (match.find()) {
            String group = match.group();
            String tmp = "";
            if (group.toLowerCase().matches("\\b(div|mod|and|or)\\b.*") || group.matches("@.*")) {
                tmp = group;
            } else {
                tmp = tmp + pre + group;
            }
            match.appendReplacement(sb, tmp);
        }
        match.appendTail(sb);
        
        return sb.toString();
	}
	
}

class XML_API_tExtractXMLField_1{
	public boolean isDefNull(org.dom4j.Node node) throws javax.xml.transform.TransformerException {
        if (node != null && node instanceof org.dom4j.Element) {
        	org.dom4j.Attribute attri = ((org.dom4j.Element)node).attribute("nil");
        	if(attri != null && ("true").equals(attri.getText())){
            	return true;
            }
        }
        return false;
    }

    public boolean isMissing(org.dom4j.Node node) throws javax.xml.transform.TransformerException {
        return node == null ? true : false;
    }

    public boolean isEmpty(org.dom4j.Node node) throws javax.xml.transform.TransformerException {
        if (node != null) {
            return node.getText().length() == 0;
        }
        return false;
    }
}

XML_API_tExtractXMLField_1 xml_api_tExtractXMLField_1 = new XML_API_tExtractXMLField_1();
 



/**
 * [tExtractXMLField_1 begin ] stop
 */



	
	/**
	 * [tXMLMap_1 begin ] start
	 */

	

	
		
		ok_Hash.put("tXMLMap_1", false);
		start_Hash.put("tXMLMap_1", System.currentTimeMillis());
		
	
	currentComponent="tXMLMap_1";

	
			if (execStat) {
				if(resourceMap.get("inIterateVComp") == null){
					
						runStat.updateStatOnConnection("infogene" + iterateId, 0, 0);
					
				}
			} 

		
		int tos_count_tXMLMap_1 = 0;
		
    	class BytesLimit65535_tXMLMap_1{
    		public void limitLog4jByte() throws Exception{
    			
    		}
    	}
    	
        new BytesLimit65535_tXMLMap_1().limitLog4jByte();

	
	
//===============================input xml init part===============================
class XML_API_tXMLMap_1{
	public boolean isDefNull(org.dom4j.Node node) throws javax.xml.transform.TransformerException {
        if (node != null && node instanceof org.dom4j.Element) {
        	org.dom4j.Attribute attri = ((org.dom4j.Element)node).attribute("nil");
        	if(attri != null && ("true").equals(attri.getText())){
            	return true;
            }
        }
        return false;
    }

    public boolean isMissing(org.dom4j.Node node) throws javax.xml.transform.TransformerException {
        return node == null ? true : false;
    }

    public boolean isEmpty(org.dom4j.Node node) throws javax.xml.transform.TransformerException {
        if (node != null) {
            return node.getText().length() == 0;
        }
        return false;
    }
}
	class Var__tXMLMap_1__Struct {	String fullname;
	}
	Var__tXMLMap_1__Struct Var__tXMLMap_1 = new Var__tXMLMap_1__Struct();
// ###############################
// # Outputs initialization
xmlStruct xml_tmp = new xmlStruct();
xmlStruct xml_save = null;
// ###############################
		int nb_line_tXMLMap_1 = 0; 
	
    XML_API_tXMLMap_1 xml_api_tXMLMap_1 = new XML_API_tXMLMap_1();

class GenerateDocument_xml {

	java.util.Map<String,Object> valueMap = null;
	
	routines.system.DocumentGenerateOrderHelper orderHelper = new routines.system.DocumentGenerateOrderHelper(1);
		
	org.dom4j.Document doc = null;
	
	org.dom4j.Element root4Group = null;
	
	org.dom4j.io.OutputFormat format = null;
	
	java.util.List<java.util.List<String>> groupbyList = null;
	java.util.List<org.dom4j.Element> groupElementList = null;
	int order = 0;
	
	boolean isFirst = true;
	
	boolean	needRoot = true;
	
	String currentValue = null;
	
    public GenerateDocument_xml() {
//    	this.treeNodeAPI = treeNodeAPI;
    	
    	valueMap = new java.util.HashMap<String,Object>();
    	
    	groupbyList =  new java.util.ArrayList<java.util.List<String>>();
		groupElementList = new java.util.ArrayList<org.dom4j.Element>();
    	
    	doc = org.dom4j.DocumentHelper.createDocument();
    	format = org.dom4j.io.OutputFormat.createPrettyPrint();
    	format.setTrimText(false);
    }
    
    public org.dom4j.Document getDocument(){
		generateOk();
    	return this.doc;
    }
    
    //do some work after document has been generated
    private void generateOk() {
    	routines.system.NestXMLTool.replaceDefaultNameSpace(this.doc.getRootElement(),null);
		routines.system.NestXMLTool.removeEmptyElement(this.doc.getRootElement());
    }
	
	//We generate the TreeNode_API object only if there is a document in the main input table.
    void generateElements(boolean isInnerJoin, infogeneStruct infogene, Var__tXMLMap_1__Struct Var
	) {
	
	
	/*if(this.treeNodeAPI==null) {
		this.treeNodeAPI = treeNodeAPI;
	}*/
	
	org.dom4j.Element subTreeRootParent = null;
// build root xml tree 
if (needRoot) {
	needRoot=false;
		org.dom4j.Element root = null;
				root = doc.addElement("users");
		subTreeRootParent = root;
		root4Group = subTreeRootParent;
	}else{
		subTreeRootParent=root4Group;
	}
	/* build group xml tree */
	boolean isNewElement = false;
		isNewElement = false;
		org.dom4j.Element loop = null;
				loop = org.dom4j.DocumentHelper.createElement("user");
				subTreeRootParent.elements().add(orderHelper.getInsertLocation(0,0),loop);
		subTreeRootParent = loop;
				currentValue = null;
    			routines.system.DocumentHelper.applyNamespace2Attribute(loop,  null , "link", currentValue);
		org.dom4j.Element loop_1 = null;
				loop_1 = loop.addElement("record_type");
		valueMap.put("loop_1",context.sigb_record_type);
		if(valueMap.get("loop_1")!=null) {
			routines.system.NestXMLTool.setText(loop_1,FormatterUtils.format(context.sigb_record_type,null));
		}
				currentValue = null;
    			routines.system.DocumentHelper.applyNamespace2Attribute(loop_1,  null , "desc", currentValue);
		org.dom4j.Element loop_3 = null;
				loop_3 = loop.addElement("primary_id");
		valueMap.put("loop_3",infogene.CODE_BARRE);
		if(valueMap.get("loop_3")!=null) {
			routines.system.NestXMLTool.setText(loop_3,FormatterUtils.format(infogene.CODE_BARRE,null));
		}
		org.dom4j.Element loop_4 = null;
				loop_4 = loop.addElement("first_name");
		valueMap.put("loop_4",infogene.PRENOM);
		if(valueMap.get("loop_4")!=null) {
			routines.system.NestXMLTool.setText(loop_4,FormatterUtils.format(infogene.PRENOM,null));
		}
		org.dom4j.Element loop_5 = null;
				loop_5 = loop.addElement("middle_name");
		org.dom4j.Element loop_6 = null;
				loop_6 = loop.addElement("last_name");
		valueMap.put("loop_6",infogene.NOM);
		if(valueMap.get("loop_6")!=null) {
			routines.system.NestXMLTool.setText(loop_6,FormatterUtils.format(infogene.NOM,null));
		}
		org.dom4j.Element loop_7 = null;
				loop_7 = loop.addElement("full_name");
		valueMap.put("loop_7",Var.fullname);
		if(valueMap.get("loop_7")!=null) {
			routines.system.NestXMLTool.setText(loop_7,FormatterUtils.format(Var.fullname,null));
		}
		org.dom4j.Element loop_8 = null;
				loop_8 = loop.addElement("pin_number");
		org.dom4j.Element loop_9 = null;
				loop_9 = loop.addElement("user_title");
				currentValue = null;
    			routines.system.DocumentHelper.applyNamespace2Attribute(loop_9,  null , "desc", currentValue);
		org.dom4j.Element loop_11 = null;
				loop_11 = loop.addElement("job_category");
				currentValue = null;
    			routines.system.DocumentHelper.applyNamespace2Attribute(loop_11,  null , "desc", currentValue);
		org.dom4j.Element loop_13 = null;
				loop_13 = loop.addElement("job_description");
		org.dom4j.Element loop_14 = null;
				loop_14 = loop.addElement("gender");
				currentValue = null;
    			routines.system.DocumentHelper.applyNamespace2Attribute(loop_14,  null , "desc", currentValue);
		org.dom4j.Element loop_16 = null;
				loop_16 = loop.addElement("user_group");
		valueMap.put("loop_16",context.sigb_user_group);
		if(valueMap.get("loop_16")!=null) {
			routines.system.NestXMLTool.setText(loop_16,FormatterUtils.format(context.sigb_user_group,null));
		}
				currentValue = null;
    			valueMap.put("loop_16",context.sigb_user_group_desc);
    			if(valueMap.get("loop_16")!=null) {
    				currentValue = FormatterUtils.format(context.sigb_user_group_desc,null);
    			}
    			routines.system.DocumentHelper.applyNamespace2Attribute(loop_16,  null , "desc", currentValue);
		org.dom4j.Element loop_18 = null;
				loop_18 = loop.addElement("campus_code");
		valueMap.put("loop_18",infogene.CAMPUS);
		if(valueMap.get("loop_18")!=null) {
			routines.system.NestXMLTool.setText(loop_18,FormatterUtils.format(infogene.CAMPUS,null));
		}
				currentValue = null;
    			routines.system.DocumentHelper.applyNamespace2Attribute(loop_18,  null , "desc", currentValue);
		org.dom4j.Element loop_20 = null;
				loop_20 = loop.addElement("web_site_url");
		org.dom4j.Element loop_21 = null;
				loop_21 = loop.addElement("cataloger_level");
		valueMap.put("loop_21",context.sigb_cataloger_level);
		if(valueMap.get("loop_21")!=null) {
			routines.system.NestXMLTool.setText(loop_21,FormatterUtils.format(context.sigb_cataloger_level,null));
		}
				currentValue = null;
    			valueMap.put("loop_21",context.sigb_cataloger_level_desc);
    			if(valueMap.get("loop_21")!=null) {
    				currentValue = FormatterUtils.format(context.sigb_cataloger_level_desc,null);
    			}
    			routines.system.DocumentHelper.applyNamespace2Attribute(loop_21,  null , "desc", currentValue);
		org.dom4j.Element loop_23 = null;
				loop_23 = loop.addElement("preferred_language");
		valueMap.put("loop_23", infogene.LANGUE);
		if(valueMap.get("loop_23")!=null) {
			routines.system.NestXMLTool.setText(loop_23,FormatterUtils.format( infogene.LANGUE,null));
		}
		org.dom4j.Element loop_24 = null;
				loop_24 = loop.addElement("birth_date");
		valueMap.put("loop_24",TalendDate.formatDate("yyyy-MM-dd'Z'", infogene.DATE_NAISSANCE) );
		if(valueMap.get("loop_24")!=null) {
			routines.system.NestXMLTool.setText(loop_24,FormatterUtils.format(TalendDate.formatDate("yyyy-MM-dd'Z'", infogene.DATE_NAISSANCE) ,"dd-MM-yyyy"));
		}
		org.dom4j.Element loop_25 = null;
				loop_25 = loop.addElement("expiry_date");
		valueMap.put("loop_25",TalendDate.formatDate("yyyy-MM-dd'Z'", infogene.DATE_EXPIRATION) );
		if(valueMap.get("loop_25")!=null) {
			routines.system.NestXMLTool.setText(loop_25,FormatterUtils.format(TalendDate.formatDate("yyyy-MM-dd'Z'", infogene.DATE_EXPIRATION) ,"dd-MM-yyyy"));
		}
		org.dom4j.Element loop_26 = null;
				loop_26 = loop.addElement("purge_date");
		valueMap.put("loop_26",TalendDate.formatDate("yyyy-MM-dd'Z'", infogene.DATE_ELIMINATION) );
		if(valueMap.get("loop_26")!=null) {
			routines.system.NestXMLTool.setText(loop_26,FormatterUtils.format(TalendDate.formatDate("yyyy-MM-dd'Z'", infogene.DATE_ELIMINATION) ,"dd-MM-yyyy"));
		}
		org.dom4j.Element loop_27 = null;
				loop_27 = loop.addElement("account_type");
		valueMap.put("loop_27",context.sigb_external);
		if(valueMap.get("loop_27")!=null) {
			routines.system.NestXMLTool.setText(loop_27,FormatterUtils.format(context.sigb_external,null));
		}
				currentValue = null;
    			valueMap.put("loop_27",context.sigb_external_desc);
    			if(valueMap.get("loop_27")!=null) {
    				currentValue = FormatterUtils.format(context.sigb_external_desc,null);
    			}
    			routines.system.DocumentHelper.applyNamespace2Attribute(loop_27,  null , "desc", currentValue);
		org.dom4j.Element loop_29 = null;
				loop_29 = loop.addElement("external_id");
		valueMap.put("loop_29",context.sigb_external_id);
		if(valueMap.get("loop_29")!=null) {
			routines.system.NestXMLTool.setText(loop_29,FormatterUtils.format(context.sigb_external_id,null));
		}
		org.dom4j.Element loop_30 = null;
				loop_30 = loop.addElement("password");
		org.dom4j.Element loop_31 = null;
				loop_31 = loop.addElement("force_password_change");
		org.dom4j.Element loop_32 = null;
				loop_32 = loop.addElement("status");
		valueMap.put("loop_32",context.sigb_active);
		if(valueMap.get("loop_32")!=null) {
			routines.system.NestXMLTool.setText(loop_32,FormatterUtils.format(context.sigb_active,null));
		}
				currentValue = null;
    			valueMap.put("loop_32",context.sigb_active);
    			if(valueMap.get("loop_32")!=null) {
    				currentValue = FormatterUtils.format(context.sigb_active,null);
    			}
    			routines.system.DocumentHelper.applyNamespace2Attribute(loop_32,  null , "desc", currentValue);
		org.dom4j.Element loop_34 = null;
				loop_34 = loop.addElement("contact_info");
		org.dom4j.Element loop_34_35 = null;
				loop_34_35 = loop_34.addElement("addresses");
		valueMap.put("loop_34_35","toReplaceByAddresses");
		if(valueMap.get("loop_34_35")!=null) {
			routines.system.NestXMLTool.setText(loop_34_35,FormatterUtils.format("toReplaceByAddresses",null));
		}
		org.dom4j.Element loop_34_36 = null;
				loop_34_36 = loop_34.addElement("emails");
		valueMap.put("loop_34_36","toReplaceByMails");
		if(valueMap.get("loop_34_36")!=null) {
			routines.system.NestXMLTool.setText(loop_34_36,FormatterUtils.format("toReplaceByMails",null));
		}
		org.dom4j.Element loop_34_37 = null;
				loop_34_37 = loop_34.addElement("phones");
		valueMap.put("loop_34_37","toReplaceByPhones");
		if(valueMap.get("loop_34_37")!=null) {
			routines.system.NestXMLTool.setText(loop_34_37,FormatterUtils.format("toReplaceByPhones",null));
		}
		org.dom4j.Element loop_38 = null;
				loop_38 = loop.addElement("user_identifiers");
		org.dom4j.Element loop_38_39 = null;
				loop_38_39 = loop_38.addElement("user_identifier");
				currentValue = null;
    			routines.system.DocumentHelper.applyNamespace2Attribute(loop_38_39,  null , "segment_type", currentValue);
		org.dom4j.Element loop_38_39_41 = null;
				loop_38_39_41 = loop_38_39.addElement("id_type");
		valueMap.put("loop_38_39_41",context.sigb_id_type_eppn);
		if(valueMap.get("loop_38_39_41")!=null) {
			routines.system.NestXMLTool.setText(loop_38_39_41,FormatterUtils.format(context.sigb_id_type_eppn,null));
		}
				currentValue = null;
    			routines.system.DocumentHelper.applyNamespace2Attribute(loop_38_39_41,  null , "desc", currentValue);
		org.dom4j.Element loop_38_39_43 = null;
				loop_38_39_43 = loop_38_39.addElement("value");
		valueMap.put("loop_38_39_43",infogene.EPPN);
		if(valueMap.get("loop_38_39_43")!=null) {
			routines.system.NestXMLTool.setText(loop_38_39_43,FormatterUtils.format(infogene.EPPN,null));
		}
		org.dom4j.Element loop_38_39_44 = null;
				loop_38_39_44 = loop_38_39.addElement("note");
		org.dom4j.Element loop_38_39_45 = null;
				loop_38_39_45 = loop_38_39.addElement("status");
		valueMap.put("loop_38_39_45",context.sigb_active);
		if(valueMap.get("loop_38_39_45")!=null) {
			routines.system.NestXMLTool.setText(loop_38_39_45,FormatterUtils.format(context.sigb_active,null));
		}
		org.dom4j.Element loop_46 = null;
				loop_46 = loop.addElement("user_roles");
		org.dom4j.Element loop_46_47 = null;
				loop_46_47 = loop_46.addElement("user_role");
		org.dom4j.Element loop_46_47_48 = null;
				loop_46_47_48 = loop_46_47.addElement("status");
				currentValue = null;
    			routines.system.DocumentHelper.applyNamespace2Attribute(loop_46_47_48,  null , "desc", currentValue);
		org.dom4j.Element loop_46_47_50 = null;
				loop_46_47_50 = loop_46_47.addElement("scope");
				currentValue = null;
    			routines.system.DocumentHelper.applyNamespace2Attribute(loop_46_47_50,  null , "desc", currentValue);
		org.dom4j.Element loop_46_47_52 = null;
				loop_46_47_52 = loop_46_47.addElement("role_type");
				currentValue = null;
    			routines.system.DocumentHelper.applyNamespace2Attribute(loop_46_47_52,  null , "desc", currentValue);
		org.dom4j.Element loop_46_47_54 = null;
				loop_46_47_54 = loop_46_47.addElement("parameters");
		org.dom4j.Element loop_46_47_54_55 = null;
				loop_46_47_54_55 = loop_46_47_54.addElement("parameter");
		org.dom4j.Element loop_46_47_54_55_56 = null;
				loop_46_47_54_55_56 = loop_46_47_54_55.addElement("type");
				currentValue = null;
    			routines.system.DocumentHelper.applyNamespace2Attribute(loop_46_47_54_55_56,  null , "desc", currentValue);
		org.dom4j.Element loop_46_47_54_55_58 = null;
				loop_46_47_54_55_58 = loop_46_47_54_55.addElement("value");
				currentValue = null;
    			routines.system.DocumentHelper.applyNamespace2Attribute(loop_46_47_54_55_58,  null , "desc", currentValue);
		org.dom4j.Element loop_60 = null;
				loop_60 = loop.addElement("user_blocks");
		org.dom4j.Element loop_61 = null;
				loop_61 = loop.addElement("user_notes");
		org.dom4j.Element loop_61_62 = null;
				loop_61_62 = loop_61.addElement("user_note");
		org.dom4j.Element loop_63 = null;
				loop_63 = loop.addElement("user_statistics");
		valueMap.put("loop_63","toReplaceByStatistics");
		if(valueMap.get("loop_63")!=null) {
			routines.system.NestXMLTool.setText(loop_63,FormatterUtils.format("toReplaceByStatistics",null));
		}
		org.dom4j.Element loop_64 = null;
				loop_64 = loop.addElement("proxy_for_users");
		org.dom4j.Element loop_64_65 = null;
				loop_64_65 = loop_64.addElement("proxy_for_user");
				currentValue = null;
    			routines.system.DocumentHelper.applyNamespace2Attribute(loop_64_65,  null , "link", currentValue);
		org.dom4j.Element loop_64_65_67 = null;
				loop_64_65_67 = loop_64_65.addElement("primary_id");
		org.dom4j.Element loop_64_65_68 = null;
				loop_64_65_68 = loop_64_65.addElement("full_name");
		org.dom4j.Element loop_69 = null;
				loop_69 = loop.addElement("rs_libraries");
		org.dom4j.Element loop_69_70 = null;
				loop_69_70 = loop_69.addElement("rs_library");
		org.dom4j.Element loop_69_70_71 = null;
				loop_69_70_71 = loop_69_70.addElement("code");
				currentValue = null;
    			routines.system.DocumentHelper.applyNamespace2Attribute(loop_69_70_71,  null , "desc", currentValue);
		org.dom4j.Element loop_73 = null;
				loop_73 = loop.addElement("library_notices");
		org.dom4j.Element loop_73_74 = null;
				loop_73_74 = loop_73.addElement("library_notice");
		org.dom4j.Element loop_73_74_75 = null;
				loop_73_74_75 = loop_73_74.addElement("code");
				currentValue = null;
    			routines.system.DocumentHelper.applyNamespace2Attribute(loop_73_74_75,  null , "desc", currentValue);
		org.dom4j.Element loop_77 = null;
				loop_77 = loop.addElement("source_link_id");
		org.dom4j.Element loop_78 = null;
				loop_78 = loop.addElement("source_institution_code");
		org.dom4j.Element loop_79 = null;
				loop_79 = loop.addElement("linking_id");
		}
    }


	            
 



/**
 * [tXMLMap_1 begin ] stop
 */



	
	/**
	 * [tOracleInput_5 begin ] start
	 */

	

	
		
		ok_Hash.put("tOracleInput_5", false);
		start_Hash.put("tOracleInput_5", System.currentTimeMillis());
		
	
	currentComponent="tOracleInput_5";

	
		int tos_count_tOracleInput_5 = 0;
		
    	class BytesLimit65535_tOracleInput_5{
    		public void limitLog4jByte() throws Exception{
    			
    		}
    	}
    	
        new BytesLimit65535_tOracleInput_5().limitLog4jByte();
	


	
		    int nb_line_tOracleInput_5 = 0;
		    java.sql.Connection conn_tOracleInput_5 = null;
		        conn_tOracleInput_5 = (java.sql.Connection)globalMap.get("conn_tOracleConnection_1");
				
				if(((oracle.jdbc.OracleConnection)conn_tOracleInput_5).getSessionTimeZone() == null){
					java.sql.Statement stmtGetTZ_tOracleInput_5 = conn_tOracleInput_5.createStatement();
					java.sql.ResultSet rsGetTZ_tOracleInput_5 = stmtGetTZ_tOracleInput_5.executeQuery("select sessiontimezone from dual");
					String sessionTimezone_tOracleInput_5 = java.util.TimeZone.getDefault().getID();
					while (rsGetTZ_tOracleInput_5.next()) {
						sessionTimezone_tOracleInput_5 = rsGetTZ_tOracleInput_5.getString(1);
					}
					((oracle.jdbc.OracleConnection)conn_tOracleInput_5).setSessionTimeZone(sessionTimezone_tOracleInput_5);
				}
			
		    
			java.sql.Statement stmt_tOracleInput_5 = conn_tOracleInput_5.createStatement();

		    String dbquery_tOracleInput_5 = "SELECT \n  "+context.oracle_schema+".V_SGBMP_INFOGENE.* \nFROM "+context.oracle_schema+".V_SGBMP_INFOGENE "
/*+ " WHERE " + context.oracle_schema+".V_SGBMP_INFOGENE.CODE_BARRE = 'UN17678'"*/
;
			

            	globalMap.put("tOracleInput_5_QUERY",dbquery_tOracleInput_5);
		    java.sql.ResultSet rs_tOracleInput_5 = null;

		    try {
		    	rs_tOracleInput_5 = stmt_tOracleInput_5.executeQuery(dbquery_tOracleInput_5);
		    	java.sql.ResultSetMetaData rsmd_tOracleInput_5 = rs_tOracleInput_5.getMetaData();
		    	int colQtyInRs_tOracleInput_5 = rsmd_tOracleInput_5.getColumnCount();

		    String tmpContent_tOracleInput_5 = null;
		    
		    
		    while (rs_tOracleInput_5.next()) {
		        nb_line_tOracleInput_5++;
		        
							if(colQtyInRs_tOracleInput_5 < 1) {
								infogene.CODE_BARRE = null;
							} else {
	                         		
        	infogene.CODE_BARRE = routines.system.JDBCUtil.getString(rs_tOracleInput_5, 1, false);
		                    }
							if(colQtyInRs_tOracleInput_5 < 2) {
								infogene.NOM = null;
							} else {
	                         		
        	infogene.NOM = routines.system.JDBCUtil.getString(rs_tOracleInput_5, 2, false);
		                    }
							if(colQtyInRs_tOracleInput_5 < 3) {
								infogene.PRENOM = null;
							} else {
	                         		
        	infogene.PRENOM = routines.system.JDBCUtil.getString(rs_tOracleInput_5, 3, false);
		                    }
							if(colQtyInRs_tOracleInput_5 < 4) {
								infogene.GROUPE = null;
							} else {
	                         		
        	infogene.GROUPE = routines.system.JDBCUtil.getString(rs_tOracleInput_5, 4, false);
		                    }
							if(colQtyInRs_tOracleInput_5 < 5) {
								infogene.CAMPUS = null;
							} else {
	                         		
        	infogene.CAMPUS = routines.system.JDBCUtil.getString(rs_tOracleInput_5, 5, false);
		                    }
							if(colQtyInRs_tOracleInput_5 < 6) {
								infogene.LANGUE = null;
							} else {
	                         		
        	infogene.LANGUE = routines.system.JDBCUtil.getString(rs_tOracleInput_5, 6, false);
		                    }
							if(colQtyInRs_tOracleInput_5 < 7) {
								infogene.STATUT = null;
							} else {
	                         		
        	infogene.STATUT = routines.system.JDBCUtil.getString(rs_tOracleInput_5, 7, false);
		                    }
							if(colQtyInRs_tOracleInput_5 < 8) {
								infogene.DATE_NAISSANCE = null;
							} else {
										
			infogene.DATE_NAISSANCE = routines.system.JDBCUtil.getDate(rs_tOracleInput_5, 8);
		                    }
							if(colQtyInRs_tOracleInput_5 < 9) {
								infogene.DATE_MODIF = null;
							} else {
										
			infogene.DATE_MODIF = routines.system.JDBCUtil.getDate(rs_tOracleInput_5, 9);
		                    }
							if(colQtyInRs_tOracleInput_5 < 10) {
								infogene.DATE_EXPIRATION = null;
							} else {
										
			infogene.DATE_EXPIRATION = routines.system.JDBCUtil.getDate(rs_tOracleInput_5, 10);
		                    }
							if(colQtyInRs_tOracleInput_5 < 11) {
								infogene.DATE_ELIMINATION = null;
							} else {
										
			infogene.DATE_ELIMINATION = routines.system.JDBCUtil.getDate(rs_tOracleInput_5, 11);
		                    }
							if(colQtyInRs_tOracleInput_5 < 12) {
								infogene.EPPN = null;
							} else {
	                         		
        	infogene.EPPN = routines.system.JDBCUtil.getString(rs_tOracleInput_5, 12, false);
		                    }
					




 



/**
 * [tOracleInput_5 begin ] stop
 */
	
	/**
	 * [tOracleInput_5 main ] start
	 */

	

	
	
	currentComponent="tOracleInput_5";

	

 


	tos_count_tOracleInput_5++;

/**
 * [tOracleInput_5 main ] stop
 */

	
	/**
	 * [tXMLMap_1 main ] start
	 */

	

	
	
	currentComponent="tXMLMap_1";

	

			//infogene
			//infogene


			
				if(execStat){
					runStat.updateStatOnConnection("infogene"+iterateId,1, 1);
				} 
			

		


	boolean rejectedInnerJoin_tXMLMap_1 = false;
	boolean rejectedDocInnerJoin_tXMLMap_1 = false;
	boolean mainRowRejected_tXMLMap_1 = false;
	boolean isMatchDocRowtXMLMap_1 = false;
	  
	
				    GenerateDocument_xml gen_Doc_xml_tXMLMap_1 = new GenerateDocument_xml();
					xml_tmp.document = null;
					
		


			
        { // start of Var scope
        
	        // ###############################
        	// # Vars tables
        
Var__tXMLMap_1__Struct Var = Var__tXMLMap_1;
					
Var.fullname = infogene.PRENOM + " " + infogene.NOM ;
		// ###############################
		// # Output tables

xml = null;


// # Output table : 'xml'

gen_Doc_xml_tXMLMap_1.generateElements(rejectedDocInnerJoin_tXMLMap_1,infogene,Var);

if(xml_tmp.document == null){
xml_tmp.document = new routines.system.Document();
xml_tmp.document.setDocument(gen_Doc_xml_tXMLMap_1.getDocument());
}

xml_tmp.CODE_BARRE = infogene.CODE_BARRE;
xml = xml_tmp;
xml_save = xml_tmp;
// ###############################

} // end of Var scope

rejectedInnerJoin_tXMLMap_1 = false;



 


	tos_count_tXMLMap_1++;

/**
 * [tXMLMap_1 main ] stop
 */
// Start of branch "xml"
if(xml != null) { 



	
	/**
	 * [tExtractXMLField_1 main ] start
	 */

	

	
	
	currentComponent="tExtractXMLField_1";

	

			//xml
			//xml


			
				if(execStat){
					runStat.updateStatOnConnection("xml"+iterateId,1, 1);
				} 
			

		

	String xmlStr_tExtractXMLField_1 = null;
	routines.system.Document xmlDocument_tExtractXMLField_1 = null;
	if(xml.document!=null){
				xmlDocument_tExtractXMLField_1 = xml.document;
	}
			if(xmlDocument_tExtractXMLField_1!=null && xmlDocument_tExtractXMLField_1.getDocument()!=null){// C_01
infos = null;
	NameSpaceTool_tExtractXMLField_1 nsTool_tExtractXMLField_1 = new NameSpaceTool_tExtractXMLField_1();
    org.dom4j.io.SAXReader reader_tExtractXMLField_1 = new org.dom4j.io.SAXReader();
	
    org.dom4j.Document doc_tExtractXMLField_1 = null;
    java.util.HashMap xmlNameSpaceMap_tExtractXMLField_1 = null;
    org.dom4j.XPath x_tExtractXMLField_1 = null;
    java.util.List<org.dom4j.tree.AbstractNode> nodeList_tExtractXMLField_1 = null;
		String loopQuery_tExtractXMLField_1 = "/users"; 
	
    boolean isStructError_tExtractXMLField_1= true;
        
    try{
		
	    	doc_tExtractXMLField_1= xmlDocument_tExtractXMLField_1.getDocument();
	    
	    nsTool_tExtractXMLField_1.countNSMap(doc_tExtractXMLField_1.getRootElement());
	    xmlNameSpaceMap_tExtractXMLField_1 = nsTool_tExtractXMLField_1.xmlNameSpaceMap;

    	x_tExtractXMLField_1 = doc_tExtractXMLField_1.createXPath(nsTool_tExtractXMLField_1.addDefaultNSPrefix(loopQuery_tExtractXMLField_1,loopQuery_tExtractXMLField_1));
      
    	x_tExtractXMLField_1.setNamespaceURIs(xmlNameSpaceMap_tExtractXMLField_1); 
    
		 
    	nodeList_tExtractXMLField_1 = (java.util.List<org.dom4j.tree.AbstractNode>)x_tExtractXMLField_1.selectNodes(doc_tExtractXMLField_1);
    	
    	isStructError_tExtractXMLField_1 = false;
    	
    }catch(java.lang.Exception ex_tExtractXMLField_1){
    System.err.println(ex_tExtractXMLField_1.getMessage());
    }
    
    org.dom4j.Node node_tExtractXMLField_1 = null;
    String str_tExtractXMLField_1 = "";
    boolean resultIsNode_tExtractXMLField_1 = true;
    for(int i_tExtractXMLField_1=0; isStructError_tExtractXMLField_1 || (nodeList_tExtractXMLField_1!=null && i_tExtractXMLField_1 < nodeList_tExtractXMLField_1.size());i_tExtractXMLField_1++){
    	
    	if(!isStructError_tExtractXMLField_1){
			infos = null;
    		infos = new infosStruct();
    	
    		org.dom4j.tree.AbstractNode temp_tExtractXMLField_1 = nodeList_tExtractXMLField_1.get(i_tExtractXMLField_1);
	
	    	nb_line_tExtractXMLField_1++;	
			try{
			infos.CODE_BARRE = xml.CODE_BARRE;
				org.dom4j.XPath xTmp0_tExtractXMLField_1 = temp_tExtractXMLField_1.createXPath(nsTool_tExtractXMLField_1.addDefaultNSPrefix("user",loopQuery_tExtractXMLField_1));
			    xTmp0_tExtractXMLField_1.setNamespaceURIs(xmlNameSpaceMap_tExtractXMLField_1);
				
			    Object obj0_tExtractXMLField_1 = xTmp0_tExtractXMLField_1.evaluate(temp_tExtractXMLField_1);
			    if(obj0_tExtractXMLField_1 instanceof String || obj0_tExtractXMLField_1 instanceof Number){
			    	resultIsNode_tExtractXMLField_1 = false;
    				str_tExtractXMLField_1 = String.valueOf(obj0_tExtractXMLField_1);
   				}else{
   					resultIsNode_tExtractXMLField_1 = true;
				    node_tExtractXMLField_1 = xTmp0_tExtractXMLField_1.selectSingleNode(temp_tExtractXMLField_1);
					str_tExtractXMLField_1 = node_tExtractXMLField_1==null?null:node_tExtractXMLField_1.asXML();
				}
									infos.document = ParserUtils.parseTo_Document(str_tExtractXMLField_1);
}catch(java.lang.Exception ex_tExtractXMLField_1){
    System.err.println(ex_tExtractXMLField_1.getMessage());
    infos = null;
    	}
    }
    
    isStructError_tExtractXMLField_1 = false;


   globalMap.put("tExtractXMLField_1_NB_LINE", nb_line_tExtractXMLField_1);

 


	tos_count_tExtractXMLField_1++;

/**
 * [tExtractXMLField_1 main ] stop
 */
// Start of branch "infos"
if(infos != null) { 



	
	/**
	 * [tMap_1 main ] start
	 */

	

	
	
	currentComponent="tMap_1";

	

			//infos
			//infos


			
				if(execStat){
					runStat.updateStatOnConnection("infos"+iterateId,1, 1);
				} 
			

		

		
		
		boolean hasCasePrimitiveKeyWithNull_tMap_1 = false;
		
        // ###############################
        // # Input tables (lookups)
		  boolean rejectedInnerJoin_tMap_1 = false;
		  boolean mainRowRejected_tMap_1 = false;
            				    								  
		

				///////////////////////////////////////////////
				// Starting Lookup Table "email" 
				///////////////////////////////////////////////


				
				
                            
 					    boolean forceLoopemail = false;
       		  	    	
       		  	    	
 							emailStruct emailObjectFromLookup = null;
                          
		           		  	if(!rejectedInnerJoin_tMap_1) { // G_TM_M_020

								
								hasCasePrimitiveKeyWithNull_tMap_1 = false;
								
                        		    		emailHashKey.CODE_BARRE = infos.CODE_BARRE ;
                        		    		

								
		                        	emailHashKey.hashCodeDirty = true;
                        		
	  					
	  							
			  					
			  					
	  					
		  							tHash_Lookup_email.lookup( emailHashKey );

	  							

	  							

 								
		  				
	  								
						
									
  									  		
 								



							} // G_TM_M_020
			           		  	  
							
				           		if(tHash_Lookup_email != null && tHash_Lookup_email.getCount(emailHashKey) > 1) { // G 071
			  							
			  						
									 		
									//System.out.println("WARNING: UNIQUE MATCH is configured for the lookup 'email' and it contains more one result from keys :  email.CODE_BARRE = '" + emailHashKey.CODE_BARRE + "'");
								} // G 071
							

							emailStruct email = null;
                    		  	 
							   
                    		  	 
	       		  	    	emailStruct fromLookup_email = null;
							email = emailDefault;
										 
							
								 
							
							
								if (tHash_Lookup_email !=null && tHash_Lookup_email.hasNext()) { // G 099
								
							
								
								fromLookup_email = tHash_Lookup_email.next();

							
							
								} // G 099
							
							

							if(fromLookup_email != null) {
								email = fromLookup_email;
							}
							
							
							
			  							
								
	                    		  	
		                    
	            	
	           	
	            	
	            	
	            

				///////////////////////////////////////////////
				// Starting Lookup Table "adress" 
				///////////////////////////////////////////////


				
				
                            
 					    boolean forceLoopadress = false;
       		  	    	
       		  	    	
 							adressStruct adressObjectFromLookup = null;
                          
		           		  	if(!rejectedInnerJoin_tMap_1) { // G_TM_M_020

								
								hasCasePrimitiveKeyWithNull_tMap_1 = false;
								
                        		    		adressHashKey.CODE_BARRE = infos.CODE_BARRE ;
                        		    		

								
		                        	adressHashKey.hashCodeDirty = true;
                        		
	  					
	  							
			  					
			  					
	  					
		  							tHash_Lookup_adress.lookup( adressHashKey );

	  							

	  							

 								
		  				
	  								
						
									
  									  		
 								



							} // G_TM_M_020
			           		  	  
							
				           		if(tHash_Lookup_adress != null && tHash_Lookup_adress.getCount(adressHashKey) > 1) { // G 071
			  							
			  						
									 		
									//System.out.println("WARNING: UNIQUE MATCH is configured for the lookup 'adress' and it contains more one result from keys :  adress.CODE_BARRE = '" + adressHashKey.CODE_BARRE + "'");
								} // G 071
							

							adressStruct adress = null;
                    		  	 
							   
                    		  	 
	       		  	    	adressStruct fromLookup_adress = null;
							adress = adressDefault;
										 
							
								 
							
							
								if (tHash_Lookup_adress !=null && tHash_Lookup_adress.hasNext()) { // G 099
								
							
								
								fromLookup_adress = tHash_Lookup_adress.next();

							
							
								} // G 099
							
							

							if(fromLookup_adress != null) {
								adress = fromLookup_adress;
							}
							
							
							
			  							
								
	                    		  	
		                    
	            	
	           	
	            	
	            	
	            

				///////////////////////////////////////////////
				// Starting Lookup Table "phone" 
				///////////////////////////////////////////////


				
				
                            
 					    boolean forceLoopphone = false;
       		  	    	
       		  	    	
 							phoneStruct phoneObjectFromLookup = null;
                          
		           		  	if(!rejectedInnerJoin_tMap_1) { // G_TM_M_020

								
								hasCasePrimitiveKeyWithNull_tMap_1 = false;
								
                        		    		phoneHashKey.CODE_BARRE = infos.CODE_BARRE ;
                        		    		

								
		                        	phoneHashKey.hashCodeDirty = true;
                        		
	  					
	  							
			  					
			  					
	  					
		  							tHash_Lookup_phone.lookup( phoneHashKey );

	  							

	  							

 								
		  				
	  								
						
									
  									  		
 								



							} // G_TM_M_020
			           		  	  
							
				           		if(tHash_Lookup_phone != null && tHash_Lookup_phone.getCount(phoneHashKey) > 1) { // G 071
			  							
			  						
									 		
									//System.out.println("WARNING: UNIQUE MATCH is configured for the lookup 'phone' and it contains more one result from keys :  phone.CODE_BARRE = '" + phoneHashKey.CODE_BARRE + "'");
								} // G 071
							

							phoneStruct phone = null;
                    		  	 
							   
                    		  	 
	       		  	    	phoneStruct fromLookup_phone = null;
							phone = phoneDefault;
										 
							
								 
							
							
								if (tHash_Lookup_phone !=null && tHash_Lookup_phone.hasNext()) { // G 099
								
							
								
								fromLookup_phone = tHash_Lookup_phone.next();

							
							
								} // G 099
							
							

							if(fromLookup_phone != null) {
								phone = fromLookup_phone;
							}
							
							
							
			  							
								
	                    		  	
		                    
	            	
	           	
	            	
	            	
	            

				///////////////////////////////////////////////
				// Starting Lookup Table "statistique" 
				///////////////////////////////////////////////


				
				
                            
 					    boolean forceLoopstatistique = false;
       		  	    	
       		  	    	
 							statistiqueStruct statistiqueObjectFromLookup = null;
                          
		           		  	if(!rejectedInnerJoin_tMap_1) { // G_TM_M_020

								
								hasCasePrimitiveKeyWithNull_tMap_1 = false;
								
                        		    		statistiqueHashKey.CODE_BARRE = infos.CODE_BARRE ;
                        		    		

								
		                        	statistiqueHashKey.hashCodeDirty = true;
                        		
	  					
	  							
			  					
			  					
	  					
		  							tHash_Lookup_statistique.lookup( statistiqueHashKey );

	  							

	  							

 								
		  				
	  								
						
									
  									  		
 								



							} // G_TM_M_020
			           		  	  
							
				           		if(tHash_Lookup_statistique != null && tHash_Lookup_statistique.getCount(statistiqueHashKey) > 1) { // G 071
			  							
			  						
									 		
									//System.out.println("WARNING: UNIQUE MATCH is configured for the lookup 'statistique' and it contains more one result from keys :  statistique.CODE_BARRE = '" + statistiqueHashKey.CODE_BARRE + "'");
								} // G 071
							

							statistiqueStruct statistique = null;
                    		  	 
							   
                    		  	 
	       		  	    	statistiqueStruct fromLookup_statistique = null;
							statistique = statistiqueDefault;
										 
							
								 
							
							
								if (tHash_Lookup_statistique !=null && tHash_Lookup_statistique.hasNext()) { // G 099
								
							
								
								fromLookup_statistique = tHash_Lookup_statistique.next();

							
							
								} // G 099
							
							

							if(fromLookup_statistique != null) {
								statistique = fromLookup_statistique;
							}
							
							
							
			  							
								
	                    		  	
		                    
	            	
	            	
	            // ###############################
        { // start of Var scope
        
	        // ###############################
        	// # Vars tables
        
Var__tMap_1__Struct Var = Var__tMap_1;
Var.mails = (email.doc != null)?email.doc.toString().replace("<?xml version=\"1.0\" encoding=\"UTF-8\"?>",""):"" ;
Var.telephones = (adress.doc != null)?adress.doc.toString().replace("<?xml version=\"1.0\" encoding=\"UTF-8\"?>",""):"" ;
Var.adresses = (phone.doc != null)?phone.doc.toString().replace
("<?xml version=\"1.0\" encoding=\"UTF-8\"?>",""):"" ;
Var.statistiques = (statistique.doc != null)?statistique.doc.toString().replace
("<?xml version=\"1.0\" encoding=\"UTF-8\"?>",""):"" ;// ###############################
        // ###############################
        // # Output tables

out1 = null;


// # Output table : 'out1'
out1_tmp.user = infos.document.toString().replace("<emails>toReplaceByMails</emails>",Var.mails).replace("<phones>toReplaceByPhones</phones>",Var.telephones).replace("<addresses>toReplaceByAddresses</addresses>",Var.adresses).replace("<user_statistics>toReplaceByStatistics</user_statistics>",Var.statistiques).replace("<?xml version=\"1.0\" encoding=\"UTF-8\"?>","") ;
out1_tmp.CODE_BARRE = infos.CODE_BARRE ;
out1 = out1_tmp;
// ###############################

} // end of Var scope

rejectedInnerJoin_tMap_1 = false;










 


	tos_count_tMap_1++;

/**
 * [tMap_1 main ] stop
 */
// Start of branch "out1"
if(out1 != null) { 



	
	/**
	 * [tJavaFlex_1 main ] start
	 */

	

	
	
	currentComponent="tJavaFlex_1";

	

			//out1
			//out1


			
				if(execStat){
					runStat.updateStatOnConnection("out1"+iterateId,1, 1);
				} 
			

		



writer.append(out1.user);



 


	tos_count_tJavaFlex_1++;

/**
 * [tJavaFlex_1 main ] stop
 */

} // End of branch "out1"





} // End of branch "infos"

		// end for
	}


	
		} // C_01
	

} // End of branch "xml"







	
	/**
	 * [tOracleInput_5 end ] start
	 */

	

	
	
	currentComponent="tOracleInput_5";

	

}
}finally{
stmt_tOracleInput_5.close();

}

globalMap.put("tOracleInput_5_NB_LINE",nb_line_tOracleInput_5);
 

ok_Hash.put("tOracleInput_5", true);
end_Hash.put("tOracleInput_5", System.currentTimeMillis());




/**
 * [tOracleInput_5 end ] stop
 */

	
	/**
	 * [tXMLMap_1 end ] start
	 */

	

	
	
	currentComponent="tXMLMap_1";

	

			if(execStat){
				if(resourceMap.get("inIterateVComp") == null || !((Boolean)resourceMap.get("inIterateVComp"))){
			 		runStat.updateStatOnConnection("infogene"+iterateId,2, 0); 
			 	}
			}
		
 

ok_Hash.put("tXMLMap_1", true);
end_Hash.put("tXMLMap_1", System.currentTimeMillis());




/**
 * [tXMLMap_1 end ] stop
 */

	
	/**
	 * [tExtractXMLField_1 end ] start
	 */

	

	
	
	currentComponent="tExtractXMLField_1";

	



globalMap.put("tExtractXMLField_1_NB_LINE", nb_line_tExtractXMLField_1);

			if(execStat){
				if(resourceMap.get("inIterateVComp") == null || !((Boolean)resourceMap.get("inIterateVComp"))){
			 		runStat.updateStatOnConnection("xml"+iterateId,2, 0); 
			 	}
			}
		
 

ok_Hash.put("tExtractXMLField_1", true);
end_Hash.put("tExtractXMLField_1", System.currentTimeMillis());




/**
 * [tExtractXMLField_1 end ] stop
 */

	
	/**
	 * [tMap_1 end ] start
	 */

	

	
	
	currentComponent="tMap_1";

	


// ###############################
// # Lookup hashes releasing
					if(tHash_Lookup_email != null) {
						tHash_Lookup_email.endGet();
					}
					globalMap.remove( "tHash_Lookup_email" );

					
					
				
					if(tHash_Lookup_adress != null) {
						tHash_Lookup_adress.endGet();
					}
					globalMap.remove( "tHash_Lookup_adress" );

					
					
				
					if(tHash_Lookup_phone != null) {
						tHash_Lookup_phone.endGet();
					}
					globalMap.remove( "tHash_Lookup_phone" );

					
					
				
					if(tHash_Lookup_statistique != null) {
						tHash_Lookup_statistique.endGet();
					}
					globalMap.remove( "tHash_Lookup_statistique" );

					
					
				
// ###############################      





			if(execStat){
				if(resourceMap.get("inIterateVComp") == null || !((Boolean)resourceMap.get("inIterateVComp"))){
			 		runStat.updateStatOnConnection("infos"+iterateId,2, 0); 
			 	}
			}
		
 

ok_Hash.put("tMap_1", true);
end_Hash.put("tMap_1", System.currentTimeMillis());




/**
 * [tMap_1 end ] stop
 */

	
	/**
	 * [tJavaFlex_1 end ] start
	 */

	

	
	
	currentComponent="tJavaFlex_1";

	


// end of the component, outside/closing the loop
      
writer.println("</users>");
writer.close();

			if(execStat){
				if(resourceMap.get("inIterateVComp") == null || !((Boolean)resourceMap.get("inIterateVComp"))){
			 		runStat.updateStatOnConnection("out1"+iterateId,2, 0); 
			 	}
			}
		
 

ok_Hash.put("tJavaFlex_1", true);
end_Hash.put("tJavaFlex_1", System.currentTimeMillis());

				if(execStat){   
   	 				runStat.updateStatOnConnection("OnComponentOk6", 0, "ok");
				}
				tFileArchive_1Process(globalMap);



/**
 * [tJavaFlex_1 end ] stop
 */












				}//end the resume

				



	
			}catch(java.lang.Exception e){	
				
				TalendException te = new TalendException(e, currentComponent, globalMap);
				
				throw te;
			}catch(java.lang.Error error){	
				
					runStat.stopThreadStat();
				
				throw error;
			}finally{
				
					     			//free memory for "tMap_1"
					     			globalMap.remove("tHash_Lookup_adress"); 
				     			
					     			//free memory for "tMap_1"
					     			globalMap.remove("tHash_Lookup_email"); 
				     			
					     			//free memory for "tMap_1"
					     			globalMap.remove("tHash_Lookup_phone"); 
				     			
					     			//free memory for "tMap_1"
					     			globalMap.remove("tHash_Lookup_statistique"); 
				     			
				try{
					
	
	/**
	 * [tOracleInput_5 finally ] start
	 */

	

	
	
	currentComponent="tOracleInput_5";

	

 



/**
 * [tOracleInput_5 finally ] stop
 */

	
	/**
	 * [tXMLMap_1 finally ] start
	 */

	

	
	
	currentComponent="tXMLMap_1";

	

 



/**
 * [tXMLMap_1 finally ] stop
 */

	
	/**
	 * [tExtractXMLField_1 finally ] start
	 */

	

	
	
	currentComponent="tExtractXMLField_1";

	

 



/**
 * [tExtractXMLField_1 finally ] stop
 */

	
	/**
	 * [tMap_1 finally ] start
	 */

	

	
	
	currentComponent="tMap_1";

	

 



/**
 * [tMap_1 finally ] stop
 */

	
	/**
	 * [tJavaFlex_1 finally ] start
	 */

	

	
	
	currentComponent="tJavaFlex_1";

	

 



/**
 * [tJavaFlex_1 finally ] stop
 */












				}catch(java.lang.Exception e){	
					//ignore
				}catch(java.lang.Error error){
					//ignore
				}
				resourceMap = null;
			}
		

		globalMap.put("tOracleInput_5_SUBPROCESS_STATE", 1);
	}
	


public static class row2Struct implements routines.system.IPersistableRow<row2Struct> {
    final static byte[] commonByteArrayLock_LDAP_sgbm_export = new byte[0];
    static byte[] commonByteArray_LDAP_sgbm_export = new byte[0];

	
			    public routines.system.Document doc;

				public routines.system.Document getDoc () {
					return this.doc;
				}
				



    public void readData(ObjectInputStream dis) {

		synchronized(commonByteArrayLock_LDAP_sgbm_export) {

        	try {

        		int length = 0;
		
						this.doc = (routines.system.Document) dis.readObject();
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);

		
			} catch(ClassNotFoundException eCNFE) {
				 throw new RuntimeException(eCNFE);
		

        }

		

      }


    }

    public void writeData(ObjectOutputStream dos) {
        try {

		
					// Document
				
       			    	dos.writeObject(this.doc);
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);
        }


    }


    public String toString() {

		StringBuilder sb = new StringBuilder();
		sb.append(super.toString());
		sb.append("[");
		sb.append("doc="+String.valueOf(doc));
	    sb.append("]");

	    return sb.toString();
    }

    /**
     * Compare keys
     */
    public int compareTo(row2Struct other) {

		int returnValue = -1;
		
	    return returnValue;
    }


    private int checkNullsAndCompare(Object object1, Object object2) {
        int returnValue = 0;
		if (object1 instanceof Comparable && object2 instanceof Comparable) {
            returnValue = ((Comparable) object1).compareTo(object2);
        } else if (object1 != null && object2 != null) {
            returnValue = compareStrings(object1.toString(), object2.toString());
        } else if (object1 == null && object2 != null) {
            returnValue = 1;
        } else if (object1 != null && object2 == null) {
            returnValue = -1;
        } else {
            returnValue = 0;
        }

        return returnValue;
    }

    private int compareStrings(String string1, String string2) {
        return string1.compareTo(string2);
    }


}
public void tFileArchive_1Process(final java.util.Map<String, Object> globalMap) throws TalendException {
	globalMap.put("tFileArchive_1_SUBPROCESS_STATE", 0);

 final boolean execStat = this.execStat;
	
		String iterateId = "";
	
	
	String currentComponent = "";
	java.util.Map<String, Object> resourceMap = new java.util.HashMap<String, Object>();

	try {

			String currentMethodName = new java.lang.Exception().getStackTrace()[0].getMethodName();
			boolean resumeIt = currentMethodName.equals(resumeEntryMethodName);
			if( resumeEntryMethodName == null || resumeIt || globalResumeTicket){//start the resume
				globalResumeTicket = true;



		row2Struct row2 = new row2Struct();




	
	/**
	 * [tSCPPut_1 begin ] start
	 */

	

	
		
		ok_Hash.put("tSCPPut_1", false);
		start_Hash.put("tSCPPut_1", System.currentTimeMillis());
		
	
	currentComponent="tSCPPut_1";

	
			if (execStat) {
				if(resourceMap.get("inIterateVComp") == null){
					
						runStat.updateStatOnConnection("row2" + iterateId, 0, 0);
					
				}
			} 

		
		int tos_count_tSCPPut_1 = 0;
		
    	class BytesLimit65535_tSCPPut_1{
    		public void limitLog4jByte() throws Exception{
    			
    		}
    	}
    	
        new BytesLimit65535_tSCPPut_1().limitLog4jByte();

 
	int nb_file_tSCPPut_1 = 0;
	globalMap.put("tSCPPut_1_STATUS", "");
    /* Create a connection instance */
	
		ch.ethz.ssh2.Connection conn_tSCPPut_1 = (ch.ethz.ssh2.Connection)globalMap.get("conn_tSCPConnection_1");
		
	
	
        ch.ethz.ssh2.SCPClient scp_tSCPPut_1 = new  ch.ethz.ssh2.SCPClient(conn_tSCPPut_1);
		
        java.util.List<String> sourceList_tSCPPut_1 = new java.util.ArrayList<String>();
			if((new java.io.File(context.sigb_files_dir+context.sigb_file_name + ".zip").exists()) 
			&& (new java.io.File(context.sigb_files_dir+context.sigb_file_name + ".zip").isFile())){
				sourceList_tSCPPut_1.add(context.sigb_files_dir+context.sigb_file_name + ".zip");
			}else{
        }   
		String[] sourceFileNames_tSCPPut_1 = new String[sourceList_tSCPPut_1.size()];
        for(int i_tSCPPut_1 = 0;i_tSCPPut_1 < sourceList_tSCPPut_1.size(); i_tSCPPut_1++){
        	sourceFileNames_tSCPPut_1[i_tSCPPut_1] = sourceList_tSCPPut_1.get(i_tSCPPut_1);
        }

 



/**
 * [tSCPPut_1 begin ] stop
 */



	
	/**
	 * [tFileArchive_1 begin ] start
	 */

	

	
		
		ok_Hash.put("tFileArchive_1", false);
		start_Hash.put("tFileArchive_1", System.currentTimeMillis());
		
	
	currentComponent="tFileArchive_1";

	
		int tos_count_tFileArchive_1 = 0;
		
    	class BytesLimit65535_tFileArchive_1{
    		public void limitLog4jByte() throws Exception{
    			
    		}
    	}
    	
        new BytesLimit65535_tFileArchive_1().limitLog4jByte();

 



/**
 * [tFileArchive_1 begin ] stop
 */
	
	/**
	 * [tFileArchive_1 main ] start
	 */

	

	
	
	currentComponent="tFileArchive_1";

	

	
	
		String sourceFile_tFileArchive_1 = context.sigb_files_dir;
	
    String zipFile_tFileArchive_1 = context.sigb_files_dir + context.sigb_file_name + ".zip";
    
    com.talend.compress.zip.Zip zip_tFileArchive_1 = new com.talend.compress.zip.Zip(sourceFile_tFileArchive_1, zipFile_tFileArchive_1);
    zip_tFileArchive_1.setOverwriteExistTargetZip(true);
	zip_tFileArchive_1.setMakeTargetDir(false);
	zip_tFileArchive_1.setCompressLevel(9);
	zip_tFileArchive_1.setArchiveFormat("zip");
	zip_tFileArchive_1.setAllFiles(false);
	
	  
    	//build filename pattern filter
	    String[] patterns_tFileArchive_1 = new String[1];
    	
	        patterns_tFileArchive_1[0] = context.sigb_file_name + ".xml";
  		StringBuilder sbf_tFileArchive_1 = new StringBuilder(); 
        sbf_tFileArchive_1.append("(");
        for (int i_tFileArchive_1 = 0 ; i_tFileArchive_1 < patterns_tFileArchive_1.length ; i_tFileArchive_1++) {
            sbf_tFileArchive_1.append(patterns_tFileArchive_1[i_tFileArchive_1].replaceAll("\\.", "\\\\.").replaceAll("\\*", ".*"));
            if(i_tFileArchive_1 != patterns_tFileArchive_1.length-1) sbf_tFileArchive_1.append("|");
        }        
        sbf_tFileArchive_1.append(")");
        final String maskStr_tFileArchive_1 = new String(sbf_tFileArchive_1.toString());
        
        //apply the filter
       	zip_tFileArchive_1.setNamePatternFilter(maskStr_tFileArchive_1);
	
	   zip_tFileArchive_1.setContainSubDir(true);
	   zip_tFileArchive_1.setEncoding("UTF-8");
	   zip_tFileArchive_1.setZip64Mode("ASNEEDED");
	   zip_tFileArchive_1.setEncrypted(false);
		        
	   
	    
	    
	final String decryptedPassword_tFileArchive_1 = routines.system.PasswordEncryptUtil.decryptPassword("f4f7aba1746784ea");
	    
	   zip_tFileArchive_1.setPassword(decryptedPassword_tFileArchive_1);
	   
	      zip_tFileArchive_1.setUseZip4jEncryption(true);
	      zip_tFileArchive_1.setEncryptionMethod(net.lingala.zip4j.util.Zip4jConstants.ENC_METHOD_STANDARD);
	      
  
  
   globalMap.put("tFileArchive_1_ARCHIVE_FILEPATH",zipFile_tFileArchive_1);
   
   globalMap.put("tFileArchive_1_ARCHIVE_FILENAME", new java.io.File(zipFile_tFileArchive_1).getName());

   zip_tFileArchive_1.doZip();


 


	tos_count_tFileArchive_1++;

/**
 * [tFileArchive_1 main ] stop
 */

	
	/**
	 * [tSCPPut_1 main ] start
	 */

	

	
	
	currentComponent="tSCPPut_1";

	

			//row2
			//row2


			
				if(execStat){
					runStat.updateStatOnConnection("row2"+iterateId,1, 1);
				} 
			

		

	try{
        if(sourceFileNames_tSCPPut_1!=null && sourceFileNames_tSCPPut_1.length!=0){
           	for (int i_tSCPPut_1 = 0; i_tSCPPut_1 < sourceFileNames_tSCPPut_1.length; i_tSCPPut_1++) {
       			java.io.File file_tSCPPut_1 = new java.io.File(sourceFileNames_tSCPPut_1[i_tSCPPut_1]);
       			long sendSize_tSCPPut_1 = file_tSCPPut_1.length();
       			String remoteName_tSCPPut_1 = file_tSCPPut_1.getName();
       			java.io.OutputStream out_tSCPPut_1 = null;
       			java.io.InputStream is_tSCPPut_1 = null;
				byte[] buffer_tSCPPut_1 = new byte[8192];
				int receive_tSCPPut_1 = -1;
				try {
					out_tSCPPut_1 = scp_tSCPPut_1.put(remoteName_tSCPPut_1, sendSize_tSCPPut_1, context.sigb_biu_dir, "0644");
					is_tSCPPut_1 = new java.io.FileInputStream(file_tSCPPut_1);
					
    				while((receive_tSCPPut_1 = is_tSCPPut_1.read(buffer_tSCPPut_1))!=-1) {
						out_tSCPPut_1.write(buffer_tSCPPut_1, 0, receive_tSCPPut_1);
    				}
				} finally {
                	if(out_tSCPPut_1 != null){
            			out_tSCPPut_1.close();
                	}
                	
                	if(is_tSCPPut_1 != null) {
            			is_tSCPPut_1.close();
                	}
				}
           	}
			
            nb_file_tSCPPut_1 = sourceFileNames_tSCPPut_1.length;
            globalMap.put("tSCPPut_1_STATUS", "File put OK.");
        }else{
        	globalMap.put("tSCPPut_1_STATUS", "No file transfered.");
        }
    }catch(java.lang.Exception e){
    		e.printStackTrace();
    		
    		globalMap.put("tSCPPut_1_STATUS", "File put fail.");
    }

 


	tos_count_tSCPPut_1++;

/**
 * [tSCPPut_1 main ] stop
 */



	
	/**
	 * [tFileArchive_1 end ] start
	 */

	

	
	
	currentComponent="tFileArchive_1";

	

 

ok_Hash.put("tFileArchive_1", true);
end_Hash.put("tFileArchive_1", System.currentTimeMillis());




/**
 * [tFileArchive_1 end ] stop
 */

	
	/**
	 * [tSCPPut_1 end ] start
	 */

	

	
	
	currentComponent="tSCPPut_1";

	

		globalMap.put("tSCPPut_1_NB_FILE",nb_file_tSCPPut_1);
			
		

			if(execStat){
				if(resourceMap.get("inIterateVComp") == null || !((Boolean)resourceMap.get("inIterateVComp"))){
			 		runStat.updateStatOnConnection("row2"+iterateId,2, 0); 
			 	}
			}
		
 

ok_Hash.put("tSCPPut_1", true);
end_Hash.put("tSCPPut_1", System.currentTimeMillis());




/**
 * [tSCPPut_1 end ] stop
 */



				}//end the resume

				



	
			}catch(java.lang.Exception e){	
				
				TalendException te = new TalendException(e, currentComponent, globalMap);
				
				throw te;
			}catch(java.lang.Error error){	
				
					runStat.stopThreadStat();
				
				throw error;
			}finally{
				
				try{
					
	
	/**
	 * [tFileArchive_1 finally ] start
	 */

	

	
	
	currentComponent="tFileArchive_1";

	

 



/**
 * [tFileArchive_1 finally ] stop
 */

	
	/**
	 * [tSCPPut_1 finally ] start
	 */

	

	
	
	currentComponent="tSCPPut_1";

	

 



/**
 * [tSCPPut_1 finally ] stop
 */



				}catch(java.lang.Exception e){	
					//ignore
				}catch(java.lang.Error error){
					//ignore
				}
				resourceMap = null;
			}
		

		globalMap.put("tFileArchive_1_SUBPROCESS_STATE", 1);
	}
	


public static class adressStruct implements routines.system.IPersistableComparableLookupRow<adressStruct> {
    final static byte[] commonByteArrayLock_LDAP_sgbm_export = new byte[0];
    static byte[] commonByteArray_LDAP_sgbm_export = new byte[0];
	protected static final int DEFAULT_HASHCODE = 1;
    protected static final int PRIME = 31;
    protected int hashCode = DEFAULT_HASHCODE;
    public boolean hashCodeDirty = true;

    public String loopKey;



	
			    public routines.system.Document doc;

				public routines.system.Document getDoc () {
					return this.doc;
				}
				
			    public String CODE_BARRE;

				public String getCODE_BARRE () {
					return this.CODE_BARRE;
				}
				


	@Override
	public int hashCode() {
		if (this.hashCodeDirty) {
			final int prime = PRIME;
			int result = DEFAULT_HASHCODE;
	
						result = prime * result + ((this.CODE_BARRE == null) ? 0 : this.CODE_BARRE.hashCode());
					
    		this.hashCode = result;
    		this.hashCodeDirty = false;
		}
		return this.hashCode;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj) return true;
		if (obj == null) return false;
		if (getClass() != obj.getClass()) return false;
		final adressStruct other = (adressStruct) obj;
		
						if (this.CODE_BARRE == null) {
							if (other.CODE_BARRE != null)
								return false;
						
						} else if (!this.CODE_BARRE.equals(other.CODE_BARRE))
						
							return false;
					

		return true;
    }

	public void copyDataTo(adressStruct other) {

		other.doc = this.doc;
	            other.CODE_BARRE = this.CODE_BARRE;
	            
	}

	public void copyKeysDataTo(adressStruct other) {

		other.CODE_BARRE = this.CODE_BARRE;
	            	
	}




	private String readString(ObjectInputStream dis) throws IOException{
		String strReturn = null;
		int length = 0;
        length = dis.readInt();
		if (length == -1) {
			strReturn = null;
		} else {
			if(length > commonByteArray_LDAP_sgbm_export.length) {
				if(length < 1024 && commonByteArray_LDAP_sgbm_export.length == 0) {
   					commonByteArray_LDAP_sgbm_export = new byte[1024];
				} else {
   					commonByteArray_LDAP_sgbm_export = new byte[2 * length];
   				}
			}
			dis.readFully(commonByteArray_LDAP_sgbm_export, 0, length);
			strReturn = new String(commonByteArray_LDAP_sgbm_export, 0, length, utf8Charset);
		}
		return strReturn;
	}

    private void writeString(String str, ObjectOutputStream dos) throws IOException{
		if(str == null) {
            dos.writeInt(-1);
		} else {
            byte[] byteArray = str.getBytes(utf8Charset);
	    	dos.writeInt(byteArray.length);
			dos.write(byteArray);
    	}
    }

    public void readKeysData(ObjectInputStream dis) {

		synchronized(commonByteArrayLock_LDAP_sgbm_export) {

        	try {

        		int length = 0;
		
					this.CODE_BARRE = readString(dis);
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);

		

        }

		

      }


    }

    public void writeKeysData(ObjectOutputStream dos) {
        try {

		
					// String
				
						writeString(this.CODE_BARRE,dos);
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);
        }


    }



    /**
     * Fill Values data by reading ObjectInputStream.
     */
    public void readValuesData(DataInputStream dis, ObjectInputStream ois) {
        try {

			int length = 0;
		
       			    	this.doc = (routines.system.Document) ois.readObject();
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);

		
			} catch(ClassNotFoundException eCNFE) {
				 throw new RuntimeException(eCNFE);
		

        }

		

    }

    /**
     * Return a byte array which represents Values data.
     */
    public void writeValuesData(DataOutputStream dos, ObjectOutputStream oos) {
        try {

		
       			    	oos.writeObject(this.doc);
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);
        	}

    }


    public String toString() {

		StringBuilder sb = new StringBuilder();
		sb.append(super.toString());
		sb.append("[");
		sb.append("doc="+String.valueOf(doc));
		sb.append(",CODE_BARRE="+CODE_BARRE);
	    sb.append("]");

	    return sb.toString();
    }

    /**
     * Compare keys
     */
    public int compareTo(adressStruct other) {

		int returnValue = -1;
		
						returnValue = checkNullsAndCompare(this.CODE_BARRE, other.CODE_BARRE);
						if(returnValue != 0) {
							return returnValue;
						}

					
	    return returnValue;
    }


    private int checkNullsAndCompare(Object object1, Object object2) {
        int returnValue = 0;
		if (object1 instanceof Comparable && object2 instanceof Comparable) {
            returnValue = ((Comparable) object1).compareTo(object2);
        } else if (object1 != null && object2 != null) {
            returnValue = compareStrings(object1.toString(), object2.toString());
        } else if (object1 == null && object2 != null) {
            returnValue = 1;
        } else if (object1 != null && object2 == null) {
            returnValue = -1;
        } else {
            returnValue = 0;
        }

        return returnValue;
    }

    private int compareStrings(String string1, String string2) {
        return string1.compareTo(string2);
    }


}

public static class adressesStruct implements routines.system.IPersistableRow<adressesStruct> {
    final static byte[] commonByteArrayLock_LDAP_sgbm_export = new byte[0];
    static byte[] commonByteArray_LDAP_sgbm_export = new byte[0];

	
			    public routines.system.Document doc;

				public routines.system.Document getDoc () {
					return this.doc;
				}
				
			    public String CODE_BARRE;

				public String getCODE_BARRE () {
					return this.CODE_BARRE;
				}
				



	private String readString(ObjectInputStream dis) throws IOException{
		String strReturn = null;
		int length = 0;
        length = dis.readInt();
		if (length == -1) {
			strReturn = null;
		} else {
			if(length > commonByteArray_LDAP_sgbm_export.length) {
				if(length < 1024 && commonByteArray_LDAP_sgbm_export.length == 0) {
   					commonByteArray_LDAP_sgbm_export = new byte[1024];
				} else {
   					commonByteArray_LDAP_sgbm_export = new byte[2 * length];
   				}
			}
			dis.readFully(commonByteArray_LDAP_sgbm_export, 0, length);
			strReturn = new String(commonByteArray_LDAP_sgbm_export, 0, length, utf8Charset);
		}
		return strReturn;
	}

    private void writeString(String str, ObjectOutputStream dos) throws IOException{
		if(str == null) {
            dos.writeInt(-1);
		} else {
            byte[] byteArray = str.getBytes(utf8Charset);
	    	dos.writeInt(byteArray.length);
			dos.write(byteArray);
    	}
    }

    public void readData(ObjectInputStream dis) {

		synchronized(commonByteArrayLock_LDAP_sgbm_export) {

        	try {

        		int length = 0;
		
						this.doc = (routines.system.Document) dis.readObject();
					
					this.CODE_BARRE = readString(dis);
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);

		
			} catch(ClassNotFoundException eCNFE) {
				 throw new RuntimeException(eCNFE);
		

        }

		

      }


    }

    public void writeData(ObjectOutputStream dos) {
        try {

		
					// Document
				
       			    	dos.writeObject(this.doc);
					
					// String
				
						writeString(this.CODE_BARRE,dos);
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);
        }


    }


    public String toString() {

		StringBuilder sb = new StringBuilder();
		sb.append(super.toString());
		sb.append("[");
		sb.append("doc="+String.valueOf(doc));
		sb.append(",CODE_BARRE="+CODE_BARRE);
	    sb.append("]");

	    return sb.toString();
    }

    /**
     * Compare keys
     */
    public int compareTo(adressesStruct other) {

		int returnValue = -1;
		
	    return returnValue;
    }


    private int checkNullsAndCompare(Object object1, Object object2) {
        int returnValue = 0;
		if (object1 instanceof Comparable && object2 instanceof Comparable) {
            returnValue = ((Comparable) object1).compareTo(object2);
        } else if (object1 != null && object2 != null) {
            returnValue = compareStrings(object1.toString(), object2.toString());
        } else if (object1 == null && object2 != null) {
            returnValue = 1;
        } else if (object1 != null && object2 == null) {
            returnValue = -1;
        } else {
            returnValue = 0;
        }

        return returnValue;
    }

    private int compareStrings(String string1, String string2) {
        return string1.compareTo(string2);
    }


}

public static class infoAdresseStruct implements routines.system.IPersistableRow<infoAdresseStruct> {
    final static byte[] commonByteArrayLock_LDAP_sgbm_export = new byte[0];
    static byte[] commonByteArray_LDAP_sgbm_export = new byte[0];

	
			    public String CODE_BARRE;

				public String getCODE_BARRE () {
					return this.CODE_BARRE;
				}
				
			    public String NOM;

				public String getNOM () {
					return this.NOM;
				}
				
			    public String PRENOM;

				public String getPRENOM () {
					return this.PRENOM;
				}
				
			    public String GROUPE;

				public String getGROUPE () {
					return this.GROUPE;
				}
				
			    public String CAMPUS;

				public String getCAMPUS () {
					return this.CAMPUS;
				}
				
			    public String LANGUE;

				public String getLANGUE () {
					return this.LANGUE;
				}
				
			    public String STATUT;

				public String getSTATUT () {
					return this.STATUT;
				}
				
			    public java.util.Date DATE_NAISSANCE;

				public java.util.Date getDATE_NAISSANCE () {
					return this.DATE_NAISSANCE;
				}
				
			    public java.util.Date DATE_MODIF;

				public java.util.Date getDATE_MODIF () {
					return this.DATE_MODIF;
				}
				
			    public java.util.Date DATE_EXPIRATION;

				public java.util.Date getDATE_EXPIRATION () {
					return this.DATE_EXPIRATION;
				}
				
			    public java.util.Date DATE_ELIMINATION;

				public java.util.Date getDATE_ELIMINATION () {
					return this.DATE_ELIMINATION;
				}
				
			    public String EPPN;

				public String getEPPN () {
					return this.EPPN;
				}
				



	private String readString(ObjectInputStream dis) throws IOException{
		String strReturn = null;
		int length = 0;
        length = dis.readInt();
		if (length == -1) {
			strReturn = null;
		} else {
			if(length > commonByteArray_LDAP_sgbm_export.length) {
				if(length < 1024 && commonByteArray_LDAP_sgbm_export.length == 0) {
   					commonByteArray_LDAP_sgbm_export = new byte[1024];
				} else {
   					commonByteArray_LDAP_sgbm_export = new byte[2 * length];
   				}
			}
			dis.readFully(commonByteArray_LDAP_sgbm_export, 0, length);
			strReturn = new String(commonByteArray_LDAP_sgbm_export, 0, length, utf8Charset);
		}
		return strReturn;
	}

    private void writeString(String str, ObjectOutputStream dos) throws IOException{
		if(str == null) {
            dos.writeInt(-1);
		} else {
            byte[] byteArray = str.getBytes(utf8Charset);
	    	dos.writeInt(byteArray.length);
			dos.write(byteArray);
    	}
    }

	private java.util.Date readDate(ObjectInputStream dis) throws IOException{
		java.util.Date dateReturn = null;
        int length = 0;
        length = dis.readByte();
		if (length == -1) {
			dateReturn = null;
		} else {
	    	dateReturn = new Date(dis.readLong());
		}
		return dateReturn;
	}

    private void writeDate(java.util.Date date1, ObjectOutputStream dos) throws IOException{
		if(date1 == null) {
            dos.writeByte(-1);
		} else {
			dos.writeByte(0);
	    	dos.writeLong(date1.getTime());
    	}
    }

    public void readData(ObjectInputStream dis) {

		synchronized(commonByteArrayLock_LDAP_sgbm_export) {

        	try {

        		int length = 0;
		
					this.CODE_BARRE = readString(dis);
					
					this.NOM = readString(dis);
					
					this.PRENOM = readString(dis);
					
					this.GROUPE = readString(dis);
					
					this.CAMPUS = readString(dis);
					
					this.LANGUE = readString(dis);
					
					this.STATUT = readString(dis);
					
					this.DATE_NAISSANCE = readDate(dis);
					
					this.DATE_MODIF = readDate(dis);
					
					this.DATE_EXPIRATION = readDate(dis);
					
					this.DATE_ELIMINATION = readDate(dis);
					
					this.EPPN = readString(dis);
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);

		

        }

		

      }


    }

    public void writeData(ObjectOutputStream dos) {
        try {

		
					// String
				
						writeString(this.CODE_BARRE,dos);
					
					// String
				
						writeString(this.NOM,dos);
					
					// String
				
						writeString(this.PRENOM,dos);
					
					// String
				
						writeString(this.GROUPE,dos);
					
					// String
				
						writeString(this.CAMPUS,dos);
					
					// String
				
						writeString(this.LANGUE,dos);
					
					// String
				
						writeString(this.STATUT,dos);
					
					// java.util.Date
				
						writeDate(this.DATE_NAISSANCE,dos);
					
					// java.util.Date
				
						writeDate(this.DATE_MODIF,dos);
					
					// java.util.Date
				
						writeDate(this.DATE_EXPIRATION,dos);
					
					// java.util.Date
				
						writeDate(this.DATE_ELIMINATION,dos);
					
					// String
				
						writeString(this.EPPN,dos);
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);
        }


    }


    public String toString() {

		StringBuilder sb = new StringBuilder();
		sb.append(super.toString());
		sb.append("[");
		sb.append("CODE_BARRE="+CODE_BARRE);
		sb.append(",NOM="+NOM);
		sb.append(",PRENOM="+PRENOM);
		sb.append(",GROUPE="+GROUPE);
		sb.append(",CAMPUS="+CAMPUS);
		sb.append(",LANGUE="+LANGUE);
		sb.append(",STATUT="+STATUT);
		sb.append(",DATE_NAISSANCE="+String.valueOf(DATE_NAISSANCE));
		sb.append(",DATE_MODIF="+String.valueOf(DATE_MODIF));
		sb.append(",DATE_EXPIRATION="+String.valueOf(DATE_EXPIRATION));
		sb.append(",DATE_ELIMINATION="+String.valueOf(DATE_ELIMINATION));
		sb.append(",EPPN="+EPPN);
	    sb.append("]");

	    return sb.toString();
    }

    /**
     * Compare keys
     */
    public int compareTo(infoAdresseStruct other) {

		int returnValue = -1;
		
	    return returnValue;
    }


    private int checkNullsAndCompare(Object object1, Object object2) {
        int returnValue = 0;
		if (object1 instanceof Comparable && object2 instanceof Comparable) {
            returnValue = ((Comparable) object1).compareTo(object2);
        } else if (object1 != null && object2 != null) {
            returnValue = compareStrings(object1.toString(), object2.toString());
        } else if (object1 == null && object2 != null) {
            returnValue = 1;
        } else if (object1 != null && object2 == null) {
            returnValue = -1;
        } else {
            returnValue = 0;
        }

        return returnValue;
    }

    private int compareStrings(String string1, String string2) {
        return string1.compareTo(string2);
    }


}

public static class after_tOracleInput_1Struct implements routines.system.IPersistableRow<after_tOracleInput_1Struct> {
    final static byte[] commonByteArrayLock_LDAP_sgbm_export = new byte[0];
    static byte[] commonByteArray_LDAP_sgbm_export = new byte[0];

	
			    public String CODE_BARRE;

				public String getCODE_BARRE () {
					return this.CODE_BARRE;
				}
				
			    public String NOM;

				public String getNOM () {
					return this.NOM;
				}
				
			    public String PRENOM;

				public String getPRENOM () {
					return this.PRENOM;
				}
				
			    public String GROUPE;

				public String getGROUPE () {
					return this.GROUPE;
				}
				
			    public String CAMPUS;

				public String getCAMPUS () {
					return this.CAMPUS;
				}
				
			    public String LANGUE;

				public String getLANGUE () {
					return this.LANGUE;
				}
				
			    public String STATUT;

				public String getSTATUT () {
					return this.STATUT;
				}
				
			    public java.util.Date DATE_NAISSANCE;

				public java.util.Date getDATE_NAISSANCE () {
					return this.DATE_NAISSANCE;
				}
				
			    public java.util.Date DATE_MODIF;

				public java.util.Date getDATE_MODIF () {
					return this.DATE_MODIF;
				}
				
			    public java.util.Date DATE_EXPIRATION;

				public java.util.Date getDATE_EXPIRATION () {
					return this.DATE_EXPIRATION;
				}
				
			    public java.util.Date DATE_ELIMINATION;

				public java.util.Date getDATE_ELIMINATION () {
					return this.DATE_ELIMINATION;
				}
				
			    public String EPPN;

				public String getEPPN () {
					return this.EPPN;
				}
				



	private String readString(ObjectInputStream dis) throws IOException{
		String strReturn = null;
		int length = 0;
        length = dis.readInt();
		if (length == -1) {
			strReturn = null;
		} else {
			if(length > commonByteArray_LDAP_sgbm_export.length) {
				if(length < 1024 && commonByteArray_LDAP_sgbm_export.length == 0) {
   					commonByteArray_LDAP_sgbm_export = new byte[1024];
				} else {
   					commonByteArray_LDAP_sgbm_export = new byte[2 * length];
   				}
			}
			dis.readFully(commonByteArray_LDAP_sgbm_export, 0, length);
			strReturn = new String(commonByteArray_LDAP_sgbm_export, 0, length, utf8Charset);
		}
		return strReturn;
	}

    private void writeString(String str, ObjectOutputStream dos) throws IOException{
		if(str == null) {
            dos.writeInt(-1);
		} else {
            byte[] byteArray = str.getBytes(utf8Charset);
	    	dos.writeInt(byteArray.length);
			dos.write(byteArray);
    	}
    }

	private java.util.Date readDate(ObjectInputStream dis) throws IOException{
		java.util.Date dateReturn = null;
        int length = 0;
        length = dis.readByte();
		if (length == -1) {
			dateReturn = null;
		} else {
	    	dateReturn = new Date(dis.readLong());
		}
		return dateReturn;
	}

    private void writeDate(java.util.Date date1, ObjectOutputStream dos) throws IOException{
		if(date1 == null) {
            dos.writeByte(-1);
		} else {
			dos.writeByte(0);
	    	dos.writeLong(date1.getTime());
    	}
    }

    public void readData(ObjectInputStream dis) {

		synchronized(commonByteArrayLock_LDAP_sgbm_export) {

        	try {

        		int length = 0;
		
					this.CODE_BARRE = readString(dis);
					
					this.NOM = readString(dis);
					
					this.PRENOM = readString(dis);
					
					this.GROUPE = readString(dis);
					
					this.CAMPUS = readString(dis);
					
					this.LANGUE = readString(dis);
					
					this.STATUT = readString(dis);
					
					this.DATE_NAISSANCE = readDate(dis);
					
					this.DATE_MODIF = readDate(dis);
					
					this.DATE_EXPIRATION = readDate(dis);
					
					this.DATE_ELIMINATION = readDate(dis);
					
					this.EPPN = readString(dis);
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);

		

        }

		

      }


    }

    public void writeData(ObjectOutputStream dos) {
        try {

		
					// String
				
						writeString(this.CODE_BARRE,dos);
					
					// String
				
						writeString(this.NOM,dos);
					
					// String
				
						writeString(this.PRENOM,dos);
					
					// String
				
						writeString(this.GROUPE,dos);
					
					// String
				
						writeString(this.CAMPUS,dos);
					
					// String
				
						writeString(this.LANGUE,dos);
					
					// String
				
						writeString(this.STATUT,dos);
					
					// java.util.Date
				
						writeDate(this.DATE_NAISSANCE,dos);
					
					// java.util.Date
				
						writeDate(this.DATE_MODIF,dos);
					
					// java.util.Date
				
						writeDate(this.DATE_EXPIRATION,dos);
					
					// java.util.Date
				
						writeDate(this.DATE_ELIMINATION,dos);
					
					// String
				
						writeString(this.EPPN,dos);
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);
        }


    }


    public String toString() {

		StringBuilder sb = new StringBuilder();
		sb.append(super.toString());
		sb.append("[");
		sb.append("CODE_BARRE="+CODE_BARRE);
		sb.append(",NOM="+NOM);
		sb.append(",PRENOM="+PRENOM);
		sb.append(",GROUPE="+GROUPE);
		sb.append(",CAMPUS="+CAMPUS);
		sb.append(",LANGUE="+LANGUE);
		sb.append(",STATUT="+STATUT);
		sb.append(",DATE_NAISSANCE="+String.valueOf(DATE_NAISSANCE));
		sb.append(",DATE_MODIF="+String.valueOf(DATE_MODIF));
		sb.append(",DATE_EXPIRATION="+String.valueOf(DATE_EXPIRATION));
		sb.append(",DATE_ELIMINATION="+String.valueOf(DATE_ELIMINATION));
		sb.append(",EPPN="+EPPN);
	    sb.append("]");

	    return sb.toString();
    }

    /**
     * Compare keys
     */
    public int compareTo(after_tOracleInput_1Struct other) {

		int returnValue = -1;
		
	    return returnValue;
    }


    private int checkNullsAndCompare(Object object1, Object object2) {
        int returnValue = 0;
		if (object1 instanceof Comparable && object2 instanceof Comparable) {
            returnValue = ((Comparable) object1).compareTo(object2);
        } else if (object1 != null && object2 != null) {
            returnValue = compareStrings(object1.toString(), object2.toString());
        } else if (object1 == null && object2 != null) {
            returnValue = 1;
        } else if (object1 != null && object2 == null) {
            returnValue = -1;
        } else {
            returnValue = 0;
        }

        return returnValue;
    }

    private int compareStrings(String string1, String string2) {
        return string1.compareTo(string2);
    }


}
public void tOracleInput_1Process(final java.util.Map<String, Object> globalMap) throws TalendException {
	globalMap.put("tOracleInput_1_SUBPROCESS_STATE", 0);

 final boolean execStat = this.execStat;
		String currentVirtualComponent = null;
	
		String iterateId = "";
	
	
	String currentComponent = "";
	java.util.Map<String, Object> resourceMap = new java.util.HashMap<String, Object>();

	try {

			String currentMethodName = new java.lang.Exception().getStackTrace()[0].getMethodName();
			boolean resumeIt = currentMethodName.equals(resumeEntryMethodName);
			if( resumeEntryMethodName == null || resumeIt || globalResumeTicket){//start the resume
				globalResumeTicket = true;


		tOracleInput_2Process(globalMap);

		infoAdresseStruct infoAdresse = new infoAdresseStruct();
adressesStruct adresses = new adressesStruct();
adressStruct adress = new adressStruct();




	
	/**
	 * [tXMLMap_2_TXMLMAP_OUT begin ] start
	 */

	

	
		
		ok_Hash.put("tXMLMap_2_TXMLMAP_OUT", false);
		start_Hash.put("tXMLMap_2_TXMLMAP_OUT", System.currentTimeMillis());
		
	
		currentVirtualComponent = "tXMLMap_2";
	
	currentComponent="tXMLMap_2_TXMLMAP_OUT";

	
			if (execStat) {
				if(resourceMap.get("inIterateVComp") == null){
					
						runStat.updateStatOnConnection("infoAdresse" + iterateId, 0, 0);
					
				}
			} 

		
		int tos_count_tXMLMap_2_TXMLMAP_OUT = 0;
		
    	class BytesLimit65535_tXMLMap_2_TXMLMAP_OUT{
    		public void limitLog4jByte() throws Exception{
    			
    		}
    	}
    	
        new BytesLimit65535_tXMLMap_2_TXMLMAP_OUT().limitLog4jByte();

	org.talend.designer.components.lookup.memory.AdvancedMemoryLookup<adresseStruct> tHash_Lookup_adresse = (org.talend.designer.components.lookup.memory.AdvancedMemoryLookup<adresseStruct>) 
			((org.talend.designer.components.lookup.memory.AdvancedMemoryLookup<adresseStruct>) 
				globalMap.get( "tHash_Lookup_adresse" ))
				;
	
	
	adresseStruct adresseHashKey = new adresseStruct();
	adresseStruct adresseDefault = new adresseStruct();
	adresseStruct adresse = new adresseStruct();
	
	
	
//===============================input xml init part===============================
class XML_API_tXMLMap_2_TXMLMAP_OUT{
	public boolean isDefNull(org.dom4j.Node node) throws javax.xml.transform.TransformerException {
        if (node != null && node instanceof org.dom4j.Element) {
        	org.dom4j.Attribute attri = ((org.dom4j.Element)node).attribute("nil");
        	if(attri != null && ("true").equals(attri.getText())){
            	return true;
            }
        }
        return false;
    }

    public boolean isMissing(org.dom4j.Node node) throws javax.xml.transform.TransformerException {
        return node == null ? true : false;
    }

    public boolean isEmpty(org.dom4j.Node node) throws javax.xml.transform.TransformerException {
        if (node != null) {
            return node.getText().length() == 0;
        }
        return false;
    }
}
	class Var__tXMLMap_2_TXMLMAP_OUT__Struct {
	}
	Var__tXMLMap_2_TXMLMAP_OUT__Struct Var__tXMLMap_2_TXMLMAP_OUT = new Var__tXMLMap_2_TXMLMAP_OUT__Struct();
// ###############################
// # Outputs initialization
adressesStruct adresses_tmp = new adressesStruct();
adressesStruct adresses_save = null;
//the aggregate variable
adressesStruct adresses_aggregate = null;
//init the resultset for aggregate
java.util.List<Object> allOutsForAggregate_tXMLMap_2 = new java.util.ArrayList<Object>();
globalMap.put("allOutsForAggregate_tXMLMap_2",allOutsForAggregate_tXMLMap_2);
// ###############################
		int nb_line_tXMLMap_2_TXMLMAP_OUT = 0; 
	
    XML_API_tXMLMap_2_TXMLMAP_OUT xml_api_tXMLMap_2_TXMLMAP_OUT = new XML_API_tXMLMap_2_TXMLMAP_OUT();

	//the map store the previous value of aggregate columns
	java.util.Map<String,Object> aggregateCacheMap_tXMLMap_2_TXMLMAP_OUT = new java.util.HashMap<String,Object>();
					//init the map,the keys is aggregate columns xpath,the values is all null.
					aggregateCacheMap_tXMLMap_2_TXMLMAP_OUT.put("adresses.doc:/root/@test",null);

class GenerateDocument_adresses {

	java.util.Map<String,Object> valueMap = null;
	
	routines.system.DocumentGenerateOrderHelper orderHelper = new routines.system.DocumentGenerateOrderHelper(1);
	
	org.dom4j.Document doc = null;
	
	org.dom4j.Element root4Group = null;
	
	org.dom4j.io.OutputFormat format = null;
	
	java.util.List<java.util.List<String>> groupbyList = null;
	java.util.List<org.dom4j.Element> groupElementList = null;
	int order = 0;
	
	boolean isFirst = true;
	
	boolean	needRoot = true;
	
	String currentValue = null;

		org.dom4j.Element subTreeLoopParent0 = null;
		public boolean  subTreeLoop0 = false;
	
    public GenerateDocument_adresses() {
//    	this.treeNodeAPI = treeNodeAPI;
    	
    	valueMap = new java.util.HashMap<String,Object>();
    	
    	groupbyList =  new java.util.ArrayList<java.util.List<String>>();
		groupElementList = new java.util.ArrayList<org.dom4j.Element>();
    	
    	doc = org.dom4j.DocumentHelper.createDocument();
    	format = org.dom4j.io.OutputFormat.createPrettyPrint();
    	format.setTrimText(false);
    }
    
    public org.dom4j.Document getDocument(){
    	return this.doc;
    }
    
	//We generate the TreeNode_API object only if there is a document in the main input table.
    void generateElements(boolean isInnerJoin, infoAdresseStruct infoAdresse, adresseStruct adresse, Var__tXMLMap_2_TXMLMAP_OUT__Struct Var
	) {
	
	
	/*if(this.treeNodeAPI==null) {
		this.treeNodeAPI = treeNodeAPI;
	}*/
	
	org.dom4j.Element subTreeRootParent = null;
// build root xml tree 
if (needRoot) {
	needRoot=false;
		org.dom4j.Element root = null;
				root = doc.addElement("root");
		subTreeRootParent = root;
				currentValue = null;
    			valueMap.put("root",infoAdresse.CODE_BARRE );
    			if(valueMap.get("root")!=null) {
    				currentValue = FormatterUtils.format(infoAdresse.CODE_BARRE ,null);
    			} else {
    				currentValue = "";
    			}
				
    			routines.system.DocumentHelper.applyNamespace2Attribute(root,  null , "test", currentValue);
		org.dom4j.Element root_1 = null;
				root_1 = root.addElement("addresses");
		subTreeRootParent = root_1;
					subTreeLoopParent0 = root_1;
		root4Group = subTreeRootParent;
	}else{
		subTreeRootParent=root4Group;
	}
	/* build group xml tree */
	boolean isNewElement = false;
		isNewElement = false;
		org.dom4j.Element loop = null;
				loop = org.dom4j.DocumentHelper.createElement("address");
				subTreeRootParent.elements().add(orderHelper.getInsertLocation(0,0),loop);
		subTreeRootParent = loop;
				currentValue = null;
    			valueMap.put("loop",(adresse.TYPE.equals("work"))?"true":"false");
    			if(valueMap.get("loop")!=null) {
    				currentValue = FormatterUtils.format((adresse.TYPE.equals("work"))?"true":"false",null);
    			} else {
    				currentValue = "";
    			}
				
    			routines.system.DocumentHelper.applyNamespace2Attribute(loop,  null , "preferred", currentValue);
				currentValue = null;
    			valueMap.put("loop",context.sigb_external_desc);
    			if(valueMap.get("loop")!=null) {
    				currentValue = FormatterUtils.format(context.sigb_external_desc,null);
    			} else {
    				currentValue = "";
    			}
				
    			routines.system.DocumentHelper.applyNamespace2Attribute(loop,  null , "segment_type", currentValue);
		org.dom4j.Element loop_4 = null;
				loop_4 = loop.addElement("line1");
		valueMap.put("loop_4",adresse.ADR1);
		if(valueMap.get("loop_4")!=null) {
			routines.system.NestXMLTool.setText(loop_4, FormatterUtils.format(adresse.ADR1,null));
		}
		org.dom4j.Element loop_5 = null;
				loop_5 = loop.addElement("line2");
		valueMap.put("loop_5",adresse.ADR2);
		if(valueMap.get("loop_5")!=null) {
			routines.system.NestXMLTool.setText(loop_5, FormatterUtils.format(adresse.ADR2,null));
		}
		org.dom4j.Element loop_6 = null;
				loop_6 = loop.addElement("line3");
		valueMap.put("loop_6",adresse.ADR3);
		if(valueMap.get("loop_6")!=null) {
			routines.system.NestXMLTool.setText(loop_6, FormatterUtils.format(adresse.ADR3,null));
		}
		org.dom4j.Element loop_7 = null;
				loop_7 = loop.addElement("line4");
		valueMap.put("loop_7",adresse.ADR4);
		if(valueMap.get("loop_7")!=null) {
			routines.system.NestXMLTool.setText(loop_7, FormatterUtils.format(adresse.ADR4,null));
		}
		org.dom4j.Element loop_8 = null;
				loop_8 = loop.addElement("line5");
		valueMap.put("loop_8",adresse.ADR5);
		if(valueMap.get("loop_8")!=null) {
			routines.system.NestXMLTool.setText(loop_8, FormatterUtils.format(adresse.ADR5,null));
		}
		org.dom4j.Element loop_9 = null;
				loop_9 = loop.addElement("city");
		valueMap.put("loop_9",adresse.VILLE);
		if(valueMap.get("loop_9")!=null) {
			routines.system.NestXMLTool.setText(loop_9, FormatterUtils.format(adresse.VILLE,null));
		}
		org.dom4j.Element loop_10 = null;
				loop_10 = loop.addElement("postal_code");
		valueMap.put("loop_10",adresse.CP);
		if(valueMap.get("loop_10")!=null) {
			routines.system.NestXMLTool.setText(loop_10, FormatterUtils.format(adresse.CP,null));
		}
		org.dom4j.Element loop_11 = null;
				loop_11 = loop.addElement("country");
		valueMap.put("loop_11",adresse.PAYS);
		if(valueMap.get("loop_11")!=null) {
			routines.system.NestXMLTool.setText(loop_11, FormatterUtils.format(adresse.PAYS,null));
		}
		org.dom4j.Element loop_12 = null;
				loop_12 = loop.addElement("start_date");
		valueMap.put("loop_12",adresse.DEBUT);
		if(valueMap.get("loop_12")!=null) {
			routines.system.NestXMLTool.setText(loop_12, FormatterUtils.format(adresse.DEBUT,null));
		}
		org.dom4j.Element loop_13 = null;
				loop_13 = loop.addElement("address_types");
		org.dom4j.Element loop_13_14 = null;
				loop_13_14 = loop_13.addElement("address_type");
		valueMap.put("loop_13_14",adresse.TYPE);
		if(valueMap.get("loop_13_14")!=null) {
			routines.system.NestXMLTool.setText(loop_13_14, FormatterUtils.format(adresse.TYPE,null));
		}
		}
    }

	GenerateDocument_adresses gen_Doc_adresses_tXMLMap_2_TXMLMAP_OUT = new GenerateDocument_adresses();
	boolean docAlreadyInstanciate_adresses = false;

	            
 



/**
 * [tXMLMap_2_TXMLMAP_OUT begin ] stop
 */



	
	/**
	 * [tOracleInput_1 begin ] start
	 */

	

	
		
		ok_Hash.put("tOracleInput_1", false);
		start_Hash.put("tOracleInput_1", System.currentTimeMillis());
		
	
	currentComponent="tOracleInput_1";

	
		int tos_count_tOracleInput_1 = 0;
		
    	class BytesLimit65535_tOracleInput_1{
    		public void limitLog4jByte() throws Exception{
    			
    		}
    	}
    	
        new BytesLimit65535_tOracleInput_1().limitLog4jByte();
	


	
		    int nb_line_tOracleInput_1 = 0;
		    java.sql.Connection conn_tOracleInput_1 = null;
		        conn_tOracleInput_1 = (java.sql.Connection)globalMap.get("conn_tOracleConnection_1");
				
				if(((oracle.jdbc.OracleConnection)conn_tOracleInput_1).getSessionTimeZone() == null){
					java.sql.Statement stmtGetTZ_tOracleInput_1 = conn_tOracleInput_1.createStatement();
					java.sql.ResultSet rsGetTZ_tOracleInput_1 = stmtGetTZ_tOracleInput_1.executeQuery("select sessiontimezone from dual");
					String sessionTimezone_tOracleInput_1 = java.util.TimeZone.getDefault().getID();
					while (rsGetTZ_tOracleInput_1.next()) {
						sessionTimezone_tOracleInput_1 = rsGetTZ_tOracleInput_1.getString(1);
					}
					((oracle.jdbc.OracleConnection)conn_tOracleInput_1).setSessionTimeZone(sessionTimezone_tOracleInput_1);
				}
			
		    
			java.sql.Statement stmt_tOracleInput_1 = conn_tOracleInput_1.createStatement();

		    String dbquery_tOracleInput_1 = "SELECT \n  "+context.oracle_schema+".V_SGBMP_INFOGENE.* \nFROM "+context.oracle_schema+".V_SGBMP_INFOGENE "

;
			

            	globalMap.put("tOracleInput_1_QUERY",dbquery_tOracleInput_1);
		    java.sql.ResultSet rs_tOracleInput_1 = null;

		    try {
		    	rs_tOracleInput_1 = stmt_tOracleInput_1.executeQuery(dbquery_tOracleInput_1);
		    	java.sql.ResultSetMetaData rsmd_tOracleInput_1 = rs_tOracleInput_1.getMetaData();
		    	int colQtyInRs_tOracleInput_1 = rsmd_tOracleInput_1.getColumnCount();

		    String tmpContent_tOracleInput_1 = null;
		    
		    
		    while (rs_tOracleInput_1.next()) {
		        nb_line_tOracleInput_1++;
		        
							if(colQtyInRs_tOracleInput_1 < 1) {
								infoAdresse.CODE_BARRE = null;
							} else {
	                         		
        	infoAdresse.CODE_BARRE = routines.system.JDBCUtil.getString(rs_tOracleInput_1, 1, false);
		                    }
							if(colQtyInRs_tOracleInput_1 < 2) {
								infoAdresse.NOM = null;
							} else {
	                         		
        	infoAdresse.NOM = routines.system.JDBCUtil.getString(rs_tOracleInput_1, 2, false);
		                    }
							if(colQtyInRs_tOracleInput_1 < 3) {
								infoAdresse.PRENOM = null;
							} else {
	                         		
        	infoAdresse.PRENOM = routines.system.JDBCUtil.getString(rs_tOracleInput_1, 3, false);
		                    }
							if(colQtyInRs_tOracleInput_1 < 4) {
								infoAdresse.GROUPE = null;
							} else {
	                         		
        	infoAdresse.GROUPE = routines.system.JDBCUtil.getString(rs_tOracleInput_1, 4, false);
		                    }
							if(colQtyInRs_tOracleInput_1 < 5) {
								infoAdresse.CAMPUS = null;
							} else {
	                         		
        	infoAdresse.CAMPUS = routines.system.JDBCUtil.getString(rs_tOracleInput_1, 5, false);
		                    }
							if(colQtyInRs_tOracleInput_1 < 6) {
								infoAdresse.LANGUE = null;
							} else {
	                         		
        	infoAdresse.LANGUE = routines.system.JDBCUtil.getString(rs_tOracleInput_1, 6, false);
		                    }
							if(colQtyInRs_tOracleInput_1 < 7) {
								infoAdresse.STATUT = null;
							} else {
	                         		
        	infoAdresse.STATUT = routines.system.JDBCUtil.getString(rs_tOracleInput_1, 7, false);
		                    }
							if(colQtyInRs_tOracleInput_1 < 8) {
								infoAdresse.DATE_NAISSANCE = null;
							} else {
										
			infoAdresse.DATE_NAISSANCE = routines.system.JDBCUtil.getDate(rs_tOracleInput_1, 8);
		                    }
							if(colQtyInRs_tOracleInput_1 < 9) {
								infoAdresse.DATE_MODIF = null;
							} else {
										
			infoAdresse.DATE_MODIF = routines.system.JDBCUtil.getDate(rs_tOracleInput_1, 9);
		                    }
							if(colQtyInRs_tOracleInput_1 < 10) {
								infoAdresse.DATE_EXPIRATION = null;
							} else {
										
			infoAdresse.DATE_EXPIRATION = routines.system.JDBCUtil.getDate(rs_tOracleInput_1, 10);
		                    }
							if(colQtyInRs_tOracleInput_1 < 11) {
								infoAdresse.DATE_ELIMINATION = null;
							} else {
										
			infoAdresse.DATE_ELIMINATION = routines.system.JDBCUtil.getDate(rs_tOracleInput_1, 11);
		                    }
							if(colQtyInRs_tOracleInput_1 < 12) {
								infoAdresse.EPPN = null;
							} else {
	                         		
        	infoAdresse.EPPN = routines.system.JDBCUtil.getString(rs_tOracleInput_1, 12, false);
		                    }
					




 



/**
 * [tOracleInput_1 begin ] stop
 */
	
	/**
	 * [tOracleInput_1 main ] start
	 */

	

	
	
	currentComponent="tOracleInput_1";

	

 


	tos_count_tOracleInput_1++;

/**
 * [tOracleInput_1 main ] stop
 */

	
	/**
	 * [tXMLMap_2_TXMLMAP_OUT main ] start
	 */

	

	
	
		currentVirtualComponent = "tXMLMap_2";
	
	currentComponent="tXMLMap_2_TXMLMAP_OUT";

	

			//infoAdresse
			//infoAdresse


			
				if(execStat){
					runStat.updateStatOnConnection("infoAdresse"+iterateId,1, 1);
				} 
			

		

	boolean rejectedInnerJoin_tXMLMap_2_TXMLMAP_OUT = false;
	boolean rejectedDocInnerJoin_tXMLMap_2_TXMLMAP_OUT = false;
	boolean mainRowRejected_tXMLMap_2_TXMLMAP_OUT = false;
	boolean isMatchDocRowtXMLMap_2_TXMLMAP_OUT = false;
	  
	
			
   
					adresses_tmp.doc = null;
					
		
		


			

			
				///////////////////////////////////////////////
				//Starting Lookup Table "org.talend.designer.xmlmap.model.emf.xmlmap.impl.InputXmlTreeImpl@4e526ef0 (expressionFilter: null, activateExpressionFilter: false, activateCondensedTool: true, minimized: false, name: adresse, multiLoops: false) (lookup: true, matchingMode: ALL_MATCHES, lookupMode: LOAD_ONCE, innerJoin: false, persistent: false, activateGlobalMap: false)" 
				///////////////////////////////////////////////
				//tHash_Lookup_adresse.initGet();
				
				
				
					boolean forceLoopadresse = false;
					adresseStruct adresseObjectFromLookup = null;
					boolean hasResultFromLookupCacheadresse = false;
					java.util.Map<String,Object> cacheResultadresse = new java.util.HashMap<String,Object>();
				
				
				
					   	adresseHashKey.CODE_BARRE = infoAdresse.CODE_BARRE ;
						adresseHashKey.hashCodeDirty = true;
						
					
					
						if(!rejectedInnerJoin_tXMLMap_2_TXMLMAP_OUT){//TD120
							
					
							
								
									tHash_Lookup_adresse.lookup( adresseHashKey );
								
							
							if(hasResultFromLookupCacheadresse  || tHash_Lookup_adresse.hasNext()){
							
							} else {
								
									adresse = adresseDefault;
								
								
								
								forceLoopadresse = true;
								
							}
						}//TD120
				   
				   		
				   			if(rejectedInnerJoin_tXMLMap_2_TXMLMAP_OUT) {
				   				forceLoopadresse = true;
				   			}
				   		
				   
				   		adresseStruct fromLookup_adresse = null;
						adresse = adresseDefault;
				   
				   		
				  		
				  		//////////////////////////////////////////////////////////////////////////////////////////////
				  		
				  		boolean fromCacheadresse = hasResultFromLookupCacheadresse;
				  		List<java.util.Map<String,Object>> multipleResultSetadresse = new java.util.ArrayList<java.util.Map<String,Object>>();
				  		//the var for cache the adresseStruct
				  		java.util.Map<String,Object> oneRow_adresse = null;
						if(hasResultFromLookupCacheadresse) {
					    	
					    } else if(!rejectedInnerJoin_tXMLMap_2_TXMLMAP_OUT) {
					    	
					    	while (tHash_Lookup_adresse.hasNext()) {
					    		fromLookup_adresse = null;
								adresse = adresseDefault;
								fromLookup_adresse = tHash_Lookup_adresse.next();
								if(fromLookup_adresse != null) {
								
										
									adresse = fromLookup_adresse;
									//construct the resultset for mutiple lookup when no document lookup.
									oneRow_adresse = new java.util.HashMap<String, Object>();
									oneRow_adresse.put("adresse",adresse);
									multipleResultSetadresse.add(oneRow_adresse);
									
								}
					    	}//end while
					    	
					    }//end else if
					    //now not support cache all_matches lookup
					    
					    
					    
					    
					    java.util.Iterator<java.util.Map<String,Object>> iteradresse = multipleResultSetadresse.iterator();
					    while(iteradresse.hasNext() || forceLoopadresse) { // G_TM_M_002
					    	adresse = adresseDefault;
					    	adresseStruct tempLookupadresse = null; 
					    	if(!forceLoopadresse) {
						    	java.util.Map<String,Object> oneRowadresse = iteradresse.next();
						   		
					    		tempLookupadresse = (adresseStruct)oneRowadresse.get("adresse");
					    		if(tempLookupadresse!=null) {
					    			adresse = tempLookupadresse;
					    		}
					    		
					    		
				    		}
				    		forceLoopadresse = false;
				  		
				  		/////////////////////////////////////////////////////////////////////////////////////////////////
				  		
					
				
{ // start of Var scope

	// ###############################
	// # Vars tables

Var__tXMLMap_2_TXMLMAP_OUT__Struct Var = Var__tXMLMap_2_TXMLMAP_OUT;
		// ###############################
		// # Output tables

adresses = null;


// # Output table : 'adresses'

if((infoAdresse.CODE_BARRE )==null ||!infoAdresse.CODE_BARRE .equals(aggregateCacheMap_tXMLMap_2_TXMLMAP_OUT.get("adresses.doc:/root/@test"))) {
gen_Doc_adresses_tXMLMap_2_TXMLMAP_OUT = new GenerateDocument_adresses();
//init one new out struct for cache the result.
adresses_aggregate = new adressesStruct();
adresses_aggregate.doc = new routines.system.Document();
adresses_aggregate.doc.setDocument(gen_Doc_adresses_tXMLMap_2_TXMLMAP_OUT.getDocument());

//construct the resultset
allOutsForAggregate_tXMLMap_2.add(adresses_aggregate);
//store the previous value
aggregateCacheMap_tXMLMap_2_TXMLMAP_OUT.put("adresses.doc:/root/@test", infoAdresse.CODE_BARRE );
}


gen_Doc_adresses_tXMLMap_2_TXMLMAP_OUT.generateElements(rejectedDocInnerJoin_tXMLMap_2_TXMLMAP_OUT,infoAdresse,adresse,Var);


adresses_tmp.CODE_BARRE = adresse.CODE_BARRE;//set the flat column for aggregate
adresses_aggregate.CODE_BARRE = adresse.CODE_BARRE;


if(adresses_aggregate!=null){

adresses_aggregate.CODE_BARRE = adresses_tmp.CODE_BARRE;
}
// ###############################

} // end of Var scope

rejectedInnerJoin_tXMLMap_2_TXMLMAP_OUT = false;


		}// G_TM_M_002

 


	tos_count_tXMLMap_2_TXMLMAP_OUT++;

/**
 * [tXMLMap_2_TXMLMAP_OUT main ] stop
 */



	
	/**
	 * [tOracleInput_1 end ] start
	 */

	

	
	
	currentComponent="tOracleInput_1";

	

}
}finally{
stmt_tOracleInput_1.close();

}

globalMap.put("tOracleInput_1_NB_LINE",nb_line_tOracleInput_1);
 

ok_Hash.put("tOracleInput_1", true);
end_Hash.put("tOracleInput_1", System.currentTimeMillis());




/**
 * [tOracleInput_1 end ] stop
 */

	
	/**
	 * [tXMLMap_2_TXMLMAP_OUT end ] start
	 */

	

	
	
		currentVirtualComponent = "tXMLMap_2";
	
	currentComponent="tXMLMap_2_TXMLMAP_OUT";

	




			if(execStat){
				if(resourceMap.get("inIterateVComp") == null || !((Boolean)resourceMap.get("inIterateVComp"))){
			 		runStat.updateStatOnConnection("infoAdresse"+iterateId,2, 0); 
			 	}
			}
		
 

ok_Hash.put("tXMLMap_2_TXMLMAP_OUT", true);
end_Hash.put("tXMLMap_2_TXMLMAP_OUT", System.currentTimeMillis());




/**
 * [tXMLMap_2_TXMLMAP_OUT end ] stop
 */



	
	/**
	 * [tAdvancedHash_adress begin ] start
	 */

	

	
		
		ok_Hash.put("tAdvancedHash_adress", false);
		start_Hash.put("tAdvancedHash_adress", System.currentTimeMillis());
		
	
	currentComponent="tAdvancedHash_adress";

	
			if (execStat) {
				if(resourceMap.get("inIterateVComp") == null){
					
						runStat.updateStatOnConnection("adress" + iterateId, 0, 0);
					
				}
			} 

		
		int tos_count_tAdvancedHash_adress = 0;
		
    	class BytesLimit65535_tAdvancedHash_adress{
    		public void limitLog4jByte() throws Exception{
    			
    		}
    	}
    	
        new BytesLimit65535_tAdvancedHash_adress().limitLog4jByte();

			   		// connection name:adress
			   		// source node:tExtractXMLField_2 - inputs:(adresses) outputs:(adress,adress) | target node:tAdvancedHash_adress - inputs:(adress) outputs:()
			   		// linked node: tMap_1 - inputs:(infos,adress,email,phone,statistique) outputs:(out1)
			   
			   		org.talend.designer.components.lookup.common.ICommonLookup.MATCHING_MODE matchingModeEnum_adress = 
			   			org.talend.designer.components.lookup.common.ICommonLookup.MATCHING_MODE.UNIQUE_MATCH;
			   			
			   
	   			org.talend.designer.components.lookup.memory.AdvancedMemoryLookup<adressStruct> tHash_Lookup_adress =org.talend.designer.components.lookup.memory.AdvancedMemoryLookup.
	   						<adressStruct>getLookup(matchingModeEnum_adress);
	   						   
		   	   	   globalMap.put("tHash_Lookup_adress", tHash_Lookup_adress);
		   	   	   
				
           

 



/**
 * [tAdvancedHash_adress begin ] stop
 */



	
	/**
	 * [tExtractXMLField_2 begin ] start
	 */

	

	
		
		ok_Hash.put("tExtractXMLField_2", false);
		start_Hash.put("tExtractXMLField_2", System.currentTimeMillis());
		
	
	currentComponent="tExtractXMLField_2";

	
			if (execStat) {
				if(resourceMap.get("inIterateVComp") == null){
					
						runStat.updateStatOnConnection("adresses" + iterateId, 0, 0);
					
				}
			} 

		
		int tos_count_tExtractXMLField_2 = 0;
		
    	class BytesLimit65535_tExtractXMLField_2{
    		public void limitLog4jByte() throws Exception{
    			
    		}
    	}
    	
        new BytesLimit65535_tExtractXMLField_2().limitLog4jByte();

int nb_line_tExtractXMLField_2 = 0;

class NameSpaceTool_tExtractXMLField_2 {

    public java.util.HashMap<String, String> xmlNameSpaceMap = new java.util.HashMap<String, String>();
    
	private java.util.List<String> defualtNSPath = new java.util.ArrayList<String>();

    public void countNSMap(org.dom4j.Element el) {
        for (org.dom4j.Namespace ns : (java.util.List<org.dom4j.Namespace>) el.declaredNamespaces()) {
            if (ns.getPrefix().trim().length() == 0) {
                xmlNameSpaceMap.put("pre"+defualtNSPath.size(), ns.getURI());
                String path = "";
                org.dom4j.Element elTmp = el;
                while (elTmp != null) {
                   	if (elTmp.getNamespacePrefix() != null && elTmp.getNamespacePrefix().length() > 0) {
                        path = "/" + elTmp.getNamespacePrefix() + ":" + elTmp.getName() + path;
                    } else {
                        path = "/" + elTmp.getName() + path;
                    }
                    elTmp = elTmp.getParent();
                }
                defualtNSPath.add(path);
            } else {
                xmlNameSpaceMap.put(ns.getPrefix(), ns.getURI());
            }

        }
        for (org.dom4j.Element e : (java.util.List<org.dom4j.Element>) el.elements()) {
            countNSMap(e);
        }
    }
    
    /**
	 *	the regex for the xpath like that : 
	 *	case 1 : functionA(locationXPathExpression) 
	 *	case 2 : fn:functionA(locationXPathExpression) 
	 *	case 3 : functionA(functionB(locationXPathExpression))
	 *	case 4 : fn:functionA(fn:functionB(locationXPathExpression))
	 *	and like that.
	*/
	private java.util.regex.Pattern simpleFunctionPattern;
	private StringBuffer stringBuffer;
	private java.util.Map<String,String> resultCache;
	
	public String addDefaultNSPrefix(final String xpathExpression, String loopPath) {
	    if (defualtNSPath.size() < 1) {
        	return xpathExpression;
    	}
    	
    	if(resultCache == null) {
    		resultCache = new java.util.HashMap<String,String>();
    	}
    	
    	String resultXpathExpression = resultCache.get(xpathExpression);
		if(resultXpathExpression!=null) {
    		return resultXpathExpression;
    	}
    	
    	String locationPathExpression = xpathExpression;
    	
    	if(simpleFunctionPattern == null) {
    		simpleFunctionPattern = java.util.regex.Pattern.compile("([a-zA-z0-9]+:)?[a-zA-Z]+-?[A-Za-z]+\\(.*\\)");
    	}
    	
    	boolean isSimpleFunctionXPath = simpleFunctionPattern.matcher(xpathExpression).matches();
    	String tail = null;
    	if(isSimpleFunctionXPath) {
			int start = xpathExpression.lastIndexOf('(');
			int end = xpathExpression.indexOf(')');
			if(start < end) {
			    if(stringBuffer == null) {
    				stringBuffer = new StringBuffer();
    			}
				locationPathExpression = xpathExpression.substring(start+1,end);
				stringBuffer.append(xpathExpression.substring(0,start+1));
				tail = xpathExpression.substring(end);
			} else {
				isSimpleFunctionXPath = false;
			}
    	}
    	
    	locationPathExpression = addDefaultNSPrefixForLocationXPathExpression(locationPathExpression,loopPath);
    	
    	resultXpathExpression = locationPathExpression;
    	
    	if(isSimpleFunctionXPath) {
        	stringBuffer.append(locationPathExpression);
    		stringBuffer.append(tail);
    		resultXpathExpression = stringBuffer.toString();
    		stringBuffer.setLength(0);
        }
    	
    	resultCache.put(xpathExpression,resultXpathExpression);
    	return resultXpathExpression;
	}
	
    private String addDefaultNSPrefixForLocationXPathExpression(String path, String loopPath) {
    	String fullPath = loopPath;
    	if(!path.equals(fullPath)){
        	for (String tmp : path.split("/")) {
        		if (("..").equals(tmp)) {
                    fullPath = fullPath.substring(0, fullPath.lastIndexOf("/"));
                } else {
                    fullPath += "/" + tmp;
                }
        	}
        }
    	int[] indexs = new int[fullPath.split("/").length - 1];
        java.util.Arrays.fill(indexs, -1);
        int length = 0;
        for (int i = 0; i < defualtNSPath.size(); i++) {
            if (defualtNSPath.get(i).length() > length && fullPath.startsWith(defualtNSPath.get(i))) {
                java.util.Arrays.fill(indexs, defualtNSPath.get(i).split("/").length - 2, indexs.length, i);
                length = defualtNSPath.get(i).length();
            }
        }
    
        StringBuilder newPath = new StringBuilder();
        String[] pathStrs = path.split("/");
        for (int i = 0; i < pathStrs.length; i++) {
            String tmp = pathStrs[i];
            if (newPath.length() > 0) {
                newPath.append("/");
            }
            if (tmp.length() > 0 && tmp.indexOf(":") == -1 && tmp.indexOf(".") == -1 /*&& tmp.indexOf("@") == -1*/) {
                int index = indexs[i + indexs.length - pathStrs.length];
                if (index >= 0) {
                	//==== add by wliu to support both filter and functions==
    				if(tmp.indexOf("[")>0 && tmp.indexOf("]")>tmp.indexOf("[")){//include filter
    					String tmpStr=replaceElementWithNS(tmp,"pre"+index+":");
    					newPath.append(tmpStr);
    				}else{
    					if(tmp.indexOf("@") != -1 || tmp.indexOf("(")<tmp.indexOf(")")){  // include attribute
    						newPath.append(tmp);
    					}else{
    				//==add end=======	
                    		newPath.append("pre").append(index).append(":").append(tmp);
                    	}
                    }                    
                } else {
                    newPath.append(tmp);
                }
            } else {
                newPath.append(tmp);
            }
        }
        return newPath.toString();
    }
    
	private String matches = "@*\\b[a-z|A-Z|_]+[[-]*\\w]*\\b[^'|^\\(]";
    private java.util.regex.Pattern pattern = java.util.regex.Pattern.compile(matches);
    
	private String replaceElementWithNS(String global, String pre){

        java.util.regex.Matcher match = pattern.matcher(global);
        StringBuffer sb = new StringBuffer();
        match.reset();
        while (match.find()) {
            String group = match.group();
            String tmp = "";
            if (group.toLowerCase().matches("\\b(div|mod|and|or)\\b.*") || group.matches("@.*")) {
                tmp = group;
            } else {
                tmp = tmp + pre + group;
            }
            match.appendReplacement(sb, tmp);
        }
        match.appendTail(sb);
        
        return sb.toString();
	}
	
}

class XML_API_tExtractXMLField_2{
	public boolean isDefNull(org.dom4j.Node node) throws javax.xml.transform.TransformerException {
        if (node != null && node instanceof org.dom4j.Element) {
        	org.dom4j.Attribute attri = ((org.dom4j.Element)node).attribute("nil");
        	if(attri != null && ("true").equals(attri.getText())){
            	return true;
            }
        }
        return false;
    }

    public boolean isMissing(org.dom4j.Node node) throws javax.xml.transform.TransformerException {
        return node == null ? true : false;
    }

    public boolean isEmpty(org.dom4j.Node node) throws javax.xml.transform.TransformerException {
        if (node != null) {
            return node.getText().length() == 0;
        }
        return false;
    }
}

XML_API_tExtractXMLField_2 xml_api_tExtractXMLField_2 = new XML_API_tExtractXMLField_2();
 



/**
 * [tExtractXMLField_2 begin ] stop
 */



	
	/**
	 * [tXMLMap_2_TXMLMAP_IN begin ] start
	 */

	

	
		
		ok_Hash.put("tXMLMap_2_TXMLMAP_IN", false);
		start_Hash.put("tXMLMap_2_TXMLMAP_IN", System.currentTimeMillis());
		
	
		currentVirtualComponent = "tXMLMap_2";
	
	currentComponent="tXMLMap_2_TXMLMAP_IN";

	
		int tos_count_tXMLMap_2_TXMLMAP_IN = 0;
		
    	class BytesLimit65535_tXMLMap_2_TXMLMAP_IN{
    		public void limitLog4jByte() throws Exception{
    			
    		}
    	}
    	
        new BytesLimit65535_tXMLMap_2_TXMLMAP_IN().limitLog4jByte();
java.util.List<Object> outs_tXMLMap_2 = (java.util.List<Object>)globalMap.get("allOutsForAggregate_tXMLMap_2");
for(Object  row_out_tXMLMap_2_TXMLMAP_IN : outs_tXMLMap_2) {//TD512
 



/**
 * [tXMLMap_2_TXMLMAP_IN begin ] stop
 */
	
	/**
	 * [tXMLMap_2_TXMLMAP_IN main ] start
	 */

	

	
	
		currentVirtualComponent = "tXMLMap_2";
	
	currentComponent="tXMLMap_2_TXMLMAP_IN";

	

	adresses = null;
	if(row_out_tXMLMap_2_TXMLMAP_IN!=null && row_out_tXMLMap_2_TXMLMAP_IN instanceof adressesStruct) {
		adresses = (adressesStruct)row_out_tXMLMap_2_TXMLMAP_IN;
			routines.system.NestXMLTool.generateOk(adresses.doc, false);		
	}
 


	tos_count_tXMLMap_2_TXMLMAP_IN++;

/**
 * [tXMLMap_2_TXMLMAP_IN main ] stop
 */
// Start of branch "adresses"
if(adresses != null) { 



	
	/**
	 * [tExtractXMLField_2 main ] start
	 */

	

	
	
	currentComponent="tExtractXMLField_2";

	

			//adresses
			//adresses


			
				if(execStat){
					runStat.updateStatOnConnection("adresses"+iterateId,1, 1);
				} 
			

		

	String xmlStr_tExtractXMLField_2 = null;
	routines.system.Document xmlDocument_tExtractXMLField_2 = null;
	if(adresses.doc!=null){
				xmlDocument_tExtractXMLField_2 = adresses.doc;
	}
			if(xmlDocument_tExtractXMLField_2!=null && xmlDocument_tExtractXMLField_2.getDocument()!=null){// C_01
adress = null;
adress = null;
	NameSpaceTool_tExtractXMLField_2 nsTool_tExtractXMLField_2 = new NameSpaceTool_tExtractXMLField_2();
    org.dom4j.io.SAXReader reader_tExtractXMLField_2 = new org.dom4j.io.SAXReader();
	
    org.dom4j.Document doc_tExtractXMLField_2 = null;
    java.util.HashMap xmlNameSpaceMap_tExtractXMLField_2 = null;
    org.dom4j.XPath x_tExtractXMLField_2 = null;
    java.util.List<org.dom4j.tree.AbstractNode> nodeList_tExtractXMLField_2 = null;
		String loopQuery_tExtractXMLField_2 = "/root"; 
	
    boolean isStructError_tExtractXMLField_2= true;
        
    try{
		
	    	doc_tExtractXMLField_2= xmlDocument_tExtractXMLField_2.getDocument();
	    
	    nsTool_tExtractXMLField_2.countNSMap(doc_tExtractXMLField_2.getRootElement());
	    xmlNameSpaceMap_tExtractXMLField_2 = nsTool_tExtractXMLField_2.xmlNameSpaceMap;

    	x_tExtractXMLField_2 = doc_tExtractXMLField_2.createXPath(nsTool_tExtractXMLField_2.addDefaultNSPrefix(loopQuery_tExtractXMLField_2,loopQuery_tExtractXMLField_2));
      
    	x_tExtractXMLField_2.setNamespaceURIs(xmlNameSpaceMap_tExtractXMLField_2); 
    
		 
    	nodeList_tExtractXMLField_2 = (java.util.List<org.dom4j.tree.AbstractNode>)x_tExtractXMLField_2.selectNodes(doc_tExtractXMLField_2);
    	
    	isStructError_tExtractXMLField_2 = false;
    	
    }catch(java.lang.Exception ex_tExtractXMLField_2){
    System.err.println(ex_tExtractXMLField_2.getMessage());
    }
    
    org.dom4j.Node node_tExtractXMLField_2 = null;
    String str_tExtractXMLField_2 = "";
    boolean resultIsNode_tExtractXMLField_2 = true;
    for(int i_tExtractXMLField_2=0; isStructError_tExtractXMLField_2 || (nodeList_tExtractXMLField_2!=null && i_tExtractXMLField_2 < nodeList_tExtractXMLField_2.size());i_tExtractXMLField_2++){
    	
    	if(!isStructError_tExtractXMLField_2){
			adress = null;
			adress = null;
    		adress = new adressStruct();
    	
    		org.dom4j.tree.AbstractNode temp_tExtractXMLField_2 = nodeList_tExtractXMLField_2.get(i_tExtractXMLField_2);
	
	    	nb_line_tExtractXMLField_2++;	
			try{
			adress.CODE_BARRE = adresses.CODE_BARRE;
				org.dom4j.XPath xTmp0_tExtractXMLField_2 = temp_tExtractXMLField_2.createXPath(nsTool_tExtractXMLField_2.addDefaultNSPrefix("addresses",loopQuery_tExtractXMLField_2));
			    xTmp0_tExtractXMLField_2.setNamespaceURIs(xmlNameSpaceMap_tExtractXMLField_2);
				
			    Object obj0_tExtractXMLField_2 = xTmp0_tExtractXMLField_2.evaluate(temp_tExtractXMLField_2);
			    if(obj0_tExtractXMLField_2 instanceof String || obj0_tExtractXMLField_2 instanceof Number){
			    	resultIsNode_tExtractXMLField_2 = false;
    				str_tExtractXMLField_2 = String.valueOf(obj0_tExtractXMLField_2);
   				}else{
   					resultIsNode_tExtractXMLField_2 = true;
				    node_tExtractXMLField_2 = xTmp0_tExtractXMLField_2.selectSingleNode(temp_tExtractXMLField_2);
					str_tExtractXMLField_2 = node_tExtractXMLField_2==null?null:node_tExtractXMLField_2.asXML();
				}
									adress.doc = ParserUtils.parseTo_Document(str_tExtractXMLField_2);
}catch(java.lang.Exception ex_tExtractXMLField_2){
    System.err.println(ex_tExtractXMLField_2.getMessage());
    adress = null;
    	}
    }
    
    isStructError_tExtractXMLField_2 = false;


   globalMap.put("tExtractXMLField_2_NB_LINE", nb_line_tExtractXMLField_2);

 


	tos_count_tExtractXMLField_2++;

/**
 * [tExtractXMLField_2 main ] stop
 */
// Start of branch "adress"
if(adress != null) { 



	
	/**
	 * [tAdvancedHash_adress main ] start
	 */

	

	
	
	currentComponent="tAdvancedHash_adress";

	

			//adress
			//adress


			
				if(execStat){
					runStat.updateStatOnConnection("adress"+iterateId,1, 1);
				} 
			

		


			   
			   

					adressStruct adress_HashRow = new adressStruct();
		   	   	   
				
				adress_HashRow.doc = adress.doc;
				
				adress_HashRow.CODE_BARRE = adress.CODE_BARRE;
				
			tHash_Lookup_adress.put(adress_HashRow);
			
            




 


	tos_count_tAdvancedHash_adress++;

/**
 * [tAdvancedHash_adress main ] stop
 */

} // End of branch "adress"

		// end for
	}


	
		} // C_01
	

} // End of branch "adresses"




	
	/**
	 * [tXMLMap_2_TXMLMAP_IN end ] start
	 */

	

	
	
		currentVirtualComponent = "tXMLMap_2";
	
	currentComponent="tXMLMap_2_TXMLMAP_IN";

	

}//TD512
 

ok_Hash.put("tXMLMap_2_TXMLMAP_IN", true);
end_Hash.put("tXMLMap_2_TXMLMAP_IN", System.currentTimeMillis());




/**
 * [tXMLMap_2_TXMLMAP_IN end ] stop
 */

	
	/**
	 * [tExtractXMLField_2 end ] start
	 */

	

	
	
	currentComponent="tExtractXMLField_2";

	



globalMap.put("tExtractXMLField_2_NB_LINE", nb_line_tExtractXMLField_2);

			if(execStat){
				if(resourceMap.get("inIterateVComp") == null || !((Boolean)resourceMap.get("inIterateVComp"))){
			 		runStat.updateStatOnConnection("adresses"+iterateId,2, 0); 
			 	}
			}
		
 

ok_Hash.put("tExtractXMLField_2", true);
end_Hash.put("tExtractXMLField_2", System.currentTimeMillis());




/**
 * [tExtractXMLField_2 end ] stop
 */

	
	/**
	 * [tAdvancedHash_adress end ] start
	 */

	

	
	
	currentComponent="tAdvancedHash_adress";

	

tHash_Lookup_adress.endPut();

			if(execStat){
				if(resourceMap.get("inIterateVComp") == null || !((Boolean)resourceMap.get("inIterateVComp"))){
			 		runStat.updateStatOnConnection("adress"+iterateId,2, 0); 
			 	}
			}
		
 

ok_Hash.put("tAdvancedHash_adress", true);
end_Hash.put("tAdvancedHash_adress", System.currentTimeMillis());




/**
 * [tAdvancedHash_adress end ] stop
 */












				}//end the resume

				



	
			}catch(java.lang.Exception e){	
				
				TalendException te = new TalendException(e, currentComponent, globalMap);
				
					te.setVirtualComponentName(currentVirtualComponent);
				
				throw te;
			}catch(java.lang.Error error){	
				
					runStat.stopThreadStat();
				
				throw error;
			}finally{
				
				try{
					
	
	/**
	 * [tOracleInput_1 finally ] start
	 */

	

	
	
	currentComponent="tOracleInput_1";

	

 



/**
 * [tOracleInput_1 finally ] stop
 */

	
	/**
	 * [tXMLMap_2_TXMLMAP_OUT finally ] start
	 */

	

	
	
		currentVirtualComponent = "tXMLMap_2";
	
	currentComponent="tXMLMap_2_TXMLMAP_OUT";

	

 



/**
 * [tXMLMap_2_TXMLMAP_OUT finally ] stop
 */

	
	/**
	 * [tXMLMap_2_TXMLMAP_IN finally ] start
	 */

	

	
	
		currentVirtualComponent = "tXMLMap_2";
	
	currentComponent="tXMLMap_2_TXMLMAP_IN";

	

 



/**
 * [tXMLMap_2_TXMLMAP_IN finally ] stop
 */

	
	/**
	 * [tExtractXMLField_2 finally ] start
	 */

	

	
	
	currentComponent="tExtractXMLField_2";

	

 



/**
 * [tExtractXMLField_2 finally ] stop
 */

	
	/**
	 * [tAdvancedHash_adress finally ] start
	 */

	

	
	
	currentComponent="tAdvancedHash_adress";

	

 



/**
 * [tAdvancedHash_adress finally ] stop
 */












				}catch(java.lang.Exception e){	
					//ignore
				}catch(java.lang.Error error){
					//ignore
				}
				resourceMap = null;
			}
		

		globalMap.put("tOracleInput_1_SUBPROCESS_STATE", 1);
	}
	


public static class adresseStruct implements routines.system.IPersistableComparableLookupRow<adresseStruct> {
    final static byte[] commonByteArrayLock_LDAP_sgbm_export = new byte[0];
    static byte[] commonByteArray_LDAP_sgbm_export = new byte[0];
	protected static final int DEFAULT_HASHCODE = 1;
    protected static final int PRIME = 31;
    protected int hashCode = DEFAULT_HASHCODE;
    public boolean hashCodeDirty = true;

    public String loopKey;



	
			    public String CODE_BARRE;

				public String getCODE_BARRE () {
					return this.CODE_BARRE;
				}
				
			    public String TYPE;

				public String getTYPE () {
					return this.TYPE;
				}
				
			    public String ADR1;

				public String getADR1 () {
					return this.ADR1;
				}
				
			    public String ADR2;

				public String getADR2 () {
					return this.ADR2;
				}
				
			    public String ADR3;

				public String getADR3 () {
					return this.ADR3;
				}
				
			    public String ADR4;

				public String getADR4 () {
					return this.ADR4;
				}
				
			    public String ADR5;

				public String getADR5 () {
					return this.ADR5;
				}
				
			    public String VILLE;

				public String getVILLE () {
					return this.VILLE;
				}
				
			    public String CP;

				public String getCP () {
					return this.CP;
				}
				
			    public String PAYS;

				public String getPAYS () {
					return this.PAYS;
				}
				
			    public java.util.Date DEBUT;

				public java.util.Date getDEBUT () {
					return this.DEBUT;
				}
				


	@Override
	public int hashCode() {
		if (this.hashCodeDirty) {
			final int prime = PRIME;
			int result = DEFAULT_HASHCODE;
	
						result = prime * result + ((this.CODE_BARRE == null) ? 0 : this.CODE_BARRE.hashCode());
					
    		this.hashCode = result;
    		this.hashCodeDirty = false;
		}
		return this.hashCode;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj) return true;
		if (obj == null) return false;
		if (getClass() != obj.getClass()) return false;
		final adresseStruct other = (adresseStruct) obj;
		
						if (this.CODE_BARRE == null) {
							if (other.CODE_BARRE != null)
								return false;
						
						} else if (!this.CODE_BARRE.equals(other.CODE_BARRE))
						
							return false;
					

		return true;
    }

	public void copyDataTo(adresseStruct other) {

		other.CODE_BARRE = this.CODE_BARRE;
	            other.TYPE = this.TYPE;
	            other.ADR1 = this.ADR1;
	            other.ADR2 = this.ADR2;
	            other.ADR3 = this.ADR3;
	            other.ADR4 = this.ADR4;
	            other.ADR5 = this.ADR5;
	            other.VILLE = this.VILLE;
	            other.CP = this.CP;
	            other.PAYS = this.PAYS;
	            other.DEBUT = this.DEBUT;
	            
	}

	public void copyKeysDataTo(adresseStruct other) {

		other.CODE_BARRE = this.CODE_BARRE;
	            	
	}




	private String readString(ObjectInputStream dis) throws IOException{
		String strReturn = null;
		int length = 0;
        length = dis.readInt();
		if (length == -1) {
			strReturn = null;
		} else {
			if(length > commonByteArray_LDAP_sgbm_export.length) {
				if(length < 1024 && commonByteArray_LDAP_sgbm_export.length == 0) {
   					commonByteArray_LDAP_sgbm_export = new byte[1024];
				} else {
   					commonByteArray_LDAP_sgbm_export = new byte[2 * length];
   				}
			}
			dis.readFully(commonByteArray_LDAP_sgbm_export, 0, length);
			strReturn = new String(commonByteArray_LDAP_sgbm_export, 0, length, utf8Charset);
		}
		return strReturn;
	}

    private void writeString(String str, ObjectOutputStream dos) throws IOException{
		if(str == null) {
            dos.writeInt(-1);
		} else {
            byte[] byteArray = str.getBytes(utf8Charset);
	    	dos.writeInt(byteArray.length);
			dos.write(byteArray);
    	}
    }

	private String readString(DataInputStream dis, ObjectInputStream ois) throws IOException{
		String strReturn = null;
		int length = 0;
        length = dis.readInt();
		if (length == -1) {
			strReturn = null;
		} else {
			byte[] byteArray = new byte[length];
			dis.read(byteArray);
			strReturn = new String(byteArray, utf8Charset);
		}
		return strReturn;
	}

	private void writeString(String str, DataOutputStream dos, ObjectOutputStream oos) throws IOException{
		if(str == null) {
            dos.writeInt(-1);
		} else {
            byte[] byteArray = str.getBytes(utf8Charset);
	    	dos.writeInt(byteArray.length);
			dos.write(byteArray);
    	}
	}

	private java.util.Date readDate(DataInputStream dis, ObjectInputStream ois) throws IOException{
		java.util.Date dateReturn = null;
		int length = 0;
        length = dis.readByte();
		if (length == -1) {
			dateReturn = null;
		} else {
	    	dateReturn = new Date(dis.readLong());
		}
		return dateReturn;
	}

	private void writeDate(java.util.Date date1, DataOutputStream dos, ObjectOutputStream oos) throws IOException{
		if(date1 == null) {
            dos.writeByte(-1);
		} else {
			dos.writeByte(0);
	    	dos.writeLong(date1.getTime());
    	}
	}

    public void readKeysData(ObjectInputStream dis) {

		synchronized(commonByteArrayLock_LDAP_sgbm_export) {

        	try {

        		int length = 0;
		
					this.CODE_BARRE = readString(dis);
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);

		

        }

		

      }


    }

    public void writeKeysData(ObjectOutputStream dos) {
        try {

		
					// String
				
						writeString(this.CODE_BARRE,dos);
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);
        }


    }



    /**
     * Fill Values data by reading ObjectInputStream.
     */
    public void readValuesData(DataInputStream dis, ObjectInputStream ois) {
        try {

			int length = 0;
		
						this.TYPE = readString(dis,ois);
					
						this.ADR1 = readString(dis,ois);
					
						this.ADR2 = readString(dis,ois);
					
						this.ADR3 = readString(dis,ois);
					
						this.ADR4 = readString(dis,ois);
					
						this.ADR5 = readString(dis,ois);
					
						this.VILLE = readString(dis,ois);
					
						this.CP = readString(dis,ois);
					
						this.PAYS = readString(dis,ois);
					
						this.DEBUT = readDate(dis,ois);
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);

		

        }

		

    }

    /**
     * Return a byte array which represents Values data.
     */
    public void writeValuesData(DataOutputStream dos, ObjectOutputStream oos) {
        try {

		
						writeString(this.TYPE, dos, oos);
					
						writeString(this.ADR1, dos, oos);
					
						writeString(this.ADR2, dos, oos);
					
						writeString(this.ADR3, dos, oos);
					
						writeString(this.ADR4, dos, oos);
					
						writeString(this.ADR5, dos, oos);
					
						writeString(this.VILLE, dos, oos);
					
						writeString(this.CP, dos, oos);
					
						writeString(this.PAYS, dos, oos);
					
						writeDate(this.DEBUT, dos, oos);
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);
        	}

    }


    public String toString() {

		StringBuilder sb = new StringBuilder();
		sb.append(super.toString());
		sb.append("[");
		sb.append("CODE_BARRE="+CODE_BARRE);
		sb.append(",TYPE="+TYPE);
		sb.append(",ADR1="+ADR1);
		sb.append(",ADR2="+ADR2);
		sb.append(",ADR3="+ADR3);
		sb.append(",ADR4="+ADR4);
		sb.append(",ADR5="+ADR5);
		sb.append(",VILLE="+VILLE);
		sb.append(",CP="+CP);
		sb.append(",PAYS="+PAYS);
		sb.append(",DEBUT="+String.valueOf(DEBUT));
	    sb.append("]");

	    return sb.toString();
    }

    /**
     * Compare keys
     */
    public int compareTo(adresseStruct other) {

		int returnValue = -1;
		
						returnValue = checkNullsAndCompare(this.CODE_BARRE, other.CODE_BARRE);
						if(returnValue != 0) {
							return returnValue;
						}

					
	    return returnValue;
    }


    private int checkNullsAndCompare(Object object1, Object object2) {
        int returnValue = 0;
		if (object1 instanceof Comparable && object2 instanceof Comparable) {
            returnValue = ((Comparable) object1).compareTo(object2);
        } else if (object1 != null && object2 != null) {
            returnValue = compareStrings(object1.toString(), object2.toString());
        } else if (object1 == null && object2 != null) {
            returnValue = 1;
        } else if (object1 != null && object2 == null) {
            returnValue = -1;
        } else {
            returnValue = 0;
        }

        return returnValue;
    }

    private int compareStrings(String string1, String string2) {
        return string1.compareTo(string2);
    }


}
public void tOracleInput_2Process(final java.util.Map<String, Object> globalMap) throws TalendException {
	globalMap.put("tOracleInput_2_SUBPROCESS_STATE", 0);

 final boolean execStat = this.execStat;
	
		String iterateId = "";
	
	
	String currentComponent = "";
	java.util.Map<String, Object> resourceMap = new java.util.HashMap<String, Object>();

	try {

			String currentMethodName = new java.lang.Exception().getStackTrace()[0].getMethodName();
			boolean resumeIt = currentMethodName.equals(resumeEntryMethodName);
			if( resumeEntryMethodName == null || resumeIt || globalResumeTicket){//start the resume
				globalResumeTicket = true;



		adresseStruct adresse = new adresseStruct();




	
	/**
	 * [tAdvancedXMLMapHash_adresse begin ] start
	 */

	

	
		
		ok_Hash.put("tAdvancedXMLMapHash_adresse", false);
		start_Hash.put("tAdvancedXMLMapHash_adresse", System.currentTimeMillis());
		
	
	currentComponent="tAdvancedXMLMapHash_adresse";

	
			if (execStat) {
				if(resourceMap.get("inIterateVComp") == null){
					
						runStat.updateStatOnConnection("adresse" + iterateId, 0, 0);
					
				}
			} 

		
		int tos_count_tAdvancedXMLMapHash_adresse = 0;
		
    	class BytesLimit65535_tAdvancedXMLMapHash_adresse{
    		public void limitLog4jByte() throws Exception{
    			
    		}
    	}
    	
        new BytesLimit65535_tAdvancedXMLMapHash_adresse().limitLog4jByte();

			   		// connection name:adresse
			   		// source node:tOracleInput_2 - inputs:(after_tOracleInput_1) outputs:(adresse,adresse) | target node:tAdvancedXMLMapHash_adresse - inputs:(adresse) outputs:()
			   		// linked node: tXMLMap_2 - inputs:(infoAdresse,adresse) outputs:(adresses)
			   
			   		org.talend.designer.components.lookup.common.ICommonLookup.MATCHING_MODE matchingModeEnum_adresse = 
			   			org.talend.designer.components.lookup.common.ICommonLookup.MATCHING_MODE.ALL_MATCHES;
			   
			   
	   				org.talend.designer.components.lookup.memory.AdvancedMemoryLookup<adresseStruct> tHash_Lookup_adresse = 
	   					org.talend.designer.components.lookup.memory.AdvancedMemoryLookup.
	   						<adresseStruct>getLookup(matchingModeEnum_adresse);

		   	   	   globalMap.put("tHash_Lookup_adresse", tHash_Lookup_adresse);
		   	   	   
				
            

 



/**
 * [tAdvancedXMLMapHash_adresse begin ] stop
 */



	
	/**
	 * [tOracleInput_2 begin ] start
	 */

	

	
		
		ok_Hash.put("tOracleInput_2", false);
		start_Hash.put("tOracleInput_2", System.currentTimeMillis());
		
	
	currentComponent="tOracleInput_2";

	
		int tos_count_tOracleInput_2 = 0;
		
    	class BytesLimit65535_tOracleInput_2{
    		public void limitLog4jByte() throws Exception{
    			
    		}
    	}
    	
        new BytesLimit65535_tOracleInput_2().limitLog4jByte();
	


	
		    int nb_line_tOracleInput_2 = 0;
		    java.sql.Connection conn_tOracleInput_2 = null;
		        conn_tOracleInput_2 = (java.sql.Connection)globalMap.get("conn_tOracleConnection_1");
				
				if(((oracle.jdbc.OracleConnection)conn_tOracleInput_2).getSessionTimeZone() == null){
					java.sql.Statement stmtGetTZ_tOracleInput_2 = conn_tOracleInput_2.createStatement();
					java.sql.ResultSet rsGetTZ_tOracleInput_2 = stmtGetTZ_tOracleInput_2.executeQuery("select sessiontimezone from dual");
					String sessionTimezone_tOracleInput_2 = java.util.TimeZone.getDefault().getID();
					while (rsGetTZ_tOracleInput_2.next()) {
						sessionTimezone_tOracleInput_2 = rsGetTZ_tOracleInput_2.getString(1);
					}
					((oracle.jdbc.OracleConnection)conn_tOracleInput_2).setSessionTimeZone(sessionTimezone_tOracleInput_2);
				}
			
		    
			java.sql.Statement stmt_tOracleInput_2 = conn_tOracleInput_2.createStatement();

		    String dbquery_tOracleInput_2 = "SELECT \n  "+context.oracle_schema+".V_SGBMP_ADRESSE.*\nFROM "+context.oracle_schema+".V_SGBMP_ADRESSE";
			

            	globalMap.put("tOracleInput_2_QUERY",dbquery_tOracleInput_2);
		    java.sql.ResultSet rs_tOracleInput_2 = null;

		    try {
		    	rs_tOracleInput_2 = stmt_tOracleInput_2.executeQuery(dbquery_tOracleInput_2);
		    	java.sql.ResultSetMetaData rsmd_tOracleInput_2 = rs_tOracleInput_2.getMetaData();
		    	int colQtyInRs_tOracleInput_2 = rsmd_tOracleInput_2.getColumnCount();

		    String tmpContent_tOracleInput_2 = null;
		    
		    
		    while (rs_tOracleInput_2.next()) {
		        nb_line_tOracleInput_2++;
		        
							if(colQtyInRs_tOracleInput_2 < 1) {
								adresse.CODE_BARRE = null;
							} else {
	                         		
        	adresse.CODE_BARRE = routines.system.JDBCUtil.getString(rs_tOracleInput_2, 1, false);
		                    }
							if(colQtyInRs_tOracleInput_2 < 2) {
								adresse.TYPE = null;
							} else {
	                         		
        	adresse.TYPE = routines.system.JDBCUtil.getString(rs_tOracleInput_2, 2, false);
		                    }
							if(colQtyInRs_tOracleInput_2 < 3) {
								adresse.ADR1 = null;
							} else {
	                         		
        	adresse.ADR1 = routines.system.JDBCUtil.getString(rs_tOracleInput_2, 3, false);
		                    }
							if(colQtyInRs_tOracleInput_2 < 4) {
								adresse.ADR2 = null;
							} else {
	                         		
        	adresse.ADR2 = routines.system.JDBCUtil.getString(rs_tOracleInput_2, 4, false);
		                    }
							if(colQtyInRs_tOracleInput_2 < 5) {
								adresse.ADR3 = null;
							} else {
	                         		
        	adresse.ADR3 = routines.system.JDBCUtil.getString(rs_tOracleInput_2, 5, false);
		                    }
							if(colQtyInRs_tOracleInput_2 < 6) {
								adresse.ADR4 = null;
							} else {
	                         		
        	adresse.ADR4 = routines.system.JDBCUtil.getString(rs_tOracleInput_2, 6, false);
		                    }
							if(colQtyInRs_tOracleInput_2 < 7) {
								adresse.ADR5 = null;
							} else {
	                         		
        	adresse.ADR5 = routines.system.JDBCUtil.getString(rs_tOracleInput_2, 7, false);
		                    }
							if(colQtyInRs_tOracleInput_2 < 8) {
								adresse.VILLE = null;
							} else {
	                         		
        	adresse.VILLE = routines.system.JDBCUtil.getString(rs_tOracleInput_2, 8, false);
		                    }
							if(colQtyInRs_tOracleInput_2 < 9) {
								adresse.CP = null;
							} else {
	                         		
        	adresse.CP = routines.system.JDBCUtil.getString(rs_tOracleInput_2, 9, false);
		                    }
							if(colQtyInRs_tOracleInput_2 < 10) {
								adresse.PAYS = null;
							} else {
	                         		
        	adresse.PAYS = routines.system.JDBCUtil.getString(rs_tOracleInput_2, 10, false);
		                    }
							if(colQtyInRs_tOracleInput_2 < 11) {
								adresse.DEBUT = null;
							} else {
										
			adresse.DEBUT = routines.system.JDBCUtil.getDate(rs_tOracleInput_2, 11);
		                    }
					




 



/**
 * [tOracleInput_2 begin ] stop
 */
	
	/**
	 * [tOracleInput_2 main ] start
	 */

	

	
	
	currentComponent="tOracleInput_2";

	

 


	tos_count_tOracleInput_2++;

/**
 * [tOracleInput_2 main ] stop
 */

	
	/**
	 * [tAdvancedXMLMapHash_adresse main ] start
	 */

	

	
	
	currentComponent="tAdvancedXMLMapHash_adresse";

	

			//adresse
			//adresse


			
				if(execStat){
					runStat.updateStatOnConnection("adresse"+iterateId,1, 1);
				} 
			

		


			   
			   

					adresseStruct adresse_HashRow = new adresseStruct();
					
				
					adresse_HashRow.CODE_BARRE = adresse.CODE_BARRE;
					
					adresse_HashRow.TYPE = adresse.TYPE;
					
					adresse_HashRow.ADR1 = adresse.ADR1;
					
					adresse_HashRow.ADR2 = adresse.ADR2;
					
					adresse_HashRow.ADR3 = adresse.ADR3;
					
					adresse_HashRow.ADR4 = adresse.ADR4;
					
					adresse_HashRow.ADR5 = adresse.ADR5;
					
					adresse_HashRow.VILLE = adresse.VILLE;
					
					adresse_HashRow.CP = adresse.CP;
					
					adresse_HashRow.PAYS = adresse.PAYS;
					
					adresse_HashRow.DEBUT = adresse.DEBUT;
					
					tHash_Lookup_adresse.put(adresse_HashRow);
				
            




 


	tos_count_tAdvancedXMLMapHash_adresse++;

/**
 * [tAdvancedXMLMapHash_adresse main ] stop
 */



	
	/**
	 * [tOracleInput_2 end ] start
	 */

	

	
	
	currentComponent="tOracleInput_2";

	

}
}finally{
stmt_tOracleInput_2.close();

}

globalMap.put("tOracleInput_2_NB_LINE",nb_line_tOracleInput_2);
 

ok_Hash.put("tOracleInput_2", true);
end_Hash.put("tOracleInput_2", System.currentTimeMillis());




/**
 * [tOracleInput_2 end ] stop
 */

	
	/**
	 * [tAdvancedXMLMapHash_adresse end ] start
	 */

	

	
	
	currentComponent="tAdvancedXMLMapHash_adresse";

	

tHash_Lookup_adresse.endPut();

			if(execStat){
				if(resourceMap.get("inIterateVComp") == null || !((Boolean)resourceMap.get("inIterateVComp"))){
			 		runStat.updateStatOnConnection("adresse"+iterateId,2, 0); 
			 	}
			}
		
 

ok_Hash.put("tAdvancedXMLMapHash_adresse", true);
end_Hash.put("tAdvancedXMLMapHash_adresse", System.currentTimeMillis());




/**
 * [tAdvancedXMLMapHash_adresse end ] stop
 */



				}//end the resume

				



	
			}catch(java.lang.Exception e){	
				
				TalendException te = new TalendException(e, currentComponent, globalMap);
				
				throw te;
			}catch(java.lang.Error error){	
				
					runStat.stopThreadStat();
				
				throw error;
			}finally{
				
				try{
					
	
	/**
	 * [tOracleInput_2 finally ] start
	 */

	

	
	
	currentComponent="tOracleInput_2";

	

 



/**
 * [tOracleInput_2 finally ] stop
 */

	
	/**
	 * [tAdvancedXMLMapHash_adresse finally ] start
	 */

	

	
	
	currentComponent="tAdvancedXMLMapHash_adresse";

	

 



/**
 * [tAdvancedXMLMapHash_adresse finally ] stop
 */



				}catch(java.lang.Exception e){	
					//ignore
				}catch(java.lang.Error error){
					//ignore
				}
				resourceMap = null;
			}
		

		globalMap.put("tOracleInput_2_SUBPROCESS_STATE", 1);
	}
	


public static class emailStruct implements routines.system.IPersistableComparableLookupRow<emailStruct> {
    final static byte[] commonByteArrayLock_LDAP_sgbm_export = new byte[0];
    static byte[] commonByteArray_LDAP_sgbm_export = new byte[0];
	protected static final int DEFAULT_HASHCODE = 1;
    protected static final int PRIME = 31;
    protected int hashCode = DEFAULT_HASHCODE;
    public boolean hashCodeDirty = true;

    public String loopKey;



	
			    public String CODE_BARRE;

				public String getCODE_BARRE () {
					return this.CODE_BARRE;
				}
				
			    public routines.system.Document doc;

				public routines.system.Document getDoc () {
					return this.doc;
				}
				


	@Override
	public int hashCode() {
		if (this.hashCodeDirty) {
			final int prime = PRIME;
			int result = DEFAULT_HASHCODE;
	
						result = prime * result + ((this.CODE_BARRE == null) ? 0 : this.CODE_BARRE.hashCode());
					
    		this.hashCode = result;
    		this.hashCodeDirty = false;
		}
		return this.hashCode;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj) return true;
		if (obj == null) return false;
		if (getClass() != obj.getClass()) return false;
		final emailStruct other = (emailStruct) obj;
		
						if (this.CODE_BARRE == null) {
							if (other.CODE_BARRE != null)
								return false;
						
						} else if (!this.CODE_BARRE.equals(other.CODE_BARRE))
						
							return false;
					

		return true;
    }

	public void copyDataTo(emailStruct other) {

		other.CODE_BARRE = this.CODE_BARRE;
	            other.doc = this.doc;
	            
	}

	public void copyKeysDataTo(emailStruct other) {

		other.CODE_BARRE = this.CODE_BARRE;
	            	
	}




	private String readString(ObjectInputStream dis) throws IOException{
		String strReturn = null;
		int length = 0;
        length = dis.readInt();
		if (length == -1) {
			strReturn = null;
		} else {
			if(length > commonByteArray_LDAP_sgbm_export.length) {
				if(length < 1024 && commonByteArray_LDAP_sgbm_export.length == 0) {
   					commonByteArray_LDAP_sgbm_export = new byte[1024];
				} else {
   					commonByteArray_LDAP_sgbm_export = new byte[2 * length];
   				}
			}
			dis.readFully(commonByteArray_LDAP_sgbm_export, 0, length);
			strReturn = new String(commonByteArray_LDAP_sgbm_export, 0, length, utf8Charset);
		}
		return strReturn;
	}

    private void writeString(String str, ObjectOutputStream dos) throws IOException{
		if(str == null) {
            dos.writeInt(-1);
		} else {
            byte[] byteArray = str.getBytes(utf8Charset);
	    	dos.writeInt(byteArray.length);
			dos.write(byteArray);
    	}
    }

    public void readKeysData(ObjectInputStream dis) {

		synchronized(commonByteArrayLock_LDAP_sgbm_export) {

        	try {

        		int length = 0;
		
					this.CODE_BARRE = readString(dis);
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);

		

        }

		

      }


    }

    public void writeKeysData(ObjectOutputStream dos) {
        try {

		
					// String
				
						writeString(this.CODE_BARRE,dos);
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);
        }


    }



    /**
     * Fill Values data by reading ObjectInputStream.
     */
    public void readValuesData(DataInputStream dis, ObjectInputStream ois) {
        try {

			int length = 0;
		
       			    	this.doc = (routines.system.Document) ois.readObject();
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);

		
			} catch(ClassNotFoundException eCNFE) {
				 throw new RuntimeException(eCNFE);
		

        }

		

    }

    /**
     * Return a byte array which represents Values data.
     */
    public void writeValuesData(DataOutputStream dos, ObjectOutputStream oos) {
        try {

		
       			    	oos.writeObject(this.doc);
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);
        	}

    }


    public String toString() {

		StringBuilder sb = new StringBuilder();
		sb.append(super.toString());
		sb.append("[");
		sb.append("CODE_BARRE="+CODE_BARRE);
		sb.append(",doc="+String.valueOf(doc));
	    sb.append("]");

	    return sb.toString();
    }

    /**
     * Compare keys
     */
    public int compareTo(emailStruct other) {

		int returnValue = -1;
		
						returnValue = checkNullsAndCompare(this.CODE_BARRE, other.CODE_BARRE);
						if(returnValue != 0) {
							return returnValue;
						}

					
	    return returnValue;
    }


    private int checkNullsAndCompare(Object object1, Object object2) {
        int returnValue = 0;
		if (object1 instanceof Comparable && object2 instanceof Comparable) {
            returnValue = ((Comparable) object1).compareTo(object2);
        } else if (object1 != null && object2 != null) {
            returnValue = compareStrings(object1.toString(), object2.toString());
        } else if (object1 == null && object2 != null) {
            returnValue = 1;
        } else if (object1 != null && object2 == null) {
            returnValue = -1;
        } else {
            returnValue = 0;
        }

        return returnValue;
    }

    private int compareStrings(String string1, String string2) {
        return string1.compareTo(string2);
    }


}

public static class mailsStruct implements routines.system.IPersistableRow<mailsStruct> {
    final static byte[] commonByteArrayLock_LDAP_sgbm_export = new byte[0];
    static byte[] commonByteArray_LDAP_sgbm_export = new byte[0];

	
			    public String CODE_BARRE;

				public String getCODE_BARRE () {
					return this.CODE_BARRE;
				}
				
			    public routines.system.Document doc;

				public routines.system.Document getDoc () {
					return this.doc;
				}
				



	private String readString(ObjectInputStream dis) throws IOException{
		String strReturn = null;
		int length = 0;
        length = dis.readInt();
		if (length == -1) {
			strReturn = null;
		} else {
			if(length > commonByteArray_LDAP_sgbm_export.length) {
				if(length < 1024 && commonByteArray_LDAP_sgbm_export.length == 0) {
   					commonByteArray_LDAP_sgbm_export = new byte[1024];
				} else {
   					commonByteArray_LDAP_sgbm_export = new byte[2 * length];
   				}
			}
			dis.readFully(commonByteArray_LDAP_sgbm_export, 0, length);
			strReturn = new String(commonByteArray_LDAP_sgbm_export, 0, length, utf8Charset);
		}
		return strReturn;
	}

    private void writeString(String str, ObjectOutputStream dos) throws IOException{
		if(str == null) {
            dos.writeInt(-1);
		} else {
            byte[] byteArray = str.getBytes(utf8Charset);
	    	dos.writeInt(byteArray.length);
			dos.write(byteArray);
    	}
    }

    public void readData(ObjectInputStream dis) {

		synchronized(commonByteArrayLock_LDAP_sgbm_export) {

        	try {

        		int length = 0;
		
					this.CODE_BARRE = readString(dis);
					
						this.doc = (routines.system.Document) dis.readObject();
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);

		
			} catch(ClassNotFoundException eCNFE) {
				 throw new RuntimeException(eCNFE);
		

        }

		

      }


    }

    public void writeData(ObjectOutputStream dos) {
        try {

		
					// String
				
						writeString(this.CODE_BARRE,dos);
					
					// Document
				
       			    	dos.writeObject(this.doc);
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);
        }


    }


    public String toString() {

		StringBuilder sb = new StringBuilder();
		sb.append(super.toString());
		sb.append("[");
		sb.append("CODE_BARRE="+CODE_BARRE);
		sb.append(",doc="+String.valueOf(doc));
	    sb.append("]");

	    return sb.toString();
    }

    /**
     * Compare keys
     */
    public int compareTo(mailsStruct other) {

		int returnValue = -1;
		
	    return returnValue;
    }


    private int checkNullsAndCompare(Object object1, Object object2) {
        int returnValue = 0;
		if (object1 instanceof Comparable && object2 instanceof Comparable) {
            returnValue = ((Comparable) object1).compareTo(object2);
        } else if (object1 != null && object2 != null) {
            returnValue = compareStrings(object1.toString(), object2.toString());
        } else if (object1 == null && object2 != null) {
            returnValue = 1;
        } else if (object1 != null && object2 == null) {
            returnValue = -1;
        } else {
            returnValue = 0;
        }

        return returnValue;
    }

    private int compareStrings(String string1, String string2) {
        return string1.compareTo(string2);
    }


}

public static class infoMailStruct implements routines.system.IPersistableRow<infoMailStruct> {
    final static byte[] commonByteArrayLock_LDAP_sgbm_export = new byte[0];
    static byte[] commonByteArray_LDAP_sgbm_export = new byte[0];

	
			    public String CODE_BARRE;

				public String getCODE_BARRE () {
					return this.CODE_BARRE;
				}
				
			    public String NOM;

				public String getNOM () {
					return this.NOM;
				}
				
			    public String PRENOM;

				public String getPRENOM () {
					return this.PRENOM;
				}
				
			    public String GROUPE;

				public String getGROUPE () {
					return this.GROUPE;
				}
				
			    public String CAMPUS;

				public String getCAMPUS () {
					return this.CAMPUS;
				}
				
			    public String LANGUE;

				public String getLANGUE () {
					return this.LANGUE;
				}
				
			    public String STATUT;

				public String getSTATUT () {
					return this.STATUT;
				}
				
			    public java.util.Date DATE_NAISSANCE;

				public java.util.Date getDATE_NAISSANCE () {
					return this.DATE_NAISSANCE;
				}
				
			    public java.util.Date DATE_MODIF;

				public java.util.Date getDATE_MODIF () {
					return this.DATE_MODIF;
				}
				
			    public java.util.Date DATE_EXPIRATION;

				public java.util.Date getDATE_EXPIRATION () {
					return this.DATE_EXPIRATION;
				}
				
			    public java.util.Date DATE_ELIMINATION;

				public java.util.Date getDATE_ELIMINATION () {
					return this.DATE_ELIMINATION;
				}
				
			    public String EPPN;

				public String getEPPN () {
					return this.EPPN;
				}
				



	private String readString(ObjectInputStream dis) throws IOException{
		String strReturn = null;
		int length = 0;
        length = dis.readInt();
		if (length == -1) {
			strReturn = null;
		} else {
			if(length > commonByteArray_LDAP_sgbm_export.length) {
				if(length < 1024 && commonByteArray_LDAP_sgbm_export.length == 0) {
   					commonByteArray_LDAP_sgbm_export = new byte[1024];
				} else {
   					commonByteArray_LDAP_sgbm_export = new byte[2 * length];
   				}
			}
			dis.readFully(commonByteArray_LDAP_sgbm_export, 0, length);
			strReturn = new String(commonByteArray_LDAP_sgbm_export, 0, length, utf8Charset);
		}
		return strReturn;
	}

    private void writeString(String str, ObjectOutputStream dos) throws IOException{
		if(str == null) {
            dos.writeInt(-1);
		} else {
            byte[] byteArray = str.getBytes(utf8Charset);
	    	dos.writeInt(byteArray.length);
			dos.write(byteArray);
    	}
    }

	private java.util.Date readDate(ObjectInputStream dis) throws IOException{
		java.util.Date dateReturn = null;
        int length = 0;
        length = dis.readByte();
		if (length == -1) {
			dateReturn = null;
		} else {
	    	dateReturn = new Date(dis.readLong());
		}
		return dateReturn;
	}

    private void writeDate(java.util.Date date1, ObjectOutputStream dos) throws IOException{
		if(date1 == null) {
            dos.writeByte(-1);
		} else {
			dos.writeByte(0);
	    	dos.writeLong(date1.getTime());
    	}
    }

    public void readData(ObjectInputStream dis) {

		synchronized(commonByteArrayLock_LDAP_sgbm_export) {

        	try {

        		int length = 0;
		
					this.CODE_BARRE = readString(dis);
					
					this.NOM = readString(dis);
					
					this.PRENOM = readString(dis);
					
					this.GROUPE = readString(dis);
					
					this.CAMPUS = readString(dis);
					
					this.LANGUE = readString(dis);
					
					this.STATUT = readString(dis);
					
					this.DATE_NAISSANCE = readDate(dis);
					
					this.DATE_MODIF = readDate(dis);
					
					this.DATE_EXPIRATION = readDate(dis);
					
					this.DATE_ELIMINATION = readDate(dis);
					
					this.EPPN = readString(dis);
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);

		

        }

		

      }


    }

    public void writeData(ObjectOutputStream dos) {
        try {

		
					// String
				
						writeString(this.CODE_BARRE,dos);
					
					// String
				
						writeString(this.NOM,dos);
					
					// String
				
						writeString(this.PRENOM,dos);
					
					// String
				
						writeString(this.GROUPE,dos);
					
					// String
				
						writeString(this.CAMPUS,dos);
					
					// String
				
						writeString(this.LANGUE,dos);
					
					// String
				
						writeString(this.STATUT,dos);
					
					// java.util.Date
				
						writeDate(this.DATE_NAISSANCE,dos);
					
					// java.util.Date
				
						writeDate(this.DATE_MODIF,dos);
					
					// java.util.Date
				
						writeDate(this.DATE_EXPIRATION,dos);
					
					// java.util.Date
				
						writeDate(this.DATE_ELIMINATION,dos);
					
					// String
				
						writeString(this.EPPN,dos);
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);
        }


    }


    public String toString() {

		StringBuilder sb = new StringBuilder();
		sb.append(super.toString());
		sb.append("[");
		sb.append("CODE_BARRE="+CODE_BARRE);
		sb.append(",NOM="+NOM);
		sb.append(",PRENOM="+PRENOM);
		sb.append(",GROUPE="+GROUPE);
		sb.append(",CAMPUS="+CAMPUS);
		sb.append(",LANGUE="+LANGUE);
		sb.append(",STATUT="+STATUT);
		sb.append(",DATE_NAISSANCE="+String.valueOf(DATE_NAISSANCE));
		sb.append(",DATE_MODIF="+String.valueOf(DATE_MODIF));
		sb.append(",DATE_EXPIRATION="+String.valueOf(DATE_EXPIRATION));
		sb.append(",DATE_ELIMINATION="+String.valueOf(DATE_ELIMINATION));
		sb.append(",EPPN="+EPPN);
	    sb.append("]");

	    return sb.toString();
    }

    /**
     * Compare keys
     */
    public int compareTo(infoMailStruct other) {

		int returnValue = -1;
		
	    return returnValue;
    }


    private int checkNullsAndCompare(Object object1, Object object2) {
        int returnValue = 0;
		if (object1 instanceof Comparable && object2 instanceof Comparable) {
            returnValue = ((Comparable) object1).compareTo(object2);
        } else if (object1 != null && object2 != null) {
            returnValue = compareStrings(object1.toString(), object2.toString());
        } else if (object1 == null && object2 != null) {
            returnValue = 1;
        } else if (object1 != null && object2 == null) {
            returnValue = -1;
        } else {
            returnValue = 0;
        }

        return returnValue;
    }

    private int compareStrings(String string1, String string2) {
        return string1.compareTo(string2);
    }


}

public static class after_tOracleInput_3Struct implements routines.system.IPersistableRow<after_tOracleInput_3Struct> {
    final static byte[] commonByteArrayLock_LDAP_sgbm_export = new byte[0];
    static byte[] commonByteArray_LDAP_sgbm_export = new byte[0];

	
			    public String CODE_BARRE;

				public String getCODE_BARRE () {
					return this.CODE_BARRE;
				}
				
			    public String NOM;

				public String getNOM () {
					return this.NOM;
				}
				
			    public String PRENOM;

				public String getPRENOM () {
					return this.PRENOM;
				}
				
			    public String GROUPE;

				public String getGROUPE () {
					return this.GROUPE;
				}
				
			    public String CAMPUS;

				public String getCAMPUS () {
					return this.CAMPUS;
				}
				
			    public String LANGUE;

				public String getLANGUE () {
					return this.LANGUE;
				}
				
			    public String STATUT;

				public String getSTATUT () {
					return this.STATUT;
				}
				
			    public java.util.Date DATE_NAISSANCE;

				public java.util.Date getDATE_NAISSANCE () {
					return this.DATE_NAISSANCE;
				}
				
			    public java.util.Date DATE_MODIF;

				public java.util.Date getDATE_MODIF () {
					return this.DATE_MODIF;
				}
				
			    public java.util.Date DATE_EXPIRATION;

				public java.util.Date getDATE_EXPIRATION () {
					return this.DATE_EXPIRATION;
				}
				
			    public java.util.Date DATE_ELIMINATION;

				public java.util.Date getDATE_ELIMINATION () {
					return this.DATE_ELIMINATION;
				}
				
			    public String EPPN;

				public String getEPPN () {
					return this.EPPN;
				}
				



	private String readString(ObjectInputStream dis) throws IOException{
		String strReturn = null;
		int length = 0;
        length = dis.readInt();
		if (length == -1) {
			strReturn = null;
		} else {
			if(length > commonByteArray_LDAP_sgbm_export.length) {
				if(length < 1024 && commonByteArray_LDAP_sgbm_export.length == 0) {
   					commonByteArray_LDAP_sgbm_export = new byte[1024];
				} else {
   					commonByteArray_LDAP_sgbm_export = new byte[2 * length];
   				}
			}
			dis.readFully(commonByteArray_LDAP_sgbm_export, 0, length);
			strReturn = new String(commonByteArray_LDAP_sgbm_export, 0, length, utf8Charset);
		}
		return strReturn;
	}

    private void writeString(String str, ObjectOutputStream dos) throws IOException{
		if(str == null) {
            dos.writeInt(-1);
		} else {
            byte[] byteArray = str.getBytes(utf8Charset);
	    	dos.writeInt(byteArray.length);
			dos.write(byteArray);
    	}
    }

	private java.util.Date readDate(ObjectInputStream dis) throws IOException{
		java.util.Date dateReturn = null;
        int length = 0;
        length = dis.readByte();
		if (length == -1) {
			dateReturn = null;
		} else {
	    	dateReturn = new Date(dis.readLong());
		}
		return dateReturn;
	}

    private void writeDate(java.util.Date date1, ObjectOutputStream dos) throws IOException{
		if(date1 == null) {
            dos.writeByte(-1);
		} else {
			dos.writeByte(0);
	    	dos.writeLong(date1.getTime());
    	}
    }

    public void readData(ObjectInputStream dis) {

		synchronized(commonByteArrayLock_LDAP_sgbm_export) {

        	try {

        		int length = 0;
		
					this.CODE_BARRE = readString(dis);
					
					this.NOM = readString(dis);
					
					this.PRENOM = readString(dis);
					
					this.GROUPE = readString(dis);
					
					this.CAMPUS = readString(dis);
					
					this.LANGUE = readString(dis);
					
					this.STATUT = readString(dis);
					
					this.DATE_NAISSANCE = readDate(dis);
					
					this.DATE_MODIF = readDate(dis);
					
					this.DATE_EXPIRATION = readDate(dis);
					
					this.DATE_ELIMINATION = readDate(dis);
					
					this.EPPN = readString(dis);
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);

		

        }

		

      }


    }

    public void writeData(ObjectOutputStream dos) {
        try {

		
					// String
				
						writeString(this.CODE_BARRE,dos);
					
					// String
				
						writeString(this.NOM,dos);
					
					// String
				
						writeString(this.PRENOM,dos);
					
					// String
				
						writeString(this.GROUPE,dos);
					
					// String
				
						writeString(this.CAMPUS,dos);
					
					// String
				
						writeString(this.LANGUE,dos);
					
					// String
				
						writeString(this.STATUT,dos);
					
					// java.util.Date
				
						writeDate(this.DATE_NAISSANCE,dos);
					
					// java.util.Date
				
						writeDate(this.DATE_MODIF,dos);
					
					// java.util.Date
				
						writeDate(this.DATE_EXPIRATION,dos);
					
					// java.util.Date
				
						writeDate(this.DATE_ELIMINATION,dos);
					
					// String
				
						writeString(this.EPPN,dos);
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);
        }


    }


    public String toString() {

		StringBuilder sb = new StringBuilder();
		sb.append(super.toString());
		sb.append("[");
		sb.append("CODE_BARRE="+CODE_BARRE);
		sb.append(",NOM="+NOM);
		sb.append(",PRENOM="+PRENOM);
		sb.append(",GROUPE="+GROUPE);
		sb.append(",CAMPUS="+CAMPUS);
		sb.append(",LANGUE="+LANGUE);
		sb.append(",STATUT="+STATUT);
		sb.append(",DATE_NAISSANCE="+String.valueOf(DATE_NAISSANCE));
		sb.append(",DATE_MODIF="+String.valueOf(DATE_MODIF));
		sb.append(",DATE_EXPIRATION="+String.valueOf(DATE_EXPIRATION));
		sb.append(",DATE_ELIMINATION="+String.valueOf(DATE_ELIMINATION));
		sb.append(",EPPN="+EPPN);
	    sb.append("]");

	    return sb.toString();
    }

    /**
     * Compare keys
     */
    public int compareTo(after_tOracleInput_3Struct other) {

		int returnValue = -1;
		
	    return returnValue;
    }


    private int checkNullsAndCompare(Object object1, Object object2) {
        int returnValue = 0;
		if (object1 instanceof Comparable && object2 instanceof Comparable) {
            returnValue = ((Comparable) object1).compareTo(object2);
        } else if (object1 != null && object2 != null) {
            returnValue = compareStrings(object1.toString(), object2.toString());
        } else if (object1 == null && object2 != null) {
            returnValue = 1;
        } else if (object1 != null && object2 == null) {
            returnValue = -1;
        } else {
            returnValue = 0;
        }

        return returnValue;
    }

    private int compareStrings(String string1, String string2) {
        return string1.compareTo(string2);
    }


}
public void tOracleInput_3Process(final java.util.Map<String, Object> globalMap) throws TalendException {
	globalMap.put("tOracleInput_3_SUBPROCESS_STATE", 0);

 final boolean execStat = this.execStat;
		String currentVirtualComponent = null;
	
		String iterateId = "";
	
	
	String currentComponent = "";
	java.util.Map<String, Object> resourceMap = new java.util.HashMap<String, Object>();

	try {

			String currentMethodName = new java.lang.Exception().getStackTrace()[0].getMethodName();
			boolean resumeIt = currentMethodName.equals(resumeEntryMethodName);
			if( resumeEntryMethodName == null || resumeIt || globalResumeTicket){//start the resume
				globalResumeTicket = true;


		tOracleInput_4Process(globalMap);

		infoMailStruct infoMail = new infoMailStruct();
mailsStruct mails = new mailsStruct();
emailStruct email = new emailStruct();




	
	/**
	 * [tXMLMap_3_TXMLMAP_OUT begin ] start
	 */

	

	
		
		ok_Hash.put("tXMLMap_3_TXMLMAP_OUT", false);
		start_Hash.put("tXMLMap_3_TXMLMAP_OUT", System.currentTimeMillis());
		
	
		currentVirtualComponent = "tXMLMap_3";
	
	currentComponent="tXMLMap_3_TXMLMAP_OUT";

	
			if (execStat) {
				if(resourceMap.get("inIterateVComp") == null){
					
						runStat.updateStatOnConnection("infoMail" + iterateId, 0, 0);
					
				}
			} 

		
		int tos_count_tXMLMap_3_TXMLMAP_OUT = 0;
		
    	class BytesLimit65535_tXMLMap_3_TXMLMAP_OUT{
    		public void limitLog4jByte() throws Exception{
    			
    		}
    	}
    	
        new BytesLimit65535_tXMLMap_3_TXMLMAP_OUT().limitLog4jByte();

	org.talend.designer.components.lookup.memory.AdvancedMemoryLookup<mailStruct> tHash_Lookup_mail = (org.talend.designer.components.lookup.memory.AdvancedMemoryLookup<mailStruct>) 
			((org.talend.designer.components.lookup.memory.AdvancedMemoryLookup<mailStruct>) 
				globalMap.get( "tHash_Lookup_mail" ))
				;
	
	
	mailStruct mailHashKey = new mailStruct();
	mailStruct mailDefault = new mailStruct();
	mailStruct mail = new mailStruct();
	
	
	
//===============================input xml init part===============================
class XML_API_tXMLMap_3_TXMLMAP_OUT{
	public boolean isDefNull(org.dom4j.Node node) throws javax.xml.transform.TransformerException {
        if (node != null && node instanceof org.dom4j.Element) {
        	org.dom4j.Attribute attri = ((org.dom4j.Element)node).attribute("nil");
        	if(attri != null && ("true").equals(attri.getText())){
            	return true;
            }
        }
        return false;
    }

    public boolean isMissing(org.dom4j.Node node) throws javax.xml.transform.TransformerException {
        return node == null ? true : false;
    }

    public boolean isEmpty(org.dom4j.Node node) throws javax.xml.transform.TransformerException {
        if (node != null) {
            return node.getText().length() == 0;
        }
        return false;
    }
}
	class Var__tXMLMap_3_TXMLMAP_OUT__Struct {
	}
	Var__tXMLMap_3_TXMLMAP_OUT__Struct Var__tXMLMap_3_TXMLMAP_OUT = new Var__tXMLMap_3_TXMLMAP_OUT__Struct();
// ###############################
// # Outputs initialization
mailsStruct mails_tmp = new mailsStruct();
mailsStruct mails_save = null;
//the aggregate variable
mailsStruct mails_aggregate = null;
//init the resultset for aggregate
java.util.List<Object> allOutsForAggregate_tXMLMap_3 = new java.util.ArrayList<Object>();
globalMap.put("allOutsForAggregate_tXMLMap_3",allOutsForAggregate_tXMLMap_3);
// ###############################
		int nb_line_tXMLMap_3_TXMLMAP_OUT = 0; 
	
    XML_API_tXMLMap_3_TXMLMAP_OUT xml_api_tXMLMap_3_TXMLMAP_OUT = new XML_API_tXMLMap_3_TXMLMAP_OUT();

	//the map store the previous value of aggregate columns
	java.util.Map<String,Object> aggregateCacheMap_tXMLMap_3_TXMLMAP_OUT = new java.util.HashMap<String,Object>();
					//init the map,the keys is aggregate columns xpath,the values is all null.
					aggregateCacheMap_tXMLMap_3_TXMLMAP_OUT.put("mails.doc:/root/@test",null);

class GenerateDocument_mails {

	java.util.Map<String,Object> valueMap = null;
	
	routines.system.DocumentGenerateOrderHelper orderHelper = new routines.system.DocumentGenerateOrderHelper(1);
	
	org.dom4j.Document doc = null;
	
	org.dom4j.Element root4Group = null;
	
	org.dom4j.io.OutputFormat format = null;
	
	java.util.List<java.util.List<String>> groupbyList = null;
	java.util.List<org.dom4j.Element> groupElementList = null;
	int order = 0;
	
	boolean isFirst = true;
	
	boolean	needRoot = true;
	
	String currentValue = null;

		org.dom4j.Element subTreeLoopParent0 = null;
		public boolean  subTreeLoop0 = false;
	
    public GenerateDocument_mails() {
//    	this.treeNodeAPI = treeNodeAPI;
    	
    	valueMap = new java.util.HashMap<String,Object>();
    	
    	groupbyList =  new java.util.ArrayList<java.util.List<String>>();
		groupElementList = new java.util.ArrayList<org.dom4j.Element>();
    	
    	doc = org.dom4j.DocumentHelper.createDocument();
    	format = org.dom4j.io.OutputFormat.createPrettyPrint();
    	format.setTrimText(false);
    }
    
    public org.dom4j.Document getDocument(){
    	return this.doc;
    }
    
	//We generate the TreeNode_API object only if there is a document in the main input table.
    void generateElements(boolean isInnerJoin, infoMailStruct infoMail, mailStruct mail, Var__tXMLMap_3_TXMLMAP_OUT__Struct Var
	) {
	
	
	/*if(this.treeNodeAPI==null) {
		this.treeNodeAPI = treeNodeAPI;
	}*/
	
	org.dom4j.Element subTreeRootParent = null;
// build root xml tree 
if (needRoot) {
	needRoot=false;
		org.dom4j.Element root = null;
				root = doc.addElement("root");
		subTreeRootParent = root;
				currentValue = null;
    			valueMap.put("root",infoMail.CODE_BARRE);
    			if(valueMap.get("root")!=null) {
    				currentValue = FormatterUtils.format(infoMail.CODE_BARRE,null);
    			} else {
    				currentValue = "";
    			}
				
    			routines.system.DocumentHelper.applyNamespace2Attribute(root,  null , "test", currentValue);
		org.dom4j.Element root_1 = null;
				root_1 = root.addElement("emails");
		subTreeRootParent = root_1;
					subTreeLoopParent0 = root_1;
		root4Group = subTreeRootParent;
	}else{
		subTreeRootParent=root4Group;
	}
	/* build group xml tree */
	boolean isNewElement = false;
		isNewElement = false;
		org.dom4j.Element loop = null;
				loop = org.dom4j.DocumentHelper.createElement("email");
				subTreeRootParent.elements().add(orderHelper.getInsertLocation(0,0),loop);
		subTreeRootParent = loop;
				currentValue = null;
    			valueMap.put("loop",(mail.MAIL != null)?((mail.PREF != null)?mail.PREF:"false"):null );
    			if(valueMap.get("loop")!=null) {
    				currentValue = FormatterUtils.format((mail.MAIL != null)?((mail.PREF != null)?mail.PREF:"false"):null ,null);
    			} else {
    				currentValue = "";
    			}
				
    			routines.system.DocumentHelper.applyNamespace2Attribute(loop,  null , "preferred", currentValue);
				currentValue = null;
    			valueMap.put("loop",(mail.MAIL != null)?context.sigb_external_desc:null );
    			if(valueMap.get("loop")!=null) {
    				currentValue = FormatterUtils.format((mail.MAIL != null)?context.sigb_external_desc:null ,null);
    			} else {
    				currentValue = "";
    			}
				
    			routines.system.DocumentHelper.applyNamespace2Attribute(loop,  null , "segment_type", currentValue);
		org.dom4j.Element loop_4 = null;
				loop_4 = loop.addElement("email_address");
		valueMap.put("loop_4",(mail.MAIL != null)?mail.MAIL:null);
		if(valueMap.get("loop_4")!=null) {
			routines.system.NestXMLTool.setText(loop_4, FormatterUtils.format((mail.MAIL != null)?mail.MAIL:null,null));
		}
		org.dom4j.Element loop_5 = null;
				loop_5 = loop.addElement("email_types");
		org.dom4j.Element loop_5_6 = null;
				loop_5_6 = loop_5.addElement("email_type");
		valueMap.put("loop_5_6",(mail.MAIL != null && !mail.MAIL.trim().isEmpty())?mail.TYPE:null );
		if(valueMap.get("loop_5_6")!=null) {
			routines.system.NestXMLTool.setText(loop_5_6, FormatterUtils.format((mail.MAIL != null && !mail.MAIL.trim().isEmpty())?mail.TYPE:null ,null));
		}
		}
    }

	GenerateDocument_mails gen_Doc_mails_tXMLMap_3_TXMLMAP_OUT = new GenerateDocument_mails();
	boolean docAlreadyInstanciate_mails = false;

	            
 



/**
 * [tXMLMap_3_TXMLMAP_OUT begin ] stop
 */



	
	/**
	 * [tOracleInput_3 begin ] start
	 */

	

	
		
		ok_Hash.put("tOracleInput_3", false);
		start_Hash.put("tOracleInput_3", System.currentTimeMillis());
		
	
	currentComponent="tOracleInput_3";

	
		int tos_count_tOracleInput_3 = 0;
		
    	class BytesLimit65535_tOracleInput_3{
    		public void limitLog4jByte() throws Exception{
    			
    		}
    	}
    	
        new BytesLimit65535_tOracleInput_3().limitLog4jByte();
	


	
		    int nb_line_tOracleInput_3 = 0;
		    java.sql.Connection conn_tOracleInput_3 = null;
		        conn_tOracleInput_3 = (java.sql.Connection)globalMap.get("conn_tOracleConnection_1");
				
				if(((oracle.jdbc.OracleConnection)conn_tOracleInput_3).getSessionTimeZone() == null){
					java.sql.Statement stmtGetTZ_tOracleInput_3 = conn_tOracleInput_3.createStatement();
					java.sql.ResultSet rsGetTZ_tOracleInput_3 = stmtGetTZ_tOracleInput_3.executeQuery("select sessiontimezone from dual");
					String sessionTimezone_tOracleInput_3 = java.util.TimeZone.getDefault().getID();
					while (rsGetTZ_tOracleInput_3.next()) {
						sessionTimezone_tOracleInput_3 = rsGetTZ_tOracleInput_3.getString(1);
					}
					((oracle.jdbc.OracleConnection)conn_tOracleInput_3).setSessionTimeZone(sessionTimezone_tOracleInput_3);
				}
			
		    
			java.sql.Statement stmt_tOracleInput_3 = conn_tOracleInput_3.createStatement();

		    String dbquery_tOracleInput_3 = "SELECT \n  "+context.oracle_schema+".V_SGBMP_INFOGENE.* \nFROM "+context.oracle_schema+".V_SGBMP_INFOGENE "

;
			

            	globalMap.put("tOracleInput_3_QUERY",dbquery_tOracleInput_3);
		    java.sql.ResultSet rs_tOracleInput_3 = null;

		    try {
		    	rs_tOracleInput_3 = stmt_tOracleInput_3.executeQuery(dbquery_tOracleInput_3);
		    	java.sql.ResultSetMetaData rsmd_tOracleInput_3 = rs_tOracleInput_3.getMetaData();
		    	int colQtyInRs_tOracleInput_3 = rsmd_tOracleInput_3.getColumnCount();

		    String tmpContent_tOracleInput_3 = null;
		    
		    
		    while (rs_tOracleInput_3.next()) {
		        nb_line_tOracleInput_3++;
		        
							if(colQtyInRs_tOracleInput_3 < 1) {
								infoMail.CODE_BARRE = null;
							} else {
	                         		
        	infoMail.CODE_BARRE = routines.system.JDBCUtil.getString(rs_tOracleInput_3, 1, false);
		                    }
							if(colQtyInRs_tOracleInput_3 < 2) {
								infoMail.NOM = null;
							} else {
	                         		
        	infoMail.NOM = routines.system.JDBCUtil.getString(rs_tOracleInput_3, 2, false);
		                    }
							if(colQtyInRs_tOracleInput_3 < 3) {
								infoMail.PRENOM = null;
							} else {
	                         		
        	infoMail.PRENOM = routines.system.JDBCUtil.getString(rs_tOracleInput_3, 3, false);
		                    }
							if(colQtyInRs_tOracleInput_3 < 4) {
								infoMail.GROUPE = null;
							} else {
	                         		
        	infoMail.GROUPE = routines.system.JDBCUtil.getString(rs_tOracleInput_3, 4, false);
		                    }
							if(colQtyInRs_tOracleInput_3 < 5) {
								infoMail.CAMPUS = null;
							} else {
	                         		
        	infoMail.CAMPUS = routines.system.JDBCUtil.getString(rs_tOracleInput_3, 5, false);
		                    }
							if(colQtyInRs_tOracleInput_3 < 6) {
								infoMail.LANGUE = null;
							} else {
	                         		
        	infoMail.LANGUE = routines.system.JDBCUtil.getString(rs_tOracleInput_3, 6, false);
		                    }
							if(colQtyInRs_tOracleInput_3 < 7) {
								infoMail.STATUT = null;
							} else {
	                         		
        	infoMail.STATUT = routines.system.JDBCUtil.getString(rs_tOracleInput_3, 7, false);
		                    }
							if(colQtyInRs_tOracleInput_3 < 8) {
								infoMail.DATE_NAISSANCE = null;
							} else {
										
			infoMail.DATE_NAISSANCE = routines.system.JDBCUtil.getDate(rs_tOracleInput_3, 8);
		                    }
							if(colQtyInRs_tOracleInput_3 < 9) {
								infoMail.DATE_MODIF = null;
							} else {
										
			infoMail.DATE_MODIF = routines.system.JDBCUtil.getDate(rs_tOracleInput_3, 9);
		                    }
							if(colQtyInRs_tOracleInput_3 < 10) {
								infoMail.DATE_EXPIRATION = null;
							} else {
										
			infoMail.DATE_EXPIRATION = routines.system.JDBCUtil.getDate(rs_tOracleInput_3, 10);
		                    }
							if(colQtyInRs_tOracleInput_3 < 11) {
								infoMail.DATE_ELIMINATION = null;
							} else {
										
			infoMail.DATE_ELIMINATION = routines.system.JDBCUtil.getDate(rs_tOracleInput_3, 11);
		                    }
							if(colQtyInRs_tOracleInput_3 < 12) {
								infoMail.EPPN = null;
							} else {
	                         		
        	infoMail.EPPN = routines.system.JDBCUtil.getString(rs_tOracleInput_3, 12, false);
		                    }
					




 



/**
 * [tOracleInput_3 begin ] stop
 */
	
	/**
	 * [tOracleInput_3 main ] start
	 */

	

	
	
	currentComponent="tOracleInput_3";

	

 


	tos_count_tOracleInput_3++;

/**
 * [tOracleInput_3 main ] stop
 */

	
	/**
	 * [tXMLMap_3_TXMLMAP_OUT main ] start
	 */

	

	
	
		currentVirtualComponent = "tXMLMap_3";
	
	currentComponent="tXMLMap_3_TXMLMAP_OUT";

	

			//infoMail
			//infoMail


			
				if(execStat){
					runStat.updateStatOnConnection("infoMail"+iterateId,1, 1);
				} 
			

		

	boolean rejectedInnerJoin_tXMLMap_3_TXMLMAP_OUT = false;
	boolean rejectedDocInnerJoin_tXMLMap_3_TXMLMAP_OUT = false;
	boolean mainRowRejected_tXMLMap_3_TXMLMAP_OUT = false;
	boolean isMatchDocRowtXMLMap_3_TXMLMAP_OUT = false;
	  
	
			
   
					mails_tmp.doc = null;
					
		
		


			

			
				///////////////////////////////////////////////
				//Starting Lookup Table "org.talend.designer.xmlmap.model.emf.xmlmap.impl.InputXmlTreeImpl@4ea7879 (expressionFilter: null, activateExpressionFilter: false, activateCondensedTool: false, minimized: false, name: mail, multiLoops: false) (lookup: true, matchingMode: UNIQUE_MATCH, lookupMode: LOAD_ONCE, innerJoin: false, persistent: false, activateGlobalMap: false)" 
				///////////////////////////////////////////////
				//tHash_Lookup_mail.initGet();
				
				
				
					boolean forceLoopmail = false;
					mailStruct mailObjectFromLookup = null;
					boolean hasResultFromLookupCachemail = false;
					java.util.Map<String,Object> cacheResultmail = new java.util.HashMap<String,Object>();
				
				
				
					   	mailHashKey.CODE_BARRE = infoMail.CODE_BARRE ;
						mailHashKey.hashCodeDirty = true;
						
					
					
						if(!rejectedInnerJoin_tXMLMap_3_TXMLMAP_OUT){//TD120
							
					
							
								
									tHash_Lookup_mail.lookup( mailHashKey );
								
							
							if(hasResultFromLookupCachemail  || tHash_Lookup_mail.hasNext()){
							
							} else {
								
									mail = mailDefault;
								
								
								
							}
						}//TD120
				   
				   		
				   
				   		mailStruct fromLookup_mail = null;
						mail = mailDefault;
				   
				   		
					    if(hasResultFromLookupCachemail) {//TD10086
					    	
					    } else if(!rejectedInnerJoin_tXMLMap_3_TXMLMAP_OUT) {
						  	
							while (tHash_Lookup_mail.hasNext()) {//TD119
								fromLookup_mail = null;
								mail = mailDefault;
								fromLookup_mail = tHash_Lookup_mail.next();
								if (fromLookup_mail != null) {
								
									mail = fromLookup_mail;
									
									
									
									
								}
							}//TD119
							
						  	
						  	
				  		}//TD10086
				  		
				  		
				  		
				  		//////////////////////////////////////////////////////////////////////////////////////////////
				  		
				  		/////////////////////////////////////////////////////////////////////////////////////////////////
				  		
					
				
{ // start of Var scope

	// ###############################
	// # Vars tables

Var__tXMLMap_3_TXMLMAP_OUT__Struct Var = Var__tXMLMap_3_TXMLMAP_OUT;
		// ###############################
		// # Output tables

mails = null;


// # Output table : 'mails'
mails_tmp.CODE_BARRE = mail.CODE_BARRE;

if((infoMail.CODE_BARRE)==null ||!infoMail.CODE_BARRE.equals(aggregateCacheMap_tXMLMap_3_TXMLMAP_OUT.get("mails.doc:/root/@test"))) {
gen_Doc_mails_tXMLMap_3_TXMLMAP_OUT = new GenerateDocument_mails();
//init one new out struct for cache the result.
mails_aggregate = new mailsStruct();
mails_aggregate.doc = new routines.system.Document();
mails_aggregate.doc.setDocument(gen_Doc_mails_tXMLMap_3_TXMLMAP_OUT.getDocument());

//construct the resultset
allOutsForAggregate_tXMLMap_3.add(mails_aggregate);
//store the previous value
aggregateCacheMap_tXMLMap_3_TXMLMAP_OUT.put("mails.doc:/root/@test", infoMail.CODE_BARRE);
}


gen_Doc_mails_tXMLMap_3_TXMLMAP_OUT.generateElements(rejectedDocInnerJoin_tXMLMap_3_TXMLMAP_OUT,infoMail,mail,Var);



if(mails_aggregate!=null){

mails_aggregate.CODE_BARRE = mails_tmp.CODE_BARRE;
}
// ###############################

} // end of Var scope

rejectedInnerJoin_tXMLMap_3_TXMLMAP_OUT = false;



 


	tos_count_tXMLMap_3_TXMLMAP_OUT++;

/**
 * [tXMLMap_3_TXMLMAP_OUT main ] stop
 */



	
	/**
	 * [tOracleInput_3 end ] start
	 */

	

	
	
	currentComponent="tOracleInput_3";

	

}
}finally{
stmt_tOracleInput_3.close();

}

globalMap.put("tOracleInput_3_NB_LINE",nb_line_tOracleInput_3);
 

ok_Hash.put("tOracleInput_3", true);
end_Hash.put("tOracleInput_3", System.currentTimeMillis());




/**
 * [tOracleInput_3 end ] stop
 */

	
	/**
	 * [tXMLMap_3_TXMLMAP_OUT end ] start
	 */

	

	
	
		currentVirtualComponent = "tXMLMap_3";
	
	currentComponent="tXMLMap_3_TXMLMAP_OUT";

	




			if(execStat){
				if(resourceMap.get("inIterateVComp") == null || !((Boolean)resourceMap.get("inIterateVComp"))){
			 		runStat.updateStatOnConnection("infoMail"+iterateId,2, 0); 
			 	}
			}
		
 

ok_Hash.put("tXMLMap_3_TXMLMAP_OUT", true);
end_Hash.put("tXMLMap_3_TXMLMAP_OUT", System.currentTimeMillis());




/**
 * [tXMLMap_3_TXMLMAP_OUT end ] stop
 */



	
	/**
	 * [tAdvancedHash_email begin ] start
	 */

	

	
		
		ok_Hash.put("tAdvancedHash_email", false);
		start_Hash.put("tAdvancedHash_email", System.currentTimeMillis());
		
	
	currentComponent="tAdvancedHash_email";

	
			if (execStat) {
				if(resourceMap.get("inIterateVComp") == null){
					
						runStat.updateStatOnConnection("email" + iterateId, 0, 0);
					
				}
			} 

		
		int tos_count_tAdvancedHash_email = 0;
		
    	class BytesLimit65535_tAdvancedHash_email{
    		public void limitLog4jByte() throws Exception{
    			
    		}
    	}
    	
        new BytesLimit65535_tAdvancedHash_email().limitLog4jByte();

			   		// connection name:email
			   		// source node:tExtractXMLField_3 - inputs:(mails) outputs:(email,email) | target node:tAdvancedHash_email - inputs:(email) outputs:()
			   		// linked node: tMap_1 - inputs:(infos,adress,email,phone,statistique) outputs:(out1)
			   
			   		org.talend.designer.components.lookup.common.ICommonLookup.MATCHING_MODE matchingModeEnum_email = 
			   			org.talend.designer.components.lookup.common.ICommonLookup.MATCHING_MODE.UNIQUE_MATCH;
			   			
			   
	   			org.talend.designer.components.lookup.memory.AdvancedMemoryLookup<emailStruct> tHash_Lookup_email =org.talend.designer.components.lookup.memory.AdvancedMemoryLookup.
	   						<emailStruct>getLookup(matchingModeEnum_email);
	   						   
		   	   	   globalMap.put("tHash_Lookup_email", tHash_Lookup_email);
		   	   	   
				
           

 



/**
 * [tAdvancedHash_email begin ] stop
 */



	
	/**
	 * [tExtractXMLField_3 begin ] start
	 */

	

	
		
		ok_Hash.put("tExtractXMLField_3", false);
		start_Hash.put("tExtractXMLField_3", System.currentTimeMillis());
		
	
	currentComponent="tExtractXMLField_3";

	
			if (execStat) {
				if(resourceMap.get("inIterateVComp") == null){
					
						runStat.updateStatOnConnection("mails" + iterateId, 0, 0);
					
				}
			} 

		
		int tos_count_tExtractXMLField_3 = 0;
		
    	class BytesLimit65535_tExtractXMLField_3{
    		public void limitLog4jByte() throws Exception{
    			
    		}
    	}
    	
        new BytesLimit65535_tExtractXMLField_3().limitLog4jByte();

int nb_line_tExtractXMLField_3 = 0;

class NameSpaceTool_tExtractXMLField_3 {

    public java.util.HashMap<String, String> xmlNameSpaceMap = new java.util.HashMap<String, String>();
    
	private java.util.List<String> defualtNSPath = new java.util.ArrayList<String>();

    public void countNSMap(org.dom4j.Element el) {
        for (org.dom4j.Namespace ns : (java.util.List<org.dom4j.Namespace>) el.declaredNamespaces()) {
            if (ns.getPrefix().trim().length() == 0) {
                xmlNameSpaceMap.put("pre"+defualtNSPath.size(), ns.getURI());
                String path = "";
                org.dom4j.Element elTmp = el;
                while (elTmp != null) {
                   	if (elTmp.getNamespacePrefix() != null && elTmp.getNamespacePrefix().length() > 0) {
                        path = "/" + elTmp.getNamespacePrefix() + ":" + elTmp.getName() + path;
                    } else {
                        path = "/" + elTmp.getName() + path;
                    }
                    elTmp = elTmp.getParent();
                }
                defualtNSPath.add(path);
            } else {
                xmlNameSpaceMap.put(ns.getPrefix(), ns.getURI());
            }

        }
        for (org.dom4j.Element e : (java.util.List<org.dom4j.Element>) el.elements()) {
            countNSMap(e);
        }
    }
    
    /**
	 *	the regex for the xpath like that : 
	 *	case 1 : functionA(locationXPathExpression) 
	 *	case 2 : fn:functionA(locationXPathExpression) 
	 *	case 3 : functionA(functionB(locationXPathExpression))
	 *	case 4 : fn:functionA(fn:functionB(locationXPathExpression))
	 *	and like that.
	*/
	private java.util.regex.Pattern simpleFunctionPattern;
	private StringBuffer stringBuffer;
	private java.util.Map<String,String> resultCache;
	
	public String addDefaultNSPrefix(final String xpathExpression, String loopPath) {
	    if (defualtNSPath.size() < 1) {
        	return xpathExpression;
    	}
    	
    	if(resultCache == null) {
    		resultCache = new java.util.HashMap<String,String>();
    	}
    	
    	String resultXpathExpression = resultCache.get(xpathExpression);
		if(resultXpathExpression!=null) {
    		return resultXpathExpression;
    	}
    	
    	String locationPathExpression = xpathExpression;
    	
    	if(simpleFunctionPattern == null) {
    		simpleFunctionPattern = java.util.regex.Pattern.compile("([a-zA-z0-9]+:)?[a-zA-Z]+-?[A-Za-z]+\\(.*\\)");
    	}
    	
    	boolean isSimpleFunctionXPath = simpleFunctionPattern.matcher(xpathExpression).matches();
    	String tail = null;
    	if(isSimpleFunctionXPath) {
			int start = xpathExpression.lastIndexOf('(');
			int end = xpathExpression.indexOf(')');
			if(start < end) {
			    if(stringBuffer == null) {
    				stringBuffer = new StringBuffer();
    			}
				locationPathExpression = xpathExpression.substring(start+1,end);
				stringBuffer.append(xpathExpression.substring(0,start+1));
				tail = xpathExpression.substring(end);
			} else {
				isSimpleFunctionXPath = false;
			}
    	}
    	
    	locationPathExpression = addDefaultNSPrefixForLocationXPathExpression(locationPathExpression,loopPath);
    	
    	resultXpathExpression = locationPathExpression;
    	
    	if(isSimpleFunctionXPath) {
        	stringBuffer.append(locationPathExpression);
    		stringBuffer.append(tail);
    		resultXpathExpression = stringBuffer.toString();
    		stringBuffer.setLength(0);
        }
    	
    	resultCache.put(xpathExpression,resultXpathExpression);
    	return resultXpathExpression;
	}
	
    private String addDefaultNSPrefixForLocationXPathExpression(String path, String loopPath) {
    	String fullPath = loopPath;
    	if(!path.equals(fullPath)){
        	for (String tmp : path.split("/")) {
        		if (("..").equals(tmp)) {
                    fullPath = fullPath.substring(0, fullPath.lastIndexOf("/"));
                } else {
                    fullPath += "/" + tmp;
                }
        	}
        }
    	int[] indexs = new int[fullPath.split("/").length - 1];
        java.util.Arrays.fill(indexs, -1);
        int length = 0;
        for (int i = 0; i < defualtNSPath.size(); i++) {
            if (defualtNSPath.get(i).length() > length && fullPath.startsWith(defualtNSPath.get(i))) {
                java.util.Arrays.fill(indexs, defualtNSPath.get(i).split("/").length - 2, indexs.length, i);
                length = defualtNSPath.get(i).length();
            }
        }
    
        StringBuilder newPath = new StringBuilder();
        String[] pathStrs = path.split("/");
        for (int i = 0; i < pathStrs.length; i++) {
            String tmp = pathStrs[i];
            if (newPath.length() > 0) {
                newPath.append("/");
            }
            if (tmp.length() > 0 && tmp.indexOf(":") == -1 && tmp.indexOf(".") == -1 /*&& tmp.indexOf("@") == -1*/) {
                int index = indexs[i + indexs.length - pathStrs.length];
                if (index >= 0) {
                	//==== add by wliu to support both filter and functions==
    				if(tmp.indexOf("[")>0 && tmp.indexOf("]")>tmp.indexOf("[")){//include filter
    					String tmpStr=replaceElementWithNS(tmp,"pre"+index+":");
    					newPath.append(tmpStr);
    				}else{
    					if(tmp.indexOf("@") != -1 || tmp.indexOf("(")<tmp.indexOf(")")){  // include attribute
    						newPath.append(tmp);
    					}else{
    				//==add end=======	
                    		newPath.append("pre").append(index).append(":").append(tmp);
                    	}
                    }                    
                } else {
                    newPath.append(tmp);
                }
            } else {
                newPath.append(tmp);
            }
        }
        return newPath.toString();
    }
    
	private String matches = "@*\\b[a-z|A-Z|_]+[[-]*\\w]*\\b[^'|^\\(]";
    private java.util.regex.Pattern pattern = java.util.regex.Pattern.compile(matches);
    
	private String replaceElementWithNS(String global, String pre){

        java.util.regex.Matcher match = pattern.matcher(global);
        StringBuffer sb = new StringBuffer();
        match.reset();
        while (match.find()) {
            String group = match.group();
            String tmp = "";
            if (group.toLowerCase().matches("\\b(div|mod|and|or)\\b.*") || group.matches("@.*")) {
                tmp = group;
            } else {
                tmp = tmp + pre + group;
            }
            match.appendReplacement(sb, tmp);
        }
        match.appendTail(sb);
        
        return sb.toString();
	}
	
}

class XML_API_tExtractXMLField_3{
	public boolean isDefNull(org.dom4j.Node node) throws javax.xml.transform.TransformerException {
        if (node != null && node instanceof org.dom4j.Element) {
        	org.dom4j.Attribute attri = ((org.dom4j.Element)node).attribute("nil");
        	if(attri != null && ("true").equals(attri.getText())){
            	return true;
            }
        }
        return false;
    }

    public boolean isMissing(org.dom4j.Node node) throws javax.xml.transform.TransformerException {
        return node == null ? true : false;
    }

    public boolean isEmpty(org.dom4j.Node node) throws javax.xml.transform.TransformerException {
        if (node != null) {
            return node.getText().length() == 0;
        }
        return false;
    }
}

XML_API_tExtractXMLField_3 xml_api_tExtractXMLField_3 = new XML_API_tExtractXMLField_3();
 



/**
 * [tExtractXMLField_3 begin ] stop
 */



	
	/**
	 * [tXMLMap_3_TXMLMAP_IN begin ] start
	 */

	

	
		
		ok_Hash.put("tXMLMap_3_TXMLMAP_IN", false);
		start_Hash.put("tXMLMap_3_TXMLMAP_IN", System.currentTimeMillis());
		
	
		currentVirtualComponent = "tXMLMap_3";
	
	currentComponent="tXMLMap_3_TXMLMAP_IN";

	
		int tos_count_tXMLMap_3_TXMLMAP_IN = 0;
		
    	class BytesLimit65535_tXMLMap_3_TXMLMAP_IN{
    		public void limitLog4jByte() throws Exception{
    			
    		}
    	}
    	
        new BytesLimit65535_tXMLMap_3_TXMLMAP_IN().limitLog4jByte();
java.util.List<Object> outs_tXMLMap_3 = (java.util.List<Object>)globalMap.get("allOutsForAggregate_tXMLMap_3");
for(Object  row_out_tXMLMap_3_TXMLMAP_IN : outs_tXMLMap_3) {//TD512
 



/**
 * [tXMLMap_3_TXMLMAP_IN begin ] stop
 */
	
	/**
	 * [tXMLMap_3_TXMLMAP_IN main ] start
	 */

	

	
	
		currentVirtualComponent = "tXMLMap_3";
	
	currentComponent="tXMLMap_3_TXMLMAP_IN";

	

	mails = null;
	if(row_out_tXMLMap_3_TXMLMAP_IN!=null && row_out_tXMLMap_3_TXMLMAP_IN instanceof mailsStruct) {
		mails = (mailsStruct)row_out_tXMLMap_3_TXMLMAP_IN;
			routines.system.NestXMLTool.generateOk(mails.doc, false);		
	}
 


	tos_count_tXMLMap_3_TXMLMAP_IN++;

/**
 * [tXMLMap_3_TXMLMAP_IN main ] stop
 */
// Start of branch "mails"
if(mails != null) { 



	
	/**
	 * [tExtractXMLField_3 main ] start
	 */

	

	
	
	currentComponent="tExtractXMLField_3";

	

			//mails
			//mails


			
				if(execStat){
					runStat.updateStatOnConnection("mails"+iterateId,1, 1);
				} 
			

		

	String xmlStr_tExtractXMLField_3 = null;
	routines.system.Document xmlDocument_tExtractXMLField_3 = null;
	if(mails.doc!=null){
				xmlDocument_tExtractXMLField_3 = mails.doc;
	}
			if(xmlDocument_tExtractXMLField_3!=null && xmlDocument_tExtractXMLField_3.getDocument()!=null){// C_01
email = null;
email = null;
	NameSpaceTool_tExtractXMLField_3 nsTool_tExtractXMLField_3 = new NameSpaceTool_tExtractXMLField_3();
    org.dom4j.io.SAXReader reader_tExtractXMLField_3 = new org.dom4j.io.SAXReader();
	
    org.dom4j.Document doc_tExtractXMLField_3 = null;
    java.util.HashMap xmlNameSpaceMap_tExtractXMLField_3 = null;
    org.dom4j.XPath x_tExtractXMLField_3 = null;
    java.util.List<org.dom4j.tree.AbstractNode> nodeList_tExtractXMLField_3 = null;
		String loopQuery_tExtractXMLField_3 = "/root"; 
	
    boolean isStructError_tExtractXMLField_3= true;
        
    try{
		
	    	doc_tExtractXMLField_3= xmlDocument_tExtractXMLField_3.getDocument();
	    
	    nsTool_tExtractXMLField_3.countNSMap(doc_tExtractXMLField_3.getRootElement());
	    xmlNameSpaceMap_tExtractXMLField_3 = nsTool_tExtractXMLField_3.xmlNameSpaceMap;

    	x_tExtractXMLField_3 = doc_tExtractXMLField_3.createXPath(nsTool_tExtractXMLField_3.addDefaultNSPrefix(loopQuery_tExtractXMLField_3,loopQuery_tExtractXMLField_3));
      
    	x_tExtractXMLField_3.setNamespaceURIs(xmlNameSpaceMap_tExtractXMLField_3); 
    
		 
    	nodeList_tExtractXMLField_3 = (java.util.List<org.dom4j.tree.AbstractNode>)x_tExtractXMLField_3.selectNodes(doc_tExtractXMLField_3);
    	
    	isStructError_tExtractXMLField_3 = false;
    	
    }catch(java.lang.Exception ex_tExtractXMLField_3){
    System.err.println(ex_tExtractXMLField_3.getMessage());
    }
    
    org.dom4j.Node node_tExtractXMLField_3 = null;
    String str_tExtractXMLField_3 = "";
    boolean resultIsNode_tExtractXMLField_3 = true;
    for(int i_tExtractXMLField_3=0; isStructError_tExtractXMLField_3 || (nodeList_tExtractXMLField_3!=null && i_tExtractXMLField_3 < nodeList_tExtractXMLField_3.size());i_tExtractXMLField_3++){
    	
    	if(!isStructError_tExtractXMLField_3){
			email = null;
			email = null;
    		email = new emailStruct();
    	
    		org.dom4j.tree.AbstractNode temp_tExtractXMLField_3 = nodeList_tExtractXMLField_3.get(i_tExtractXMLField_3);
	
	    	nb_line_tExtractXMLField_3++;	
			try{
			email.CODE_BARRE = mails.CODE_BARRE;
				org.dom4j.XPath xTmp1_tExtractXMLField_3 = temp_tExtractXMLField_3.createXPath(nsTool_tExtractXMLField_3.addDefaultNSPrefix("emails",loopQuery_tExtractXMLField_3));
			    xTmp1_tExtractXMLField_3.setNamespaceURIs(xmlNameSpaceMap_tExtractXMLField_3);
				
			    Object obj1_tExtractXMLField_3 = xTmp1_tExtractXMLField_3.evaluate(temp_tExtractXMLField_3);
			    if(obj1_tExtractXMLField_3 instanceof String || obj1_tExtractXMLField_3 instanceof Number){
			    	resultIsNode_tExtractXMLField_3 = false;
    				str_tExtractXMLField_3 = String.valueOf(obj1_tExtractXMLField_3);
   				}else{
   					resultIsNode_tExtractXMLField_3 = true;
				    node_tExtractXMLField_3 = xTmp1_tExtractXMLField_3.selectSingleNode(temp_tExtractXMLField_3);
					str_tExtractXMLField_3 = node_tExtractXMLField_3==null?null:node_tExtractXMLField_3.asXML();
				}
									email.doc = ParserUtils.parseTo_Document(str_tExtractXMLField_3);
}catch(java.lang.Exception ex_tExtractXMLField_3){
    System.err.println(ex_tExtractXMLField_3.getMessage());
    email = null;
    	}
    }
    
    isStructError_tExtractXMLField_3 = false;


   globalMap.put("tExtractXMLField_3_NB_LINE", nb_line_tExtractXMLField_3);

 


	tos_count_tExtractXMLField_3++;

/**
 * [tExtractXMLField_3 main ] stop
 */
// Start of branch "email"
if(email != null) { 



	
	/**
	 * [tAdvancedHash_email main ] start
	 */

	

	
	
	currentComponent="tAdvancedHash_email";

	

			//email
			//email


			
				if(execStat){
					runStat.updateStatOnConnection("email"+iterateId,1, 1);
				} 
			

		


			   
			   

					emailStruct email_HashRow = new emailStruct();
		   	   	   
				
				email_HashRow.CODE_BARRE = email.CODE_BARRE;
				
				email_HashRow.doc = email.doc;
				
			tHash_Lookup_email.put(email_HashRow);
			
            




 


	tos_count_tAdvancedHash_email++;

/**
 * [tAdvancedHash_email main ] stop
 */

} // End of branch "email"

		// end for
	}


	
		} // C_01
	

} // End of branch "mails"




	
	/**
	 * [tXMLMap_3_TXMLMAP_IN end ] start
	 */

	

	
	
		currentVirtualComponent = "tXMLMap_3";
	
	currentComponent="tXMLMap_3_TXMLMAP_IN";

	

}//TD512
 

ok_Hash.put("tXMLMap_3_TXMLMAP_IN", true);
end_Hash.put("tXMLMap_3_TXMLMAP_IN", System.currentTimeMillis());




/**
 * [tXMLMap_3_TXMLMAP_IN end ] stop
 */

	
	/**
	 * [tExtractXMLField_3 end ] start
	 */

	

	
	
	currentComponent="tExtractXMLField_3";

	



globalMap.put("tExtractXMLField_3_NB_LINE", nb_line_tExtractXMLField_3);

			if(execStat){
				if(resourceMap.get("inIterateVComp") == null || !((Boolean)resourceMap.get("inIterateVComp"))){
			 		runStat.updateStatOnConnection("mails"+iterateId,2, 0); 
			 	}
			}
		
 

ok_Hash.put("tExtractXMLField_3", true);
end_Hash.put("tExtractXMLField_3", System.currentTimeMillis());




/**
 * [tExtractXMLField_3 end ] stop
 */

	
	/**
	 * [tAdvancedHash_email end ] start
	 */

	

	
	
	currentComponent="tAdvancedHash_email";

	

tHash_Lookup_email.endPut();

			if(execStat){
				if(resourceMap.get("inIterateVComp") == null || !((Boolean)resourceMap.get("inIterateVComp"))){
			 		runStat.updateStatOnConnection("email"+iterateId,2, 0); 
			 	}
			}
		
 

ok_Hash.put("tAdvancedHash_email", true);
end_Hash.put("tAdvancedHash_email", System.currentTimeMillis());




/**
 * [tAdvancedHash_email end ] stop
 */












				}//end the resume

				



	
			}catch(java.lang.Exception e){	
				
				TalendException te = new TalendException(e, currentComponent, globalMap);
				
					te.setVirtualComponentName(currentVirtualComponent);
				
				throw te;
			}catch(java.lang.Error error){	
				
					runStat.stopThreadStat();
				
				throw error;
			}finally{
				
				try{
					
	
	/**
	 * [tOracleInput_3 finally ] start
	 */

	

	
	
	currentComponent="tOracleInput_3";

	

 



/**
 * [tOracleInput_3 finally ] stop
 */

	
	/**
	 * [tXMLMap_3_TXMLMAP_OUT finally ] start
	 */

	

	
	
		currentVirtualComponent = "tXMLMap_3";
	
	currentComponent="tXMLMap_3_TXMLMAP_OUT";

	

 



/**
 * [tXMLMap_3_TXMLMAP_OUT finally ] stop
 */

	
	/**
	 * [tXMLMap_3_TXMLMAP_IN finally ] start
	 */

	

	
	
		currentVirtualComponent = "tXMLMap_3";
	
	currentComponent="tXMLMap_3_TXMLMAP_IN";

	

 



/**
 * [tXMLMap_3_TXMLMAP_IN finally ] stop
 */

	
	/**
	 * [tExtractXMLField_3 finally ] start
	 */

	

	
	
	currentComponent="tExtractXMLField_3";

	

 



/**
 * [tExtractXMLField_3 finally ] stop
 */

	
	/**
	 * [tAdvancedHash_email finally ] start
	 */

	

	
	
	currentComponent="tAdvancedHash_email";

	

 



/**
 * [tAdvancedHash_email finally ] stop
 */












				}catch(java.lang.Exception e){	
					//ignore
				}catch(java.lang.Error error){
					//ignore
				}
				resourceMap = null;
			}
		

		globalMap.put("tOracleInput_3_SUBPROCESS_STATE", 1);
	}
	


public static class mailStruct implements routines.system.IPersistableComparableLookupRow<mailStruct> {
    final static byte[] commonByteArrayLock_LDAP_sgbm_export = new byte[0];
    static byte[] commonByteArray_LDAP_sgbm_export = new byte[0];
	protected static final int DEFAULT_HASHCODE = 1;
    protected static final int PRIME = 31;
    protected int hashCode = DEFAULT_HASHCODE;
    public boolean hashCodeDirty = true;

    public String loopKey;



	
			    public String CODE_BARRE;

				public String getCODE_BARRE () {
					return this.CODE_BARRE;
				}
				
			    public String TYPE;

				public String getTYPE () {
					return this.TYPE;
				}
				
			    public String MAIL;

				public String getMAIL () {
					return this.MAIL;
				}
				
			    public String PREF;

				public String getPREF () {
					return this.PREF;
				}
				


	@Override
	public int hashCode() {
		if (this.hashCodeDirty) {
			final int prime = PRIME;
			int result = DEFAULT_HASHCODE;
	
						result = prime * result + ((this.CODE_BARRE == null) ? 0 : this.CODE_BARRE.hashCode());
					
    		this.hashCode = result;
    		this.hashCodeDirty = false;
		}
		return this.hashCode;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj) return true;
		if (obj == null) return false;
		if (getClass() != obj.getClass()) return false;
		final mailStruct other = (mailStruct) obj;
		
						if (this.CODE_BARRE == null) {
							if (other.CODE_BARRE != null)
								return false;
						
						} else if (!this.CODE_BARRE.equals(other.CODE_BARRE))
						
							return false;
					

		return true;
    }

	public void copyDataTo(mailStruct other) {

		other.CODE_BARRE = this.CODE_BARRE;
	            other.TYPE = this.TYPE;
	            other.MAIL = this.MAIL;
	            other.PREF = this.PREF;
	            
	}

	public void copyKeysDataTo(mailStruct other) {

		other.CODE_BARRE = this.CODE_BARRE;
	            	
	}




	private String readString(ObjectInputStream dis) throws IOException{
		String strReturn = null;
		int length = 0;
        length = dis.readInt();
		if (length == -1) {
			strReturn = null;
		} else {
			if(length > commonByteArray_LDAP_sgbm_export.length) {
				if(length < 1024 && commonByteArray_LDAP_sgbm_export.length == 0) {
   					commonByteArray_LDAP_sgbm_export = new byte[1024];
				} else {
   					commonByteArray_LDAP_sgbm_export = new byte[2 * length];
   				}
			}
			dis.readFully(commonByteArray_LDAP_sgbm_export, 0, length);
			strReturn = new String(commonByteArray_LDAP_sgbm_export, 0, length, utf8Charset);
		}
		return strReturn;
	}

    private void writeString(String str, ObjectOutputStream dos) throws IOException{
		if(str == null) {
            dos.writeInt(-1);
		} else {
            byte[] byteArray = str.getBytes(utf8Charset);
	    	dos.writeInt(byteArray.length);
			dos.write(byteArray);
    	}
    }

	private String readString(DataInputStream dis, ObjectInputStream ois) throws IOException{
		String strReturn = null;
		int length = 0;
        length = dis.readInt();
		if (length == -1) {
			strReturn = null;
		} else {
			byte[] byteArray = new byte[length];
			dis.read(byteArray);
			strReturn = new String(byteArray, utf8Charset);
		}
		return strReturn;
	}

	private void writeString(String str, DataOutputStream dos, ObjectOutputStream oos) throws IOException{
		if(str == null) {
            dos.writeInt(-1);
		} else {
            byte[] byteArray = str.getBytes(utf8Charset);
	    	dos.writeInt(byteArray.length);
			dos.write(byteArray);
    	}
	}

    public void readKeysData(ObjectInputStream dis) {

		synchronized(commonByteArrayLock_LDAP_sgbm_export) {

        	try {

        		int length = 0;
		
					this.CODE_BARRE = readString(dis);
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);

		

        }

		

      }


    }

    public void writeKeysData(ObjectOutputStream dos) {
        try {

		
					// String
				
						writeString(this.CODE_BARRE,dos);
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);
        }


    }



    /**
     * Fill Values data by reading ObjectInputStream.
     */
    public void readValuesData(DataInputStream dis, ObjectInputStream ois) {
        try {

			int length = 0;
		
						this.TYPE = readString(dis,ois);
					
						this.MAIL = readString(dis,ois);
					
						this.PREF = readString(dis,ois);
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);

		

        }

		

    }

    /**
     * Return a byte array which represents Values data.
     */
    public void writeValuesData(DataOutputStream dos, ObjectOutputStream oos) {
        try {

		
						writeString(this.TYPE, dos, oos);
					
						writeString(this.MAIL, dos, oos);
					
						writeString(this.PREF, dos, oos);
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);
        	}

    }


    public String toString() {

		StringBuilder sb = new StringBuilder();
		sb.append(super.toString());
		sb.append("[");
		sb.append("CODE_BARRE="+CODE_BARRE);
		sb.append(",TYPE="+TYPE);
		sb.append(",MAIL="+MAIL);
		sb.append(",PREF="+PREF);
	    sb.append("]");

	    return sb.toString();
    }

    /**
     * Compare keys
     */
    public int compareTo(mailStruct other) {

		int returnValue = -1;
		
						returnValue = checkNullsAndCompare(this.CODE_BARRE, other.CODE_BARRE);
						if(returnValue != 0) {
							return returnValue;
						}

					
	    return returnValue;
    }


    private int checkNullsAndCompare(Object object1, Object object2) {
        int returnValue = 0;
		if (object1 instanceof Comparable && object2 instanceof Comparable) {
            returnValue = ((Comparable) object1).compareTo(object2);
        } else if (object1 != null && object2 != null) {
            returnValue = compareStrings(object1.toString(), object2.toString());
        } else if (object1 == null && object2 != null) {
            returnValue = 1;
        } else if (object1 != null && object2 == null) {
            returnValue = -1;
        } else {
            returnValue = 0;
        }

        return returnValue;
    }

    private int compareStrings(String string1, String string2) {
        return string1.compareTo(string2);
    }


}
public void tOracleInput_4Process(final java.util.Map<String, Object> globalMap) throws TalendException {
	globalMap.put("tOracleInput_4_SUBPROCESS_STATE", 0);

 final boolean execStat = this.execStat;
	
		String iterateId = "";
	
	
	String currentComponent = "";
	java.util.Map<String, Object> resourceMap = new java.util.HashMap<String, Object>();

	try {

			String currentMethodName = new java.lang.Exception().getStackTrace()[0].getMethodName();
			boolean resumeIt = currentMethodName.equals(resumeEntryMethodName);
			if( resumeEntryMethodName == null || resumeIt || globalResumeTicket){//start the resume
				globalResumeTicket = true;



		mailStruct mail = new mailStruct();




	
	/**
	 * [tAdvancedXMLMapHash_mail begin ] start
	 */

	

	
		
		ok_Hash.put("tAdvancedXMLMapHash_mail", false);
		start_Hash.put("tAdvancedXMLMapHash_mail", System.currentTimeMillis());
		
	
	currentComponent="tAdvancedXMLMapHash_mail";

	
			if (execStat) {
				if(resourceMap.get("inIterateVComp") == null){
					
						runStat.updateStatOnConnection("mail" + iterateId, 0, 0);
					
				}
			} 

		
		int tos_count_tAdvancedXMLMapHash_mail = 0;
		
    	class BytesLimit65535_tAdvancedXMLMapHash_mail{
    		public void limitLog4jByte() throws Exception{
    			
    		}
    	}
    	
        new BytesLimit65535_tAdvancedXMLMapHash_mail().limitLog4jByte();

			   		// connection name:mail
			   		// source node:tOracleInput_4 - inputs:(after_tOracleInput_3) outputs:(mail,mail) | target node:tAdvancedXMLMapHash_mail - inputs:(mail) outputs:()
			   		// linked node: tXMLMap_3 - inputs:(infoMail,mail) outputs:(mails)
			   
			   		org.talend.designer.components.lookup.common.ICommonLookup.MATCHING_MODE matchingModeEnum_mail = 
			   			org.talend.designer.components.lookup.common.ICommonLookup.MATCHING_MODE.UNIQUE_MATCH;
			   
			   
	   				org.talend.designer.components.lookup.memory.AdvancedMemoryLookup<mailStruct> tHash_Lookup_mail = 
	   					org.talend.designer.components.lookup.memory.AdvancedMemoryLookup.
	   						<mailStruct>getLookup(matchingModeEnum_mail);

		   	   	   globalMap.put("tHash_Lookup_mail", tHash_Lookup_mail);
		   	   	   
				
            

 



/**
 * [tAdvancedXMLMapHash_mail begin ] stop
 */



	
	/**
	 * [tOracleInput_4 begin ] start
	 */

	

	
		
		ok_Hash.put("tOracleInput_4", false);
		start_Hash.put("tOracleInput_4", System.currentTimeMillis());
		
	
	currentComponent="tOracleInput_4";

	
		int tos_count_tOracleInput_4 = 0;
		
    	class BytesLimit65535_tOracleInput_4{
    		public void limitLog4jByte() throws Exception{
    			
    		}
    	}
    	
        new BytesLimit65535_tOracleInput_4().limitLog4jByte();
	


	
		    int nb_line_tOracleInput_4 = 0;
		    java.sql.Connection conn_tOracleInput_4 = null;
		        conn_tOracleInput_4 = (java.sql.Connection)globalMap.get("conn_tOracleConnection_1");
				
				if(((oracle.jdbc.OracleConnection)conn_tOracleInput_4).getSessionTimeZone() == null){
					java.sql.Statement stmtGetTZ_tOracleInput_4 = conn_tOracleInput_4.createStatement();
					java.sql.ResultSet rsGetTZ_tOracleInput_4 = stmtGetTZ_tOracleInput_4.executeQuery("select sessiontimezone from dual");
					String sessionTimezone_tOracleInput_4 = java.util.TimeZone.getDefault().getID();
					while (rsGetTZ_tOracleInput_4.next()) {
						sessionTimezone_tOracleInput_4 = rsGetTZ_tOracleInput_4.getString(1);
					}
					((oracle.jdbc.OracleConnection)conn_tOracleInput_4).setSessionTimeZone(sessionTimezone_tOracleInput_4);
				}
			
		    
			java.sql.Statement stmt_tOracleInput_4 = conn_tOracleInput_4.createStatement();

		    String dbquery_tOracleInput_4 = "SELECT \n  "+context.oracle_schema+".V_SGBMP_MAIL.*\nFROM "+context.oracle_schema+".V_SGBMP_MAIL";
			

            	globalMap.put("tOracleInput_4_QUERY",dbquery_tOracleInput_4);
		    java.sql.ResultSet rs_tOracleInput_4 = null;

		    try {
		    	rs_tOracleInput_4 = stmt_tOracleInput_4.executeQuery(dbquery_tOracleInput_4);
		    	java.sql.ResultSetMetaData rsmd_tOracleInput_4 = rs_tOracleInput_4.getMetaData();
		    	int colQtyInRs_tOracleInput_4 = rsmd_tOracleInput_4.getColumnCount();

		    String tmpContent_tOracleInput_4 = null;
		    
		    
		    while (rs_tOracleInput_4.next()) {
		        nb_line_tOracleInput_4++;
		        
							if(colQtyInRs_tOracleInput_4 < 1) {
								mail.CODE_BARRE = null;
							} else {
	                         		
        	mail.CODE_BARRE = routines.system.JDBCUtil.getString(rs_tOracleInput_4, 1, false);
		                    }
							if(colQtyInRs_tOracleInput_4 < 2) {
								mail.TYPE = null;
							} else {
	                         		
        	mail.TYPE = routines.system.JDBCUtil.getString(rs_tOracleInput_4, 2, false);
		                    }
							if(colQtyInRs_tOracleInput_4 < 3) {
								mail.MAIL = null;
							} else {
	                         		
        	mail.MAIL = routines.system.JDBCUtil.getString(rs_tOracleInput_4, 3, false);
		                    }
							if(colQtyInRs_tOracleInput_4 < 4) {
								mail.PREF = null;
							} else {
	                         		
        	mail.PREF = routines.system.JDBCUtil.getString(rs_tOracleInput_4, 4, false);
		                    }
					




 



/**
 * [tOracleInput_4 begin ] stop
 */
	
	/**
	 * [tOracleInput_4 main ] start
	 */

	

	
	
	currentComponent="tOracleInput_4";

	

 


	tos_count_tOracleInput_4++;

/**
 * [tOracleInput_4 main ] stop
 */

	
	/**
	 * [tAdvancedXMLMapHash_mail main ] start
	 */

	

	
	
	currentComponent="tAdvancedXMLMapHash_mail";

	

			//mail
			//mail


			
				if(execStat){
					runStat.updateStatOnConnection("mail"+iterateId,1, 1);
				} 
			

		


			   
			   

					mailStruct mail_HashRow = new mailStruct();
					
				
					mail_HashRow.CODE_BARRE = mail.CODE_BARRE;
					
					mail_HashRow.TYPE = mail.TYPE;
					
					mail_HashRow.MAIL = mail.MAIL;
					
					mail_HashRow.PREF = mail.PREF;
					
					tHash_Lookup_mail.put(mail_HashRow);
				
            




 


	tos_count_tAdvancedXMLMapHash_mail++;

/**
 * [tAdvancedXMLMapHash_mail main ] stop
 */



	
	/**
	 * [tOracleInput_4 end ] start
	 */

	

	
	
	currentComponent="tOracleInput_4";

	

}
}finally{
stmt_tOracleInput_4.close();

}

globalMap.put("tOracleInput_4_NB_LINE",nb_line_tOracleInput_4);
 

ok_Hash.put("tOracleInput_4", true);
end_Hash.put("tOracleInput_4", System.currentTimeMillis());




/**
 * [tOracleInput_4 end ] stop
 */

	
	/**
	 * [tAdvancedXMLMapHash_mail end ] start
	 */

	

	
	
	currentComponent="tAdvancedXMLMapHash_mail";

	

tHash_Lookup_mail.endPut();

			if(execStat){
				if(resourceMap.get("inIterateVComp") == null || !((Boolean)resourceMap.get("inIterateVComp"))){
			 		runStat.updateStatOnConnection("mail"+iterateId,2, 0); 
			 	}
			}
		
 

ok_Hash.put("tAdvancedXMLMapHash_mail", true);
end_Hash.put("tAdvancedXMLMapHash_mail", System.currentTimeMillis());




/**
 * [tAdvancedXMLMapHash_mail end ] stop
 */



				}//end the resume

				



	
			}catch(java.lang.Exception e){	
				
				TalendException te = new TalendException(e, currentComponent, globalMap);
				
				throw te;
			}catch(java.lang.Error error){	
				
					runStat.stopThreadStat();
				
				throw error;
			}finally{
				
				try{
					
	
	/**
	 * [tOracleInput_4 finally ] start
	 */

	

	
	
	currentComponent="tOracleInput_4";

	

 



/**
 * [tOracleInput_4 finally ] stop
 */

	
	/**
	 * [tAdvancedXMLMapHash_mail finally ] start
	 */

	

	
	
	currentComponent="tAdvancedXMLMapHash_mail";

	

 



/**
 * [tAdvancedXMLMapHash_mail finally ] stop
 */



				}catch(java.lang.Exception e){	
					//ignore
				}catch(java.lang.Error error){
					//ignore
				}
				resourceMap = null;
			}
		

		globalMap.put("tOracleInput_4_SUBPROCESS_STATE", 1);
	}
	


public static class phoneStruct implements routines.system.IPersistableComparableLookupRow<phoneStruct> {
    final static byte[] commonByteArrayLock_LDAP_sgbm_export = new byte[0];
    static byte[] commonByteArray_LDAP_sgbm_export = new byte[0];
	protected static final int DEFAULT_HASHCODE = 1;
    protected static final int PRIME = 31;
    protected int hashCode = DEFAULT_HASHCODE;
    public boolean hashCodeDirty = true;

    public String loopKey;



	
			    public routines.system.Document doc;

				public routines.system.Document getDoc () {
					return this.doc;
				}
				
			    public String CODE_BARRE;

				public String getCODE_BARRE () {
					return this.CODE_BARRE;
				}
				


	@Override
	public int hashCode() {
		if (this.hashCodeDirty) {
			final int prime = PRIME;
			int result = DEFAULT_HASHCODE;
	
						result = prime * result + ((this.CODE_BARRE == null) ? 0 : this.CODE_BARRE.hashCode());
					
    		this.hashCode = result;
    		this.hashCodeDirty = false;
		}
		return this.hashCode;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj) return true;
		if (obj == null) return false;
		if (getClass() != obj.getClass()) return false;
		final phoneStruct other = (phoneStruct) obj;
		
						if (this.CODE_BARRE == null) {
							if (other.CODE_BARRE != null)
								return false;
						
						} else if (!this.CODE_BARRE.equals(other.CODE_BARRE))
						
							return false;
					

		return true;
    }

	public void copyDataTo(phoneStruct other) {

		other.doc = this.doc;
	            other.CODE_BARRE = this.CODE_BARRE;
	            
	}

	public void copyKeysDataTo(phoneStruct other) {

		other.CODE_BARRE = this.CODE_BARRE;
	            	
	}




	private String readString(ObjectInputStream dis) throws IOException{
		String strReturn = null;
		int length = 0;
        length = dis.readInt();
		if (length == -1) {
			strReturn = null;
		} else {
			if(length > commonByteArray_LDAP_sgbm_export.length) {
				if(length < 1024 && commonByteArray_LDAP_sgbm_export.length == 0) {
   					commonByteArray_LDAP_sgbm_export = new byte[1024];
				} else {
   					commonByteArray_LDAP_sgbm_export = new byte[2 * length];
   				}
			}
			dis.readFully(commonByteArray_LDAP_sgbm_export, 0, length);
			strReturn = new String(commonByteArray_LDAP_sgbm_export, 0, length, utf8Charset);
		}
		return strReturn;
	}

    private void writeString(String str, ObjectOutputStream dos) throws IOException{
		if(str == null) {
            dos.writeInt(-1);
		} else {
            byte[] byteArray = str.getBytes(utf8Charset);
	    	dos.writeInt(byteArray.length);
			dos.write(byteArray);
    	}
    }

    public void readKeysData(ObjectInputStream dis) {

		synchronized(commonByteArrayLock_LDAP_sgbm_export) {

        	try {

        		int length = 0;
		
					this.CODE_BARRE = readString(dis);
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);

		

        }

		

      }


    }

    public void writeKeysData(ObjectOutputStream dos) {
        try {

		
					// String
				
						writeString(this.CODE_BARRE,dos);
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);
        }


    }



    /**
     * Fill Values data by reading ObjectInputStream.
     */
    public void readValuesData(DataInputStream dis, ObjectInputStream ois) {
        try {

			int length = 0;
		
       			    	this.doc = (routines.system.Document) ois.readObject();
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);

		
			} catch(ClassNotFoundException eCNFE) {
				 throw new RuntimeException(eCNFE);
		

        }

		

    }

    /**
     * Return a byte array which represents Values data.
     */
    public void writeValuesData(DataOutputStream dos, ObjectOutputStream oos) {
        try {

		
       			    	oos.writeObject(this.doc);
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);
        	}

    }


    public String toString() {

		StringBuilder sb = new StringBuilder();
		sb.append(super.toString());
		sb.append("[");
		sb.append("doc="+String.valueOf(doc));
		sb.append(",CODE_BARRE="+CODE_BARRE);
	    sb.append("]");

	    return sb.toString();
    }

    /**
     * Compare keys
     */
    public int compareTo(phoneStruct other) {

		int returnValue = -1;
		
						returnValue = checkNullsAndCompare(this.CODE_BARRE, other.CODE_BARRE);
						if(returnValue != 0) {
							return returnValue;
						}

					
	    return returnValue;
    }


    private int checkNullsAndCompare(Object object1, Object object2) {
        int returnValue = 0;
		if (object1 instanceof Comparable && object2 instanceof Comparable) {
            returnValue = ((Comparable) object1).compareTo(object2);
        } else if (object1 != null && object2 != null) {
            returnValue = compareStrings(object1.toString(), object2.toString());
        } else if (object1 == null && object2 != null) {
            returnValue = 1;
        } else if (object1 != null && object2 == null) {
            returnValue = -1;
        } else {
            returnValue = 0;
        }

        return returnValue;
    }

    private int compareStrings(String string1, String string2) {
        return string1.compareTo(string2);
    }


}

public static class phonesStruct implements routines.system.IPersistableRow<phonesStruct> {
    final static byte[] commonByteArrayLock_LDAP_sgbm_export = new byte[0];
    static byte[] commonByteArray_LDAP_sgbm_export = new byte[0];

	
			    public routines.system.Document doc;

				public routines.system.Document getDoc () {
					return this.doc;
				}
				
			    public String CODE_BARRE;

				public String getCODE_BARRE () {
					return this.CODE_BARRE;
				}
				



	private String readString(ObjectInputStream dis) throws IOException{
		String strReturn = null;
		int length = 0;
        length = dis.readInt();
		if (length == -1) {
			strReturn = null;
		} else {
			if(length > commonByteArray_LDAP_sgbm_export.length) {
				if(length < 1024 && commonByteArray_LDAP_sgbm_export.length == 0) {
   					commonByteArray_LDAP_sgbm_export = new byte[1024];
				} else {
   					commonByteArray_LDAP_sgbm_export = new byte[2 * length];
   				}
			}
			dis.readFully(commonByteArray_LDAP_sgbm_export, 0, length);
			strReturn = new String(commonByteArray_LDAP_sgbm_export, 0, length, utf8Charset);
		}
		return strReturn;
	}

    private void writeString(String str, ObjectOutputStream dos) throws IOException{
		if(str == null) {
            dos.writeInt(-1);
		} else {
            byte[] byteArray = str.getBytes(utf8Charset);
	    	dos.writeInt(byteArray.length);
			dos.write(byteArray);
    	}
    }

    public void readData(ObjectInputStream dis) {

		synchronized(commonByteArrayLock_LDAP_sgbm_export) {

        	try {

        		int length = 0;
		
						this.doc = (routines.system.Document) dis.readObject();
					
					this.CODE_BARRE = readString(dis);
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);

		
			} catch(ClassNotFoundException eCNFE) {
				 throw new RuntimeException(eCNFE);
		

        }

		

      }


    }

    public void writeData(ObjectOutputStream dos) {
        try {

		
					// Document
				
       			    	dos.writeObject(this.doc);
					
					// String
				
						writeString(this.CODE_BARRE,dos);
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);
        }


    }


    public String toString() {

		StringBuilder sb = new StringBuilder();
		sb.append(super.toString());
		sb.append("[");
		sb.append("doc="+String.valueOf(doc));
		sb.append(",CODE_BARRE="+CODE_BARRE);
	    sb.append("]");

	    return sb.toString();
    }

    /**
     * Compare keys
     */
    public int compareTo(phonesStruct other) {

		int returnValue = -1;
		
	    return returnValue;
    }


    private int checkNullsAndCompare(Object object1, Object object2) {
        int returnValue = 0;
		if (object1 instanceof Comparable && object2 instanceof Comparable) {
            returnValue = ((Comparable) object1).compareTo(object2);
        } else if (object1 != null && object2 != null) {
            returnValue = compareStrings(object1.toString(), object2.toString());
        } else if (object1 == null && object2 != null) {
            returnValue = 1;
        } else if (object1 != null && object2 == null) {
            returnValue = -1;
        } else {
            returnValue = 0;
        }

        return returnValue;
    }

    private int compareStrings(String string1, String string2) {
        return string1.compareTo(string2);
    }


}

public static class infoTelStruct implements routines.system.IPersistableRow<infoTelStruct> {
    final static byte[] commonByteArrayLock_LDAP_sgbm_export = new byte[0];
    static byte[] commonByteArray_LDAP_sgbm_export = new byte[0];

	
			    public String CODE_BARRE;

				public String getCODE_BARRE () {
					return this.CODE_BARRE;
				}
				
			    public String NOM;

				public String getNOM () {
					return this.NOM;
				}
				
			    public String PRENOM;

				public String getPRENOM () {
					return this.PRENOM;
				}
				
			    public String GROUPE;

				public String getGROUPE () {
					return this.GROUPE;
				}
				
			    public String CAMPUS;

				public String getCAMPUS () {
					return this.CAMPUS;
				}
				
			    public String LANGUE;

				public String getLANGUE () {
					return this.LANGUE;
				}
				
			    public String STATUT;

				public String getSTATUT () {
					return this.STATUT;
				}
				
			    public java.util.Date DATE_NAISSANCE;

				public java.util.Date getDATE_NAISSANCE () {
					return this.DATE_NAISSANCE;
				}
				
			    public java.util.Date DATE_MODIF;

				public java.util.Date getDATE_MODIF () {
					return this.DATE_MODIF;
				}
				
			    public java.util.Date DATE_EXPIRATION;

				public java.util.Date getDATE_EXPIRATION () {
					return this.DATE_EXPIRATION;
				}
				
			    public java.util.Date DATE_ELIMINATION;

				public java.util.Date getDATE_ELIMINATION () {
					return this.DATE_ELIMINATION;
				}
				
			    public String EPPN;

				public String getEPPN () {
					return this.EPPN;
				}
				



	private String readString(ObjectInputStream dis) throws IOException{
		String strReturn = null;
		int length = 0;
        length = dis.readInt();
		if (length == -1) {
			strReturn = null;
		} else {
			if(length > commonByteArray_LDAP_sgbm_export.length) {
				if(length < 1024 && commonByteArray_LDAP_sgbm_export.length == 0) {
   					commonByteArray_LDAP_sgbm_export = new byte[1024];
				} else {
   					commonByteArray_LDAP_sgbm_export = new byte[2 * length];
   				}
			}
			dis.readFully(commonByteArray_LDAP_sgbm_export, 0, length);
			strReturn = new String(commonByteArray_LDAP_sgbm_export, 0, length, utf8Charset);
		}
		return strReturn;
	}

    private void writeString(String str, ObjectOutputStream dos) throws IOException{
		if(str == null) {
            dos.writeInt(-1);
		} else {
            byte[] byteArray = str.getBytes(utf8Charset);
	    	dos.writeInt(byteArray.length);
			dos.write(byteArray);
    	}
    }

	private java.util.Date readDate(ObjectInputStream dis) throws IOException{
		java.util.Date dateReturn = null;
        int length = 0;
        length = dis.readByte();
		if (length == -1) {
			dateReturn = null;
		} else {
	    	dateReturn = new Date(dis.readLong());
		}
		return dateReturn;
	}

    private void writeDate(java.util.Date date1, ObjectOutputStream dos) throws IOException{
		if(date1 == null) {
            dos.writeByte(-1);
		} else {
			dos.writeByte(0);
	    	dos.writeLong(date1.getTime());
    	}
    }

    public void readData(ObjectInputStream dis) {

		synchronized(commonByteArrayLock_LDAP_sgbm_export) {

        	try {

        		int length = 0;
		
					this.CODE_BARRE = readString(dis);
					
					this.NOM = readString(dis);
					
					this.PRENOM = readString(dis);
					
					this.GROUPE = readString(dis);
					
					this.CAMPUS = readString(dis);
					
					this.LANGUE = readString(dis);
					
					this.STATUT = readString(dis);
					
					this.DATE_NAISSANCE = readDate(dis);
					
					this.DATE_MODIF = readDate(dis);
					
					this.DATE_EXPIRATION = readDate(dis);
					
					this.DATE_ELIMINATION = readDate(dis);
					
					this.EPPN = readString(dis);
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);

		

        }

		

      }


    }

    public void writeData(ObjectOutputStream dos) {
        try {

		
					// String
				
						writeString(this.CODE_BARRE,dos);
					
					// String
				
						writeString(this.NOM,dos);
					
					// String
				
						writeString(this.PRENOM,dos);
					
					// String
				
						writeString(this.GROUPE,dos);
					
					// String
				
						writeString(this.CAMPUS,dos);
					
					// String
				
						writeString(this.LANGUE,dos);
					
					// String
				
						writeString(this.STATUT,dos);
					
					// java.util.Date
				
						writeDate(this.DATE_NAISSANCE,dos);
					
					// java.util.Date
				
						writeDate(this.DATE_MODIF,dos);
					
					// java.util.Date
				
						writeDate(this.DATE_EXPIRATION,dos);
					
					// java.util.Date
				
						writeDate(this.DATE_ELIMINATION,dos);
					
					// String
				
						writeString(this.EPPN,dos);
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);
        }


    }


    public String toString() {

		StringBuilder sb = new StringBuilder();
		sb.append(super.toString());
		sb.append("[");
		sb.append("CODE_BARRE="+CODE_BARRE);
		sb.append(",NOM="+NOM);
		sb.append(",PRENOM="+PRENOM);
		sb.append(",GROUPE="+GROUPE);
		sb.append(",CAMPUS="+CAMPUS);
		sb.append(",LANGUE="+LANGUE);
		sb.append(",STATUT="+STATUT);
		sb.append(",DATE_NAISSANCE="+String.valueOf(DATE_NAISSANCE));
		sb.append(",DATE_MODIF="+String.valueOf(DATE_MODIF));
		sb.append(",DATE_EXPIRATION="+String.valueOf(DATE_EXPIRATION));
		sb.append(",DATE_ELIMINATION="+String.valueOf(DATE_ELIMINATION));
		sb.append(",EPPN="+EPPN);
	    sb.append("]");

	    return sb.toString();
    }

    /**
     * Compare keys
     */
    public int compareTo(infoTelStruct other) {

		int returnValue = -1;
		
	    return returnValue;
    }


    private int checkNullsAndCompare(Object object1, Object object2) {
        int returnValue = 0;
		if (object1 instanceof Comparable && object2 instanceof Comparable) {
            returnValue = ((Comparable) object1).compareTo(object2);
        } else if (object1 != null && object2 != null) {
            returnValue = compareStrings(object1.toString(), object2.toString());
        } else if (object1 == null && object2 != null) {
            returnValue = 1;
        } else if (object1 != null && object2 == null) {
            returnValue = -1;
        } else {
            returnValue = 0;
        }

        return returnValue;
    }

    private int compareStrings(String string1, String string2) {
        return string1.compareTo(string2);
    }


}

public static class after_tOracleInput_6Struct implements routines.system.IPersistableRow<after_tOracleInput_6Struct> {
    final static byte[] commonByteArrayLock_LDAP_sgbm_export = new byte[0];
    static byte[] commonByteArray_LDAP_sgbm_export = new byte[0];

	
			    public String CODE_BARRE;

				public String getCODE_BARRE () {
					return this.CODE_BARRE;
				}
				
			    public String NOM;

				public String getNOM () {
					return this.NOM;
				}
				
			    public String PRENOM;

				public String getPRENOM () {
					return this.PRENOM;
				}
				
			    public String GROUPE;

				public String getGROUPE () {
					return this.GROUPE;
				}
				
			    public String CAMPUS;

				public String getCAMPUS () {
					return this.CAMPUS;
				}
				
			    public String LANGUE;

				public String getLANGUE () {
					return this.LANGUE;
				}
				
			    public String STATUT;

				public String getSTATUT () {
					return this.STATUT;
				}
				
			    public java.util.Date DATE_NAISSANCE;

				public java.util.Date getDATE_NAISSANCE () {
					return this.DATE_NAISSANCE;
				}
				
			    public java.util.Date DATE_MODIF;

				public java.util.Date getDATE_MODIF () {
					return this.DATE_MODIF;
				}
				
			    public java.util.Date DATE_EXPIRATION;

				public java.util.Date getDATE_EXPIRATION () {
					return this.DATE_EXPIRATION;
				}
				
			    public java.util.Date DATE_ELIMINATION;

				public java.util.Date getDATE_ELIMINATION () {
					return this.DATE_ELIMINATION;
				}
				
			    public String EPPN;

				public String getEPPN () {
					return this.EPPN;
				}
				



	private String readString(ObjectInputStream dis) throws IOException{
		String strReturn = null;
		int length = 0;
        length = dis.readInt();
		if (length == -1) {
			strReturn = null;
		} else {
			if(length > commonByteArray_LDAP_sgbm_export.length) {
				if(length < 1024 && commonByteArray_LDAP_sgbm_export.length == 0) {
   					commonByteArray_LDAP_sgbm_export = new byte[1024];
				} else {
   					commonByteArray_LDAP_sgbm_export = new byte[2 * length];
   				}
			}
			dis.readFully(commonByteArray_LDAP_sgbm_export, 0, length);
			strReturn = new String(commonByteArray_LDAP_sgbm_export, 0, length, utf8Charset);
		}
		return strReturn;
	}

    private void writeString(String str, ObjectOutputStream dos) throws IOException{
		if(str == null) {
            dos.writeInt(-1);
		} else {
            byte[] byteArray = str.getBytes(utf8Charset);
	    	dos.writeInt(byteArray.length);
			dos.write(byteArray);
    	}
    }

	private java.util.Date readDate(ObjectInputStream dis) throws IOException{
		java.util.Date dateReturn = null;
        int length = 0;
        length = dis.readByte();
		if (length == -1) {
			dateReturn = null;
		} else {
	    	dateReturn = new Date(dis.readLong());
		}
		return dateReturn;
	}

    private void writeDate(java.util.Date date1, ObjectOutputStream dos) throws IOException{
		if(date1 == null) {
            dos.writeByte(-1);
		} else {
			dos.writeByte(0);
	    	dos.writeLong(date1.getTime());
    	}
    }

    public void readData(ObjectInputStream dis) {

		synchronized(commonByteArrayLock_LDAP_sgbm_export) {

        	try {

        		int length = 0;
		
					this.CODE_BARRE = readString(dis);
					
					this.NOM = readString(dis);
					
					this.PRENOM = readString(dis);
					
					this.GROUPE = readString(dis);
					
					this.CAMPUS = readString(dis);
					
					this.LANGUE = readString(dis);
					
					this.STATUT = readString(dis);
					
					this.DATE_NAISSANCE = readDate(dis);
					
					this.DATE_MODIF = readDate(dis);
					
					this.DATE_EXPIRATION = readDate(dis);
					
					this.DATE_ELIMINATION = readDate(dis);
					
					this.EPPN = readString(dis);
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);

		

        }

		

      }


    }

    public void writeData(ObjectOutputStream dos) {
        try {

		
					// String
				
						writeString(this.CODE_BARRE,dos);
					
					// String
				
						writeString(this.NOM,dos);
					
					// String
				
						writeString(this.PRENOM,dos);
					
					// String
				
						writeString(this.GROUPE,dos);
					
					// String
				
						writeString(this.CAMPUS,dos);
					
					// String
				
						writeString(this.LANGUE,dos);
					
					// String
				
						writeString(this.STATUT,dos);
					
					// java.util.Date
				
						writeDate(this.DATE_NAISSANCE,dos);
					
					// java.util.Date
				
						writeDate(this.DATE_MODIF,dos);
					
					// java.util.Date
				
						writeDate(this.DATE_EXPIRATION,dos);
					
					// java.util.Date
				
						writeDate(this.DATE_ELIMINATION,dos);
					
					// String
				
						writeString(this.EPPN,dos);
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);
        }


    }


    public String toString() {

		StringBuilder sb = new StringBuilder();
		sb.append(super.toString());
		sb.append("[");
		sb.append("CODE_BARRE="+CODE_BARRE);
		sb.append(",NOM="+NOM);
		sb.append(",PRENOM="+PRENOM);
		sb.append(",GROUPE="+GROUPE);
		sb.append(",CAMPUS="+CAMPUS);
		sb.append(",LANGUE="+LANGUE);
		sb.append(",STATUT="+STATUT);
		sb.append(",DATE_NAISSANCE="+String.valueOf(DATE_NAISSANCE));
		sb.append(",DATE_MODIF="+String.valueOf(DATE_MODIF));
		sb.append(",DATE_EXPIRATION="+String.valueOf(DATE_EXPIRATION));
		sb.append(",DATE_ELIMINATION="+String.valueOf(DATE_ELIMINATION));
		sb.append(",EPPN="+EPPN);
	    sb.append("]");

	    return sb.toString();
    }

    /**
     * Compare keys
     */
    public int compareTo(after_tOracleInput_6Struct other) {

		int returnValue = -1;
		
	    return returnValue;
    }


    private int checkNullsAndCompare(Object object1, Object object2) {
        int returnValue = 0;
		if (object1 instanceof Comparable && object2 instanceof Comparable) {
            returnValue = ((Comparable) object1).compareTo(object2);
        } else if (object1 != null && object2 != null) {
            returnValue = compareStrings(object1.toString(), object2.toString());
        } else if (object1 == null && object2 != null) {
            returnValue = 1;
        } else if (object1 != null && object2 == null) {
            returnValue = -1;
        } else {
            returnValue = 0;
        }

        return returnValue;
    }

    private int compareStrings(String string1, String string2) {
        return string1.compareTo(string2);
    }


}
public void tOracleInput_6Process(final java.util.Map<String, Object> globalMap) throws TalendException {
	globalMap.put("tOracleInput_6_SUBPROCESS_STATE", 0);

 final boolean execStat = this.execStat;
		String currentVirtualComponent = null;
	
		String iterateId = "";
	
	
	String currentComponent = "";
	java.util.Map<String, Object> resourceMap = new java.util.HashMap<String, Object>();

	try {

			String currentMethodName = new java.lang.Exception().getStackTrace()[0].getMethodName();
			boolean resumeIt = currentMethodName.equals(resumeEntryMethodName);
			if( resumeEntryMethodName == null || resumeIt || globalResumeTicket){//start the resume
				globalResumeTicket = true;


		tOracleInput_7Process(globalMap);

		infoTelStruct infoTel = new infoTelStruct();
phonesStruct phones = new phonesStruct();
phoneStruct phone = new phoneStruct();




	
	/**
	 * [tXMLMap_4_TXMLMAP_OUT begin ] start
	 */

	

	
		
		ok_Hash.put("tXMLMap_4_TXMLMAP_OUT", false);
		start_Hash.put("tXMLMap_4_TXMLMAP_OUT", System.currentTimeMillis());
		
	
		currentVirtualComponent = "tXMLMap_4";
	
	currentComponent="tXMLMap_4_TXMLMAP_OUT";

	
			if (execStat) {
				if(resourceMap.get("inIterateVComp") == null){
					
						runStat.updateStatOnConnection("infoTel" + iterateId, 0, 0);
					
				}
			} 

		
		int tos_count_tXMLMap_4_TXMLMAP_OUT = 0;
		
    	class BytesLimit65535_tXMLMap_4_TXMLMAP_OUT{
    		public void limitLog4jByte() throws Exception{
    			
    		}
    	}
    	
        new BytesLimit65535_tXMLMap_4_TXMLMAP_OUT().limitLog4jByte();

	org.talend.designer.components.lookup.memory.AdvancedMemoryLookup<telephoneStruct> tHash_Lookup_telephone = (org.talend.designer.components.lookup.memory.AdvancedMemoryLookup<telephoneStruct>) 
			((org.talend.designer.components.lookup.memory.AdvancedMemoryLookup<telephoneStruct>) 
				globalMap.get( "tHash_Lookup_telephone" ))
				;
	
	
	telephoneStruct telephoneHashKey = new telephoneStruct();
	telephoneStruct telephoneDefault = new telephoneStruct();
	telephoneStruct telephone = new telephoneStruct();
	
	
	
//===============================input xml init part===============================
class XML_API_tXMLMap_4_TXMLMAP_OUT{
	public boolean isDefNull(org.dom4j.Node node) throws javax.xml.transform.TransformerException {
        if (node != null && node instanceof org.dom4j.Element) {
        	org.dom4j.Attribute attri = ((org.dom4j.Element)node).attribute("nil");
        	if(attri != null && ("true").equals(attri.getText())){
            	return true;
            }
        }
        return false;
    }

    public boolean isMissing(org.dom4j.Node node) throws javax.xml.transform.TransformerException {
        return node == null ? true : false;
    }

    public boolean isEmpty(org.dom4j.Node node) throws javax.xml.transform.TransformerException {
        if (node != null) {
            return node.getText().length() == 0;
        }
        return false;
    }
}
	class Var__tXMLMap_4_TXMLMAP_OUT__Struct {
	}
	Var__tXMLMap_4_TXMLMAP_OUT__Struct Var__tXMLMap_4_TXMLMAP_OUT = new Var__tXMLMap_4_TXMLMAP_OUT__Struct();
// ###############################
// # Outputs initialization
phonesStruct phones_tmp = new phonesStruct();
phonesStruct phones_save = null;
//the aggregate variable
phonesStruct phones_aggregate = null;
//init the resultset for aggregate
java.util.List<Object> allOutsForAggregate_tXMLMap_4 = new java.util.ArrayList<Object>();
globalMap.put("allOutsForAggregate_tXMLMap_4",allOutsForAggregate_tXMLMap_4);
// ###############################
		int nb_line_tXMLMap_4_TXMLMAP_OUT = 0; 
	
    XML_API_tXMLMap_4_TXMLMAP_OUT xml_api_tXMLMap_4_TXMLMAP_OUT = new XML_API_tXMLMap_4_TXMLMAP_OUT();

	//the map store the previous value of aggregate columns
	java.util.Map<String,Object> aggregateCacheMap_tXMLMap_4_TXMLMAP_OUT = new java.util.HashMap<String,Object>();
					//init the map,the keys is aggregate columns xpath,the values is all null.
					aggregateCacheMap_tXMLMap_4_TXMLMAP_OUT.put("phones.doc:/root/@test",null);

class GenerateDocument_phones {

	java.util.Map<String,Object> valueMap = null;
	
	routines.system.DocumentGenerateOrderHelper orderHelper = new routines.system.DocumentGenerateOrderHelper(1);
	
	org.dom4j.Document doc = null;
	
	org.dom4j.Element root4Group = null;
	
	org.dom4j.io.OutputFormat format = null;
	
	java.util.List<java.util.List<String>> groupbyList = null;
	java.util.List<org.dom4j.Element> groupElementList = null;
	int order = 0;
	
	boolean isFirst = true;
	
	boolean	needRoot = true;
	
	String currentValue = null;

		org.dom4j.Element subTreeLoopParent0 = null;
		public boolean  subTreeLoop0 = false;
	
    public GenerateDocument_phones() {
//    	this.treeNodeAPI = treeNodeAPI;
    	
    	valueMap = new java.util.HashMap<String,Object>();
    	
    	groupbyList =  new java.util.ArrayList<java.util.List<String>>();
		groupElementList = new java.util.ArrayList<org.dom4j.Element>();
    	
    	doc = org.dom4j.DocumentHelper.createDocument();
    	format = org.dom4j.io.OutputFormat.createPrettyPrint();
    	format.setTrimText(false);
    }
    
    public org.dom4j.Document getDocument(){
    	return this.doc;
    }
    
	//We generate the TreeNode_API object only if there is a document in the main input table.
    void generateElements(boolean isInnerJoin, infoTelStruct infoTel, telephoneStruct telephone, Var__tXMLMap_4_TXMLMAP_OUT__Struct Var
	) {
	
	
	/*if(this.treeNodeAPI==null) {
		this.treeNodeAPI = treeNodeAPI;
	}*/
	
	org.dom4j.Element subTreeRootParent = null;
// build root xml tree 
if (needRoot) {
	needRoot=false;
		org.dom4j.Element root = null;
				root = doc.addElement("root");
		subTreeRootParent = root;
				currentValue = null;
    			valueMap.put("root",infoTel.CODE_BARRE );
    			if(valueMap.get("root")!=null) {
    				currentValue = FormatterUtils.format(infoTel.CODE_BARRE ,null);
    			} else {
    				currentValue = "";
    			}
				
    			routines.system.DocumentHelper.applyNamespace2Attribute(root,  null , "test", currentValue);
		org.dom4j.Element root_1 = null;
				root_1 = root.addElement("phones");
		subTreeRootParent = root_1;
					subTreeLoopParent0 = root_1;
		root4Group = subTreeRootParent;
	}else{
		subTreeRootParent=root4Group;
	}
	/* build group xml tree */
	boolean isNewElement = false;
		isNewElement = false;
		org.dom4j.Element loop = null;
				loop = org.dom4j.DocumentHelper.createElement("phone");
				subTreeRootParent.elements().add(orderHelper.getInsertLocation(0,0),loop);
		subTreeRootParent = loop;
				currentValue = null;
    			valueMap.put("loop",telephone.PREF );
    			if(valueMap.get("loop")!=null) {
    				currentValue = FormatterUtils.format(telephone.PREF ,null);
    			} else {
    				currentValue = "";
    			}
				
    			routines.system.DocumentHelper.applyNamespace2Attribute(loop,  null , "preferred", currentValue);
				currentValue = null;
    			valueMap.put("loop",telephone.SMS_PREF );
    			if(valueMap.get("loop")!=null) {
    				currentValue = FormatterUtils.format(telephone.SMS_PREF ,null);
    			} else {
    				currentValue = "";
    			}
				
    			routines.system.DocumentHelper.applyNamespace2Attribute(loop,  null , "preferred_sms", currentValue);
				currentValue = null;
    			valueMap.put("loop",(telephone.NUMERO != null && !telephone.NUMERO.trim().isEmpty())?context.sigb_external_desc:null );
    			if(valueMap.get("loop")!=null) {
    				currentValue = FormatterUtils.format((telephone.NUMERO != null && !telephone.NUMERO.trim().isEmpty())?context.sigb_external_desc:null ,null);
    			} else {
    				currentValue = "";
    			}
				
    			routines.system.DocumentHelper.applyNamespace2Attribute(loop,  null , "preferred_type", currentValue);
		org.dom4j.Element loop_5 = null;
				loop_5 = loop.addElement("phone_number");
		valueMap.put("loop_5",telephone.NUMERO );
		if(valueMap.get("loop_5")!=null) {
			routines.system.NestXMLTool.setText(loop_5, FormatterUtils.format(telephone.NUMERO ,null));
		}
		org.dom4j.Element loop_6 = null;
				loop_6 = loop.addElement("phone_types");
		org.dom4j.Element loop_6_7 = null;
				loop_6_7 = loop_6.addElement("phone_type");
		valueMap.put("loop_6_7",telephone.TYPE );
		if(valueMap.get("loop_6_7")!=null) {
			routines.system.NestXMLTool.setText(loop_6_7, FormatterUtils.format(telephone.TYPE ,null));
		}
		}
    }

	GenerateDocument_phones gen_Doc_phones_tXMLMap_4_TXMLMAP_OUT = new GenerateDocument_phones();
	boolean docAlreadyInstanciate_phones = false;

	            
 



/**
 * [tXMLMap_4_TXMLMAP_OUT begin ] stop
 */



	
	/**
	 * [tOracleInput_6 begin ] start
	 */

	

	
		
		ok_Hash.put("tOracleInput_6", false);
		start_Hash.put("tOracleInput_6", System.currentTimeMillis());
		
	
	currentComponent="tOracleInput_6";

	
		int tos_count_tOracleInput_6 = 0;
		
    	class BytesLimit65535_tOracleInput_6{
    		public void limitLog4jByte() throws Exception{
    			
    		}
    	}
    	
        new BytesLimit65535_tOracleInput_6().limitLog4jByte();
	


	
		    int nb_line_tOracleInput_6 = 0;
		    java.sql.Connection conn_tOracleInput_6 = null;
		        conn_tOracleInput_6 = (java.sql.Connection)globalMap.get("conn_tOracleConnection_1");
				
				if(((oracle.jdbc.OracleConnection)conn_tOracleInput_6).getSessionTimeZone() == null){
					java.sql.Statement stmtGetTZ_tOracleInput_6 = conn_tOracleInput_6.createStatement();
					java.sql.ResultSet rsGetTZ_tOracleInput_6 = stmtGetTZ_tOracleInput_6.executeQuery("select sessiontimezone from dual");
					String sessionTimezone_tOracleInput_6 = java.util.TimeZone.getDefault().getID();
					while (rsGetTZ_tOracleInput_6.next()) {
						sessionTimezone_tOracleInput_6 = rsGetTZ_tOracleInput_6.getString(1);
					}
					((oracle.jdbc.OracleConnection)conn_tOracleInput_6).setSessionTimeZone(sessionTimezone_tOracleInput_6);
				}
			
		    
			java.sql.Statement stmt_tOracleInput_6 = conn_tOracleInput_6.createStatement();

		    String dbquery_tOracleInput_6 = "SELECT \n  "+context.oracle_schema+".V_SGBMP_INFOGENE.* \nFROM "+context.oracle_schema+".V_SGBMP_INFOGENE "

;
			

            	globalMap.put("tOracleInput_6_QUERY",dbquery_tOracleInput_6);
		    java.sql.ResultSet rs_tOracleInput_6 = null;

		    try {
		    	rs_tOracleInput_6 = stmt_tOracleInput_6.executeQuery(dbquery_tOracleInput_6);
		    	java.sql.ResultSetMetaData rsmd_tOracleInput_6 = rs_tOracleInput_6.getMetaData();
		    	int colQtyInRs_tOracleInput_6 = rsmd_tOracleInput_6.getColumnCount();

		    String tmpContent_tOracleInput_6 = null;
		    
		    
		    while (rs_tOracleInput_6.next()) {
		        nb_line_tOracleInput_6++;
		        
							if(colQtyInRs_tOracleInput_6 < 1) {
								infoTel.CODE_BARRE = null;
							} else {
	                         		
        	infoTel.CODE_BARRE = routines.system.JDBCUtil.getString(rs_tOracleInput_6, 1, false);
		                    }
							if(colQtyInRs_tOracleInput_6 < 2) {
								infoTel.NOM = null;
							} else {
	                         		
        	infoTel.NOM = routines.system.JDBCUtil.getString(rs_tOracleInput_6, 2, false);
		                    }
							if(colQtyInRs_tOracleInput_6 < 3) {
								infoTel.PRENOM = null;
							} else {
	                         		
        	infoTel.PRENOM = routines.system.JDBCUtil.getString(rs_tOracleInput_6, 3, false);
		                    }
							if(colQtyInRs_tOracleInput_6 < 4) {
								infoTel.GROUPE = null;
							} else {
	                         		
        	infoTel.GROUPE = routines.system.JDBCUtil.getString(rs_tOracleInput_6, 4, false);
		                    }
							if(colQtyInRs_tOracleInput_6 < 5) {
								infoTel.CAMPUS = null;
							} else {
	                         		
        	infoTel.CAMPUS = routines.system.JDBCUtil.getString(rs_tOracleInput_6, 5, false);
		                    }
							if(colQtyInRs_tOracleInput_6 < 6) {
								infoTel.LANGUE = null;
							} else {
	                         		
        	infoTel.LANGUE = routines.system.JDBCUtil.getString(rs_tOracleInput_6, 6, false);
		                    }
							if(colQtyInRs_tOracleInput_6 < 7) {
								infoTel.STATUT = null;
							} else {
	                         		
        	infoTel.STATUT = routines.system.JDBCUtil.getString(rs_tOracleInput_6, 7, false);
		                    }
							if(colQtyInRs_tOracleInput_6 < 8) {
								infoTel.DATE_NAISSANCE = null;
							} else {
										
			infoTel.DATE_NAISSANCE = routines.system.JDBCUtil.getDate(rs_tOracleInput_6, 8);
		                    }
							if(colQtyInRs_tOracleInput_6 < 9) {
								infoTel.DATE_MODIF = null;
							} else {
										
			infoTel.DATE_MODIF = routines.system.JDBCUtil.getDate(rs_tOracleInput_6, 9);
		                    }
							if(colQtyInRs_tOracleInput_6 < 10) {
								infoTel.DATE_EXPIRATION = null;
							} else {
										
			infoTel.DATE_EXPIRATION = routines.system.JDBCUtil.getDate(rs_tOracleInput_6, 10);
		                    }
							if(colQtyInRs_tOracleInput_6 < 11) {
								infoTel.DATE_ELIMINATION = null;
							} else {
										
			infoTel.DATE_ELIMINATION = routines.system.JDBCUtil.getDate(rs_tOracleInput_6, 11);
		                    }
							if(colQtyInRs_tOracleInput_6 < 12) {
								infoTel.EPPN = null;
							} else {
	                         		
        	infoTel.EPPN = routines.system.JDBCUtil.getString(rs_tOracleInput_6, 12, false);
		                    }
					




 



/**
 * [tOracleInput_6 begin ] stop
 */
	
	/**
	 * [tOracleInput_6 main ] start
	 */

	

	
	
	currentComponent="tOracleInput_6";

	

 


	tos_count_tOracleInput_6++;

/**
 * [tOracleInput_6 main ] stop
 */

	
	/**
	 * [tXMLMap_4_TXMLMAP_OUT main ] start
	 */

	

	
	
		currentVirtualComponent = "tXMLMap_4";
	
	currentComponent="tXMLMap_4_TXMLMAP_OUT";

	

			//infoTel
			//infoTel


			
				if(execStat){
					runStat.updateStatOnConnection("infoTel"+iterateId,1, 1);
				} 
			

		

	boolean rejectedInnerJoin_tXMLMap_4_TXMLMAP_OUT = false;
	boolean rejectedDocInnerJoin_tXMLMap_4_TXMLMAP_OUT = false;
	boolean mainRowRejected_tXMLMap_4_TXMLMAP_OUT = false;
	boolean isMatchDocRowtXMLMap_4_TXMLMAP_OUT = false;
	  
	
			
   
					phones_tmp.doc = null;
					
		
		


			

			
				///////////////////////////////////////////////
				//Starting Lookup Table "org.talend.designer.xmlmap.model.emf.xmlmap.impl.InputXmlTreeImpl@59cce842 (expressionFilter: null, activateExpressionFilter: false, activateCondensedTool: true, minimized: false, name: telephone, multiLoops: false) (lookup: true, matchingMode: ALL_MATCHES, lookupMode: LOAD_ONCE, innerJoin: false, persistent: false, activateGlobalMap: false)" 
				///////////////////////////////////////////////
				//tHash_Lookup_telephone.initGet();
				
				
				
					boolean forceLooptelephone = false;
					telephoneStruct telephoneObjectFromLookup = null;
					boolean hasResultFromLookupCachetelephone = false;
					java.util.Map<String,Object> cacheResulttelephone = new java.util.HashMap<String,Object>();
				
				
				
					   	telephoneHashKey.CODE_BARRE = infoTel.CODE_BARRE ;
						telephoneHashKey.hashCodeDirty = true;
						
					
					
						if(!rejectedInnerJoin_tXMLMap_4_TXMLMAP_OUT){//TD120
							
					
							
								
									tHash_Lookup_telephone.lookup( telephoneHashKey );
								
							
							if(hasResultFromLookupCachetelephone  || tHash_Lookup_telephone.hasNext()){
							
							} else {
								
									telephone = telephoneDefault;
								
								
								
								forceLooptelephone = true;
								
							}
						}//TD120
				   
				   		
				   			if(rejectedInnerJoin_tXMLMap_4_TXMLMAP_OUT) {
				   				forceLooptelephone = true;
				   			}
				   		
				   
				   		telephoneStruct fromLookup_telephone = null;
						telephone = telephoneDefault;
				   
				   		
				  		
				  		//////////////////////////////////////////////////////////////////////////////////////////////
				  		
				  		boolean fromCachetelephone = hasResultFromLookupCachetelephone;
				  		List<java.util.Map<String,Object>> multipleResultSettelephone = new java.util.ArrayList<java.util.Map<String,Object>>();
				  		//the var for cache the telephoneStruct
				  		java.util.Map<String,Object> oneRow_telephone = null;
						if(hasResultFromLookupCachetelephone) {
					    	
					    } else if(!rejectedInnerJoin_tXMLMap_4_TXMLMAP_OUT) {
					    	
					    	while (tHash_Lookup_telephone.hasNext()) {
					    		fromLookup_telephone = null;
								telephone = telephoneDefault;
								fromLookup_telephone = tHash_Lookup_telephone.next();
								if(fromLookup_telephone != null) {
								
										
									telephone = fromLookup_telephone;
									//construct the resultset for mutiple lookup when no document lookup.
									oneRow_telephone = new java.util.HashMap<String, Object>();
									oneRow_telephone.put("telephone",telephone);
									multipleResultSettelephone.add(oneRow_telephone);
									
								}
					    	}//end while
					    	
					    }//end else if
					    //now not support cache all_matches lookup
					    
					    
					    
					    
					    java.util.Iterator<java.util.Map<String,Object>> itertelephone = multipleResultSettelephone.iterator();
					    while(itertelephone.hasNext() || forceLooptelephone) { // G_TM_M_002
					    	telephone = telephoneDefault;
					    	telephoneStruct tempLookuptelephone = null; 
					    	if(!forceLooptelephone) {
						    	java.util.Map<String,Object> oneRowtelephone = itertelephone.next();
						   		
					    		tempLookuptelephone = (telephoneStruct)oneRowtelephone.get("telephone");
					    		if(tempLookuptelephone!=null) {
					    			telephone = tempLookuptelephone;
					    		}
					    		
					    		
				    		}
				    		forceLooptelephone = false;
				  		
				  		/////////////////////////////////////////////////////////////////////////////////////////////////
				  		
					
				
{ // start of Var scope

	// ###############################
	// # Vars tables

Var__tXMLMap_4_TXMLMAP_OUT__Struct Var = Var__tXMLMap_4_TXMLMAP_OUT;
		// ###############################
		// # Output tables

phones = null;


// # Output table : 'phones'

if((infoTel.CODE_BARRE )==null ||!infoTel.CODE_BARRE .equals(aggregateCacheMap_tXMLMap_4_TXMLMAP_OUT.get("phones.doc:/root/@test"))) {
gen_Doc_phones_tXMLMap_4_TXMLMAP_OUT = new GenerateDocument_phones();
//init one new out struct for cache the result.
phones_aggregate = new phonesStruct();
phones_aggregate.doc = new routines.system.Document();
phones_aggregate.doc.setDocument(gen_Doc_phones_tXMLMap_4_TXMLMAP_OUT.getDocument());

//construct the resultset
allOutsForAggregate_tXMLMap_4.add(phones_aggregate);
//store the previous value
aggregateCacheMap_tXMLMap_4_TXMLMAP_OUT.put("phones.doc:/root/@test", infoTel.CODE_BARRE );
}


gen_Doc_phones_tXMLMap_4_TXMLMAP_OUT.generateElements(rejectedDocInnerJoin_tXMLMap_4_TXMLMAP_OUT,infoTel,telephone,Var);


phones_tmp.CODE_BARRE = telephone.CODE_BARRE ;//set the flat column for aggregate
phones_aggregate.CODE_BARRE = telephone.CODE_BARRE ;


if(phones_aggregate!=null){

phones_aggregate.CODE_BARRE = phones_tmp.CODE_BARRE;
}
// ###############################

} // end of Var scope

rejectedInnerJoin_tXMLMap_4_TXMLMAP_OUT = false;


		}// G_TM_M_002

 


	tos_count_tXMLMap_4_TXMLMAP_OUT++;

/**
 * [tXMLMap_4_TXMLMAP_OUT main ] stop
 */



	
	/**
	 * [tOracleInput_6 end ] start
	 */

	

	
	
	currentComponent="tOracleInput_6";

	

}
}finally{
stmt_tOracleInput_6.close();

}

globalMap.put("tOracleInput_6_NB_LINE",nb_line_tOracleInput_6);
 

ok_Hash.put("tOracleInput_6", true);
end_Hash.put("tOracleInput_6", System.currentTimeMillis());




/**
 * [tOracleInput_6 end ] stop
 */

	
	/**
	 * [tXMLMap_4_TXMLMAP_OUT end ] start
	 */

	

	
	
		currentVirtualComponent = "tXMLMap_4";
	
	currentComponent="tXMLMap_4_TXMLMAP_OUT";

	




			if(execStat){
				if(resourceMap.get("inIterateVComp") == null || !((Boolean)resourceMap.get("inIterateVComp"))){
			 		runStat.updateStatOnConnection("infoTel"+iterateId,2, 0); 
			 	}
			}
		
 

ok_Hash.put("tXMLMap_4_TXMLMAP_OUT", true);
end_Hash.put("tXMLMap_4_TXMLMAP_OUT", System.currentTimeMillis());




/**
 * [tXMLMap_4_TXMLMAP_OUT end ] stop
 */



	
	/**
	 * [tAdvancedHash_phone begin ] start
	 */

	

	
		
		ok_Hash.put("tAdvancedHash_phone", false);
		start_Hash.put("tAdvancedHash_phone", System.currentTimeMillis());
		
	
	currentComponent="tAdvancedHash_phone";

	
			if (execStat) {
				if(resourceMap.get("inIterateVComp") == null){
					
						runStat.updateStatOnConnection("phone" + iterateId, 0, 0);
					
				}
			} 

		
		int tos_count_tAdvancedHash_phone = 0;
		
    	class BytesLimit65535_tAdvancedHash_phone{
    		public void limitLog4jByte() throws Exception{
    			
    		}
    	}
    	
        new BytesLimit65535_tAdvancedHash_phone().limitLog4jByte();

			   		// connection name:phone
			   		// source node:tExtractXMLField_4 - inputs:(phones) outputs:(phone,phone) | target node:tAdvancedHash_phone - inputs:(phone) outputs:()
			   		// linked node: tMap_1 - inputs:(infos,adress,email,phone,statistique) outputs:(out1)
			   
			   		org.talend.designer.components.lookup.common.ICommonLookup.MATCHING_MODE matchingModeEnum_phone = 
			   			org.talend.designer.components.lookup.common.ICommonLookup.MATCHING_MODE.UNIQUE_MATCH;
			   			
			   
	   			org.talend.designer.components.lookup.memory.AdvancedMemoryLookup<phoneStruct> tHash_Lookup_phone =org.talend.designer.components.lookup.memory.AdvancedMemoryLookup.
	   						<phoneStruct>getLookup(matchingModeEnum_phone);
	   						   
		   	   	   globalMap.put("tHash_Lookup_phone", tHash_Lookup_phone);
		   	   	   
				
           

 



/**
 * [tAdvancedHash_phone begin ] stop
 */



	
	/**
	 * [tExtractXMLField_4 begin ] start
	 */

	

	
		
		ok_Hash.put("tExtractXMLField_4", false);
		start_Hash.put("tExtractXMLField_4", System.currentTimeMillis());
		
	
	currentComponent="tExtractXMLField_4";

	
			if (execStat) {
				if(resourceMap.get("inIterateVComp") == null){
					
						runStat.updateStatOnConnection("phones" + iterateId, 0, 0);
					
				}
			} 

		
		int tos_count_tExtractXMLField_4 = 0;
		
    	class BytesLimit65535_tExtractXMLField_4{
    		public void limitLog4jByte() throws Exception{
    			
    		}
    	}
    	
        new BytesLimit65535_tExtractXMLField_4().limitLog4jByte();

int nb_line_tExtractXMLField_4 = 0;

class NameSpaceTool_tExtractXMLField_4 {

    public java.util.HashMap<String, String> xmlNameSpaceMap = new java.util.HashMap<String, String>();
    
	private java.util.List<String> defualtNSPath = new java.util.ArrayList<String>();

    public void countNSMap(org.dom4j.Element el) {
        for (org.dom4j.Namespace ns : (java.util.List<org.dom4j.Namespace>) el.declaredNamespaces()) {
            if (ns.getPrefix().trim().length() == 0) {
                xmlNameSpaceMap.put("pre"+defualtNSPath.size(), ns.getURI());
                String path = "";
                org.dom4j.Element elTmp = el;
                while (elTmp != null) {
                   	if (elTmp.getNamespacePrefix() != null && elTmp.getNamespacePrefix().length() > 0) {
                        path = "/" + elTmp.getNamespacePrefix() + ":" + elTmp.getName() + path;
                    } else {
                        path = "/" + elTmp.getName() + path;
                    }
                    elTmp = elTmp.getParent();
                }
                defualtNSPath.add(path);
            } else {
                xmlNameSpaceMap.put(ns.getPrefix(), ns.getURI());
            }

        }
        for (org.dom4j.Element e : (java.util.List<org.dom4j.Element>) el.elements()) {
            countNSMap(e);
        }
    }
    
    /**
	 *	the regex for the xpath like that : 
	 *	case 1 : functionA(locationXPathExpression) 
	 *	case 2 : fn:functionA(locationXPathExpression) 
	 *	case 3 : functionA(functionB(locationXPathExpression))
	 *	case 4 : fn:functionA(fn:functionB(locationXPathExpression))
	 *	and like that.
	*/
	private java.util.regex.Pattern simpleFunctionPattern;
	private StringBuffer stringBuffer;
	private java.util.Map<String,String> resultCache;
	
	public String addDefaultNSPrefix(final String xpathExpression, String loopPath) {
	    if (defualtNSPath.size() < 1) {
        	return xpathExpression;
    	}
    	
    	if(resultCache == null) {
    		resultCache = new java.util.HashMap<String,String>();
    	}
    	
    	String resultXpathExpression = resultCache.get(xpathExpression);
		if(resultXpathExpression!=null) {
    		return resultXpathExpression;
    	}
    	
    	String locationPathExpression = xpathExpression;
    	
    	if(simpleFunctionPattern == null) {
    		simpleFunctionPattern = java.util.regex.Pattern.compile("([a-zA-z0-9]+:)?[a-zA-Z]+-?[A-Za-z]+\\(.*\\)");
    	}
    	
    	boolean isSimpleFunctionXPath = simpleFunctionPattern.matcher(xpathExpression).matches();
    	String tail = null;
    	if(isSimpleFunctionXPath) {
			int start = xpathExpression.lastIndexOf('(');
			int end = xpathExpression.indexOf(')');
			if(start < end) {
			    if(stringBuffer == null) {
    				stringBuffer = new StringBuffer();
    			}
				locationPathExpression = xpathExpression.substring(start+1,end);
				stringBuffer.append(xpathExpression.substring(0,start+1));
				tail = xpathExpression.substring(end);
			} else {
				isSimpleFunctionXPath = false;
			}
    	}
    	
    	locationPathExpression = addDefaultNSPrefixForLocationXPathExpression(locationPathExpression,loopPath);
    	
    	resultXpathExpression = locationPathExpression;
    	
    	if(isSimpleFunctionXPath) {
        	stringBuffer.append(locationPathExpression);
    		stringBuffer.append(tail);
    		resultXpathExpression = stringBuffer.toString();
    		stringBuffer.setLength(0);
        }
    	
    	resultCache.put(xpathExpression,resultXpathExpression);
    	return resultXpathExpression;
	}
	
    private String addDefaultNSPrefixForLocationXPathExpression(String path, String loopPath) {
    	String fullPath = loopPath;
    	if(!path.equals(fullPath)){
        	for (String tmp : path.split("/")) {
        		if (("..").equals(tmp)) {
                    fullPath = fullPath.substring(0, fullPath.lastIndexOf("/"));
                } else {
                    fullPath += "/" + tmp;
                }
        	}
        }
    	int[] indexs = new int[fullPath.split("/").length - 1];
        java.util.Arrays.fill(indexs, -1);
        int length = 0;
        for (int i = 0; i < defualtNSPath.size(); i++) {
            if (defualtNSPath.get(i).length() > length && fullPath.startsWith(defualtNSPath.get(i))) {
                java.util.Arrays.fill(indexs, defualtNSPath.get(i).split("/").length - 2, indexs.length, i);
                length = defualtNSPath.get(i).length();
            }
        }
    
        StringBuilder newPath = new StringBuilder();
        String[] pathStrs = path.split("/");
        for (int i = 0; i < pathStrs.length; i++) {
            String tmp = pathStrs[i];
            if (newPath.length() > 0) {
                newPath.append("/");
            }
            if (tmp.length() > 0 && tmp.indexOf(":") == -1 && tmp.indexOf(".") == -1 /*&& tmp.indexOf("@") == -1*/) {
                int index = indexs[i + indexs.length - pathStrs.length];
                if (index >= 0) {
                	//==== add by wliu to support both filter and functions==
    				if(tmp.indexOf("[")>0 && tmp.indexOf("]")>tmp.indexOf("[")){//include filter
    					String tmpStr=replaceElementWithNS(tmp,"pre"+index+":");
    					newPath.append(tmpStr);
    				}else{
    					if(tmp.indexOf("@") != -1 || tmp.indexOf("(")<tmp.indexOf(")")){  // include attribute
    						newPath.append(tmp);
    					}else{
    				//==add end=======	
                    		newPath.append("pre").append(index).append(":").append(tmp);
                    	}
                    }                    
                } else {
                    newPath.append(tmp);
                }
            } else {
                newPath.append(tmp);
            }
        }
        return newPath.toString();
    }
    
	private String matches = "@*\\b[a-z|A-Z|_]+[[-]*\\w]*\\b[^'|^\\(]";
    private java.util.regex.Pattern pattern = java.util.regex.Pattern.compile(matches);
    
	private String replaceElementWithNS(String global, String pre){

        java.util.regex.Matcher match = pattern.matcher(global);
        StringBuffer sb = new StringBuffer();
        match.reset();
        while (match.find()) {
            String group = match.group();
            String tmp = "";
            if (group.toLowerCase().matches("\\b(div|mod|and|or)\\b.*") || group.matches("@.*")) {
                tmp = group;
            } else {
                tmp = tmp + pre + group;
            }
            match.appendReplacement(sb, tmp);
        }
        match.appendTail(sb);
        
        return sb.toString();
	}
	
}

class XML_API_tExtractXMLField_4{
	public boolean isDefNull(org.dom4j.Node node) throws javax.xml.transform.TransformerException {
        if (node != null && node instanceof org.dom4j.Element) {
        	org.dom4j.Attribute attri = ((org.dom4j.Element)node).attribute("nil");
        	if(attri != null && ("true").equals(attri.getText())){
            	return true;
            }
        }
        return false;
    }

    public boolean isMissing(org.dom4j.Node node) throws javax.xml.transform.TransformerException {
        return node == null ? true : false;
    }

    public boolean isEmpty(org.dom4j.Node node) throws javax.xml.transform.TransformerException {
        if (node != null) {
            return node.getText().length() == 0;
        }
        return false;
    }
}

XML_API_tExtractXMLField_4 xml_api_tExtractXMLField_4 = new XML_API_tExtractXMLField_4();
 



/**
 * [tExtractXMLField_4 begin ] stop
 */



	
	/**
	 * [tXMLMap_4_TXMLMAP_IN begin ] start
	 */

	

	
		
		ok_Hash.put("tXMLMap_4_TXMLMAP_IN", false);
		start_Hash.put("tXMLMap_4_TXMLMAP_IN", System.currentTimeMillis());
		
	
		currentVirtualComponent = "tXMLMap_4";
	
	currentComponent="tXMLMap_4_TXMLMAP_IN";

	
		int tos_count_tXMLMap_4_TXMLMAP_IN = 0;
		
    	class BytesLimit65535_tXMLMap_4_TXMLMAP_IN{
    		public void limitLog4jByte() throws Exception{
    			
    		}
    	}
    	
        new BytesLimit65535_tXMLMap_4_TXMLMAP_IN().limitLog4jByte();
java.util.List<Object> outs_tXMLMap_4 = (java.util.List<Object>)globalMap.get("allOutsForAggregate_tXMLMap_4");
for(Object  row_out_tXMLMap_4_TXMLMAP_IN : outs_tXMLMap_4) {//TD512
 



/**
 * [tXMLMap_4_TXMLMAP_IN begin ] stop
 */
	
	/**
	 * [tXMLMap_4_TXMLMAP_IN main ] start
	 */

	

	
	
		currentVirtualComponent = "tXMLMap_4";
	
	currentComponent="tXMLMap_4_TXMLMAP_IN";

	

	phones = null;
	if(row_out_tXMLMap_4_TXMLMAP_IN!=null && row_out_tXMLMap_4_TXMLMAP_IN instanceof phonesStruct) {
		phones = (phonesStruct)row_out_tXMLMap_4_TXMLMAP_IN;
			routines.system.NestXMLTool.generateOk(phones.doc, false);		
	}
 


	tos_count_tXMLMap_4_TXMLMAP_IN++;

/**
 * [tXMLMap_4_TXMLMAP_IN main ] stop
 */
// Start of branch "phones"
if(phones != null) { 



	
	/**
	 * [tExtractXMLField_4 main ] start
	 */

	

	
	
	currentComponent="tExtractXMLField_4";

	

			//phones
			//phones


			
				if(execStat){
					runStat.updateStatOnConnection("phones"+iterateId,1, 1);
				} 
			

		

	String xmlStr_tExtractXMLField_4 = null;
	routines.system.Document xmlDocument_tExtractXMLField_4 = null;
	if(phones.doc!=null){
				xmlDocument_tExtractXMLField_4 = phones.doc;
	}
			if(xmlDocument_tExtractXMLField_4!=null && xmlDocument_tExtractXMLField_4.getDocument()!=null){// C_01
phone = null;
phone = null;
	NameSpaceTool_tExtractXMLField_4 nsTool_tExtractXMLField_4 = new NameSpaceTool_tExtractXMLField_4();
    org.dom4j.io.SAXReader reader_tExtractXMLField_4 = new org.dom4j.io.SAXReader();
	
    org.dom4j.Document doc_tExtractXMLField_4 = null;
    java.util.HashMap xmlNameSpaceMap_tExtractXMLField_4 = null;
    org.dom4j.XPath x_tExtractXMLField_4 = null;
    java.util.List<org.dom4j.tree.AbstractNode> nodeList_tExtractXMLField_4 = null;
		String loopQuery_tExtractXMLField_4 = "/root"; 
	
    boolean isStructError_tExtractXMLField_4= true;
        
    try{
		
	    	doc_tExtractXMLField_4= xmlDocument_tExtractXMLField_4.getDocument();
	    
	    nsTool_tExtractXMLField_4.countNSMap(doc_tExtractXMLField_4.getRootElement());
	    xmlNameSpaceMap_tExtractXMLField_4 = nsTool_tExtractXMLField_4.xmlNameSpaceMap;

    	x_tExtractXMLField_4 = doc_tExtractXMLField_4.createXPath(nsTool_tExtractXMLField_4.addDefaultNSPrefix(loopQuery_tExtractXMLField_4,loopQuery_tExtractXMLField_4));
      
    	x_tExtractXMLField_4.setNamespaceURIs(xmlNameSpaceMap_tExtractXMLField_4); 
    
		 
    	nodeList_tExtractXMLField_4 = (java.util.List<org.dom4j.tree.AbstractNode>)x_tExtractXMLField_4.selectNodes(doc_tExtractXMLField_4);
    	
    	isStructError_tExtractXMLField_4 = false;
    	
    }catch(java.lang.Exception ex_tExtractXMLField_4){
    System.err.println(ex_tExtractXMLField_4.getMessage());
    }
    
    org.dom4j.Node node_tExtractXMLField_4 = null;
    String str_tExtractXMLField_4 = "";
    boolean resultIsNode_tExtractXMLField_4 = true;
    for(int i_tExtractXMLField_4=0; isStructError_tExtractXMLField_4 || (nodeList_tExtractXMLField_4!=null && i_tExtractXMLField_4 < nodeList_tExtractXMLField_4.size());i_tExtractXMLField_4++){
    	
    	if(!isStructError_tExtractXMLField_4){
			phone = null;
			phone = null;
    		phone = new phoneStruct();
    	
    		org.dom4j.tree.AbstractNode temp_tExtractXMLField_4 = nodeList_tExtractXMLField_4.get(i_tExtractXMLField_4);
	
	    	nb_line_tExtractXMLField_4++;	
			try{
			phone.CODE_BARRE = phones.CODE_BARRE;
				org.dom4j.XPath xTmp0_tExtractXMLField_4 = temp_tExtractXMLField_4.createXPath(nsTool_tExtractXMLField_4.addDefaultNSPrefix("phones",loopQuery_tExtractXMLField_4));
			    xTmp0_tExtractXMLField_4.setNamespaceURIs(xmlNameSpaceMap_tExtractXMLField_4);
				
			    Object obj0_tExtractXMLField_4 = xTmp0_tExtractXMLField_4.evaluate(temp_tExtractXMLField_4);
			    if(obj0_tExtractXMLField_4 instanceof String || obj0_tExtractXMLField_4 instanceof Number){
			    	resultIsNode_tExtractXMLField_4 = false;
    				str_tExtractXMLField_4 = String.valueOf(obj0_tExtractXMLField_4);
   				}else{
   					resultIsNode_tExtractXMLField_4 = true;
				    node_tExtractXMLField_4 = xTmp0_tExtractXMLField_4.selectSingleNode(temp_tExtractXMLField_4);
					str_tExtractXMLField_4 = node_tExtractXMLField_4==null?null:node_tExtractXMLField_4.asXML();
				}
									phone.doc = ParserUtils.parseTo_Document(str_tExtractXMLField_4);
}catch(java.lang.Exception ex_tExtractXMLField_4){
    System.err.println(ex_tExtractXMLField_4.getMessage());
    phone = null;
    	}
    }
    
    isStructError_tExtractXMLField_4 = false;


   globalMap.put("tExtractXMLField_4_NB_LINE", nb_line_tExtractXMLField_4);

 


	tos_count_tExtractXMLField_4++;

/**
 * [tExtractXMLField_4 main ] stop
 */
// Start of branch "phone"
if(phone != null) { 



	
	/**
	 * [tAdvancedHash_phone main ] start
	 */

	

	
	
	currentComponent="tAdvancedHash_phone";

	

			//phone
			//phone


			
				if(execStat){
					runStat.updateStatOnConnection("phone"+iterateId,1, 1);
				} 
			

		


			   
			   

					phoneStruct phone_HashRow = new phoneStruct();
		   	   	   
				
				phone_HashRow.doc = phone.doc;
				
				phone_HashRow.CODE_BARRE = phone.CODE_BARRE;
				
			tHash_Lookup_phone.put(phone_HashRow);
			
            




 


	tos_count_tAdvancedHash_phone++;

/**
 * [tAdvancedHash_phone main ] stop
 */

} // End of branch "phone"

		// end for
	}


	
		} // C_01
	

} // End of branch "phones"




	
	/**
	 * [tXMLMap_4_TXMLMAP_IN end ] start
	 */

	

	
	
		currentVirtualComponent = "tXMLMap_4";
	
	currentComponent="tXMLMap_4_TXMLMAP_IN";

	

}//TD512
 

ok_Hash.put("tXMLMap_4_TXMLMAP_IN", true);
end_Hash.put("tXMLMap_4_TXMLMAP_IN", System.currentTimeMillis());




/**
 * [tXMLMap_4_TXMLMAP_IN end ] stop
 */

	
	/**
	 * [tExtractXMLField_4 end ] start
	 */

	

	
	
	currentComponent="tExtractXMLField_4";

	



globalMap.put("tExtractXMLField_4_NB_LINE", nb_line_tExtractXMLField_4);

			if(execStat){
				if(resourceMap.get("inIterateVComp") == null || !((Boolean)resourceMap.get("inIterateVComp"))){
			 		runStat.updateStatOnConnection("phones"+iterateId,2, 0); 
			 	}
			}
		
 

ok_Hash.put("tExtractXMLField_4", true);
end_Hash.put("tExtractXMLField_4", System.currentTimeMillis());




/**
 * [tExtractXMLField_4 end ] stop
 */

	
	/**
	 * [tAdvancedHash_phone end ] start
	 */

	

	
	
	currentComponent="tAdvancedHash_phone";

	

tHash_Lookup_phone.endPut();

			if(execStat){
				if(resourceMap.get("inIterateVComp") == null || !((Boolean)resourceMap.get("inIterateVComp"))){
			 		runStat.updateStatOnConnection("phone"+iterateId,2, 0); 
			 	}
			}
		
 

ok_Hash.put("tAdvancedHash_phone", true);
end_Hash.put("tAdvancedHash_phone", System.currentTimeMillis());




/**
 * [tAdvancedHash_phone end ] stop
 */












				}//end the resume

				



	
			}catch(java.lang.Exception e){	
				
				TalendException te = new TalendException(e, currentComponent, globalMap);
				
					te.setVirtualComponentName(currentVirtualComponent);
				
				throw te;
			}catch(java.lang.Error error){	
				
					runStat.stopThreadStat();
				
				throw error;
			}finally{
				
				try{
					
	
	/**
	 * [tOracleInput_6 finally ] start
	 */

	

	
	
	currentComponent="tOracleInput_6";

	

 



/**
 * [tOracleInput_6 finally ] stop
 */

	
	/**
	 * [tXMLMap_4_TXMLMAP_OUT finally ] start
	 */

	

	
	
		currentVirtualComponent = "tXMLMap_4";
	
	currentComponent="tXMLMap_4_TXMLMAP_OUT";

	

 



/**
 * [tXMLMap_4_TXMLMAP_OUT finally ] stop
 */

	
	/**
	 * [tXMLMap_4_TXMLMAP_IN finally ] start
	 */

	

	
	
		currentVirtualComponent = "tXMLMap_4";
	
	currentComponent="tXMLMap_4_TXMLMAP_IN";

	

 



/**
 * [tXMLMap_4_TXMLMAP_IN finally ] stop
 */

	
	/**
	 * [tExtractXMLField_4 finally ] start
	 */

	

	
	
	currentComponent="tExtractXMLField_4";

	

 



/**
 * [tExtractXMLField_4 finally ] stop
 */

	
	/**
	 * [tAdvancedHash_phone finally ] start
	 */

	

	
	
	currentComponent="tAdvancedHash_phone";

	

 



/**
 * [tAdvancedHash_phone finally ] stop
 */












				}catch(java.lang.Exception e){	
					//ignore
				}catch(java.lang.Error error){
					//ignore
				}
				resourceMap = null;
			}
		

		globalMap.put("tOracleInput_6_SUBPROCESS_STATE", 1);
	}
	


public static class telephoneStruct implements routines.system.IPersistableComparableLookupRow<telephoneStruct> {
    final static byte[] commonByteArrayLock_LDAP_sgbm_export = new byte[0];
    static byte[] commonByteArray_LDAP_sgbm_export = new byte[0];
	protected static final int DEFAULT_HASHCODE = 1;
    protected static final int PRIME = 31;
    protected int hashCode = DEFAULT_HASHCODE;
    public boolean hashCodeDirty = true;

    public String loopKey;



	
			    public String CODE_BARRE;

				public String getCODE_BARRE () {
					return this.CODE_BARRE;
				}
				
			    public String TYPE;

				public String getTYPE () {
					return this.TYPE;
				}
				
			    public String NUMERO;

				public String getNUMERO () {
					return this.NUMERO;
				}
				
			    public String PREF;

				public String getPREF () {
					return this.PREF;
				}
				
			    public String SMS_PREF;

				public String getSMS_PREF () {
					return this.SMS_PREF;
				}
				


	@Override
	public int hashCode() {
		if (this.hashCodeDirty) {
			final int prime = PRIME;
			int result = DEFAULT_HASHCODE;
	
						result = prime * result + ((this.CODE_BARRE == null) ? 0 : this.CODE_BARRE.hashCode());
					
    		this.hashCode = result;
    		this.hashCodeDirty = false;
		}
		return this.hashCode;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj) return true;
		if (obj == null) return false;
		if (getClass() != obj.getClass()) return false;
		final telephoneStruct other = (telephoneStruct) obj;
		
						if (this.CODE_BARRE == null) {
							if (other.CODE_BARRE != null)
								return false;
						
						} else if (!this.CODE_BARRE.equals(other.CODE_BARRE))
						
							return false;
					

		return true;
    }

	public void copyDataTo(telephoneStruct other) {

		other.CODE_BARRE = this.CODE_BARRE;
	            other.TYPE = this.TYPE;
	            other.NUMERO = this.NUMERO;
	            other.PREF = this.PREF;
	            other.SMS_PREF = this.SMS_PREF;
	            
	}

	public void copyKeysDataTo(telephoneStruct other) {

		other.CODE_BARRE = this.CODE_BARRE;
	            	
	}




	private String readString(ObjectInputStream dis) throws IOException{
		String strReturn = null;
		int length = 0;
        length = dis.readInt();
		if (length == -1) {
			strReturn = null;
		} else {
			if(length > commonByteArray_LDAP_sgbm_export.length) {
				if(length < 1024 && commonByteArray_LDAP_sgbm_export.length == 0) {
   					commonByteArray_LDAP_sgbm_export = new byte[1024];
				} else {
   					commonByteArray_LDAP_sgbm_export = new byte[2 * length];
   				}
			}
			dis.readFully(commonByteArray_LDAP_sgbm_export, 0, length);
			strReturn = new String(commonByteArray_LDAP_sgbm_export, 0, length, utf8Charset);
		}
		return strReturn;
	}

    private void writeString(String str, ObjectOutputStream dos) throws IOException{
		if(str == null) {
            dos.writeInt(-1);
		} else {
            byte[] byteArray = str.getBytes(utf8Charset);
	    	dos.writeInt(byteArray.length);
			dos.write(byteArray);
    	}
    }

	private String readString(DataInputStream dis, ObjectInputStream ois) throws IOException{
		String strReturn = null;
		int length = 0;
        length = dis.readInt();
		if (length == -1) {
			strReturn = null;
		} else {
			byte[] byteArray = new byte[length];
			dis.read(byteArray);
			strReturn = new String(byteArray, utf8Charset);
		}
		return strReturn;
	}

	private void writeString(String str, DataOutputStream dos, ObjectOutputStream oos) throws IOException{
		if(str == null) {
            dos.writeInt(-1);
		} else {
            byte[] byteArray = str.getBytes(utf8Charset);
	    	dos.writeInt(byteArray.length);
			dos.write(byteArray);
    	}
	}

    public void readKeysData(ObjectInputStream dis) {

		synchronized(commonByteArrayLock_LDAP_sgbm_export) {

        	try {

        		int length = 0;
		
					this.CODE_BARRE = readString(dis);
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);

		

        }

		

      }


    }

    public void writeKeysData(ObjectOutputStream dos) {
        try {

		
					// String
				
						writeString(this.CODE_BARRE,dos);
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);
        }


    }



    /**
     * Fill Values data by reading ObjectInputStream.
     */
    public void readValuesData(DataInputStream dis, ObjectInputStream ois) {
        try {

			int length = 0;
		
						this.TYPE = readString(dis,ois);
					
						this.NUMERO = readString(dis,ois);
					
						this.PREF = readString(dis,ois);
					
						this.SMS_PREF = readString(dis,ois);
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);

		

        }

		

    }

    /**
     * Return a byte array which represents Values data.
     */
    public void writeValuesData(DataOutputStream dos, ObjectOutputStream oos) {
        try {

		
						writeString(this.TYPE, dos, oos);
					
						writeString(this.NUMERO, dos, oos);
					
						writeString(this.PREF, dos, oos);
					
						writeString(this.SMS_PREF, dos, oos);
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);
        	}

    }


    public String toString() {

		StringBuilder sb = new StringBuilder();
		sb.append(super.toString());
		sb.append("[");
		sb.append("CODE_BARRE="+CODE_BARRE);
		sb.append(",TYPE="+TYPE);
		sb.append(",NUMERO="+NUMERO);
		sb.append(",PREF="+PREF);
		sb.append(",SMS_PREF="+SMS_PREF);
	    sb.append("]");

	    return sb.toString();
    }

    /**
     * Compare keys
     */
    public int compareTo(telephoneStruct other) {

		int returnValue = -1;
		
						returnValue = checkNullsAndCompare(this.CODE_BARRE, other.CODE_BARRE);
						if(returnValue != 0) {
							return returnValue;
						}

					
	    return returnValue;
    }


    private int checkNullsAndCompare(Object object1, Object object2) {
        int returnValue = 0;
		if (object1 instanceof Comparable && object2 instanceof Comparable) {
            returnValue = ((Comparable) object1).compareTo(object2);
        } else if (object1 != null && object2 != null) {
            returnValue = compareStrings(object1.toString(), object2.toString());
        } else if (object1 == null && object2 != null) {
            returnValue = 1;
        } else if (object1 != null && object2 == null) {
            returnValue = -1;
        } else {
            returnValue = 0;
        }

        return returnValue;
    }

    private int compareStrings(String string1, String string2) {
        return string1.compareTo(string2);
    }


}
public void tOracleInput_7Process(final java.util.Map<String, Object> globalMap) throws TalendException {
	globalMap.put("tOracleInput_7_SUBPROCESS_STATE", 0);

 final boolean execStat = this.execStat;
	
		String iterateId = "";
	
	
	String currentComponent = "";
	java.util.Map<String, Object> resourceMap = new java.util.HashMap<String, Object>();

	try {

			String currentMethodName = new java.lang.Exception().getStackTrace()[0].getMethodName();
			boolean resumeIt = currentMethodName.equals(resumeEntryMethodName);
			if( resumeEntryMethodName == null || resumeIt || globalResumeTicket){//start the resume
				globalResumeTicket = true;



		telephoneStruct telephone = new telephoneStruct();




	
	/**
	 * [tAdvancedXMLMapHash_telephone begin ] start
	 */

	

	
		
		ok_Hash.put("tAdvancedXMLMapHash_telephone", false);
		start_Hash.put("tAdvancedXMLMapHash_telephone", System.currentTimeMillis());
		
	
	currentComponent="tAdvancedXMLMapHash_telephone";

	
			if (execStat) {
				if(resourceMap.get("inIterateVComp") == null){
					
						runStat.updateStatOnConnection("telephone" + iterateId, 0, 0);
					
				}
			} 

		
		int tos_count_tAdvancedXMLMapHash_telephone = 0;
		
    	class BytesLimit65535_tAdvancedXMLMapHash_telephone{
    		public void limitLog4jByte() throws Exception{
    			
    		}
    	}
    	
        new BytesLimit65535_tAdvancedXMLMapHash_telephone().limitLog4jByte();

			   		// connection name:telephone
			   		// source node:tOracleInput_7 - inputs:(after_tOracleInput_6) outputs:(telephone,telephone) | target node:tAdvancedXMLMapHash_telephone - inputs:(telephone) outputs:()
			   		// linked node: tXMLMap_4 - inputs:(infoTel,telephone) outputs:(phones)
			   
			   		org.talend.designer.components.lookup.common.ICommonLookup.MATCHING_MODE matchingModeEnum_telephone = 
			   			org.talend.designer.components.lookup.common.ICommonLookup.MATCHING_MODE.ALL_MATCHES;
			   
			   
	   				org.talend.designer.components.lookup.memory.AdvancedMemoryLookup<telephoneStruct> tHash_Lookup_telephone = 
	   					org.talend.designer.components.lookup.memory.AdvancedMemoryLookup.
	   						<telephoneStruct>getLookup(matchingModeEnum_telephone);

		   	   	   globalMap.put("tHash_Lookup_telephone", tHash_Lookup_telephone);
		   	   	   
				
            

 



/**
 * [tAdvancedXMLMapHash_telephone begin ] stop
 */



	
	/**
	 * [tOracleInput_7 begin ] start
	 */

	

	
		
		ok_Hash.put("tOracleInput_7", false);
		start_Hash.put("tOracleInput_7", System.currentTimeMillis());
		
	
	currentComponent="tOracleInput_7";

	
		int tos_count_tOracleInput_7 = 0;
		
    	class BytesLimit65535_tOracleInput_7{
    		public void limitLog4jByte() throws Exception{
    			
    		}
    	}
    	
        new BytesLimit65535_tOracleInput_7().limitLog4jByte();
	


	
		    int nb_line_tOracleInput_7 = 0;
		    java.sql.Connection conn_tOracleInput_7 = null;
		        conn_tOracleInput_7 = (java.sql.Connection)globalMap.get("conn_tOracleConnection_1");
				
				if(((oracle.jdbc.OracleConnection)conn_tOracleInput_7).getSessionTimeZone() == null){
					java.sql.Statement stmtGetTZ_tOracleInput_7 = conn_tOracleInput_7.createStatement();
					java.sql.ResultSet rsGetTZ_tOracleInput_7 = stmtGetTZ_tOracleInput_7.executeQuery("select sessiontimezone from dual");
					String sessionTimezone_tOracleInput_7 = java.util.TimeZone.getDefault().getID();
					while (rsGetTZ_tOracleInput_7.next()) {
						sessionTimezone_tOracleInput_7 = rsGetTZ_tOracleInput_7.getString(1);
					}
					((oracle.jdbc.OracleConnection)conn_tOracleInput_7).setSessionTimeZone(sessionTimezone_tOracleInput_7);
				}
			
		    
			java.sql.Statement stmt_tOracleInput_7 = conn_tOracleInput_7.createStatement();

		    String dbquery_tOracleInput_7 = "SELECT \n  "+context.oracle_schema+".V_SGBMP_TELEPHONE.*\nFROM "+context.oracle_schema+".V_SGBMP_TELEPHONE";
			

            	globalMap.put("tOracleInput_7_QUERY",dbquery_tOracleInput_7);
		    java.sql.ResultSet rs_tOracleInput_7 = null;

		    try {
		    	rs_tOracleInput_7 = stmt_tOracleInput_7.executeQuery(dbquery_tOracleInput_7);
		    	java.sql.ResultSetMetaData rsmd_tOracleInput_7 = rs_tOracleInput_7.getMetaData();
		    	int colQtyInRs_tOracleInput_7 = rsmd_tOracleInput_7.getColumnCount();

		    String tmpContent_tOracleInput_7 = null;
		    
		    
		    while (rs_tOracleInput_7.next()) {
		        nb_line_tOracleInput_7++;
		        
							if(colQtyInRs_tOracleInput_7 < 1) {
								telephone.CODE_BARRE = null;
							} else {
	                         		
        	telephone.CODE_BARRE = routines.system.JDBCUtil.getString(rs_tOracleInput_7, 1, false);
		                    }
							if(colQtyInRs_tOracleInput_7 < 2) {
								telephone.TYPE = null;
							} else {
	                         		
        	telephone.TYPE = routines.system.JDBCUtil.getString(rs_tOracleInput_7, 2, false);
		                    }
							if(colQtyInRs_tOracleInput_7 < 3) {
								telephone.NUMERO = null;
							} else {
	                         		
        	telephone.NUMERO = routines.system.JDBCUtil.getString(rs_tOracleInput_7, 3, false);
		                    }
							if(colQtyInRs_tOracleInput_7 < 4) {
								telephone.PREF = null;
							} else {
	                         		
        	telephone.PREF = routines.system.JDBCUtil.getString(rs_tOracleInput_7, 4, false);
		                    }
							if(colQtyInRs_tOracleInput_7 < 5) {
								telephone.SMS_PREF = null;
							} else {
	                         		
        	telephone.SMS_PREF = routines.system.JDBCUtil.getString(rs_tOracleInput_7, 5, false);
		                    }
					




 



/**
 * [tOracleInput_7 begin ] stop
 */
	
	/**
	 * [tOracleInput_7 main ] start
	 */

	

	
	
	currentComponent="tOracleInput_7";

	

 


	tos_count_tOracleInput_7++;

/**
 * [tOracleInput_7 main ] stop
 */

	
	/**
	 * [tAdvancedXMLMapHash_telephone main ] start
	 */

	

	
	
	currentComponent="tAdvancedXMLMapHash_telephone";

	

			//telephone
			//telephone


			
				if(execStat){
					runStat.updateStatOnConnection("telephone"+iterateId,1, 1);
				} 
			

		


			   
			   

					telephoneStruct telephone_HashRow = new telephoneStruct();
					
				
					telephone_HashRow.CODE_BARRE = telephone.CODE_BARRE;
					
					telephone_HashRow.TYPE = telephone.TYPE;
					
					telephone_HashRow.NUMERO = telephone.NUMERO;
					
					telephone_HashRow.PREF = telephone.PREF;
					
					telephone_HashRow.SMS_PREF = telephone.SMS_PREF;
					
					tHash_Lookup_telephone.put(telephone_HashRow);
				
            




 


	tos_count_tAdvancedXMLMapHash_telephone++;

/**
 * [tAdvancedXMLMapHash_telephone main ] stop
 */



	
	/**
	 * [tOracleInput_7 end ] start
	 */

	

	
	
	currentComponent="tOracleInput_7";

	

}
}finally{
stmt_tOracleInput_7.close();

}

globalMap.put("tOracleInput_7_NB_LINE",nb_line_tOracleInput_7);
 

ok_Hash.put("tOracleInput_7", true);
end_Hash.put("tOracleInput_7", System.currentTimeMillis());




/**
 * [tOracleInput_7 end ] stop
 */

	
	/**
	 * [tAdvancedXMLMapHash_telephone end ] start
	 */

	

	
	
	currentComponent="tAdvancedXMLMapHash_telephone";

	

tHash_Lookup_telephone.endPut();

			if(execStat){
				if(resourceMap.get("inIterateVComp") == null || !((Boolean)resourceMap.get("inIterateVComp"))){
			 		runStat.updateStatOnConnection("telephone"+iterateId,2, 0); 
			 	}
			}
		
 

ok_Hash.put("tAdvancedXMLMapHash_telephone", true);
end_Hash.put("tAdvancedXMLMapHash_telephone", System.currentTimeMillis());




/**
 * [tAdvancedXMLMapHash_telephone end ] stop
 */



				}//end the resume

				



	
			}catch(java.lang.Exception e){	
				
				TalendException te = new TalendException(e, currentComponent, globalMap);
				
				throw te;
			}catch(java.lang.Error error){	
				
					runStat.stopThreadStat();
				
				throw error;
			}finally{
				
				try{
					
	
	/**
	 * [tOracleInput_7 finally ] start
	 */

	

	
	
	currentComponent="tOracleInput_7";

	

 



/**
 * [tOracleInput_7 finally ] stop
 */

	
	/**
	 * [tAdvancedXMLMapHash_telephone finally ] start
	 */

	

	
	
	currentComponent="tAdvancedXMLMapHash_telephone";

	

 



/**
 * [tAdvancedXMLMapHash_telephone finally ] stop
 */



				}catch(java.lang.Exception e){	
					//ignore
				}catch(java.lang.Error error){
					//ignore
				}
				resourceMap = null;
			}
		

		globalMap.put("tOracleInput_7_SUBPROCESS_STATE", 1);
	}
	


public static class statistiqueStruct implements routines.system.IPersistableComparableLookupRow<statistiqueStruct> {
    final static byte[] commonByteArrayLock_LDAP_sgbm_export = new byte[0];
    static byte[] commonByteArray_LDAP_sgbm_export = new byte[0];
	protected static final int DEFAULT_HASHCODE = 1;
    protected static final int PRIME = 31;
    protected int hashCode = DEFAULT_HASHCODE;
    public boolean hashCodeDirty = true;

    public String loopKey;



	
			    public routines.system.Document doc;

				public routines.system.Document getDoc () {
					return this.doc;
				}
				
			    public String CODE_BARRE;

				public String getCODE_BARRE () {
					return this.CODE_BARRE;
				}
				


	@Override
	public int hashCode() {
		if (this.hashCodeDirty) {
			final int prime = PRIME;
			int result = DEFAULT_HASHCODE;
	
						result = prime * result + ((this.CODE_BARRE == null) ? 0 : this.CODE_BARRE.hashCode());
					
    		this.hashCode = result;
    		this.hashCodeDirty = false;
		}
		return this.hashCode;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj) return true;
		if (obj == null) return false;
		if (getClass() != obj.getClass()) return false;
		final statistiqueStruct other = (statistiqueStruct) obj;
		
						if (this.CODE_BARRE == null) {
							if (other.CODE_BARRE != null)
								return false;
						
						} else if (!this.CODE_BARRE.equals(other.CODE_BARRE))
						
							return false;
					

		return true;
    }

	public void copyDataTo(statistiqueStruct other) {

		other.doc = this.doc;
	            other.CODE_BARRE = this.CODE_BARRE;
	            
	}

	public void copyKeysDataTo(statistiqueStruct other) {

		other.CODE_BARRE = this.CODE_BARRE;
	            	
	}




	private String readString(ObjectInputStream dis) throws IOException{
		String strReturn = null;
		int length = 0;
        length = dis.readInt();
		if (length == -1) {
			strReturn = null;
		} else {
			if(length > commonByteArray_LDAP_sgbm_export.length) {
				if(length < 1024 && commonByteArray_LDAP_sgbm_export.length == 0) {
   					commonByteArray_LDAP_sgbm_export = new byte[1024];
				} else {
   					commonByteArray_LDAP_sgbm_export = new byte[2 * length];
   				}
			}
			dis.readFully(commonByteArray_LDAP_sgbm_export, 0, length);
			strReturn = new String(commonByteArray_LDAP_sgbm_export, 0, length, utf8Charset);
		}
		return strReturn;
	}

    private void writeString(String str, ObjectOutputStream dos) throws IOException{
		if(str == null) {
            dos.writeInt(-1);
		} else {
            byte[] byteArray = str.getBytes(utf8Charset);
	    	dos.writeInt(byteArray.length);
			dos.write(byteArray);
    	}
    }

    public void readKeysData(ObjectInputStream dis) {

		synchronized(commonByteArrayLock_LDAP_sgbm_export) {

        	try {

        		int length = 0;
		
					this.CODE_BARRE = readString(dis);
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);

		

        }

		

      }


    }

    public void writeKeysData(ObjectOutputStream dos) {
        try {

		
					// String
				
						writeString(this.CODE_BARRE,dos);
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);
        }


    }



    /**
     * Fill Values data by reading ObjectInputStream.
     */
    public void readValuesData(DataInputStream dis, ObjectInputStream ois) {
        try {

			int length = 0;
		
       			    	this.doc = (routines.system.Document) ois.readObject();
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);

		
			} catch(ClassNotFoundException eCNFE) {
				 throw new RuntimeException(eCNFE);
		

        }

		

    }

    /**
     * Return a byte array which represents Values data.
     */
    public void writeValuesData(DataOutputStream dos, ObjectOutputStream oos) {
        try {

		
       			    	oos.writeObject(this.doc);
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);
        	}

    }


    public String toString() {

		StringBuilder sb = new StringBuilder();
		sb.append(super.toString());
		sb.append("[");
		sb.append("doc="+String.valueOf(doc));
		sb.append(",CODE_BARRE="+CODE_BARRE);
	    sb.append("]");

	    return sb.toString();
    }

    /**
     * Compare keys
     */
    public int compareTo(statistiqueStruct other) {

		int returnValue = -1;
		
						returnValue = checkNullsAndCompare(this.CODE_BARRE, other.CODE_BARRE);
						if(returnValue != 0) {
							return returnValue;
						}

					
	    return returnValue;
    }


    private int checkNullsAndCompare(Object object1, Object object2) {
        int returnValue = 0;
		if (object1 instanceof Comparable && object2 instanceof Comparable) {
            returnValue = ((Comparable) object1).compareTo(object2);
        } else if (object1 != null && object2 != null) {
            returnValue = compareStrings(object1.toString(), object2.toString());
        } else if (object1 == null && object2 != null) {
            returnValue = 1;
        } else if (object1 != null && object2 == null) {
            returnValue = -1;
        } else {
            returnValue = 0;
        }

        return returnValue;
    }

    private int compareStrings(String string1, String string2) {
        return string1.compareTo(string2);
    }


}

public static class statsStruct implements routines.system.IPersistableRow<statsStruct> {
    final static byte[] commonByteArrayLock_LDAP_sgbm_export = new byte[0];
    static byte[] commonByteArray_LDAP_sgbm_export = new byte[0];

	
			    public routines.system.Document doc;

				public routines.system.Document getDoc () {
					return this.doc;
				}
				
			    public String CODE_BARRE;

				public String getCODE_BARRE () {
					return this.CODE_BARRE;
				}
				



	private String readString(ObjectInputStream dis) throws IOException{
		String strReturn = null;
		int length = 0;
        length = dis.readInt();
		if (length == -1) {
			strReturn = null;
		} else {
			if(length > commonByteArray_LDAP_sgbm_export.length) {
				if(length < 1024 && commonByteArray_LDAP_sgbm_export.length == 0) {
   					commonByteArray_LDAP_sgbm_export = new byte[1024];
				} else {
   					commonByteArray_LDAP_sgbm_export = new byte[2 * length];
   				}
			}
			dis.readFully(commonByteArray_LDAP_sgbm_export, 0, length);
			strReturn = new String(commonByteArray_LDAP_sgbm_export, 0, length, utf8Charset);
		}
		return strReturn;
	}

    private void writeString(String str, ObjectOutputStream dos) throws IOException{
		if(str == null) {
            dos.writeInt(-1);
		} else {
            byte[] byteArray = str.getBytes(utf8Charset);
	    	dos.writeInt(byteArray.length);
			dos.write(byteArray);
    	}
    }

    public void readData(ObjectInputStream dis) {

		synchronized(commonByteArrayLock_LDAP_sgbm_export) {

        	try {

        		int length = 0;
		
						this.doc = (routines.system.Document) dis.readObject();
					
					this.CODE_BARRE = readString(dis);
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);

		
			} catch(ClassNotFoundException eCNFE) {
				 throw new RuntimeException(eCNFE);
		

        }

		

      }


    }

    public void writeData(ObjectOutputStream dos) {
        try {

		
					// Document
				
       			    	dos.writeObject(this.doc);
					
					// String
				
						writeString(this.CODE_BARRE,dos);
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);
        }


    }


    public String toString() {

		StringBuilder sb = new StringBuilder();
		sb.append(super.toString());
		sb.append("[");
		sb.append("doc="+String.valueOf(doc));
		sb.append(",CODE_BARRE="+CODE_BARRE);
	    sb.append("]");

	    return sb.toString();
    }

    /**
     * Compare keys
     */
    public int compareTo(statsStruct other) {

		int returnValue = -1;
		
	    return returnValue;
    }


    private int checkNullsAndCompare(Object object1, Object object2) {
        int returnValue = 0;
		if (object1 instanceof Comparable && object2 instanceof Comparable) {
            returnValue = ((Comparable) object1).compareTo(object2);
        } else if (object1 != null && object2 != null) {
            returnValue = compareStrings(object1.toString(), object2.toString());
        } else if (object1 == null && object2 != null) {
            returnValue = 1;
        } else if (object1 != null && object2 == null) {
            returnValue = -1;
        } else {
            returnValue = 0;
        }

        return returnValue;
    }

    private int compareStrings(String string1, String string2) {
        return string1.compareTo(string2);
    }


}

public static class infoStatsStruct implements routines.system.IPersistableRow<infoStatsStruct> {
    final static byte[] commonByteArrayLock_LDAP_sgbm_export = new byte[0];
    static byte[] commonByteArray_LDAP_sgbm_export = new byte[0];

	
			    public String CODE_BARRE;

				public String getCODE_BARRE () {
					return this.CODE_BARRE;
				}
				
			    public String NOM;

				public String getNOM () {
					return this.NOM;
				}
				
			    public String PRENOM;

				public String getPRENOM () {
					return this.PRENOM;
				}
				
			    public String GROUPE;

				public String getGROUPE () {
					return this.GROUPE;
				}
				
			    public String CAMPUS;

				public String getCAMPUS () {
					return this.CAMPUS;
				}
				
			    public String LANGUE;

				public String getLANGUE () {
					return this.LANGUE;
				}
				
			    public String STATUT;

				public String getSTATUT () {
					return this.STATUT;
				}
				
			    public java.util.Date DATE_NAISSANCE;

				public java.util.Date getDATE_NAISSANCE () {
					return this.DATE_NAISSANCE;
				}
				
			    public java.util.Date DATE_MODIF;

				public java.util.Date getDATE_MODIF () {
					return this.DATE_MODIF;
				}
				
			    public java.util.Date DATE_EXPIRATION;

				public java.util.Date getDATE_EXPIRATION () {
					return this.DATE_EXPIRATION;
				}
				
			    public java.util.Date DATE_ELIMINATION;

				public java.util.Date getDATE_ELIMINATION () {
					return this.DATE_ELIMINATION;
				}
				
			    public String EPPN;

				public String getEPPN () {
					return this.EPPN;
				}
				



	private String readString(ObjectInputStream dis) throws IOException{
		String strReturn = null;
		int length = 0;
        length = dis.readInt();
		if (length == -1) {
			strReturn = null;
		} else {
			if(length > commonByteArray_LDAP_sgbm_export.length) {
				if(length < 1024 && commonByteArray_LDAP_sgbm_export.length == 0) {
   					commonByteArray_LDAP_sgbm_export = new byte[1024];
				} else {
   					commonByteArray_LDAP_sgbm_export = new byte[2 * length];
   				}
			}
			dis.readFully(commonByteArray_LDAP_sgbm_export, 0, length);
			strReturn = new String(commonByteArray_LDAP_sgbm_export, 0, length, utf8Charset);
		}
		return strReturn;
	}

    private void writeString(String str, ObjectOutputStream dos) throws IOException{
		if(str == null) {
            dos.writeInt(-1);
		} else {
            byte[] byteArray = str.getBytes(utf8Charset);
	    	dos.writeInt(byteArray.length);
			dos.write(byteArray);
    	}
    }

	private java.util.Date readDate(ObjectInputStream dis) throws IOException{
		java.util.Date dateReturn = null;
        int length = 0;
        length = dis.readByte();
		if (length == -1) {
			dateReturn = null;
		} else {
	    	dateReturn = new Date(dis.readLong());
		}
		return dateReturn;
	}

    private void writeDate(java.util.Date date1, ObjectOutputStream dos) throws IOException{
		if(date1 == null) {
            dos.writeByte(-1);
		} else {
			dos.writeByte(0);
	    	dos.writeLong(date1.getTime());
    	}
    }

    public void readData(ObjectInputStream dis) {

		synchronized(commonByteArrayLock_LDAP_sgbm_export) {

        	try {

        		int length = 0;
		
					this.CODE_BARRE = readString(dis);
					
					this.NOM = readString(dis);
					
					this.PRENOM = readString(dis);
					
					this.GROUPE = readString(dis);
					
					this.CAMPUS = readString(dis);
					
					this.LANGUE = readString(dis);
					
					this.STATUT = readString(dis);
					
					this.DATE_NAISSANCE = readDate(dis);
					
					this.DATE_MODIF = readDate(dis);
					
					this.DATE_EXPIRATION = readDate(dis);
					
					this.DATE_ELIMINATION = readDate(dis);
					
					this.EPPN = readString(dis);
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);

		

        }

		

      }


    }

    public void writeData(ObjectOutputStream dos) {
        try {

		
					// String
				
						writeString(this.CODE_BARRE,dos);
					
					// String
				
						writeString(this.NOM,dos);
					
					// String
				
						writeString(this.PRENOM,dos);
					
					// String
				
						writeString(this.GROUPE,dos);
					
					// String
				
						writeString(this.CAMPUS,dos);
					
					// String
				
						writeString(this.LANGUE,dos);
					
					// String
				
						writeString(this.STATUT,dos);
					
					// java.util.Date
				
						writeDate(this.DATE_NAISSANCE,dos);
					
					// java.util.Date
				
						writeDate(this.DATE_MODIF,dos);
					
					// java.util.Date
				
						writeDate(this.DATE_EXPIRATION,dos);
					
					// java.util.Date
				
						writeDate(this.DATE_ELIMINATION,dos);
					
					// String
				
						writeString(this.EPPN,dos);
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);
        }


    }


    public String toString() {

		StringBuilder sb = new StringBuilder();
		sb.append(super.toString());
		sb.append("[");
		sb.append("CODE_BARRE="+CODE_BARRE);
		sb.append(",NOM="+NOM);
		sb.append(",PRENOM="+PRENOM);
		sb.append(",GROUPE="+GROUPE);
		sb.append(",CAMPUS="+CAMPUS);
		sb.append(",LANGUE="+LANGUE);
		sb.append(",STATUT="+STATUT);
		sb.append(",DATE_NAISSANCE="+String.valueOf(DATE_NAISSANCE));
		sb.append(",DATE_MODIF="+String.valueOf(DATE_MODIF));
		sb.append(",DATE_EXPIRATION="+String.valueOf(DATE_EXPIRATION));
		sb.append(",DATE_ELIMINATION="+String.valueOf(DATE_ELIMINATION));
		sb.append(",EPPN="+EPPN);
	    sb.append("]");

	    return sb.toString();
    }

    /**
     * Compare keys
     */
    public int compareTo(infoStatsStruct other) {

		int returnValue = -1;
		
	    return returnValue;
    }


    private int checkNullsAndCompare(Object object1, Object object2) {
        int returnValue = 0;
		if (object1 instanceof Comparable && object2 instanceof Comparable) {
            returnValue = ((Comparable) object1).compareTo(object2);
        } else if (object1 != null && object2 != null) {
            returnValue = compareStrings(object1.toString(), object2.toString());
        } else if (object1 == null && object2 != null) {
            returnValue = 1;
        } else if (object1 != null && object2 == null) {
            returnValue = -1;
        } else {
            returnValue = 0;
        }

        return returnValue;
    }

    private int compareStrings(String string1, String string2) {
        return string1.compareTo(string2);
    }


}

public static class after_tOracleInput_8Struct implements routines.system.IPersistableRow<after_tOracleInput_8Struct> {
    final static byte[] commonByteArrayLock_LDAP_sgbm_export = new byte[0];
    static byte[] commonByteArray_LDAP_sgbm_export = new byte[0];

	
			    public String CODE_BARRE;

				public String getCODE_BARRE () {
					return this.CODE_BARRE;
				}
				
			    public String NOM;

				public String getNOM () {
					return this.NOM;
				}
				
			    public String PRENOM;

				public String getPRENOM () {
					return this.PRENOM;
				}
				
			    public String GROUPE;

				public String getGROUPE () {
					return this.GROUPE;
				}
				
			    public String CAMPUS;

				public String getCAMPUS () {
					return this.CAMPUS;
				}
				
			    public String LANGUE;

				public String getLANGUE () {
					return this.LANGUE;
				}
				
			    public String STATUT;

				public String getSTATUT () {
					return this.STATUT;
				}
				
			    public java.util.Date DATE_NAISSANCE;

				public java.util.Date getDATE_NAISSANCE () {
					return this.DATE_NAISSANCE;
				}
				
			    public java.util.Date DATE_MODIF;

				public java.util.Date getDATE_MODIF () {
					return this.DATE_MODIF;
				}
				
			    public java.util.Date DATE_EXPIRATION;

				public java.util.Date getDATE_EXPIRATION () {
					return this.DATE_EXPIRATION;
				}
				
			    public java.util.Date DATE_ELIMINATION;

				public java.util.Date getDATE_ELIMINATION () {
					return this.DATE_ELIMINATION;
				}
				
			    public String EPPN;

				public String getEPPN () {
					return this.EPPN;
				}
				



	private String readString(ObjectInputStream dis) throws IOException{
		String strReturn = null;
		int length = 0;
        length = dis.readInt();
		if (length == -1) {
			strReturn = null;
		} else {
			if(length > commonByteArray_LDAP_sgbm_export.length) {
				if(length < 1024 && commonByteArray_LDAP_sgbm_export.length == 0) {
   					commonByteArray_LDAP_sgbm_export = new byte[1024];
				} else {
   					commonByteArray_LDAP_sgbm_export = new byte[2 * length];
   				}
			}
			dis.readFully(commonByteArray_LDAP_sgbm_export, 0, length);
			strReturn = new String(commonByteArray_LDAP_sgbm_export, 0, length, utf8Charset);
		}
		return strReturn;
	}

    private void writeString(String str, ObjectOutputStream dos) throws IOException{
		if(str == null) {
            dos.writeInt(-1);
		} else {
            byte[] byteArray = str.getBytes(utf8Charset);
	    	dos.writeInt(byteArray.length);
			dos.write(byteArray);
    	}
    }

	private java.util.Date readDate(ObjectInputStream dis) throws IOException{
		java.util.Date dateReturn = null;
        int length = 0;
        length = dis.readByte();
		if (length == -1) {
			dateReturn = null;
		} else {
	    	dateReturn = new Date(dis.readLong());
		}
		return dateReturn;
	}

    private void writeDate(java.util.Date date1, ObjectOutputStream dos) throws IOException{
		if(date1 == null) {
            dos.writeByte(-1);
		} else {
			dos.writeByte(0);
	    	dos.writeLong(date1.getTime());
    	}
    }

    public void readData(ObjectInputStream dis) {

		synchronized(commonByteArrayLock_LDAP_sgbm_export) {

        	try {

        		int length = 0;
		
					this.CODE_BARRE = readString(dis);
					
					this.NOM = readString(dis);
					
					this.PRENOM = readString(dis);
					
					this.GROUPE = readString(dis);
					
					this.CAMPUS = readString(dis);
					
					this.LANGUE = readString(dis);
					
					this.STATUT = readString(dis);
					
					this.DATE_NAISSANCE = readDate(dis);
					
					this.DATE_MODIF = readDate(dis);
					
					this.DATE_EXPIRATION = readDate(dis);
					
					this.DATE_ELIMINATION = readDate(dis);
					
					this.EPPN = readString(dis);
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);

		

        }

		

      }


    }

    public void writeData(ObjectOutputStream dos) {
        try {

		
					// String
				
						writeString(this.CODE_BARRE,dos);
					
					// String
				
						writeString(this.NOM,dos);
					
					// String
				
						writeString(this.PRENOM,dos);
					
					// String
				
						writeString(this.GROUPE,dos);
					
					// String
				
						writeString(this.CAMPUS,dos);
					
					// String
				
						writeString(this.LANGUE,dos);
					
					// String
				
						writeString(this.STATUT,dos);
					
					// java.util.Date
				
						writeDate(this.DATE_NAISSANCE,dos);
					
					// java.util.Date
				
						writeDate(this.DATE_MODIF,dos);
					
					// java.util.Date
				
						writeDate(this.DATE_EXPIRATION,dos);
					
					// java.util.Date
				
						writeDate(this.DATE_ELIMINATION,dos);
					
					// String
				
						writeString(this.EPPN,dos);
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);
        }


    }


    public String toString() {

		StringBuilder sb = new StringBuilder();
		sb.append(super.toString());
		sb.append("[");
		sb.append("CODE_BARRE="+CODE_BARRE);
		sb.append(",NOM="+NOM);
		sb.append(",PRENOM="+PRENOM);
		sb.append(",GROUPE="+GROUPE);
		sb.append(",CAMPUS="+CAMPUS);
		sb.append(",LANGUE="+LANGUE);
		sb.append(",STATUT="+STATUT);
		sb.append(",DATE_NAISSANCE="+String.valueOf(DATE_NAISSANCE));
		sb.append(",DATE_MODIF="+String.valueOf(DATE_MODIF));
		sb.append(",DATE_EXPIRATION="+String.valueOf(DATE_EXPIRATION));
		sb.append(",DATE_ELIMINATION="+String.valueOf(DATE_ELIMINATION));
		sb.append(",EPPN="+EPPN);
	    sb.append("]");

	    return sb.toString();
    }

    /**
     * Compare keys
     */
    public int compareTo(after_tOracleInput_8Struct other) {

		int returnValue = -1;
		
	    return returnValue;
    }


    private int checkNullsAndCompare(Object object1, Object object2) {
        int returnValue = 0;
		if (object1 instanceof Comparable && object2 instanceof Comparable) {
            returnValue = ((Comparable) object1).compareTo(object2);
        } else if (object1 != null && object2 != null) {
            returnValue = compareStrings(object1.toString(), object2.toString());
        } else if (object1 == null && object2 != null) {
            returnValue = 1;
        } else if (object1 != null && object2 == null) {
            returnValue = -1;
        } else {
            returnValue = 0;
        }

        return returnValue;
    }

    private int compareStrings(String string1, String string2) {
        return string1.compareTo(string2);
    }


}
public void tOracleInput_8Process(final java.util.Map<String, Object> globalMap) throws TalendException {
	globalMap.put("tOracleInput_8_SUBPROCESS_STATE", 0);

 final boolean execStat = this.execStat;
		String currentVirtualComponent = null;
	
		String iterateId = "";
	
	
	String currentComponent = "";
	java.util.Map<String, Object> resourceMap = new java.util.HashMap<String, Object>();

	try {

			String currentMethodName = new java.lang.Exception().getStackTrace()[0].getMethodName();
			boolean resumeIt = currentMethodName.equals(resumeEntryMethodName);
			if( resumeEntryMethodName == null || resumeIt || globalResumeTicket){//start the resume
				globalResumeTicket = true;


		tOracleInput_9Process(globalMap);

		infoStatsStruct infoStats = new infoStatsStruct();
statsStruct stats = new statsStruct();
statistiqueStruct statistique = new statistiqueStruct();




	
	/**
	 * [tXMLMap_5_TXMLMAP_OUT begin ] start
	 */

	

	
		
		ok_Hash.put("tXMLMap_5_TXMLMAP_OUT", false);
		start_Hash.put("tXMLMap_5_TXMLMAP_OUT", System.currentTimeMillis());
		
	
		currentVirtualComponent = "tXMLMap_5";
	
	currentComponent="tXMLMap_5_TXMLMAP_OUT";

	
			if (execStat) {
				if(resourceMap.get("inIterateVComp") == null){
					
						runStat.updateStatOnConnection("infoStats" + iterateId, 0, 0);
					
				}
			} 

		
		int tos_count_tXMLMap_5_TXMLMAP_OUT = 0;
		
    	class BytesLimit65535_tXMLMap_5_TXMLMAP_OUT{
    		public void limitLog4jByte() throws Exception{
    			
    		}
    	}
    	
        new BytesLimit65535_tXMLMap_5_TXMLMAP_OUT().limitLog4jByte();

	org.talend.designer.components.lookup.memory.AdvancedMemoryLookup<statStruct> tHash_Lookup_stat = (org.talend.designer.components.lookup.memory.AdvancedMemoryLookup<statStruct>) 
			((org.talend.designer.components.lookup.memory.AdvancedMemoryLookup<statStruct>) 
				globalMap.get( "tHash_Lookup_stat" ))
				;
	
	
	statStruct statHashKey = new statStruct();
	statStruct statDefault = new statStruct();
	statStruct stat = new statStruct();
	
	
	
//===============================input xml init part===============================
class XML_API_tXMLMap_5_TXMLMAP_OUT{
	public boolean isDefNull(org.dom4j.Node node) throws javax.xml.transform.TransformerException {
        if (node != null && node instanceof org.dom4j.Element) {
        	org.dom4j.Attribute attri = ((org.dom4j.Element)node).attribute("nil");
        	if(attri != null && ("true").equals(attri.getText())){
            	return true;
            }
        }
        return false;
    }

    public boolean isMissing(org.dom4j.Node node) throws javax.xml.transform.TransformerException {
        return node == null ? true : false;
    }

    public boolean isEmpty(org.dom4j.Node node) throws javax.xml.transform.TransformerException {
        if (node != null) {
            return node.getText().length() == 0;
        }
        return false;
    }
}
	class Var__tXMLMap_5_TXMLMAP_OUT__Struct {
	}
	Var__tXMLMap_5_TXMLMAP_OUT__Struct Var__tXMLMap_5_TXMLMAP_OUT = new Var__tXMLMap_5_TXMLMAP_OUT__Struct();
// ###############################
// # Outputs initialization
statsStruct stats_tmp = new statsStruct();
statsStruct stats_save = null;
//the aggregate variable
statsStruct stats_aggregate = null;
//init the resultset for aggregate
java.util.List<Object> allOutsForAggregate_tXMLMap_5 = new java.util.ArrayList<Object>();
globalMap.put("allOutsForAggregate_tXMLMap_5",allOutsForAggregate_tXMLMap_5);
// ###############################
		int nb_line_tXMLMap_5_TXMLMAP_OUT = 0; 
	
    XML_API_tXMLMap_5_TXMLMAP_OUT xml_api_tXMLMap_5_TXMLMAP_OUT = new XML_API_tXMLMap_5_TXMLMAP_OUT();

	//the map store the previous value of aggregate columns
	java.util.Map<String,Object> aggregateCacheMap_tXMLMap_5_TXMLMAP_OUT = new java.util.HashMap<String,Object>();
					//init the map,the keys is aggregate columns xpath,the values is all null.
					aggregateCacheMap_tXMLMap_5_TXMLMAP_OUT.put("stats.doc:/root/@test",null);

class GenerateDocument_stats {

	java.util.Map<String,Object> valueMap = null;
	
	routines.system.DocumentGenerateOrderHelper orderHelper = new routines.system.DocumentGenerateOrderHelper(1);
	
	org.dom4j.Document doc = null;
	
	org.dom4j.Element root4Group = null;
	
	org.dom4j.io.OutputFormat format = null;
	
	java.util.List<java.util.List<String>> groupbyList = null;
	java.util.List<org.dom4j.Element> groupElementList = null;
	int order = 0;
	
	boolean isFirst = true;
	
	boolean	needRoot = true;
	
	String currentValue = null;

		org.dom4j.Element subTreeLoopParent0 = null;
		public boolean  subTreeLoop0 = false;
	
    public GenerateDocument_stats() {
//    	this.treeNodeAPI = treeNodeAPI;
    	
    	valueMap = new java.util.HashMap<String,Object>();
    	
    	groupbyList =  new java.util.ArrayList<java.util.List<String>>();
		groupElementList = new java.util.ArrayList<org.dom4j.Element>();
    	
    	doc = org.dom4j.DocumentHelper.createDocument();
    	format = org.dom4j.io.OutputFormat.createPrettyPrint();
    	format.setTrimText(false);
    }
    
    public org.dom4j.Document getDocument(){
    	return this.doc;
    }
    
	//We generate the TreeNode_API object only if there is a document in the main input table.
    void generateElements(boolean isInnerJoin, infoStatsStruct infoStats, statStruct stat, Var__tXMLMap_5_TXMLMAP_OUT__Struct Var
	) {
	
	
	/*if(this.treeNodeAPI==null) {
		this.treeNodeAPI = treeNodeAPI;
	}*/
	
	org.dom4j.Element subTreeRootParent = null;
// build root xml tree 
if (needRoot) {
	needRoot=false;
		org.dom4j.Element root = null;
				root = doc.addElement("root");
		subTreeRootParent = root;
				currentValue = null;
    			valueMap.put("root",infoStats.CODE_BARRE);
    			if(valueMap.get("root")!=null) {
    				currentValue = FormatterUtils.format(infoStats.CODE_BARRE,null);
    			} else {
    				currentValue = "";
    			}
				
    			routines.system.DocumentHelper.applyNamespace2Attribute(root,  null , "test", currentValue);
		org.dom4j.Element root_1 = null;
				root_1 = root.addElement("user_statistics");
		subTreeRootParent = root_1;
					subTreeLoopParent0 = root_1;
		root4Group = subTreeRootParent;
	}else{
		subTreeRootParent=root4Group;
	}
	/* build group xml tree */
	boolean isNewElement = false;
		isNewElement = false;
		org.dom4j.Element loop = null;
				loop = org.dom4j.DocumentHelper.createElement("user_statistic");
				subTreeRootParent.elements().add(orderHelper.getInsertLocation(0,0),loop);
		subTreeRootParent = loop;
				currentValue = null;
				currentValue = "";
    			routines.system.DocumentHelper.applyNamespace2Attribute(loop,  null , "segment_type", currentValue);
		org.dom4j.Element loop_3 = null;
				loop_3 = loop.addElement("statistic_category");
		valueMap.put("loop_3",(stat.CATEGORIE != null && !stat.CATEGORIE.equals(""))?stat.CATEGORIE:"OFC" );
		if(valueMap.get("loop_3")!=null) {
			routines.system.NestXMLTool.setText(loop_3, FormatterUtils.format((stat.CATEGORIE != null && !stat.CATEGORIE.equals(""))?stat.CATEGORIE:"OFC" ,null));
		}
		org.dom4j.Element loop_4 = null;
				loop_4 = loop.addElement("category_type");
		org.dom4j.Element loop_5 = null;
				loop_5 = loop.addElement("statistic_note");
		}
    }

	GenerateDocument_stats gen_Doc_stats_tXMLMap_5_TXMLMAP_OUT = new GenerateDocument_stats();
	boolean docAlreadyInstanciate_stats = false;

	            
 



/**
 * [tXMLMap_5_TXMLMAP_OUT begin ] stop
 */



	
	/**
	 * [tOracleInput_8 begin ] start
	 */

	

	
		
		ok_Hash.put("tOracleInput_8", false);
		start_Hash.put("tOracleInput_8", System.currentTimeMillis());
		
	
	currentComponent="tOracleInput_8";

	
		int tos_count_tOracleInput_8 = 0;
		
    	class BytesLimit65535_tOracleInput_8{
    		public void limitLog4jByte() throws Exception{
    			
    		}
    	}
    	
        new BytesLimit65535_tOracleInput_8().limitLog4jByte();
	


	
		    int nb_line_tOracleInput_8 = 0;
		    java.sql.Connection conn_tOracleInput_8 = null;
		        conn_tOracleInput_8 = (java.sql.Connection)globalMap.get("conn_tOracleConnection_1");
				
				if(((oracle.jdbc.OracleConnection)conn_tOracleInput_8).getSessionTimeZone() == null){
					java.sql.Statement stmtGetTZ_tOracleInput_8 = conn_tOracleInput_8.createStatement();
					java.sql.ResultSet rsGetTZ_tOracleInput_8 = stmtGetTZ_tOracleInput_8.executeQuery("select sessiontimezone from dual");
					String sessionTimezone_tOracleInput_8 = java.util.TimeZone.getDefault().getID();
					while (rsGetTZ_tOracleInput_8.next()) {
						sessionTimezone_tOracleInput_8 = rsGetTZ_tOracleInput_8.getString(1);
					}
					((oracle.jdbc.OracleConnection)conn_tOracleInput_8).setSessionTimeZone(sessionTimezone_tOracleInput_8);
				}
			
		    
			java.sql.Statement stmt_tOracleInput_8 = conn_tOracleInput_8.createStatement();

		    String dbquery_tOracleInput_8 = "SELECT \n  "+context.oracle_schema+".V_SGBMP_INFOGENE.* \nFROM "+context.oracle_schema+".V_SGBMP_INFOGENE "

;
			

            	globalMap.put("tOracleInput_8_QUERY",dbquery_tOracleInput_8);
		    java.sql.ResultSet rs_tOracleInput_8 = null;

		    try {
		    	rs_tOracleInput_8 = stmt_tOracleInput_8.executeQuery(dbquery_tOracleInput_8);
		    	java.sql.ResultSetMetaData rsmd_tOracleInput_8 = rs_tOracleInput_8.getMetaData();
		    	int colQtyInRs_tOracleInput_8 = rsmd_tOracleInput_8.getColumnCount();

		    String tmpContent_tOracleInput_8 = null;
		    
		    
		    while (rs_tOracleInput_8.next()) {
		        nb_line_tOracleInput_8++;
		        
							if(colQtyInRs_tOracleInput_8 < 1) {
								infoStats.CODE_BARRE = null;
							} else {
	                         		
        	infoStats.CODE_BARRE = routines.system.JDBCUtil.getString(rs_tOracleInput_8, 1, false);
		                    }
							if(colQtyInRs_tOracleInput_8 < 2) {
								infoStats.NOM = null;
							} else {
	                         		
        	infoStats.NOM = routines.system.JDBCUtil.getString(rs_tOracleInput_8, 2, false);
		                    }
							if(colQtyInRs_tOracleInput_8 < 3) {
								infoStats.PRENOM = null;
							} else {
	                         		
        	infoStats.PRENOM = routines.system.JDBCUtil.getString(rs_tOracleInput_8, 3, false);
		                    }
							if(colQtyInRs_tOracleInput_8 < 4) {
								infoStats.GROUPE = null;
							} else {
	                         		
        	infoStats.GROUPE = routines.system.JDBCUtil.getString(rs_tOracleInput_8, 4, false);
		                    }
							if(colQtyInRs_tOracleInput_8 < 5) {
								infoStats.CAMPUS = null;
							} else {
	                         		
        	infoStats.CAMPUS = routines.system.JDBCUtil.getString(rs_tOracleInput_8, 5, false);
		                    }
							if(colQtyInRs_tOracleInput_8 < 6) {
								infoStats.LANGUE = null;
							} else {
	                         		
        	infoStats.LANGUE = routines.system.JDBCUtil.getString(rs_tOracleInput_8, 6, false);
		                    }
							if(colQtyInRs_tOracleInput_8 < 7) {
								infoStats.STATUT = null;
							} else {
	                         		
        	infoStats.STATUT = routines.system.JDBCUtil.getString(rs_tOracleInput_8, 7, false);
		                    }
							if(colQtyInRs_tOracleInput_8 < 8) {
								infoStats.DATE_NAISSANCE = null;
							} else {
										
			infoStats.DATE_NAISSANCE = routines.system.JDBCUtil.getDate(rs_tOracleInput_8, 8);
		                    }
							if(colQtyInRs_tOracleInput_8 < 9) {
								infoStats.DATE_MODIF = null;
							} else {
										
			infoStats.DATE_MODIF = routines.system.JDBCUtil.getDate(rs_tOracleInput_8, 9);
		                    }
							if(colQtyInRs_tOracleInput_8 < 10) {
								infoStats.DATE_EXPIRATION = null;
							} else {
										
			infoStats.DATE_EXPIRATION = routines.system.JDBCUtil.getDate(rs_tOracleInput_8, 10);
		                    }
							if(colQtyInRs_tOracleInput_8 < 11) {
								infoStats.DATE_ELIMINATION = null;
							} else {
										
			infoStats.DATE_ELIMINATION = routines.system.JDBCUtil.getDate(rs_tOracleInput_8, 11);
		                    }
							if(colQtyInRs_tOracleInput_8 < 12) {
								infoStats.EPPN = null;
							} else {
	                         		
        	infoStats.EPPN = routines.system.JDBCUtil.getString(rs_tOracleInput_8, 12, false);
		                    }
					




 



/**
 * [tOracleInput_8 begin ] stop
 */
	
	/**
	 * [tOracleInput_8 main ] start
	 */

	

	
	
	currentComponent="tOracleInput_8";

	

 


	tos_count_tOracleInput_8++;

/**
 * [tOracleInput_8 main ] stop
 */

	
	/**
	 * [tXMLMap_5_TXMLMAP_OUT main ] start
	 */

	

	
	
		currentVirtualComponent = "tXMLMap_5";
	
	currentComponent="tXMLMap_5_TXMLMAP_OUT";

	

			//infoStats
			//infoStats


			
				if(execStat){
					runStat.updateStatOnConnection("infoStats"+iterateId,1, 1);
				} 
			

		

	boolean rejectedInnerJoin_tXMLMap_5_TXMLMAP_OUT = false;
	boolean rejectedDocInnerJoin_tXMLMap_5_TXMLMAP_OUT = false;
	boolean mainRowRejected_tXMLMap_5_TXMLMAP_OUT = false;
	boolean isMatchDocRowtXMLMap_5_TXMLMAP_OUT = false;
	  
	
			
   
					stats_tmp.doc = null;
					
		
		


			

			
				///////////////////////////////////////////////
				//Starting Lookup Table "org.talend.designer.xmlmap.model.emf.xmlmap.impl.InputXmlTreeImpl@4ef94b65 (expressionFilter: null, activateExpressionFilter: false, activateCondensedTool: false, minimized: false, name: stat, multiLoops: false) (lookup: true, matchingMode: UNIQUE_MATCH, lookupMode: LOAD_ONCE, innerJoin: false, persistent: false, activateGlobalMap: false)" 
				///////////////////////////////////////////////
				//tHash_Lookup_stat.initGet();
				
				
				
					boolean forceLoopstat = false;
					statStruct statObjectFromLookup = null;
					boolean hasResultFromLookupCachestat = false;
					java.util.Map<String,Object> cacheResultstat = new java.util.HashMap<String,Object>();
				
				
				
					   	statHashKey.CODE_BARRE = infoStats.CODE_BARRE ;
						statHashKey.hashCodeDirty = true;
						
					
					
						if(!rejectedInnerJoin_tXMLMap_5_TXMLMAP_OUT){//TD120
							
					
							
								
									tHash_Lookup_stat.lookup( statHashKey );
								
							
							if(hasResultFromLookupCachestat  || tHash_Lookup_stat.hasNext()){
							
							} else {
								
									stat = statDefault;
								
								
								
							}
						}//TD120
				   
				   		
				   
				   		statStruct fromLookup_stat = null;
						stat = statDefault;
				   
				   		
					    if(hasResultFromLookupCachestat) {//TD10086
					    	
					    } else if(!rejectedInnerJoin_tXMLMap_5_TXMLMAP_OUT) {
						  	
							while (tHash_Lookup_stat.hasNext()) {//TD119
								fromLookup_stat = null;
								stat = statDefault;
								fromLookup_stat = tHash_Lookup_stat.next();
								if (fromLookup_stat != null) {
								
									stat = fromLookup_stat;
									
									
									
									
								}
							}//TD119
							
						  	
						  	
				  		}//TD10086
				  		
				  		
				  		
				  		//////////////////////////////////////////////////////////////////////////////////////////////
				  		
				  		/////////////////////////////////////////////////////////////////////////////////////////////////
				  		
					
				
{ // start of Var scope

	// ###############################
	// # Vars tables

Var__tXMLMap_5_TXMLMAP_OUT__Struct Var = Var__tXMLMap_5_TXMLMAP_OUT;
		// ###############################
		// # Output tables

stats = null;


// # Output table : 'stats'

if((infoStats.CODE_BARRE)==null ||!infoStats.CODE_BARRE.equals(aggregateCacheMap_tXMLMap_5_TXMLMAP_OUT.get("stats.doc:/root/@test"))) {
gen_Doc_stats_tXMLMap_5_TXMLMAP_OUT = new GenerateDocument_stats();
//init one new out struct for cache the result.
stats_aggregate = new statsStruct();
stats_aggregate.doc = new routines.system.Document();
stats_aggregate.doc.setDocument(gen_Doc_stats_tXMLMap_5_TXMLMAP_OUT.getDocument());

//construct the resultset
allOutsForAggregate_tXMLMap_5.add(stats_aggregate);
//store the previous value
aggregateCacheMap_tXMLMap_5_TXMLMAP_OUT.put("stats.doc:/root/@test", infoStats.CODE_BARRE);
}


gen_Doc_stats_tXMLMap_5_TXMLMAP_OUT.generateElements(rejectedDocInnerJoin_tXMLMap_5_TXMLMAP_OUT,infoStats,stat,Var);


stats_tmp.CODE_BARRE = infoStats.CODE_BARRE;//set the flat column for aggregate
stats_aggregate.CODE_BARRE = infoStats.CODE_BARRE;


if(stats_aggregate!=null){

stats_aggregate.CODE_BARRE = stats_tmp.CODE_BARRE;
}
// ###############################

} // end of Var scope

rejectedInnerJoin_tXMLMap_5_TXMLMAP_OUT = false;



 


	tos_count_tXMLMap_5_TXMLMAP_OUT++;

/**
 * [tXMLMap_5_TXMLMAP_OUT main ] stop
 */



	
	/**
	 * [tOracleInput_8 end ] start
	 */

	

	
	
	currentComponent="tOracleInput_8";

	

}
}finally{
stmt_tOracleInput_8.close();

}

globalMap.put("tOracleInput_8_NB_LINE",nb_line_tOracleInput_8);
 

ok_Hash.put("tOracleInput_8", true);
end_Hash.put("tOracleInput_8", System.currentTimeMillis());




/**
 * [tOracleInput_8 end ] stop
 */

	
	/**
	 * [tXMLMap_5_TXMLMAP_OUT end ] start
	 */

	

	
	
		currentVirtualComponent = "tXMLMap_5";
	
	currentComponent="tXMLMap_5_TXMLMAP_OUT";

	




			if(execStat){
				if(resourceMap.get("inIterateVComp") == null || !((Boolean)resourceMap.get("inIterateVComp"))){
			 		runStat.updateStatOnConnection("infoStats"+iterateId,2, 0); 
			 	}
			}
		
 

ok_Hash.put("tXMLMap_5_TXMLMAP_OUT", true);
end_Hash.put("tXMLMap_5_TXMLMAP_OUT", System.currentTimeMillis());




/**
 * [tXMLMap_5_TXMLMAP_OUT end ] stop
 */



	
	/**
	 * [tAdvancedHash_statistique begin ] start
	 */

	

	
		
		ok_Hash.put("tAdvancedHash_statistique", false);
		start_Hash.put("tAdvancedHash_statistique", System.currentTimeMillis());
		
	
	currentComponent="tAdvancedHash_statistique";

	
			if (execStat) {
				if(resourceMap.get("inIterateVComp") == null){
					
						runStat.updateStatOnConnection("statistique" + iterateId, 0, 0);
					
				}
			} 

		
		int tos_count_tAdvancedHash_statistique = 0;
		
    	class BytesLimit65535_tAdvancedHash_statistique{
    		public void limitLog4jByte() throws Exception{
    			
    		}
    	}
    	
        new BytesLimit65535_tAdvancedHash_statistique().limitLog4jByte();

			   		// connection name:statistique
			   		// source node:tExtractXMLField_5 - inputs:(stats) outputs:(statistique,statistique) | target node:tAdvancedHash_statistique - inputs:(statistique) outputs:()
			   		// linked node: tMap_1 - inputs:(infos,adress,email,phone,statistique) outputs:(out1)
			   
			   		org.talend.designer.components.lookup.common.ICommonLookup.MATCHING_MODE matchingModeEnum_statistique = 
			   			org.talend.designer.components.lookup.common.ICommonLookup.MATCHING_MODE.UNIQUE_MATCH;
			   			
			   
	   			org.talend.designer.components.lookup.memory.AdvancedMemoryLookup<statistiqueStruct> tHash_Lookup_statistique =org.talend.designer.components.lookup.memory.AdvancedMemoryLookup.
	   						<statistiqueStruct>getLookup(matchingModeEnum_statistique);
	   						   
		   	   	   globalMap.put("tHash_Lookup_statistique", tHash_Lookup_statistique);
		   	   	   
				
           

 



/**
 * [tAdvancedHash_statistique begin ] stop
 */



	
	/**
	 * [tExtractXMLField_5 begin ] start
	 */

	

	
		
		ok_Hash.put("tExtractXMLField_5", false);
		start_Hash.put("tExtractXMLField_5", System.currentTimeMillis());
		
	
	currentComponent="tExtractXMLField_5";

	
			if (execStat) {
				if(resourceMap.get("inIterateVComp") == null){
					
						runStat.updateStatOnConnection("stats" + iterateId, 0, 0);
					
				}
			} 

		
		int tos_count_tExtractXMLField_5 = 0;
		
    	class BytesLimit65535_tExtractXMLField_5{
    		public void limitLog4jByte() throws Exception{
    			
    		}
    	}
    	
        new BytesLimit65535_tExtractXMLField_5().limitLog4jByte();

int nb_line_tExtractXMLField_5 = 0;

class NameSpaceTool_tExtractXMLField_5 {

    public java.util.HashMap<String, String> xmlNameSpaceMap = new java.util.HashMap<String, String>();
    
	private java.util.List<String> defualtNSPath = new java.util.ArrayList<String>();

    public void countNSMap(org.dom4j.Element el) {
        for (org.dom4j.Namespace ns : (java.util.List<org.dom4j.Namespace>) el.declaredNamespaces()) {
            if (ns.getPrefix().trim().length() == 0) {
                xmlNameSpaceMap.put("pre"+defualtNSPath.size(), ns.getURI());
                String path = "";
                org.dom4j.Element elTmp = el;
                while (elTmp != null) {
                   	if (elTmp.getNamespacePrefix() != null && elTmp.getNamespacePrefix().length() > 0) {
                        path = "/" + elTmp.getNamespacePrefix() + ":" + elTmp.getName() + path;
                    } else {
                        path = "/" + elTmp.getName() + path;
                    }
                    elTmp = elTmp.getParent();
                }
                defualtNSPath.add(path);
            } else {
                xmlNameSpaceMap.put(ns.getPrefix(), ns.getURI());
            }

        }
        for (org.dom4j.Element e : (java.util.List<org.dom4j.Element>) el.elements()) {
            countNSMap(e);
        }
    }
    
    /**
	 *	the regex for the xpath like that : 
	 *	case 1 : functionA(locationXPathExpression) 
	 *	case 2 : fn:functionA(locationXPathExpression) 
	 *	case 3 : functionA(functionB(locationXPathExpression))
	 *	case 4 : fn:functionA(fn:functionB(locationXPathExpression))
	 *	and like that.
	*/
	private java.util.regex.Pattern simpleFunctionPattern;
	private StringBuffer stringBuffer;
	private java.util.Map<String,String> resultCache;
	
	public String addDefaultNSPrefix(final String xpathExpression, String loopPath) {
	    if (defualtNSPath.size() < 1) {
        	return xpathExpression;
    	}
    	
    	if(resultCache == null) {
    		resultCache = new java.util.HashMap<String,String>();
    	}
    	
    	String resultXpathExpression = resultCache.get(xpathExpression);
		if(resultXpathExpression!=null) {
    		return resultXpathExpression;
    	}
    	
    	String locationPathExpression = xpathExpression;
    	
    	if(simpleFunctionPattern == null) {
    		simpleFunctionPattern = java.util.regex.Pattern.compile("([a-zA-z0-9]+:)?[a-zA-Z]+-?[A-Za-z]+\\(.*\\)");
    	}
    	
    	boolean isSimpleFunctionXPath = simpleFunctionPattern.matcher(xpathExpression).matches();
    	String tail = null;
    	if(isSimpleFunctionXPath) {
			int start = xpathExpression.lastIndexOf('(');
			int end = xpathExpression.indexOf(')');
			if(start < end) {
			    if(stringBuffer == null) {
    				stringBuffer = new StringBuffer();
    			}
				locationPathExpression = xpathExpression.substring(start+1,end);
				stringBuffer.append(xpathExpression.substring(0,start+1));
				tail = xpathExpression.substring(end);
			} else {
				isSimpleFunctionXPath = false;
			}
    	}
    	
    	locationPathExpression = addDefaultNSPrefixForLocationXPathExpression(locationPathExpression,loopPath);
    	
    	resultXpathExpression = locationPathExpression;
    	
    	if(isSimpleFunctionXPath) {
        	stringBuffer.append(locationPathExpression);
    		stringBuffer.append(tail);
    		resultXpathExpression = stringBuffer.toString();
    		stringBuffer.setLength(0);
        }
    	
    	resultCache.put(xpathExpression,resultXpathExpression);
    	return resultXpathExpression;
	}
	
    private String addDefaultNSPrefixForLocationXPathExpression(String path, String loopPath) {
    	String fullPath = loopPath;
    	if(!path.equals(fullPath)){
        	for (String tmp : path.split("/")) {
        		if (("..").equals(tmp)) {
                    fullPath = fullPath.substring(0, fullPath.lastIndexOf("/"));
                } else {
                    fullPath += "/" + tmp;
                }
        	}
        }
    	int[] indexs = new int[fullPath.split("/").length - 1];
        java.util.Arrays.fill(indexs, -1);
        int length = 0;
        for (int i = 0; i < defualtNSPath.size(); i++) {
            if (defualtNSPath.get(i).length() > length && fullPath.startsWith(defualtNSPath.get(i))) {
                java.util.Arrays.fill(indexs, defualtNSPath.get(i).split("/").length - 2, indexs.length, i);
                length = defualtNSPath.get(i).length();
            }
        }
    
        StringBuilder newPath = new StringBuilder();
        String[] pathStrs = path.split("/");
        for (int i = 0; i < pathStrs.length; i++) {
            String tmp = pathStrs[i];
            if (newPath.length() > 0) {
                newPath.append("/");
            }
            if (tmp.length() > 0 && tmp.indexOf(":") == -1 && tmp.indexOf(".") == -1 /*&& tmp.indexOf("@") == -1*/) {
                int index = indexs[i + indexs.length - pathStrs.length];
                if (index >= 0) {
                	//==== add by wliu to support both filter and functions==
    				if(tmp.indexOf("[")>0 && tmp.indexOf("]")>tmp.indexOf("[")){//include filter
    					String tmpStr=replaceElementWithNS(tmp,"pre"+index+":");
    					newPath.append(tmpStr);
    				}else{
    					if(tmp.indexOf("@") != -1 || tmp.indexOf("(")<tmp.indexOf(")")){  // include attribute
    						newPath.append(tmp);
    					}else{
    				//==add end=======	
                    		newPath.append("pre").append(index).append(":").append(tmp);
                    	}
                    }                    
                } else {
                    newPath.append(tmp);
                }
            } else {
                newPath.append(tmp);
            }
        }
        return newPath.toString();
    }
    
	private String matches = "@*\\b[a-z|A-Z|_]+[[-]*\\w]*\\b[^'|^\\(]";
    private java.util.regex.Pattern pattern = java.util.regex.Pattern.compile(matches);
    
	private String replaceElementWithNS(String global, String pre){

        java.util.regex.Matcher match = pattern.matcher(global);
        StringBuffer sb = new StringBuffer();
        match.reset();
        while (match.find()) {
            String group = match.group();
            String tmp = "";
            if (group.toLowerCase().matches("\\b(div|mod|and|or)\\b.*") || group.matches("@.*")) {
                tmp = group;
            } else {
                tmp = tmp + pre + group;
            }
            match.appendReplacement(sb, tmp);
        }
        match.appendTail(sb);
        
        return sb.toString();
	}
	
}

class XML_API_tExtractXMLField_5{
	public boolean isDefNull(org.dom4j.Node node) throws javax.xml.transform.TransformerException {
        if (node != null && node instanceof org.dom4j.Element) {
        	org.dom4j.Attribute attri = ((org.dom4j.Element)node).attribute("nil");
        	if(attri != null && ("true").equals(attri.getText())){
            	return true;
            }
        }
        return false;
    }

    public boolean isMissing(org.dom4j.Node node) throws javax.xml.transform.TransformerException {
        return node == null ? true : false;
    }

    public boolean isEmpty(org.dom4j.Node node) throws javax.xml.transform.TransformerException {
        if (node != null) {
            return node.getText().length() == 0;
        }
        return false;
    }
}

XML_API_tExtractXMLField_5 xml_api_tExtractXMLField_5 = new XML_API_tExtractXMLField_5();
 



/**
 * [tExtractXMLField_5 begin ] stop
 */



	
	/**
	 * [tXMLMap_5_TXMLMAP_IN begin ] start
	 */

	

	
		
		ok_Hash.put("tXMLMap_5_TXMLMAP_IN", false);
		start_Hash.put("tXMLMap_5_TXMLMAP_IN", System.currentTimeMillis());
		
	
		currentVirtualComponent = "tXMLMap_5";
	
	currentComponent="tXMLMap_5_TXMLMAP_IN";

	
		int tos_count_tXMLMap_5_TXMLMAP_IN = 0;
		
    	class BytesLimit65535_tXMLMap_5_TXMLMAP_IN{
    		public void limitLog4jByte() throws Exception{
    			
    		}
    	}
    	
        new BytesLimit65535_tXMLMap_5_TXMLMAP_IN().limitLog4jByte();
java.util.List<Object> outs_tXMLMap_5 = (java.util.List<Object>)globalMap.get("allOutsForAggregate_tXMLMap_5");
for(Object  row_out_tXMLMap_5_TXMLMAP_IN : outs_tXMLMap_5) {//TD512
 



/**
 * [tXMLMap_5_TXMLMAP_IN begin ] stop
 */
	
	/**
	 * [tXMLMap_5_TXMLMAP_IN main ] start
	 */

	

	
	
		currentVirtualComponent = "tXMLMap_5";
	
	currentComponent="tXMLMap_5_TXMLMAP_IN";

	

	stats = null;
	if(row_out_tXMLMap_5_TXMLMAP_IN!=null && row_out_tXMLMap_5_TXMLMAP_IN instanceof statsStruct) {
		stats = (statsStruct)row_out_tXMLMap_5_TXMLMAP_IN;
			routines.system.NestXMLTool.generateOk(stats.doc, false);		
	}
 


	tos_count_tXMLMap_5_TXMLMAP_IN++;

/**
 * [tXMLMap_5_TXMLMAP_IN main ] stop
 */
// Start of branch "stats"
if(stats != null) { 



	
	/**
	 * [tExtractXMLField_5 main ] start
	 */

	

	
	
	currentComponent="tExtractXMLField_5";

	

			//stats
			//stats


			
				if(execStat){
					runStat.updateStatOnConnection("stats"+iterateId,1, 1);
				} 
			

		

	String xmlStr_tExtractXMLField_5 = null;
	routines.system.Document xmlDocument_tExtractXMLField_5 = null;
	if(stats.doc!=null){
				xmlDocument_tExtractXMLField_5 = stats.doc;
	}
			if(xmlDocument_tExtractXMLField_5!=null && xmlDocument_tExtractXMLField_5.getDocument()!=null){// C_01
statistique = null;
statistique = null;
	NameSpaceTool_tExtractXMLField_5 nsTool_tExtractXMLField_5 = new NameSpaceTool_tExtractXMLField_5();
    org.dom4j.io.SAXReader reader_tExtractXMLField_5 = new org.dom4j.io.SAXReader();
	
    org.dom4j.Document doc_tExtractXMLField_5 = null;
    java.util.HashMap xmlNameSpaceMap_tExtractXMLField_5 = null;
    org.dom4j.XPath x_tExtractXMLField_5 = null;
    java.util.List<org.dom4j.tree.AbstractNode> nodeList_tExtractXMLField_5 = null;
		String loopQuery_tExtractXMLField_5 = "/root"; 
	
    boolean isStructError_tExtractXMLField_5= true;
        
    try{
		
	    	doc_tExtractXMLField_5= xmlDocument_tExtractXMLField_5.getDocument();
	    
	    nsTool_tExtractXMLField_5.countNSMap(doc_tExtractXMLField_5.getRootElement());
	    xmlNameSpaceMap_tExtractXMLField_5 = nsTool_tExtractXMLField_5.xmlNameSpaceMap;

    	x_tExtractXMLField_5 = doc_tExtractXMLField_5.createXPath(nsTool_tExtractXMLField_5.addDefaultNSPrefix(loopQuery_tExtractXMLField_5,loopQuery_tExtractXMLField_5));
      
    	x_tExtractXMLField_5.setNamespaceURIs(xmlNameSpaceMap_tExtractXMLField_5); 
    
		 
    	nodeList_tExtractXMLField_5 = (java.util.List<org.dom4j.tree.AbstractNode>)x_tExtractXMLField_5.selectNodes(doc_tExtractXMLField_5);
    	
    	isStructError_tExtractXMLField_5 = false;
    	
    }catch(java.lang.Exception ex_tExtractXMLField_5){
    System.err.println(ex_tExtractXMLField_5.getMessage());
    }
    
    org.dom4j.Node node_tExtractXMLField_5 = null;
    String str_tExtractXMLField_5 = "";
    boolean resultIsNode_tExtractXMLField_5 = true;
    for(int i_tExtractXMLField_5=0; isStructError_tExtractXMLField_5 || (nodeList_tExtractXMLField_5!=null && i_tExtractXMLField_5 < nodeList_tExtractXMLField_5.size());i_tExtractXMLField_5++){
    	
    	if(!isStructError_tExtractXMLField_5){
			statistique = null;
			statistique = null;
    		statistique = new statistiqueStruct();
    	
    		org.dom4j.tree.AbstractNode temp_tExtractXMLField_5 = nodeList_tExtractXMLField_5.get(i_tExtractXMLField_5);
	
	    	nb_line_tExtractXMLField_5++;	
			try{
			statistique.CODE_BARRE = stats.CODE_BARRE;
				org.dom4j.XPath xTmp0_tExtractXMLField_5 = temp_tExtractXMLField_5.createXPath(nsTool_tExtractXMLField_5.addDefaultNSPrefix("user_statistics",loopQuery_tExtractXMLField_5));
			    xTmp0_tExtractXMLField_5.setNamespaceURIs(xmlNameSpaceMap_tExtractXMLField_5);
				
			    Object obj0_tExtractXMLField_5 = xTmp0_tExtractXMLField_5.evaluate(temp_tExtractXMLField_5);
			    if(obj0_tExtractXMLField_5 instanceof String || obj0_tExtractXMLField_5 instanceof Number){
			    	resultIsNode_tExtractXMLField_5 = false;
    				str_tExtractXMLField_5 = String.valueOf(obj0_tExtractXMLField_5);
   				}else{
   					resultIsNode_tExtractXMLField_5 = true;
				    node_tExtractXMLField_5 = xTmp0_tExtractXMLField_5.selectSingleNode(temp_tExtractXMLField_5);
					str_tExtractXMLField_5 = node_tExtractXMLField_5==null?null:node_tExtractXMLField_5.asXML();
				}
									statistique.doc = ParserUtils.parseTo_Document(str_tExtractXMLField_5);
}catch(java.lang.Exception ex_tExtractXMLField_5){
    System.err.println(ex_tExtractXMLField_5.getMessage());
    statistique = null;
    	}
    }
    
    isStructError_tExtractXMLField_5 = false;


   globalMap.put("tExtractXMLField_5_NB_LINE", nb_line_tExtractXMLField_5);

 


	tos_count_tExtractXMLField_5++;

/**
 * [tExtractXMLField_5 main ] stop
 */
// Start of branch "statistique"
if(statistique != null) { 



	
	/**
	 * [tAdvancedHash_statistique main ] start
	 */

	

	
	
	currentComponent="tAdvancedHash_statistique";

	

			//statistique
			//statistique


			
				if(execStat){
					runStat.updateStatOnConnection("statistique"+iterateId,1, 1);
				} 
			

		


			   
			   

					statistiqueStruct statistique_HashRow = new statistiqueStruct();
		   	   	   
				
				statistique_HashRow.doc = statistique.doc;
				
				statistique_HashRow.CODE_BARRE = statistique.CODE_BARRE;
				
			tHash_Lookup_statistique.put(statistique_HashRow);
			
            




 


	tos_count_tAdvancedHash_statistique++;

/**
 * [tAdvancedHash_statistique main ] stop
 */

} // End of branch "statistique"

		// end for
	}


	
		} // C_01
	

} // End of branch "stats"




	
	/**
	 * [tXMLMap_5_TXMLMAP_IN end ] start
	 */

	

	
	
		currentVirtualComponent = "tXMLMap_5";
	
	currentComponent="tXMLMap_5_TXMLMAP_IN";

	

}//TD512
 

ok_Hash.put("tXMLMap_5_TXMLMAP_IN", true);
end_Hash.put("tXMLMap_5_TXMLMAP_IN", System.currentTimeMillis());




/**
 * [tXMLMap_5_TXMLMAP_IN end ] stop
 */

	
	/**
	 * [tExtractXMLField_5 end ] start
	 */

	

	
	
	currentComponent="tExtractXMLField_5";

	



globalMap.put("tExtractXMLField_5_NB_LINE", nb_line_tExtractXMLField_5);

			if(execStat){
				if(resourceMap.get("inIterateVComp") == null || !((Boolean)resourceMap.get("inIterateVComp"))){
			 		runStat.updateStatOnConnection("stats"+iterateId,2, 0); 
			 	}
			}
		
 

ok_Hash.put("tExtractXMLField_5", true);
end_Hash.put("tExtractXMLField_5", System.currentTimeMillis());




/**
 * [tExtractXMLField_5 end ] stop
 */

	
	/**
	 * [tAdvancedHash_statistique end ] start
	 */

	

	
	
	currentComponent="tAdvancedHash_statistique";

	

tHash_Lookup_statistique.endPut();

			if(execStat){
				if(resourceMap.get("inIterateVComp") == null || !((Boolean)resourceMap.get("inIterateVComp"))){
			 		runStat.updateStatOnConnection("statistique"+iterateId,2, 0); 
			 	}
			}
		
 

ok_Hash.put("tAdvancedHash_statistique", true);
end_Hash.put("tAdvancedHash_statistique", System.currentTimeMillis());




/**
 * [tAdvancedHash_statistique end ] stop
 */












				}//end the resume

				



	
			}catch(java.lang.Exception e){	
				
				TalendException te = new TalendException(e, currentComponent, globalMap);
				
					te.setVirtualComponentName(currentVirtualComponent);
				
				throw te;
			}catch(java.lang.Error error){	
				
					runStat.stopThreadStat();
				
				throw error;
			}finally{
				
				try{
					
	
	/**
	 * [tOracleInput_8 finally ] start
	 */

	

	
	
	currentComponent="tOracleInput_8";

	

 



/**
 * [tOracleInput_8 finally ] stop
 */

	
	/**
	 * [tXMLMap_5_TXMLMAP_OUT finally ] start
	 */

	

	
	
		currentVirtualComponent = "tXMLMap_5";
	
	currentComponent="tXMLMap_5_TXMLMAP_OUT";

	

 



/**
 * [tXMLMap_5_TXMLMAP_OUT finally ] stop
 */

	
	/**
	 * [tXMLMap_5_TXMLMAP_IN finally ] start
	 */

	

	
	
		currentVirtualComponent = "tXMLMap_5";
	
	currentComponent="tXMLMap_5_TXMLMAP_IN";

	

 



/**
 * [tXMLMap_5_TXMLMAP_IN finally ] stop
 */

	
	/**
	 * [tExtractXMLField_5 finally ] start
	 */

	

	
	
	currentComponent="tExtractXMLField_5";

	

 



/**
 * [tExtractXMLField_5 finally ] stop
 */

	
	/**
	 * [tAdvancedHash_statistique finally ] start
	 */

	

	
	
	currentComponent="tAdvancedHash_statistique";

	

 



/**
 * [tAdvancedHash_statistique finally ] stop
 */












				}catch(java.lang.Exception e){	
					//ignore
				}catch(java.lang.Error error){
					//ignore
				}
				resourceMap = null;
			}
		

		globalMap.put("tOracleInput_8_SUBPROCESS_STATE", 1);
	}
	


public static class statStruct implements routines.system.IPersistableComparableLookupRow<statStruct> {
    final static byte[] commonByteArrayLock_LDAP_sgbm_export = new byte[0];
    static byte[] commonByteArray_LDAP_sgbm_export = new byte[0];
	protected static final int DEFAULT_HASHCODE = 1;
    protected static final int PRIME = 31;
    protected int hashCode = DEFAULT_HASHCODE;
    public boolean hashCodeDirty = true;

    public String loopKey;



	
			    public String CODE_BARRE;

				public String getCODE_BARRE () {
					return this.CODE_BARRE;
				}
				
			    public String TYPE;

				public String getTYPE () {
					return this.TYPE;
				}
				
			    public String CATEGORIE;

				public String getCATEGORIE () {
					return this.CATEGORIE;
				}
				


	@Override
	public int hashCode() {
		if (this.hashCodeDirty) {
			final int prime = PRIME;
			int result = DEFAULT_HASHCODE;
	
						result = prime * result + ((this.CODE_BARRE == null) ? 0 : this.CODE_BARRE.hashCode());
					
    		this.hashCode = result;
    		this.hashCodeDirty = false;
		}
		return this.hashCode;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj) return true;
		if (obj == null) return false;
		if (getClass() != obj.getClass()) return false;
		final statStruct other = (statStruct) obj;
		
						if (this.CODE_BARRE == null) {
							if (other.CODE_BARRE != null)
								return false;
						
						} else if (!this.CODE_BARRE.equals(other.CODE_BARRE))
						
							return false;
					

		return true;
    }

	public void copyDataTo(statStruct other) {

		other.CODE_BARRE = this.CODE_BARRE;
	            other.TYPE = this.TYPE;
	            other.CATEGORIE = this.CATEGORIE;
	            
	}

	public void copyKeysDataTo(statStruct other) {

		other.CODE_BARRE = this.CODE_BARRE;
	            	
	}




	private String readString(ObjectInputStream dis) throws IOException{
		String strReturn = null;
		int length = 0;
        length = dis.readInt();
		if (length == -1) {
			strReturn = null;
		} else {
			if(length > commonByteArray_LDAP_sgbm_export.length) {
				if(length < 1024 && commonByteArray_LDAP_sgbm_export.length == 0) {
   					commonByteArray_LDAP_sgbm_export = new byte[1024];
				} else {
   					commonByteArray_LDAP_sgbm_export = new byte[2 * length];
   				}
			}
			dis.readFully(commonByteArray_LDAP_sgbm_export, 0, length);
			strReturn = new String(commonByteArray_LDAP_sgbm_export, 0, length, utf8Charset);
		}
		return strReturn;
	}

    private void writeString(String str, ObjectOutputStream dos) throws IOException{
		if(str == null) {
            dos.writeInt(-1);
		} else {
            byte[] byteArray = str.getBytes(utf8Charset);
	    	dos.writeInt(byteArray.length);
			dos.write(byteArray);
    	}
    }

	private String readString(DataInputStream dis, ObjectInputStream ois) throws IOException{
		String strReturn = null;
		int length = 0;
        length = dis.readInt();
		if (length == -1) {
			strReturn = null;
		} else {
			byte[] byteArray = new byte[length];
			dis.read(byteArray);
			strReturn = new String(byteArray, utf8Charset);
		}
		return strReturn;
	}

	private void writeString(String str, DataOutputStream dos, ObjectOutputStream oos) throws IOException{
		if(str == null) {
            dos.writeInt(-1);
		} else {
            byte[] byteArray = str.getBytes(utf8Charset);
	    	dos.writeInt(byteArray.length);
			dos.write(byteArray);
    	}
	}

    public void readKeysData(ObjectInputStream dis) {

		synchronized(commonByteArrayLock_LDAP_sgbm_export) {

        	try {

        		int length = 0;
		
					this.CODE_BARRE = readString(dis);
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);

		

        }

		

      }


    }

    public void writeKeysData(ObjectOutputStream dos) {
        try {

		
					// String
				
						writeString(this.CODE_BARRE,dos);
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);
        }


    }



    /**
     * Fill Values data by reading ObjectInputStream.
     */
    public void readValuesData(DataInputStream dis, ObjectInputStream ois) {
        try {

			int length = 0;
		
						this.TYPE = readString(dis,ois);
					
						this.CATEGORIE = readString(dis,ois);
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);

		

        }

		

    }

    /**
     * Return a byte array which represents Values data.
     */
    public void writeValuesData(DataOutputStream dos, ObjectOutputStream oos) {
        try {

		
						writeString(this.TYPE, dos, oos);
					
						writeString(this.CATEGORIE, dos, oos);
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);
        	}

    }


    public String toString() {

		StringBuilder sb = new StringBuilder();
		sb.append(super.toString());
		sb.append("[");
		sb.append("CODE_BARRE="+CODE_BARRE);
		sb.append(",TYPE="+TYPE);
		sb.append(",CATEGORIE="+CATEGORIE);
	    sb.append("]");

	    return sb.toString();
    }

    /**
     * Compare keys
     */
    public int compareTo(statStruct other) {

		int returnValue = -1;
		
						returnValue = checkNullsAndCompare(this.CODE_BARRE, other.CODE_BARRE);
						if(returnValue != 0) {
							return returnValue;
						}

					
	    return returnValue;
    }


    private int checkNullsAndCompare(Object object1, Object object2) {
        int returnValue = 0;
		if (object1 instanceof Comparable && object2 instanceof Comparable) {
            returnValue = ((Comparable) object1).compareTo(object2);
        } else if (object1 != null && object2 != null) {
            returnValue = compareStrings(object1.toString(), object2.toString());
        } else if (object1 == null && object2 != null) {
            returnValue = 1;
        } else if (object1 != null && object2 == null) {
            returnValue = -1;
        } else {
            returnValue = 0;
        }

        return returnValue;
    }

    private int compareStrings(String string1, String string2) {
        return string1.compareTo(string2);
    }


}
public void tOracleInput_9Process(final java.util.Map<String, Object> globalMap) throws TalendException {
	globalMap.put("tOracleInput_9_SUBPROCESS_STATE", 0);

 final boolean execStat = this.execStat;
	
		String iterateId = "";
	
	
	String currentComponent = "";
	java.util.Map<String, Object> resourceMap = new java.util.HashMap<String, Object>();

	try {

			String currentMethodName = new java.lang.Exception().getStackTrace()[0].getMethodName();
			boolean resumeIt = currentMethodName.equals(resumeEntryMethodName);
			if( resumeEntryMethodName == null || resumeIt || globalResumeTicket){//start the resume
				globalResumeTicket = true;



		statStruct stat = new statStruct();




	
	/**
	 * [tAdvancedXMLMapHash_stat begin ] start
	 */

	

	
		
		ok_Hash.put("tAdvancedXMLMapHash_stat", false);
		start_Hash.put("tAdvancedXMLMapHash_stat", System.currentTimeMillis());
		
	
	currentComponent="tAdvancedXMLMapHash_stat";

	
			if (execStat) {
				if(resourceMap.get("inIterateVComp") == null){
					
						runStat.updateStatOnConnection("stat" + iterateId, 0, 0);
					
				}
			} 

		
		int tos_count_tAdvancedXMLMapHash_stat = 0;
		
    	class BytesLimit65535_tAdvancedXMLMapHash_stat{
    		public void limitLog4jByte() throws Exception{
    			
    		}
    	}
    	
        new BytesLimit65535_tAdvancedXMLMapHash_stat().limitLog4jByte();

			   		// connection name:stat
			   		// source node:tOracleInput_9 - inputs:(after_tOracleInput_8) outputs:(stat,stat) | target node:tAdvancedXMLMapHash_stat - inputs:(stat) outputs:()
			   		// linked node: tXMLMap_5 - inputs:(infoStats,stat) outputs:(stats)
			   
			   		org.talend.designer.components.lookup.common.ICommonLookup.MATCHING_MODE matchingModeEnum_stat = 
			   			org.talend.designer.components.lookup.common.ICommonLookup.MATCHING_MODE.UNIQUE_MATCH;
			   
			   
	   				org.talend.designer.components.lookup.memory.AdvancedMemoryLookup<statStruct> tHash_Lookup_stat = 
	   					org.talend.designer.components.lookup.memory.AdvancedMemoryLookup.
	   						<statStruct>getLookup(matchingModeEnum_stat);

		   	   	   globalMap.put("tHash_Lookup_stat", tHash_Lookup_stat);
		   	   	   
				
            

 



/**
 * [tAdvancedXMLMapHash_stat begin ] stop
 */



	
	/**
	 * [tOracleInput_9 begin ] start
	 */

	

	
		
		ok_Hash.put("tOracleInput_9", false);
		start_Hash.put("tOracleInput_9", System.currentTimeMillis());
		
	
	currentComponent="tOracleInput_9";

	
		int tos_count_tOracleInput_9 = 0;
		
    	class BytesLimit65535_tOracleInput_9{
    		public void limitLog4jByte() throws Exception{
    			
    		}
    	}
    	
        new BytesLimit65535_tOracleInput_9().limitLog4jByte();
	


	
		    int nb_line_tOracleInput_9 = 0;
		    java.sql.Connection conn_tOracleInput_9 = null;
		        conn_tOracleInput_9 = (java.sql.Connection)globalMap.get("conn_tOracleConnection_1");
				
				if(((oracle.jdbc.OracleConnection)conn_tOracleInput_9).getSessionTimeZone() == null){
					java.sql.Statement stmtGetTZ_tOracleInput_9 = conn_tOracleInput_9.createStatement();
					java.sql.ResultSet rsGetTZ_tOracleInput_9 = stmtGetTZ_tOracleInput_9.executeQuery("select sessiontimezone from dual");
					String sessionTimezone_tOracleInput_9 = java.util.TimeZone.getDefault().getID();
					while (rsGetTZ_tOracleInput_9.next()) {
						sessionTimezone_tOracleInput_9 = rsGetTZ_tOracleInput_9.getString(1);
					}
					((oracle.jdbc.OracleConnection)conn_tOracleInput_9).setSessionTimeZone(sessionTimezone_tOracleInput_9);
				}
			
		    
			java.sql.Statement stmt_tOracleInput_9 = conn_tOracleInput_9.createStatement();

		    String dbquery_tOracleInput_9 = "SELECT \n  "+context.oracle_schema+".V_SGBMP_STATISTIQUES.*\nFROM "+context.oracle_schema+".V_SGBMP_STATISTIQUES";
			

            	globalMap.put("tOracleInput_9_QUERY",dbquery_tOracleInput_9);
		    java.sql.ResultSet rs_tOracleInput_9 = null;

		    try {
		    	rs_tOracleInput_9 = stmt_tOracleInput_9.executeQuery(dbquery_tOracleInput_9);
		    	java.sql.ResultSetMetaData rsmd_tOracleInput_9 = rs_tOracleInput_9.getMetaData();
		    	int colQtyInRs_tOracleInput_9 = rsmd_tOracleInput_9.getColumnCount();

		    String tmpContent_tOracleInput_9 = null;
		    
		    
		    while (rs_tOracleInput_9.next()) {
		        nb_line_tOracleInput_9++;
		        
							if(colQtyInRs_tOracleInput_9 < 1) {
								stat.CODE_BARRE = null;
							} else {
	                         		
        	stat.CODE_BARRE = routines.system.JDBCUtil.getString(rs_tOracleInput_9, 1, false);
		                    }
							if(colQtyInRs_tOracleInput_9 < 2) {
								stat.TYPE = null;
							} else {
	                         		
        	stat.TYPE = routines.system.JDBCUtil.getString(rs_tOracleInput_9, 2, false);
		                    }
							if(colQtyInRs_tOracleInput_9 < 3) {
								stat.CATEGORIE = null;
							} else {
	                         		
        	stat.CATEGORIE = routines.system.JDBCUtil.getString(rs_tOracleInput_9, 3, false);
		                    }
					




 



/**
 * [tOracleInput_9 begin ] stop
 */
	
	/**
	 * [tOracleInput_9 main ] start
	 */

	

	
	
	currentComponent="tOracleInput_9";

	

 


	tos_count_tOracleInput_9++;

/**
 * [tOracleInput_9 main ] stop
 */

	
	/**
	 * [tAdvancedXMLMapHash_stat main ] start
	 */

	

	
	
	currentComponent="tAdvancedXMLMapHash_stat";

	

			//stat
			//stat


			
				if(execStat){
					runStat.updateStatOnConnection("stat"+iterateId,1, 1);
				} 
			

		


			   
			   

					statStruct stat_HashRow = new statStruct();
					
				
					stat_HashRow.CODE_BARRE = stat.CODE_BARRE;
					
					stat_HashRow.TYPE = stat.TYPE;
					
					stat_HashRow.CATEGORIE = stat.CATEGORIE;
					
					tHash_Lookup_stat.put(stat_HashRow);
				
            




 


	tos_count_tAdvancedXMLMapHash_stat++;

/**
 * [tAdvancedXMLMapHash_stat main ] stop
 */



	
	/**
	 * [tOracleInput_9 end ] start
	 */

	

	
	
	currentComponent="tOracleInput_9";

	

}
}finally{
stmt_tOracleInput_9.close();

}

globalMap.put("tOracleInput_9_NB_LINE",nb_line_tOracleInput_9);
 

ok_Hash.put("tOracleInput_9", true);
end_Hash.put("tOracleInput_9", System.currentTimeMillis());




/**
 * [tOracleInput_9 end ] stop
 */

	
	/**
	 * [tAdvancedXMLMapHash_stat end ] start
	 */

	

	
	
	currentComponent="tAdvancedXMLMapHash_stat";

	

tHash_Lookup_stat.endPut();

			if(execStat){
				if(resourceMap.get("inIterateVComp") == null || !((Boolean)resourceMap.get("inIterateVComp"))){
			 		runStat.updateStatOnConnection("stat"+iterateId,2, 0); 
			 	}
			}
		
 

ok_Hash.put("tAdvancedXMLMapHash_stat", true);
end_Hash.put("tAdvancedXMLMapHash_stat", System.currentTimeMillis());




/**
 * [tAdvancedXMLMapHash_stat end ] stop
 */



				}//end the resume

				



	
			}catch(java.lang.Exception e){	
				
				TalendException te = new TalendException(e, currentComponent, globalMap);
				
				throw te;
			}catch(java.lang.Error error){	
				
					runStat.stopThreadStat();
				
				throw error;
			}finally{
				
				try{
					
	
	/**
	 * [tOracleInput_9 finally ] start
	 */

	

	
	
	currentComponent="tOracleInput_9";

	

 



/**
 * [tOracleInput_9 finally ] stop
 */

	
	/**
	 * [tAdvancedXMLMapHash_stat finally ] start
	 */

	

	
	
	currentComponent="tAdvancedXMLMapHash_stat";

	

 



/**
 * [tAdvancedXMLMapHash_stat finally ] stop
 */



				}catch(java.lang.Exception e){	
					//ignore
				}catch(java.lang.Error error){
					//ignore
				}
				resourceMap = null;
			}
		

		globalMap.put("tOracleInput_9_SUBPROCESS_STATE", 1);
	}
	

public void tPostjob_1Process(final java.util.Map<String, Object> globalMap) throws TalendException {
	globalMap.put("tPostjob_1_SUBPROCESS_STATE", 0);

 final boolean execStat = this.execStat;
	
		String iterateId = "";
	
	
	String currentComponent = "";
	java.util.Map<String, Object> resourceMap = new java.util.HashMap<String, Object>();

	try {

			String currentMethodName = new java.lang.Exception().getStackTrace()[0].getMethodName();
			boolean resumeIt = currentMethodName.equals(resumeEntryMethodName);
			if( resumeEntryMethodName == null || resumeIt || globalResumeTicket){//start the resume
				globalResumeTicket = true;



		


	
	/**
	 * [tPostjob_1 begin ] start
	 */

	

	
		
		ok_Hash.put("tPostjob_1", false);
		start_Hash.put("tPostjob_1", System.currentTimeMillis());
		
	
	currentComponent="tPostjob_1";

	
		int tos_count_tPostjob_1 = 0;
		
    	class BytesLimit65535_tPostjob_1{
    		public void limitLog4jByte() throws Exception{
    			
    		}
    	}
    	
        new BytesLimit65535_tPostjob_1().limitLog4jByte();

 



/**
 * [tPostjob_1 begin ] stop
 */
	
	/**
	 * [tPostjob_1 main ] start
	 */

	

	
	
	currentComponent="tPostjob_1";

	

 


	tos_count_tPostjob_1++;

/**
 * [tPostjob_1 main ] stop
 */
	
	/**
	 * [tPostjob_1 end ] start
	 */

	

	
	
	currentComponent="tPostjob_1";

	

 

ok_Hash.put("tPostjob_1", true);
end_Hash.put("tPostjob_1", System.currentTimeMillis());

				if(execStat){   
   	 				runStat.updateStatOnConnection("OnComponentOk7", 0, "ok");
				}
				tSCPClose_1Process(globalMap);



/**
 * [tPostjob_1 end ] stop
 */
				}//end the resume

				



	
			}catch(java.lang.Exception e){	
				
				TalendException te = new TalendException(e, currentComponent, globalMap);
				
				throw te;
			}catch(java.lang.Error error){	
				
					runStat.stopThreadStat();
				
				throw error;
			}finally{
				
				try{
					
	
	/**
	 * [tPostjob_1 finally ] start
	 */

	

	
	
	currentComponent="tPostjob_1";

	

 



/**
 * [tPostjob_1 finally ] stop
 */
				}catch(java.lang.Exception e){	
					//ignore
				}catch(java.lang.Error error){
					//ignore
				}
				resourceMap = null;
			}
		

		globalMap.put("tPostjob_1_SUBPROCESS_STATE", 1);
	}
	

public void tSCPClose_1Process(final java.util.Map<String, Object> globalMap) throws TalendException {
	globalMap.put("tSCPClose_1_SUBPROCESS_STATE", 0);

 final boolean execStat = this.execStat;
	
		String iterateId = "";
	
	
	String currentComponent = "";
	java.util.Map<String, Object> resourceMap = new java.util.HashMap<String, Object>();

	try {

			String currentMethodName = new java.lang.Exception().getStackTrace()[0].getMethodName();
			boolean resumeIt = currentMethodName.equals(resumeEntryMethodName);
			if( resumeEntryMethodName == null || resumeIt || globalResumeTicket){//start the resume
				globalResumeTicket = true;



		


	
	/**
	 * [tSCPClose_1 begin ] start
	 */

	

	
		
		ok_Hash.put("tSCPClose_1", false);
		start_Hash.put("tSCPClose_1", System.currentTimeMillis());
		
	
	currentComponent="tSCPClose_1";

	
		int tos_count_tSCPClose_1 = 0;
		
    	class BytesLimit65535_tSCPClose_1{
    		public void limitLog4jByte() throws Exception{
    			
    		}
    	}
    	
        new BytesLimit65535_tSCPClose_1().limitLog4jByte();

 



/**
 * [tSCPClose_1 begin ] stop
 */
	
	/**
	 * [tSCPClose_1 main ] start
	 */

	

	
	
	currentComponent="tSCPClose_1";

	
	
 
	ch.ethz.ssh2.Connection conn_tSCPClose_1 = (ch.ethz.ssh2.Connection)globalMap.get("conn_tSCPConnection_1");
	if(conn_tSCPClose_1 != null){
		
		conn_tSCPClose_1.close();
		
	}

 


	tos_count_tSCPClose_1++;

/**
 * [tSCPClose_1 main ] stop
 */
	
	/**
	 * [tSCPClose_1 end ] start
	 */

	

	
	
	currentComponent="tSCPClose_1";

	

 

ok_Hash.put("tSCPClose_1", true);
end_Hash.put("tSCPClose_1", System.currentTimeMillis());

				if(execStat){   
   	 				runStat.updateStatOnConnection("OnComponentOk8", 0, "ok");
				}
				tOracleClose_1Process(globalMap);



/**
 * [tSCPClose_1 end ] stop
 */
				}//end the resume

				



	
			}catch(java.lang.Exception e){	
				
				TalendException te = new TalendException(e, currentComponent, globalMap);
				
				throw te;
			}catch(java.lang.Error error){	
				
					runStat.stopThreadStat();
				
				throw error;
			}finally{
				
				try{
					
	
	/**
	 * [tSCPClose_1 finally ] start
	 */

	

	
	
	currentComponent="tSCPClose_1";

	

 



/**
 * [tSCPClose_1 finally ] stop
 */
				}catch(java.lang.Exception e){	
					//ignore
				}catch(java.lang.Error error){
					//ignore
				}
				resourceMap = null;
			}
		

		globalMap.put("tSCPClose_1_SUBPROCESS_STATE", 1);
	}
	

public void tOracleClose_1Process(final java.util.Map<String, Object> globalMap) throws TalendException {
	globalMap.put("tOracleClose_1_SUBPROCESS_STATE", 0);

 final boolean execStat = this.execStat;
	
		String iterateId = "";
	
	
	String currentComponent = "";
	java.util.Map<String, Object> resourceMap = new java.util.HashMap<String, Object>();

	try {

			String currentMethodName = new java.lang.Exception().getStackTrace()[0].getMethodName();
			boolean resumeIt = currentMethodName.equals(resumeEntryMethodName);
			if( resumeEntryMethodName == null || resumeIt || globalResumeTicket){//start the resume
				globalResumeTicket = true;





	
	/**
	 * [tOracleClose_1 begin ] start
	 */

	

	
		
		ok_Hash.put("tOracleClose_1", false);
		start_Hash.put("tOracleClose_1", System.currentTimeMillis());
		
	
	currentComponent="tOracleClose_1";

	
		int tos_count_tOracleClose_1 = 0;
		
    	class BytesLimit65535_tOracleClose_1{
    		public void limitLog4jByte() throws Exception{
    			
    		}
    	}
    	
        new BytesLimit65535_tOracleClose_1().limitLog4jByte();

 



/**
 * [tOracleClose_1 begin ] stop
 */
	
	/**
	 * [tOracleClose_1 main ] start
	 */

	

	
	
	currentComponent="tOracleClose_1";

	

	java.sql.Connection conn_tOracleClose_1 = (java.sql.Connection)globalMap.get("conn_tOracleConnection_1");
	
	if(conn_tOracleClose_1 != null && !conn_tOracleClose_1.isClosed())
	{
		
			conn_tOracleClose_1.close();
			
	}

 


	tos_count_tOracleClose_1++;

/**
 * [tOracleClose_1 main ] stop
 */
	
	/**
	 * [tOracleClose_1 end ] start
	 */

	

	
	
	currentComponent="tOracleClose_1";

	

 

ok_Hash.put("tOracleClose_1", true);
end_Hash.put("tOracleClose_1", System.currentTimeMillis());




/**
 * [tOracleClose_1 end ] stop
 */
				}//end the resume

				



	
			}catch(java.lang.Exception e){	
				
				TalendException te = new TalendException(e, currentComponent, globalMap);
				
				throw te;
			}catch(java.lang.Error error){	
				
					runStat.stopThreadStat();
				
				throw error;
			}finally{
				
				try{
					
	
	/**
	 * [tOracleClose_1 finally ] start
	 */

	

	
	
	currentComponent="tOracleClose_1";

	

 



/**
 * [tOracleClose_1 finally ] stop
 */
				}catch(java.lang.Exception e){	
					//ignore
				}catch(java.lang.Error error){
					//ignore
				}
				resourceMap = null;
			}
		

		globalMap.put("tOracleClose_1_SUBPROCESS_STATE", 1);
	}
	
    public String resuming_logs_dir_path = null;
    public String resuming_checkpoint_path = null;
    public String parent_part_launcher = null;
    private String resumeEntryMethodName = null;
    private boolean globalResumeTicket = false;

    public boolean watch = false;
    // portStats is null, it means don't execute the statistics
    public Integer portStats = null;
    public int portTraces = 4334;
    public String clientHost;
    public String defaultClientHost = "localhost";
    public String contextStr = "Default";
    public boolean isDefaultContext = true;
    public String pid = "0";
    public String rootPid = null;
    public String fatherPid = null;
    public String fatherNode = null;
    public long startTime = 0;
    public boolean isChildJob = false;
    public String log4jLevel = "";

    private boolean execStat = true;

    private ThreadLocal<java.util.Map<String, String>> threadLocal = new ThreadLocal<java.util.Map<String, String>>() {
        protected java.util.Map<String, String> initialValue() {
            java.util.Map<String,String> threadRunResultMap = new java.util.HashMap<String, String>();
            threadRunResultMap.put("errorCode", null);
            threadRunResultMap.put("status", "");
            return threadRunResultMap;
        };
    };



    private PropertiesWithType context_param = new PropertiesWithType();
    public java.util.Map<String, Object> parentContextMap = new java.util.HashMap<String, Object>();

    public String status= "";

    public static void main(String[] args){
        final sgbm_export sgbm_exportClass = new sgbm_export();

        int exitCode = sgbm_exportClass.runJobInTOS(args);

        System.exit(exitCode);
    }


    public String[][] runJob(String[] args) {

        int exitCode = runJobInTOS(args);
        String[][] bufferValue = new String[][] { { Integer.toString(exitCode) } };

        return bufferValue;
    }

    public boolean hastBufferOutputComponent() {
		boolean hastBufferOutput = false;
    	
        return hastBufferOutput;
    }

    public int runJobInTOS(String[] args) {
	   	// reset status
	   	status = "";

        String lastStr = "";
        for (String arg : args) {
            if (arg.equalsIgnoreCase("--context_param")) {
                lastStr = arg;
            } else if (lastStr.equals("")) {
                evalParam(arg);
            } else {
                evalParam(lastStr + " " + arg);
                lastStr = "";
            }
        }


        if(clientHost == null) {
            clientHost = defaultClientHost;
        }

        if(pid == null || "0".equals(pid)) {
            pid = TalendString.getAsciiRandomString(6);
        }

        if (rootPid==null) {
            rootPid = pid;
        }
        if (fatherPid==null) {
            fatherPid = pid;
        }else{
            isChildJob = true;
        }

        if (portStats != null) {
            // portStats = -1; //for testing
            if (portStats < 0 || portStats > 65535) {
                // issue:10869, the portStats is invalid, so this client socket can't open
                System.err.println("The statistics socket port " + portStats + " is invalid.");
                execStat = false;
            }
        } else {
            execStat = false;
        }

        try {
            //call job/subjob with an existing context, like: --context=production. if without this parameter, there will use the default context instead.
            java.io.InputStream inContext = sgbm_export.class.getClassLoader().getResourceAsStream("ldap/sgbm_export_1_6/contexts/"+contextStr+".properties");
            if(isDefaultContext && inContext ==null) {

            } else {
                if (inContext!=null) {
                    //defaultProps is in order to keep the original context value
                    defaultProps.load(inContext);
                    inContext.close();
                    context = new ContextProperties(defaultProps);
                }else{
                    //print info and job continue to run, for case: context_param is not empty.
                    System.err.println("Could not find the context " + contextStr);
                }
            }

            if(!context_param.isEmpty()) {
                context.putAll(context_param);
				//set types for params from parentJobs
				for (Object key: context_param.keySet()){
					String context_key = key.toString();
					String context_type = context_param.getContextType(context_key);
					context.setContextType(context_key, context_type);

				}
            }
				    context.setContextType("oracle_login", "id_String");
				
                context.oracle_login=(String) context.getProperty("oracle_login");
				    context.setContextType("oracle_password", "id_String");
				
                context.oracle_password=(String) context.getProperty("oracle_password");
				    context.setContextType("oracle_port", "id_String");
				
                context.oracle_port=(String) context.getProperty("oracle_port");
				    context.setContextType("oracle_schema", "id_String");
				
                context.oracle_schema=(String) context.getProperty("oracle_schema");
				    context.setContextType("oracle_server", "id_String");
				
                context.oracle_server=(String) context.getProperty("oracle_server");
				    context.setContextType("oracle_sid", "id_String");
				
                context.oracle_sid=(String) context.getProperty("oracle_sid");
				    context.setContextType("sigb_active", "id_String");
				
                context.sigb_active=(String) context.getProperty("sigb_active");
				    context.setContextType("sigb_biu_cle_publique", "id_String");
				
                context.sigb_biu_cle_publique=(String) context.getProperty("sigb_biu_cle_publique");
				    context.setContextType("sigb_biu_dir", "id_String");
				
                context.sigb_biu_dir=(String) context.getProperty("sigb_biu_dir");
				    context.setContextType("sigb_biu_host", "id_String");
				
                context.sigb_biu_host=(String) context.getProperty("sigb_biu_host");
				    context.setContextType("sigb_biu_password", "id_String");
				
                context.sigb_biu_password=(String) context.getProperty("sigb_biu_password");
				    context.setContextType("sigb_biu_port", "id_Integer");
				
             try{
                 context.sigb_biu_port=routines.system.ParserUtils.parseTo_Integer (context.getProperty("sigb_biu_port"));
             }catch(NumberFormatException e){
                 context.sigb_biu_port=null;
              }
				    context.setContextType("sigb_biu_username", "id_String");
				
                context.sigb_biu_username=(String) context.getProperty("sigb_biu_username");
				    context.setContextType("sigb_cataloger_level", "id_String");
				
                context.sigb_cataloger_level=(String) context.getProperty("sigb_cataloger_level");
				    context.setContextType("sigb_cataloger_level_desc", "id_String");
				
                context.sigb_cataloger_level_desc=(String) context.getProperty("sigb_cataloger_level_desc");
				    context.setContextType("sigb_external", "id_String");
				
                context.sigb_external=(String) context.getProperty("sigb_external");
				    context.setContextType("sigb_external_desc", "id_String");
				
                context.sigb_external_desc=(String) context.getProperty("sigb_external_desc");
				    context.setContextType("sigb_external_id", "id_String");
				
                context.sigb_external_id=(String) context.getProperty("sigb_external_id");
				    context.setContextType("sigb_file_name", "id_String");
				
                context.sigb_file_name=(String) context.getProperty("sigb_file_name");
				    context.setContextType("sigb_files_dir", "id_String");
				
                context.sigb_files_dir=(String) context.getProperty("sigb_files_dir");
				    context.setContextType("sigb_id_type_eppn", "id_String");
				
                context.sigb_id_type_eppn=(String) context.getProperty("sigb_id_type_eppn");
				    context.setContextType("sigb_param_file", "id_String");
				
                context.sigb_param_file=(String) context.getProperty("sigb_param_file");
				    context.setContextType("sigb_record_type", "id_String");
				
                context.sigb_record_type=(String) context.getProperty("sigb_record_type");
				    context.setContextType("sigb_user_group", "id_String");
				
                context.sigb_user_group=(String) context.getProperty("sigb_user_group");
				    context.setContextType("sigb_user_group_desc", "id_String");
				
                context.sigb_user_group_desc=(String) context.getProperty("sigb_user_group_desc");
        } catch (java.io.IOException ie) {
            System.err.println("Could not load context "+contextStr);
            ie.printStackTrace();
        }


        // get context value from parent directly
        if (parentContextMap != null && !parentContextMap.isEmpty()) {if (parentContextMap.containsKey("oracle_login")) {
                context.oracle_login = (String) parentContextMap.get("oracle_login");
            }if (parentContextMap.containsKey("oracle_password")) {
                context.oracle_password = (String) parentContextMap.get("oracle_password");
            }if (parentContextMap.containsKey("oracle_port")) {
                context.oracle_port = (String) parentContextMap.get("oracle_port");
            }if (parentContextMap.containsKey("oracle_schema")) {
                context.oracle_schema = (String) parentContextMap.get("oracle_schema");
            }if (parentContextMap.containsKey("oracle_server")) {
                context.oracle_server = (String) parentContextMap.get("oracle_server");
            }if (parentContextMap.containsKey("oracle_sid")) {
                context.oracle_sid = (String) parentContextMap.get("oracle_sid");
            }if (parentContextMap.containsKey("sigb_active")) {
                context.sigb_active = (String) parentContextMap.get("sigb_active");
            }if (parentContextMap.containsKey("sigb_biu_cle_publique")) {
                context.sigb_biu_cle_publique = (String) parentContextMap.get("sigb_biu_cle_publique");
            }if (parentContextMap.containsKey("sigb_biu_dir")) {
                context.sigb_biu_dir = (String) parentContextMap.get("sigb_biu_dir");
            }if (parentContextMap.containsKey("sigb_biu_host")) {
                context.sigb_biu_host = (String) parentContextMap.get("sigb_biu_host");
            }if (parentContextMap.containsKey("sigb_biu_password")) {
                context.sigb_biu_password = (String) parentContextMap.get("sigb_biu_password");
            }if (parentContextMap.containsKey("sigb_biu_port")) {
                context.sigb_biu_port = (Integer) parentContextMap.get("sigb_biu_port");
            }if (parentContextMap.containsKey("sigb_biu_username")) {
                context.sigb_biu_username = (String) parentContextMap.get("sigb_biu_username");
            }if (parentContextMap.containsKey("sigb_cataloger_level")) {
                context.sigb_cataloger_level = (String) parentContextMap.get("sigb_cataloger_level");
            }if (parentContextMap.containsKey("sigb_cataloger_level_desc")) {
                context.sigb_cataloger_level_desc = (String) parentContextMap.get("sigb_cataloger_level_desc");
            }if (parentContextMap.containsKey("sigb_external")) {
                context.sigb_external = (String) parentContextMap.get("sigb_external");
            }if (parentContextMap.containsKey("sigb_external_desc")) {
                context.sigb_external_desc = (String) parentContextMap.get("sigb_external_desc");
            }if (parentContextMap.containsKey("sigb_external_id")) {
                context.sigb_external_id = (String) parentContextMap.get("sigb_external_id");
            }if (parentContextMap.containsKey("sigb_file_name")) {
                context.sigb_file_name = (String) parentContextMap.get("sigb_file_name");
            }if (parentContextMap.containsKey("sigb_files_dir")) {
                context.sigb_files_dir = (String) parentContextMap.get("sigb_files_dir");
            }if (parentContextMap.containsKey("sigb_id_type_eppn")) {
                context.sigb_id_type_eppn = (String) parentContextMap.get("sigb_id_type_eppn");
            }if (parentContextMap.containsKey("sigb_param_file")) {
                context.sigb_param_file = (String) parentContextMap.get("sigb_param_file");
            }if (parentContextMap.containsKey("sigb_record_type")) {
                context.sigb_record_type = (String) parentContextMap.get("sigb_record_type");
            }if (parentContextMap.containsKey("sigb_user_group")) {
                context.sigb_user_group = (String) parentContextMap.get("sigb_user_group");
            }if (parentContextMap.containsKey("sigb_user_group_desc")) {
                context.sigb_user_group_desc = (String) parentContextMap.get("sigb_user_group_desc");
            }
        }

        //Resume: init the resumeUtil
        resumeEntryMethodName = ResumeUtil.getResumeEntryMethodName(resuming_checkpoint_path);
        resumeUtil = new ResumeUtil(resuming_logs_dir_path, isChildJob, rootPid);
        resumeUtil.initCommonInfo(pid, rootPid, fatherPid, projectName, jobName, contextStr, jobVersion);

		List<String> parametersToEncrypt = new java.util.ArrayList<String>();
        //Resume: jobStart
        resumeUtil.addLog("JOB_STARTED", "JOB:" + jobName, parent_part_launcher, Thread.currentThread().getId() + "", "","","","",resumeUtil.convertToJsonText(context,parametersToEncrypt));

if(execStat) {
    try {
        runStat.openSocket(!isChildJob);
        runStat.setAllPID(rootPid, fatherPid, pid, jobName);
        runStat.startThreadStat(clientHost, portStats);
        runStat.updateStatOnJob(RunStat.JOBSTART, fatherNode);
    } catch (java.io.IOException ioException) {
        ioException.printStackTrace();
    }
}



	
	    java.util.concurrent.ConcurrentHashMap<Object, Object> concurrentHashMap = new java.util.concurrent.ConcurrentHashMap<Object, Object>();
	    globalMap.put("concurrentHashMap", concurrentHashMap);
	

    long startUsedMemory = Runtime.getRuntime().totalMemory() - Runtime.getRuntime().freeMemory();
    long endUsedMemory = 0;
    long end = 0;

    startTime = System.currentTimeMillis();




this.globalResumeTicket = true;//to run tPreJob

try {
errorCode = null;tPrejob_1Process(globalMap);
if(!"failure".equals(status)) { status = "end"; }
}catch (TalendException e_tPrejob_1) {
globalMap.put("tPrejob_1_SUBPROCESS_STATE", -1);

e_tPrejob_1.printStackTrace();

}



this.globalResumeTicket = false;//to run others jobs


this.globalResumeTicket = true;//to run tPostJob

try {
errorCode = null;tPostjob_1Process(globalMap);
if(!"failure".equals(status)) { status = "end"; }
}catch (TalendException e_tPostjob_1) {
globalMap.put("tPostjob_1_SUBPROCESS_STATE", -1);

e_tPostjob_1.printStackTrace();

}



        end = System.currentTimeMillis();

        if (watch) {
            System.out.println((end-startTime)+" milliseconds");
        }

        endUsedMemory = Runtime.getRuntime().totalMemory() - Runtime.getRuntime().freeMemory();
        if (false) {
            System.out.println((endUsedMemory - startUsedMemory) + " bytes memory increase when running : sgbm_export");
        }


    closeScpConnections();



if (execStat) {
    runStat.updateStatOnJob(RunStat.JOBEND, fatherNode);
    runStat.stopThreadStat();
}
    int returnCode = 0;
    if(errorCode == null) {
         returnCode = status != null && status.equals("failure") ? 1 : 0;
    } else {
         returnCode = errorCode.intValue();
    }
    resumeUtil.addLog("JOB_ENDED", "JOB:" + jobName, parent_part_launcher, Thread.currentThread().getId() + "", "","" + returnCode,"","","");

    return returnCode;

  }

    // only for OSGi env
    public void destroy() {
    closeScpConnections();
    closeSqlDbConnections();


    }


    private void closeScpConnections() {
        try {
            Object obj_conn;
            obj_conn = globalMap.remove("conn_tSCPConnection_1");
            if (null != obj_conn) {
                ((ch.ethz.ssh2.Connection) obj_conn).close();
            }
        } catch (java.lang.Exception e) {
        }
    }

    private void closeSqlDbConnections() {
        try {
            Object obj_conn;
            obj_conn = globalMap.remove("conn_tOracleConnection_1");
            if (null != obj_conn) {
                ((java.sql.Connection) obj_conn).close();
            }
        } catch (java.lang.Exception e) {
        }
    }











    private java.util.Map<String, Object> getSharedConnections4REST() {
        java.util.Map<String, Object> connections = new java.util.HashMap<String, Object>();
            connections.put("conn_tSCPConnection_1", globalMap.get("conn_tSCPConnection_1"));
            connections.put("conn_tOracleConnection_1", globalMap.get("conn_tOracleConnection_1"));







        return connections;
    }

    private void evalParam(String arg) {
        if (arg.startsWith("--resuming_logs_dir_path")) {
            resuming_logs_dir_path = arg.substring(25);
        } else if (arg.startsWith("--resuming_checkpoint_path")) {
            resuming_checkpoint_path = arg.substring(27);
        } else if (arg.startsWith("--parent_part_launcher")) {
            parent_part_launcher = arg.substring(23);
        } else if (arg.startsWith("--watch")) {
            watch = true;
        } else if (arg.startsWith("--stat_port=")) {
            String portStatsStr = arg.substring(12);
            if (portStatsStr != null && !portStatsStr.equals("null")) {
                portStats = Integer.parseInt(portStatsStr);
            }
        } else if (arg.startsWith("--trace_port=")) {
            portTraces = Integer.parseInt(arg.substring(13));
        } else if (arg.startsWith("--client_host=")) {
            clientHost = arg.substring(14);
        } else if (arg.startsWith("--context=")) {
            contextStr = arg.substring(10);
            isDefaultContext = false;
        } else if (arg.startsWith("--father_pid=")) {
            fatherPid = arg.substring(13);
        } else if (arg.startsWith("--root_pid=")) {
            rootPid = arg.substring(11);
        } else if (arg.startsWith("--father_node=")) {
            fatherNode = arg.substring(14);
        } else if (arg.startsWith("--pid=")) {
            pid = arg.substring(6);
        } else if (arg.startsWith("--context_type")) {
            String keyValue = arg.substring(15);
			int index = -1;
            if (keyValue != null && (index = keyValue.indexOf('=')) > -1) {
                if (fatherPid==null) {
                    context_param.setContextType(keyValue.substring(0, index), replaceEscapeChars(keyValue.substring(index + 1)));
                } else { // the subjob won't escape the especial chars
                    context_param.setContextType(keyValue.substring(0, index), keyValue.substring(index + 1) );
                }

            }

		} else if (arg.startsWith("--context_param")) {
            String keyValue = arg.substring(16);
            int index = -1;
            if (keyValue != null && (index = keyValue.indexOf('=')) > -1) {
                if (fatherPid==null) {
                    context_param.put(keyValue.substring(0, index), replaceEscapeChars(keyValue.substring(index + 1)));
                } else { // the subjob won't escape the especial chars
                    context_param.put(keyValue.substring(0, index), keyValue.substring(index + 1) );
                }
            }
        }else if (arg.startsWith("--log4jLevel=")) {
            log4jLevel = arg.substring(13);
		}

    }
    
    private static final String NULL_VALUE_EXPRESSION_IN_COMMAND_STRING_FOR_CHILD_JOB_ONLY = "<TALEND_NULL>";

    private final String[][] escapeChars = {
        {"\\\\","\\"},{"\\n","\n"},{"\\'","\'"},{"\\r","\r"},
        {"\\f","\f"},{"\\b","\b"},{"\\t","\t"}
        };
    private String replaceEscapeChars (String keyValue) {

		if (keyValue == null || ("").equals(keyValue.trim())) {
			return keyValue;
		}

		StringBuilder result = new StringBuilder();
		int currIndex = 0;
		while (currIndex < keyValue.length()) {
			int index = -1;
			// judege if the left string includes escape chars
			for (String[] strArray : escapeChars) {
				index = keyValue.indexOf(strArray[0],currIndex);
				if (index>=0) {

					result.append(keyValue.substring(currIndex, index + strArray[0].length()).replace(strArray[0], strArray[1]));
					currIndex = index + strArray[0].length();
					break;
				}
			}
			// if the left string doesn't include escape chars, append the left into the result
			if (index < 0) {
				result.append(keyValue.substring(currIndex));
				currIndex = currIndex + keyValue.length();
			}
		}

		return result.toString();
    }

    public Integer getErrorCode() {
        return errorCode;
    }


    public String getStatus() {
        return status;
    }

    ResumeUtil resumeUtil = null;
}
/************************************************************************************************
 *     493654 characters generated by Talend Open Studio for Data Integration 
 *     on the 3 avril 2018 12:19:43 CEST
 ************************************************************************************************/